/*->c.chart */

#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"
#include "flex.h"


#include "wos.h"


#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
//#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "scanplus.h"
#include "trans.h"
#include "dbhi.h"


#include "mhi.h"


#include "str.h"
#include "reslink.h"

#include "view.h"

#include "file.h"
#include "units.h"


#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"

#include "dbcolour.h"
#include "dbedcol.h"
#include "dbchart.h"

#include "chart.h"


/**************************************************************************/



#define CCHUNK (sizeof(chartstr)*32)
#define CHDRCHUNK (sizeof(charthdrstr)*4)


charthdrstr defltcharthdr={"{COLCH}"};


charthdrstr * charthdr;

chartstr    * chart;


       int chartmodel;           /* colour model for chart */
       int chartn;               /* current chart number   */
       int chartindex;           /* total entries in chart */
       int charthdrn;


/* a token is a non space, followed by a space or zero */

static char * gettok(char * string,int * len)
{
 int    tlen;
 char * p;
 char * q;

 p=string;
 while(*p==' ' || *p==',') p++;
 q=p;
 while(*q && *q!=',') q++;

 tlen=q-p;
 if(*q)
 {
  *q=0;
  tlen++;
 }

 *len=tlen;

 return(p);
}


static void getcol(int n,int * q,char * p,int len,int angle)
{
 int i;
 int c;

 for(i=0;i<n;i++)
 {
  p=gettok(p+len,&len);

  if(len)
  {           /* get dp values */
   stringtonumberxdp(p,&c,2,0);
   if(angle && i==0)
   {
    if(c>360*0x10000) c=360*0x10000;
   }
   else
   {
    c=c/100;
    if(c>0x10000) c=0x10000;
   }
   *q++=c;
  }
  else break;
 }

 if(i>=n) chartindex++;
}


os_error * unloadchart(void)
{
 chartmodel=-1;
 chartindex=0;
 return(flex_free((flex_ptr)&chart));
}



os_error * loadchart(int n)
{
 os_error * err;
 buffer     bf;
 char       string[256];
 int        eof;
 int        len;
 char    *  p;

 chartn=n;


 sprintf(string,"<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\Colours\\%s.txt",charthdr[n].name);

          err=unloadchart();
 if(!err) err=flex_alloc((flex_ptr)&chart,CCHUNK);
 if(!err) err=bf_open(string,'r',DEFBUFFSIZE,&bf);
 if(!err)
 {
  eof=0;

  while(!eof)
  {
   err=bf_getstring(&bf,string,sizeof(string),&eof);
   if(err) break;

   err=flex_chunk((flex_ptr)&chart,(chartindex+1)*sizeof(chartstr),CCHUNK);
   if(err) break;

   p=gettok(string,&len);
   if(len)
   {
    if(!strncmp(p,"/#",2))
    {
     chart[chartindex].name[0]=0;
     chartindex++;
    }
    else
    if(strncmp(p,"//",2))
    {
     if(chartmodel<0)
     {
      if(!cstrcmp(p,"RGB"))  chartmodel=RGBMODEL;
      else
      if(!cstrcmp(p,"HSV"))  chartmodel=HSVMODEL;
      else
      if(!cstrcmp(p,"CMYK")) chartmodel=CMYKMODEL;
     }
     else
     {
      /* p==colour name */

      xzstrncpy(chart[chartindex].name,p,sizeof(chart[chartindex].name));
      switch(chartmodel)
      {
        case  RGBMODEL:
                      getcol(3,&chart[chartindex].quad.type.rgb.r,p,len,0);
                      break;

        case  HSVMODEL:
                      getcol(3,&chart[chartindex].quad.type.hsv.h,p,len,1);
                      break;

        case CMYKMODEL:
                      getcol(4,&chart[chartindex].quad.type.cmyk.c,p,len,0);
                      break;
      }
     }
    }
   }
  }
  err=bf_close(&bf,err);
 }
 return(err);
}





static os_error * loadnames(void)
{
 os_error     * err;
 fxstat         f;
 char         * p;
 fsscanhandle	  handle;
	int            eof;

 /* scan the dictionary directory */

 charthdrn=0;

 err=flex_alloc((flex_ptr)&charthdr,CHDRCHUNK);
 if(!err) err=fs_startsortscan("<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\Colours",TEXT("*.*"),0,&handle);
 if(!err)
 {
  while(1)
  {
   err=fs_nextsortitem(handle,&f,&eof);
			if(err) break;
			if(eof) break;

   err=flex_chunk((flex_ptr)&charthdr,(charthdrn+1)*sizeof(charthdrstr),CHDRCHUNK);
   if(err) break;

   p=fs_extension(f.name);
   if(p && p>f.name && !cstrcmp(p,"txt"))
   {
    *(p-1)=0;
    if(strlen(f.name)<COLMODELNAMELEN)
    {
     xzstrncpy(charthdr[charthdrn].name,f.name,sizeof(charthdr[charthdrn].name));
     charthdrn++;
    }
   }
  }
  fs_endsortscan(&handle);
 }

 return(err);
}




os_error * chartinit(void)
{
 os_error * err;

 err=loadnames();

 trans(defltcharthdr.name,COLMODELNAMELEN);

 return(err);
}

