/*->c.main */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "bbc.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "flex.h"
#include "transform.h"

#include "alloc.h"
#include "wos.h"
#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "fsx.h"
#include "bf.h"
#include "timex.h"
#include "conf.h"
#include "etc.h"
#include "deb.h"
#include "key.h"
#include "dbhi.h"
#include "xhelp.h"
#include "scrap.h"
#include "ole.h"
#include "applet.h"
#include "flex.h"
#include "sp.h"
#include "appinfo.h"
#include "appreg.h"
#include "osshell.h"
#include "bits.h"
#include "oshelp.h"
#include "osddex.h"


#include "str.h"
#include "constants.h"

#include "object.h"
#include "reslink.h"
#include "xlink.h"

#include "mhi.h"
#include "file.h"
#include "undo.h"
#include "caret.h"
#include "xprint.h"
#include "xcolour.h"
#include "macros.h"
#include "utils.h"
#include "choices.h"
#include "dbscale.h"
#include "dbmore.h"
#include "scripts.h"
#include "buttons.h"
#include "oplock.h"
#include "appletman.h"
#include "tag.h"
#include "clip.h"
#include "xredraw.h"
#include "curve.h"





#include "txstr.h"
#include "new.h"
#include "dbnew.h"



#include "dscript.h"


#include "view.h"

#include "main.h"





int    version=292;
int    minversion=205;   /* oldest file we can load */
int    compatability=COMPATABILITY;  /* if file value is greater than program no load */
int    workcompatability=COMPATABILITY;
int    maxcompatability=MAXCOMPATABILITY;
char * datestring="(28th-July-2022)";

int    initcomplete;




		   





static void terminatelo(void)
{
 event(EVENT_ENDPROGRAM,NULL,0);
 tagupdate();
	finitdoc();

 olefinit();
 scrapfinit();
 osshellfinit(OSSHELLOLE);
 report(finittask());
 exit(0);
}




static os_error * terminatemessage(wimp_msgstr * msg,int * ack)
{
 terminatelo();
 return(NULL);
 USE(msg);
 USE(ack);
}


/* return 1 if not to quit */

static int termnok(void)
{
 int n=unsaved();
 int code;


 if(n && !debugactive())
 {
  /* files edited but not saved */
  if(n==1) confirmparent(NULL,CONDC|CONFORCE,&code,"{FS10}");
  else     confirmparent(NULL,CONDC|CONFORCE,&code,"%d {FS09}",n);

  if(code!=1) return(1);
 }

 return(0);
}



void xterminate(void)
{
 if(!termnok()) terminatelo();
}





/* set ack to 1 if you want to stop the quit sequence */

/*

static os_error * prequithandler(int userhandle,int * ack,int prequit) 
{
  if(unsaved() && warnings) *ack=1;
 }
 else
 {
  if(termnok()) *ack=1;
  else
  {
   closeallfiles();
  }
 }
 return(NULL);

 USE(userhandle);
}

*/

static os_error * addmessages(void)
{
 os_error * err;


 err=addmessage(terminatemessage,wimp_MCLOSEDOWN);
// if(!err) err=addprequit(prequithandler,0);

 return(err);
}



int programversion(int fp)
{
 return(version);
 USE(fp);
}


void keyboardmode(int fp)
{
 setkeyboardmode(stack[fp]);
}



void xhelptopic(int fp)
{
 if(menuview)
 {
  zreport(helptopic(menuview->handle,stringptr(stack[fp])));
 }
}


void xhelpwhatisthis(int fp)
{
 if(menuview)
 {
  zreport(helpwhatsthis(menuview->handle));
 }

 USE(fp);
}





/* open info window and pass back pointer */

int info_box(int fp)
{
 return(0);
 USE(fp);
}


void openinfobox(int fp)
{
#ifdef READER
 zreport(infowindow2(menuview->handle,version,datestring,TEXT("{NAMER}")));
#else
 zreport(infowindow(menuview->handle,version,datestring));
#endif
 USE(fp);
}



static os_error * setupmenus(void)
{
 os_error * err;

 err=menuhistart();

 return(err);
}



void xappspath(int fp)
{
 assignstring(stack[fp],appsbasepath);
}



static char * appsdatapath="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\Applets\\";

// void  appletdatapath(string & name,string & path);
// return pointer to application data folder with the given name and create if necessary

void xappsdatapath(int fp)
{
	os_error * err;
	char       datapath0[MAX_PATH];
 char       datapath1[MAX_PATH];

	fs_join(datapath0,NITEM(datapath0),appsdatapath,stringptr(stack[fp]));

	fs_expandpath(datapath0,datapath1,MAX_PATH);

	err=fs_validatepath(datapath1,1);

	assignstring(stack[fp+1],datapath1);

	zreport(err);
}



static os_error * loadscripts(void)
{
 os_error * err;

 err=adddoublefiles(TEXT("<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\Library"),
                    multiuser?TEXT("<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\Library"):NULL,
                    0);     /* do library <OvationPro$Dir> */

 if(!err) err=adddoublefiles(TEXT("<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\AutoRun"),
                             multiuser?TEXT("<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\Autorun"):NULL,
                             1);     /* auto run */

 return(err);
}



static os_error * helpinit(void)
{
 os_error * err;

 err=NULL;

// if(ihelp) 
// {

           err=addhelp(NULL,TEXT("Help.txt"));
  if(!err) err=event(EVENT_LOADHELP,NULL,0);
  if(!err) err=applethelp();

// }

 return(err);
}



static os_error * taskinit(int code)
{

 pollsetflags(POLLUNICODE,0);
 

 return(buttonalloc());
 USE(code);
}



static void crashcleanup(void)
{
// keyboard_off();
 flex_finit();
}


static void exitcalled(int code)
{
 crashcleanup();
 USE(code);
}


void zerofilesquit(os_error * err)
{
	if(userfiles()==0 && printqueue==0)
 {
  report(err);
  pollquit(0); 
 }
}


#define ZEROFILESTIME 300

static void zerofilesevent(int userhandle)
{
 if(errorlevel()==0)
 {
  zerofilesquit(NULL);
 }
 else
 {
  addscheduledevent((zerofn)zerofilesevent,0,ZEROFILESTIME);
 }

 USE(userhandle);
}



static os_error * initzerocheck(void)
{
 os_error * err;

 err=addscheduledevent((zerofn)zerofilesevent,0,ZEROFILESTIME);

 return(err);
}


static int productcodes[]=
{
 APPREGOPCODE,
 APPREGOPSLCODE,
 APPREGLASTCODE
};



static os_error * appregevent(int handle,int event)
{
 os_error * err;

 err=NULL;

 switch(event)
 {

 case APPREGDOC:
                helptopic(handle,TEXT("<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\OvnPro.chm::/registration.htm>"));
                break;

 }

 return(err);

 USE(handle);
}







void openregbox(int fp)
{
 zreport(appregwindow(menuview->handle));
 USE(fp);
}


static os_error * regevent(int eventn,int userhandle,void * data,int data1)
{
 os_error * err;

 cprintf("regevent");

 err=appreg(0);
 if(err)
 {
  return(appregfixed(((viewstr*)data)->handle,0,2022,12,24));
 }

 return(NULL);


 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}










int main(int argc,char * argv[])
{ 
 os_error * err;


 setlocale(LC_ALL,".1252");


 wimpt_wimpversion(300);

          err=inittaska(TEXT("OvationPro"),
                        TEXT("Ovation Pro"),TEXT("!OvnPro"),
                        NULL,
                        TEXT("<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\Applets>"),
                        multiuser?TEXT("<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\Applets"):NULL,
                        taskinit,version,TEXT("ovnpro"));

	// xcprintf("dde start");

// ddestart("ovnpro");

 if(!err)
 {
  err=appreginit(appregevent,productcodes);
  if(!err)
  {

#ifdef NEVER
#ifndef READER
   err=appreg(0);
   if(err)
   {
    err=NULL;
    addevent(EVENT_VOPEN,regevent,0);
//    if(timebomb(2005,12,24))
//    {
//     messagebox("This version of the program is now out of date");
//     exit(0);
//    }
   }
#endif
#endif
  }
 }

	// xcprintf("app reg");

#ifdef NEVER
#ifdef PRODLOCK
 err=checklock();
#endif
#endif

#ifndef PROD
// debugenable(crashcleanup); 
#endif

 wimpt_setcrash(crashcleanup);
 werrsetexit(exitcalled);


	// xcprintf("werr");

// if(!err) err=seticonbar("!OvnPro");
 if(!err) err=resinit(NULL);

	// xcprintf("resinit");

 if(!err) err=buttoninit();

	// xcprintf("buttoninit");

 if(!err) err=addspritesx(NULL,TEXT("Sprites2.spr"));

	// xcprintf("add sprites");

 if(!err) err=xset();                    /* script language */

	// xcprintf("xset");

 if(!err) err=dsinit();

	// xcprintf("dsinit");

 if(!err) err=setupmenus();

	// xcprintf("set up menus");

 if(!err) err=addmessages();

 if(!err) err=curveinit();

	// xcprintf("add mess");

 if(!err) err=initundo();

	// xcprintf("init undo");

 if(!err) err=caretinit();

	// xcprintf("caret");

 if(!err) err=printinit();

	// xcprintf("print");

 if(!err) err=colourinit();

	// xcprintf("colour");

 if(!err) err=utilsinit();

	// xcprintf("utils");

 if(!err) err=initkeyboard(KEYNUMLOCKKEY|KEYSCROLLLOCKKEY);

	// xcprintf("key");

 if(!err) err=macrosboot();

	// xcprintf("mac");

 if(!err) err=scriptsinit();

	// xcprintf("script");

 if(!err) err=appletmaninit();

	// xcprintf("appletman");

 if(!err) err=choicesinit();

	// xcprintf("choices");

 if(!err) err=viewinit();

	// xcprintf("view");

 if(!err) err=scrapinit(TEXT("Ovation"),NULL);

	// xcprintf("scrap");

 if(!err) err=oleinit();
// if(!err) err=ddestart("ovnpro");

	// xcprintf("ole");

 if(!err) err=initdoc();

	// xcprintf("init doc"); 

 if(!err) err=loadscripts();

	// xcprintf("load scripts");

 if(!err) err=helpinit();

	// xcprintf("help");

 if(!err) err=event(EVENT_RUNPROGRAM,NULL,0);

	// xcprintf("run");

 if(!err) err=event(EVENT_RUNPROGRAM2,NULL,0);
	// xcprintf("run1");

 
 if(!err) err=appletrun();

	// xcprintf("run2");

 abend(err);              /* quit if errors here */

	
	// xcprintf("initialisation complete");

 initcomplete=1;


// cprintf("argc %d argv1 %s",argc,argc>=2?argv[1]:"");


 if(argc==3)
 {
  if(!cstrcmp(argv[1],"-new"))
  {
   err=createdocumentfile(argv[2]);
   if(!err) pollquit(0);
  }
		else
  if(!cstrcmp(argv[1],"-print"))
  {
			err=printdoc(argv[2]);
		}
 }
 else
 if(argc==2)
 {
  if(cstrcmp(argv[1],"-dde"))
  {
   err=loadanyfile(argv[1],FLNOLOAD);
  }
 }
 else
 {
  err=newdocument();
 }

	// xcprintf("newdoc");

 report(err);

 if(err) zerofilesquit(NULL); // stops us running with no window open
                              // need err check because we wait for dde message

 initzerocheck();


	cprintf("multiuser %d",multiuser);

	// xcprintf("zero");

// Still a problem if DDE load fails, we'll be left with no windows open
// e.g. if user chooses to not replace missing fonts
// better example may be running a script

 runtask();

 return(0);
}

