/*->c.modchap */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"

#include "err.h"
#include "transform.h"
#include "etc.h"
#include "poll.h"
#include "deb.h"


#include "constants.h"
#include "str.h"
#include "object.h"
#include "chain.h"
#include "undo.h"

#include "reslink.h"

#include "view.h"
#include "viewo.h"
#include "file.h"
#include "select.h"

#include "txstr.h"
#include "fl.h"

#include "page.h"
#include "new.h"
#include "newx.h"
#include "xpage.h"



#include "modchap.h"





#define UMODCHAPF  0x7200
#define UMODCHAPS  0x7201




#ifndef PROD

static void checksect(int section,filestr * file)
{
 sectionstr * sectionp;
 pagestr    * pagep;
 int          page;
 int          next;
 int          child;
 int          nextchild;
 sobjectstr   * sob;
 textboxstr   * textp;
 texsrc       * texsp; 
 texsub       * texup;
 int            usize;


 sectionp=(sectionstr*)fob_find(section,file);
 page=sectionp->chain.child;
 while(page)
 {
  pagep=(pagestr*)fob_find(page,file);
  next=pagep->chain.next;

  cprintf("page=%d next=%d",page,next);

  child=pagep->chain.child;
  while(child)
  {
   sob=(sobjectstr*)fob_find(child,file);
   nextchild=sob->chain.next;

   cprintf("child=%d next=%d",child,nextchild);

   if(sob->type==OTEXTBOX)
   {
    textp=(textboxstr*)sob;

    cprintf("fnext=%d fprev=%d",textp->fchain.next,textp->fchain.prev);


    texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

    cprintf("source[0]=%d source[1]=%d",texsp->source,texsp->vsource);

    usize=sizeof(textboxstr)+sizeof(texsrc);

    texup=(texsub*)(((char*)textp)+usize);


    cprintf("bytes=%d lines=%d",texup[0].bytes,texup[0].vlines);


   }

   child=nextchild;
  }

  page=next;
 }
}

#endif



static os_error * canonicalpage(int dpage,int dsection,
                                int mpage,filestr * file)
{
 os_error   * err;
 objectloc    sloc;
 objectloc    dloc;
 pagestr    * pagep;
 sobjectstr * sob;
 int          mchild;
 int          mnext;
 int          dafter;
 int          dparent;
 int          dchild;
 transformstr tr;
 int          message;
 int          master;


 err=NULL;

 memset(&sloc,0,sizeof(objectloc));
 memset(&dloc,0,sizeof(objectloc));

 tr_setidentity(&tr);


 pagep=(pagestr*)fob_find(dpage,file);
 dchild=pagep->chain.child;
 dafter=0;
 dparent=dpage;

 pagep=(pagestr*)fob_find(mpage,file);
 mchild=pagep->chain.child;

 while(mchild)
 {
  sob=(sobjectstr*)fob_find(mchild,file);
  mnext=sob->chain.next;

  message=OM_FINDMASTER;
  master=mchild;

  objectchainmessage(dchild,file,&message,&master);

  if(!message)
  {
   if(master!=dchild)
   {
    sloc.file=file;
    sloc.object=master;
    sloc.page=dpage;
    sloc.section=dsection;
    sloc.chain=0;
    sloc.branch=0;

    dloc.file=file;
    dloc.object=0;
    dloc.page=dpage;
    dloc.section=dsection;
    dloc.chain=0;
    dloc.branch=0;
    dloc.parent=dparent;
    dloc.after=dafter;
    dloc.copymode=LOCMOVE;

    err=objectcopy(&sloc,&dloc,&tr);

    dafter=dloc.object;
   }
   else
   {
    dafter=dchild;
    sob=(sobjectstr*)fob_find(dchild,file);
    dchild=sob->chain.next;
   }

   dparent=0;
  }

  mchild=mnext;
 }

 return(err);
}



/* find master page                                */
/* scan through frames on master page              */
/* find document frame, and move into correct posn */


os_error * canonicalsection(int dsection,int next,int left,filestr * file)
{
 os_error   * err;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          msection;
 int          dpage;
 int          mpage[2];
 int          hand;

 err=NULL;

 sectionp=(sectionstr*)fob_find(dsection,file);
 if(!next) next=sectionp->chain.child;
 msection=sectionp->dual;

 sectionp=(sectionstr*)fob_find(msection,file);
 mpage[0]=sectionp->chain.child;
 pagep=(pagestr*)fob_find(mpage[0],file);
 mpage[1]=pagep->chain.next;
 if(!mpage[1]) mpage[1]=mpage[0];

 hand=!left;

 while(next)
 {
  dpage=next;
  pagep=(pagestr*)fob_find(dpage,file);
  next=pagep->chain.next;

  err=canonicalpage(dpage,dsection,mpage[hand],file);
  if(err) break;

  hand^=1;
 }

 return(err);
}










/* want to make a left hand page into a right hand one */

/* for double sided documents, go through pages in pairs            */
/* swop master frames between pages                                 */
/* if a master frame is local/has contents on last page add a page  */



static os_error * movemaster(int page1,int child1,int page2,
                                       int section,int chain,filestr * file)
{
 os_error     * err;
 objectloc      sloc;
 objectloc      dloc;
 int            parent;
 int            after;
 sobjectstr   * sob;
 int            next;
 int            master;
 objectbitstr   bits;
 transformstr   tr;

 err=NULL;

 memset(&sloc,0,sizeof(objectloc));
 memset(&dloc,0,sizeof(objectloc));

 tr_setidentity(&tr);

 after=0;
 parent=page2;

 while(child1)
 {
  objectmaster(child1,file,&master,&bits);
  if(!master) break;

  sob=(sobjectstr*)fob_find(child1,file);
  next=sob->chain.next;

  sloc.file=file;
  sloc.object=child1;
  sloc.page=page1;
  sloc.section=section;
  sloc.chain=chain;
  sloc.branch=0;

  dloc.file=file;
  dloc.object=0;
  dloc.page=page2;
  dloc.section=section;
  dloc.chain=chain;
  dloc.parent=parent;
  dloc.after=after;
  dloc.copymode=LOCMOVE;
  dloc.branch=0;


  err=objectcopy(&sloc,&dloc,&tr);

  after=dloc.object;
  parent=0;
  child1=next;
 }

 return(err);
}





os_error * alternatepages(int section,int start,filestr * file)
{
 os_error    * err;
 sectionstr  * sectionp;
 pagestr     * pagep;
 int           next;
 int           dpage1;
 int           dpage2;
 int           child1;
 int           gchild1;
 int           child2;
 int           gchild2;
 int           message;


/* dprintf(2,"alternate page"); */

 err=NULL;

 sectionp=(sectionstr*)fob_find(section,file);
 if(sectionp->data.dble)
 {
  if(!start) start=sectionp->chain.child;
  next=start;

  while(next)
  {
   dpage1=next;
   pagep=(pagestr*)fob_find(dpage1,file);
   dpage2=pagep->chain.next;
   child1=pagep->chain.child;
   gchild1=pagep->gchain.child;
   pagep=(pagestr*)fob_find(dpage2,file);
   next=pagep->chain.next;
   child2=pagep->chain.child;
   gchild2=pagep->gchain.child;

   /* move all master frames from page 1 to page 2 */

   movemaster(dpage1,child1,dpage2,section,0,file);

   /* move all master frames from page 2 to page 1 */

   movemaster(dpage2,child2,dpage1,section,0,file);


   movemaster(dpage1,gchild1,dpage2,section,PGLINECHAIN,file);

   movemaster(dpage2,gchild2,dpage1,section,PGLINECHAIN,file);
  }

  next=start;
  while(next)
  {
   dpage1=next;
   pagep=(pagestr*)fob_find(dpage1,file);
   next=pagep->chain.next;
   relinkpage(dpage1,section,file);
  }

  message=OM_REFLOW;
  objectchainmessage(start,file,&message,(void*)(FLNONE|TXREFLOWVBOX));
  message=OM_REFLOW;
  objectchainmessage(start,file,&message,(void*)(TXREFLOWZERO|FLDELTA));

#ifndef PROD
  checksect(section,file);
#endif
 }

 return(err);
}


/*****************************************************************************/

static int           msection;  /* this is a doc section */
static pagenumberstr mpagenum;
static pagenumberstr opagenum;
static int           dopagenoreflow;



os_error * checkheaderfooter(int section,int both,filestr * file)
{
 sectionstr     * sectionp;
 pagestr        * pagep;
 sectiondatastr   data;
 int              page;
 int              child;
 int              next;
 int              master;
 int              message;
 textboxstr     * textp;
 int              i;

 sectionp=(sectionstr*)fob_find(section,file);
 data=sectionp->data;

 page=sectionp->chain.child;

 while(1)
 {
  pagep=(pagestr*)fob_find(page,file);
  child=pagep->chain.child;
  next=pagep->chain.next;

  for(i=0;i<=data.dble;i++)
  {
   if((master=data.mainkey[i])!=0)
   {
    textp=(textboxstr*)fob_find(master,file);
    if(textp->data.header || textp->data.footer)
    {
     message=OM_FINDMASTER;
     objectchainmessage(child,file,&message,&master);
     if(!message) 
     {
      message=OM_REFLOW;
      objectmessage2(master,file,&message,(void*)(FLQUICK|TXREFLOWVBOX));
     }
    }
   }
  }

  if(!both) break;
  both=0;
  page=next;
  if(!page) break;
 }

 return(NULL);
 USE(both);
}



/* called last */

/* tagged with UMODCHAPS */

static os_error * modchaps(filestr * file)
{
 os_error   * err;
 int          alternate;

 err=NULL;

 alternate=0;

 if(undoforward(file) && opagenum.left!=mpagenum.left)
 {
  err=alternatepages(msection,0,file);
  alternate=1;
 }

 if(dopagenoreflow) pagereflowsection(msection,file);

 if((mpagenum.omitheader!=opagenum.omitheader ||
     mpagenum.omitfooter!=opagenum.omitfooter) && !alternate)
 {
  checkheaderfooter(msection,1,file);
 }

 fileresetviews(file,FRVREFRESH);

 undowritefn(file,UMODCHAPF,&msection,sizeof(int));
 undowrite(file,&opagenum,sizeof(pagenumberstr));

 return(err);
}




static os_error * modchapfsub(filestr * file)
{
 os_error   * err;
 sectionstr * sectionp;
 int          dual;

 err=undowritefn(file,UMODCHAPS,NULL,0);


 sectionp=(sectionstr*)fob_find(msection,file);
 opagenum=sectionp->data.pagenumber;

 if(sectionp->data.dble && 
    (sectionp->np & 0x1) && 
    mpagenum.left!=opagenum.left)
 {
  /* make up an even number of pages */

  catpage(lastpageinsection(msection,file),msection,file);
 }


 fob_mod(msection,file,(fobjptr)&sectionp);
 sectionp->data.pagenumber=mpagenum;
 dual=sectionp->dual;
 fob_mod(dual,file,(fobjptr)&sectionp);
 sectionp->data.pagenumber=mpagenum;

 dopagenoreflow=0;

 if(mpagenum.format!=opagenum.format ||
    mpagenum.start!=opagenum.start  ||
    mpagenum.number!=opagenum.number ||
    mpagenum.blanks!=opagenum.blanks)
 {
  renumbersections(file);
  if(
     (mpagenum.start!=opagenum.start) ||
     ((mpagenum.blanks!=opagenum.blanks) && !mpagenum.start) ||
     ((mpagenum.number!=opagenum.number) && mpagenum.start)
    )
  {
   renumberpages(NULL,msection,0,file);
  }
  else
  {
   renumberpages(NULL,msection,RENSECT,file);
  }

  dopagenoreflow=1;
 }

 if(!undoforward(file) && opagenum.left!=mpagenum.left)
 {
  err=alternatepages(msection,0,file);
 }

 return(err);
}



/* called first */

/* tagged with UNMODCHAPF */

static os_error * modchapf(filestr * file)
{
 undoread(file,&msection,sizeof(int));
 undoread(file,&mpagenum,sizeof(pagenumberstr));

 return(modchapfsub(file));
}





os_error * modifychapter(viewstr * view,int section,pagenumberstr * pagenum)
{
 os_error      * err;
 filestr       * file;
 sectionstr    * sectionp;


 file=view->file;

 err=modfile(file,section);
 if(!err)
 {
  sectionp=(sectionstr*)fob_find(section,file);

  if(pagenum->format!=sectionp->data.pagenumber.format ||
     pagenum->start!=sectionp->data.pagenumber.start ||
     pagenum->number!=sectionp->data.pagenumber.number ||
     pagenum->left!=sectionp->data.pagenumber.left ||
     pagenum->omitheader!=sectionp->data.pagenumber.omitheader ||
     pagenum->omitfooter!=sectionp->data.pagenumber.omitfooter ||
     pagenum->blanks!=sectionp->data.pagenumber.blanks)
  {
   err=undostart(file);
   if(!err)
   {
    clearselectionf(file);

    msection=section;
    mpagenum=*pagenum;
    opagenum=sectionp->data.pagenumber;
    err=modchapfsub(file);
    if(mpagenum.left!=opagenum.left)
    {
     canonicalsection(msection,0,opagenum.left,file);
    }
    if(!err) err=modchaps(file);
    undoend(file);
   }
  }
 }
 return(err);
}






#define UNDOS 2

static undofnstr undos[UNDOS]=
{
 modchapf,        NULL, UMODCHAPF,        "{UNMD}",
 modchaps,        NULL, UMODCHAPS,        "{UNMD}",
};



os_error * modchapinit(void)
{
 return(undoaddblock(undos,UNDOS));
}


