/*->h.units */

#define MILIMS  0
#define INCHES  1
#define POINTS  2
#define PICAS   3
#define CENTIMS 4
#define DIDOT   5
#define CICERO  6
#define FOOT    7
#define YARD    8
#define TWIPS   9


#define MMMUL 720000
#define MMDIV 254
#define MMSIZE (MMMUL/MMDIV)
#define MMUNITS(a) ((MMMUL*(a))/MMDIV)
#define MMRUNITS(a,b) ((MMMUL*(a))/(MMDIV*(b)))


#define MAXSKEW   (0x10000*80)
#define MINSKEW   (-(0x10000*80))

#define MAXANGLE  (0x10000*360)
#define MINANGLE  (-(0x10000*360))



extern char     * unitname(int unit);

extern os_error * stringtounitsv(char * string,int * value,int unit);
extern os_error * stringtounits(char * string,int * value,int unit);
extern char     * unitstostring(int value,int unit);

extern os_error * stringtonumber(char * string,int * value);
extern char     * numbertostring(int value);

extern char     * numbertostringdp(int value,int dp);
extern os_error * stringtonumberdp(char * string,int * value,int dp);

extern os_error * stringtonumberxdp(char * string,int * value,int dp,int base);
extern os_error * stringtonumberxdpge(char * string,int * value,int dp,int base);
extern os_error * stringtonumberxdpgelt100(char * string,int * value,int dp,int base);

extern char     * numbertostringxdp(int value,int dp,int base);


extern os_error * writeangle(int value,char * string);
extern os_error * readangle(int * value,char * string);
extern os_error * readskew(int * value,char * string);
extern os_error * writeskew(int value,char * string);

extern int        snapangle(int a,int step);

extern os_error * writepc(int value,char * string);
extern os_error * readpc(int * value,char * string);
extern os_error * readpc100(int * value,char * string);


typedef os_error * (*setunitsmenuhandler)(int n);
typedef os_error * (*getunitsmenuhandler)(int * n);

extern os_error * openunitsmenu(setunitsmenuhandler xssmh,
                                getunitsmenuhandler xgsmh,int parent);


extern int        getunits(int fp);
extern void       setunits(int fp);


