/*->c.xpage */

#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"

#include "deb.h"
#include "err.h"
#include "transform.h"
#include "etc.h"
#include "poll.h"
#include "xext.h"
#include "trans.h"
#include "bits.h"


#include "constants.h"
#include "str.h"
#include "object.h"
#include "chain.h"
#include "undo.h"

#include "reslink.h"

#include "view.h"
#include "viewo.h"
#include "viewr.h"
#include "file.h"
#include "select.h"
#include "pref.h"

#include "txstr.h"
#include "fl.h"

#include "section.h"
#include "page.h"


#include "new.h"
#include "newx.h"
#include "modchap.h"

#include "mpage.h"

#include "xpage.h"






#ifdef NEVER

void findpage(int pn,int absolute,int * xpage,
                     int * xsection,int * apno,viewstr * view)
{
 filestr    * file;
 int          nextsection;
 int          section;
 int          page;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          an;
 int          over;

 page=0; /* compiler */

 file=view->file;

 an=0;
 over=0;

 section=file->hdr.section[view->branch];

 while(section)
 {
  sectionp=fob_find(section,file);
  nextsection=sectionp->chain.next;

  page=sectionp->chain.child;
  while(page)
  {
   pagep=fob_find(page,file);

   if(absolute)
   {
    if(an==pn || (!pagep->chain.next && !nextsection)) 
    {
     over=1;
     break;
    }
   }
   else
   {
    if(pagep->data.number==pn || (!pagep->chain.next && !nextsection))
    {
     over=1;
     break;
    }
   }
   an++;
   page=pagep->chain.next;
  }

  if(over) break;
  section=nextsection;
 }

 if(xsection) *xsection=section;
 if(xpage)    *xpage=page;
 if(apno)     *apno=an;
}


#endif






int apageno(int xpage,int xsection,filestr * file,int branch)
{
 sectionstr * sectionp;
 pagestr    * pagep;
 int          an;
 int          section;
 int          page;
 int          nextsection;


 an=0;

 section=file->hdr.section[branch];

 while(section)
 {
  sectionp=(sectionstr*)fob_find(section,file);
  nextsection=sectionp->chain.next;

  if(section==xsection)
  {
   page=sectionp->chain.child;
   while(page)
   {
    if(page==xpage) break;

    pagep=(pagestr*)fob_find(page,file);
    an++;
    page=pagep->chain.next;
   }
   break;
  }
  else
  {
   an+=sectionp->np;
  }
  section=nextsection;
 }

 return(section?an:0);
}



void psapageno(int apno,int * xpage,int * xsection,filestr * file,int branch)
{
 sectionstr * sectionp;
 pagestr    * pagep=NULL;
 int          an;
 int          section;
 int          page;
 int          nextsection;


 page=0; /* compiler */

 an=0;

 section=file->hdr.section[branch];

 while(section)
 {
  sectionp=(sectionstr*)fob_find(section,file);
  nextsection=sectionp->chain.next;

  if(apno>=an && apno<(an+sectionp->np))
  {
   page=sectionp->chain.child;
   while(page)
   {
    if(an==apno) break;
    pagep=(pagestr*)fob_find(page,file);
    an++;
    page=pagep->chain.next;
   }

			cprintf("apno %d pn %d",apno,pagep?pagep->data.number:0);

   break;
  }
  else
  {
   an+=sectionp->np;
  }
  section=nextsection;
 }

 if(!section) section=file->hdr.section[branch];
 if(!page)
 {
  sectionp=(sectionstr*)fob_find(section,file);
  page=sectionp->chain.child;
 }

 *xpage=page;
 *xsection=section;
}




os_error * writepagenumber(char * string,int secno,int pageno)
{
 sprintf(string,"%d.%d",secno,pageno);
 return(NULL);
}


os_error * writepagenumbera(char * string,int apno,int cont,viewstr * view)
{
 filestr    * file;
 pagestr    * pagep;
 sectionstr * sectionp;
 int          page;
 int          section;

 file=view->file;
 psapageno(apno,&page,&section,file,view->branch);

 pagep=(pagestr*)fob_find(page,file);
 sectionp=(sectionstr*)fob_find(section,file);

 if(cont) sprintf(string,"%d",pagep->data.number);
 else     sprintf(string,"%d.%d",sectionp->data.number,pagep->data.number);

 return(NULL);
}




/* read a page number */


/*

   pagenumber = number || 'A'number || number'.'number || number'/'number
                       || number.*
                       || number.

   pagerange  = pagenumber 'to' pagenumber || pagenumber 
                                           || pagenumber '-' pagenumber
                     [, pagerange]

*/



static int pgspc(char ** string)
{
 char * p;
 int    c;

 p=*string;
 while((c=*p)==' ') p++;
 *string=p;
 return(c);
}




static os_error * pgnum(char * string,int * lenp,int * var,int * absolute)
{
 os_error * err;
 int        c;
 int        val;
 char     * p;
 int        seen;

 err=NULL;

 p=string;
 val=seen=0;


 while(1)
 {
  c=pgspc(&p);
  if(tolower(c)=='a' && (!(*absolute)))
		{
		 p++;
			*absolute=1;
		}
  else
  {
   if(!isdigit(c)) err=geterror(PA00);
   break;
  }
 }


 if(!err)
 {
  while((c=*p)!=0)
  {
   if(isdigit(c))
   {
    seen=1;
    val=val*10+(c-'0');
    p++;
   }
   else
   {
    break;
   }
  }
 }

 if(!seen) err=geterror(PA00);

 *var=val;
 *lenp=p-string;

 return(err);
}



static os_error * scanpg(char * string,filestr * file,int branch,
                                                      int * lenp,int * var)
{
 os_error   * err;
 char       * p;
 int          pno;
 int          sno;
 int          apn;
 int          section;
 int          nextsection;
 sectionstr * sectionp;
 int          page;
 pagestr    * pagep;
 int          len;
 int          chapterstart;
 int          absolute;
 int          c;



 p=string;

 absolute=0;
 err=pgnum(string,&len,&sno,&absolute);
 if(!err)
 {
  p+=len;

  if(absolute)
  {
			cprintf("scanpg absolute %d",sno);

   *var=sno-1;
  }
  else
  {
   c=pgspc(&p);

   if(c=='.' || c=='/')
   {
    p++;
    c=tolower(*p);
    if(c=='*' || c=='f')
    {
     pno=-1;
     p++;
    }
    else
    if(c=='l')
    {
     pno=-2;
     p++;
    }
    else
    if(!isdigit(c)) /* S. case */
    {
     pno=-1;
    }
    else
    {
     absolute=1;
     err=pgnum(p,&len,&pno,&absolute);
     p+=len;
    }

    if(!err)
    {
     chapterstart=prefp(file)->chapterstart;
     sno-=chapterstart;

     if(sno<0 || sno>=file->hdr.ns[branch]) err=geterror(PA00);
     else
     {
      section=file->hdr.section[branch];
      apn=0;
      while(sno--)
      {
       sectionp=(sectionstr*)fob_find(section,file);
       apn+=sectionp->np;
       section=sectionp->chain.next;
      }

      sectionp=(sectionstr*)fob_find(section,file);

      page=sectionp->chain.child;
      pagep=(pagestr*)fob_find(page,file);

      if(pno==-1) pno=0;
      else
      if(pno==-2) pno=sectionp->np-1;
      else        pno-=pagep->data.number;

      if(pno<0 || pno>=sectionp->np) err=geterror(PA01);

      apn+=pno;
      *var=apn;
     }
    }
   }
   else   /* sort out case of pagenumber with no section */
   {
    section=file->hdr.section[branch];
    apn=0;

    while(section)
    {
     sectionp=(sectionstr*)fob_find(section,file);
     nextsection=sectionp->chain.next;

     page=sectionp->chain.child;
     while(page)
     {
      pagep=(pagestr*)fob_find(page,file);

      if(pagep->data.number==sno)
      {
       break;
      }
      apn++;
      page=pagep->chain.next;
     }
     if(page) break;
     section=nextsection;
    }
    if(!section) err=geterror(PA01);

    *var=apn;
   }
  }
 }


 *lenp=p-string;

 return(err);
}





os_error * readpagenuma(char * string,int * value,viewstr * view)
{
 os_error   * err;
 int          len;


	cprintf("readpagenuma");
 err=scanpg(string,view->file,view->branch,&len,value);
 if(!err)
 {          /* check for trailing junk */
  string+=len;
  if(pgspc(&string)>=' ') err=geterror(PA00);
 }

 return(err);
}




os_error * readpagerange(char * string,int * range,int * rmax,
                                                   filestr * file,int branch)
{
 os_error * err;
 int        v1;
 int        v2;
 int        n;
 int        len;
 int        c;
 char     * tp;
 int        tplen;


 err=NULL;
 n=0;

 tp=transtoken("PA05");
 tplen=strlen(tp);

 while(1)
 {
  err=scanpg(string,file,branch,&len,&v1);
  if(err) break;
  string+=len;

  c=tolower(pgspc(&string));

  if(cstrncmp(tp,string,tplen)==0 || c=='-')
  {
   if(c=='-') string++;
   else       string+=tplen;

   err=scanpg(string,file,branch,&len,&v2);
   if(err) break;
   string+=len;
   range[n*2]=v1;
   range[n*2+1]=v2;
   if(v1>v2)
   {
    err=geterror(PA02);
    break;
   }
   n++;

   c=tolower(pgspc(&string));
  }
  else
  {
   range[n*2]=range[n*2+1]=v1;
   n++;
  }

  if(c==',')
  {
   /* continue */
   string++;
  }
  else
  if(c<' ') break;
  else
  {
   /* trailing junk */
   err=geterror(PA00);
   break;
  }
 }

 *rmax=n;

 return(err);
}












/* are pages contiguously numbered? */

int contnum(filestr * file,int branch)
{
 int          section;
 sectionstr * sectionp;
 int          page;
 pagestr    * pagep;
 int          n;
 int          start;

 section=file->hdr.section[branch];
 start=n=1;

 while(section)
 {
  sectionp=(sectionstr*)fob_find(section,file);
  section=sectionp->chain.next;

  page=sectionp->chain.child;
  while(page)
  {
   pagep=(pagestr*)fob_find(page,file);
   page=pagep->chain.next;

   if(start)
   {
    start=0;
    n=pagep->data.number;
   }
   else
   {
    if(n>=pagep->data.number) return(0);
    else n=pagep->data.number;
   }
  }
 }

 return(1);
}





/* fpage is marked bad, reflow from start of it to end of section */
/* changed to zero frame contents - see text.c.mx                 */

static os_error * reflowpages(int fpage,int fsect,filestr * file)
{
 newflowstr newflow;

 newflow.page=fpage;
 newflow.section=fsect;

 return(event(EVENT_REFLOWPAGES,file,(int)&newflow));
}



/* these pages have been taken out of the flow chain */
/* chance to stip out any line data                  */

static os_error * delinkpages(int fpage,int lpage,int fsect,filestr * file)
{
 newflowstr   newflow;
 pagestr    * pagep;

 while(1)
 {
  newflow.page=fpage;
  newflow.section=fsect;

  event(EVENT_DELINKPAGE,file,(int)&newflow);

  if(fpage==lpage) break;
  pagep=(pagestr*)fob_find(fpage,file);
  fpage=pagep->chain.next;
 }

 return(NULL);
}




static os_error * makepage(int msection,int mpage,
                           int dsection,int * dpage,
                           int n,filestr * file,int mode)
{
 os_error     * err;
 objectloc      src;
 objectloc      dest;
 sectionstr   * sectionp;
 newpagestr     newpage;
 transformstr   tr;


 sectionp=(sectionstr*)fob_find(msection,file);
 newpage.data=sectionp->data;
 newpage.pagenumber=n;

 dest.file=file;
 dest.section=dsection;
 dest.page=0;
 dest.branch=0;
 dest.object=0;

 err=objectnew(&dest,OPAGE,&newpage);

 *dpage=dest.object;



 src.file=file;
 src.section=msection;
 src.page=mpage;
 src.branch=1;
 src.object=src.page;
 src.parent=src.page;
 src.after=0;
 src.chain=0;



 dest.file=file;
 dest.section=dsection;
 dest.page=*dpage;
 dest.branch=0;
 dest.object=0;
 dest.parent=*dpage;
 dest.after=0;
 dest.chain=0;
 dest.copymode=LOCFLOWDATA|mode;


 tr_setidentity(&tr);

 err=objectcopy(&src,&dest,&tr);

 return(err);
}



/* adds a page to the current section - called by flow */

os_error * catpage(int dpage,int dsection,filestr * file)
{
 os_error   * err;
 int          mpage;
 int          msection;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          n;
 int          dble;
 int          oldpage;
 int          base;
 int          mode;
 int          np;

 err=NULL;


/* dprintf(7,"cat page"); */

 sectionp=(sectionstr*)fob_find(dsection,file);
 base=getpagebase(sectionp);
 np=sectionp->np;
 msection=sectionp->dual;

 pagep=(pagestr*)fob_find(dpage,file);
 n=pagep->data.number+1;

 sectionp=(sectionstr*)fob_find(msection,file);
 mpage=sectionp->chain.child;
 dble=sectionp->data.dble;
 mode=0;


 if(dble)
 {
  if(!islhpnb(n,base))
  {
   pagep=(pagestr*)fob_find(mpage,file);
   mpage=pagep->chain.next;
  }
 }


 oldpage=dpage;
 makepage(msection,mpage,dsection,&dpage,n,file,mode);
 insafter(dpage,oldpage,0,0,file);

 sectionp=(sectionstr*)fob_find(dsection,file);
 sectionp->np++;

 file->hdr.np[DOC]++;


 relinkpage(dpage,dsection,file);

 /*

  can't do this, because we are inside flow code !

 if(!err) err=objectchainmessage(child,file,OM_REFLOW,NULL);

 */

 renumbersections(file);
 renumberpages(dpage,dsection,RENFLOW,file);

 pagereflowpage(dpage,file); /* this was once commented */
                             /* it is needed because renumberpages() */
                             /* starts from the next page */
                             /* test add page whose page number has 3 digits */
                             /* number will spill out - DP147 */

 err=fileresetviews(file,0);

 viewrefreshpageplus(oldpage,dsection,0,file);

 return(err);
}



/* as soon as you see a non-master object ack the message */

static os_error * changefn(objhdrstr * obj,filestr * file,int * message)
{
 os_error    * err;
 int           master;
 objectbitstr  bits;
 
 err=objectmaster(obj->key,file,&master,&bits);
 if(!master) *message=0;
 else
 {
  if(bits.local) *message=0;
  else
  if(bits.localdata) *message=0;
 }

 return(err);
}


/* is this page different to master page */

os_error * changedpage(int dpage,filestr * file,int * changed)
{
 os_error * err;
 int        message;
 pagestr  * pagep;

 pagep=(pagestr*)fob_find(dpage,file);

 message=OM_FUNCTION;

 err=objectchainmessage(pagep->chain.child,file,&message,(void *)changefn);

 *changed=(message==0);

 return(err);
}



os_error * scrappagecontents(int page,filestr * file)
{
 int           child;
 pagestr     * pagep;
 chainobject * chainp;

 if(page)
 {
 /* dprintf(0,"scrappagecontents %d",page); */

  pagep=(pagestr*)fob_find(page,file);

  child=pagep->chain.child;
  while(child)
  {
   chainp=(chainobject*)fob_find(child,file);
   child=chainp->chain.next;
   objectdelete((objhdrstr*)chainp,DELETESCRAP|DELETEUNLINK,file);
  }

  pagep=(pagestr*)fob_find(page,file);
  child=pagep->gchain.child;
  while(child)
  {
   chainp=(chainobject*)fob_find(child,file);
   child=chainp->chain.next;
   objectdelete((objhdrstr*)chainp,DELETESCRAP|DELETEUNLINK,file);
  }

  fob_delete(page,file);
 }

 return(NULL);
}


static os_error * trashpage(int page,int section,filestr * file)
{
 os_error    * err;
 sectionstr  * sectionp;

 file->hdr.np[DOC]--;
 err=fob_mod(section,file,(fobjptr)&sectionp);
 if(!err)
 {
  sectionp->np--;
  unlinkobject(page,0,file);
  scrappagecontents(page,file);
 }

 return(err);
}



os_error * scrapsection(filestr * file,int section)
{
 os_error   * err;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          page;
 int          next;
 int          oldmaster;

 sectionp=(sectionstr*)fob_find(section,file);
 page=next=sectionp->chain.child;
 oldmaster=sectionp->oldmaster;

 while(next)
 {
  pagep=(pagestr*)fob_find(page,file);
  next=pagep->chain.next;
  scrappagecontents(page,file);
  page=next;
 }

 scrapoldmaster(oldmaster,file);

	sectionscrapmap(section,file);

 err=fob_delete(section,file);

 return(err);
}




/* throws pages away, called by flow  */

os_error * uncatpage(int page,int section,filestr * file,int mode)
{
 os_error *   err;
 int          prev;
 int          next;
 int          changes;
 int          changed;
 pagestr    * pagep;
 sectionstr * sectionp;
 int          last;

/* dprintf(4,"uncat page=%d",page); */

 err=NULL;
 changes=0;

 pagep=(pagestr*)fob_find(page,file);
 last=page;                   /* compiler */
 prev=pagep->chain.prev;

 if(prev)
 {
  next=page;

  while(next)
  {
   last=next;
   pagep=(pagestr*)fob_find(next,file);
   next=pagep->chain.next;
  }

  next=last;
  while(next!=prev)
  {
   last=page=next;
   pagep=(pagestr*)fob_find(page,file);
   next=pagep->chain.prev;

   changedpage(page,file,&changed);
   if(!changed)
   {
    if(isselectedpage(page,file)) clearselectionlo();
    /* situation of deleting backwards off page - selected page is */
    /* uncatted */

    trashpage(page,section,file);
    changes=1;
    last=next;
   }
   else break;

   if(mode==0) break;
  }

  if(changes)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   if(sectionp->data.dble)
   {
    pagep=(pagestr*)fob_find(last,file);        /* handle dble linked sections */
    relinkpage(pagep->chain.prev,section,file);
   }

   relinkpage(last,section,file);

   renumbersections(file);
   renumberpages(prev,section,RENFLOW,file);

   fileresetviews(file,0);

   viewrefreshpageplus(prev,section,0,file);
  }
 }

 return(err);
}


/****************************************************************************/


static os_error * checkplink(int fpage,int lpage,filestr * file)
{
 pagestr      * pagep;
 plinkdatastr   plinkdata;
 int            message;
 int            next;

 pagep=(pagestr*)fob_find(fpage,file);
 plinkdata.nf=pagep->data.number;
 pagep=(pagestr*)fob_find(lpage,file);
 plinkdata.nl=pagep->data.number;

 message=OM_PLINK;

 while(fpage)
 {
  pagep=(pagestr*)fob_find(fpage,file);
  next=pagep->chain.next;
  objectchainmessage(pagep->chain.child,file,&message,&plinkdata);
  if(!message) return(geterror(PA04));  /* Linked frames */
  if(fpage==lpage) break;
  fpage=next;
 }

 return(NULL);
}




static os_error * insertpagesub(int index,int np,int fpage,
                                          int lpage,int fsect,filestr * file)
{
 os_error   * err;
 int          fprev;
 int          lnext=NULL;
 pagestr    * pagep;
 sectionstr * sectionp;
 int          lastpage;
 int          xnp;


 err=undowritefn(file,UDPAGE,NULL,0);
 undowrite(file,&index,sizeof(int));
 undowrite(file,&np,sizeof(int));
 undowrite(file,&fsect,sizeof(int));


 sectionp=(sectionstr*)fob_find(fsect,file);
 if(index)
 {
  fprev=sectionp->chain.child;
  while(1)
  {
   pagep=(pagestr*)fob_find(fprev,file);
   lnext=pagep->chain.next;
   index--;
   if(index)
   {
    fprev=lnext;
   }
   else
   {
    break;
   }
  }
 }
 else
 {
  lnext=sectionp->chain.child;
  fprev=0;
 }


 if(sectionp->data.dble && (np & 0x1) && lnext)
 {
  lastpage=lastpageinsection(fsect,file);
  pagep=(pagestr*)fob_find(lastpage,file);
  xnp=pagep->data.number;
  pagep=(pagestr*)fob_find(lnext,file);
  xnp-=pagep->data.number;
  xnp++;

  if(xnp & 0x1) catpage(lastpage,fsect,file);
 }


 pagep=(pagestr*)fob_find(fpage,file);
 pagep->chain.prev=fprev;

 pagep=(pagestr*)fob_find(lpage,file);
 pagep->chain.next=lnext;


 if(fprev)
 {
  fob_mod(fprev,file,(fobjptr)&pagep);
  pagep->chain.next=fpage;
 }
 else
 {
  fob_mod(fsect,file,(fobjptr)&sectionp);
  sectionp->chain.child=fpage;
 }

 if(lnext)
 {
  fob_mod(lnext,file,(fobjptr)&pagep);
  pagep->chain.prev=lpage;
 }

 file->hdr.np[DOC]+=np;
 sectionp=(sectionstr*)fob_find(fsect,file);
 sectionp->np+=np;

 renumberpages(fprev?fprev:fpage,fsect,RENSECT,file);

 if(sectionp->data.dble && (np & 0x1) && lnext)
 {
  alternatepages(fsect,lnext,file);
 }

 relinkpagerange(fprev?fprev:fpage,np+2,fsect,file);

 reflowpages(fpage,fsect,file);

 renumbersections(file);
 renumberpages(fprev?fprev:fpage,fsect,RENFLOW,file);
 renumberpages(lpage,fsect,RENFLOW,file);

 pagereflowsectionplus(fpage,file);

 err=fileresetviews(file,0);

 viewrefreshpageplus(fpage,fsect,VPPREV,file);

 return(err);
}



/* tagged to UIPAGE */

os_error * uninsertpagescrap(filestr * file)
{
 os_error   * err;
 int          fpage;
 int          lpage;
 int          fsect;
 pagestr    * pagep;
 int          next;
 int          index;
 int          np;


 err=NULL;


 undoread(file,&index,sizeof(int));
 undoread(file,&np,sizeof(int));
 undoread(file,&fpage,sizeof(int));
 undoread(file,&lpage,sizeof(int));
 undoread(file,&fsect,sizeof(int));
 
 while(fpage)
 {
  pagep=(pagestr*)fob_find(fpage,file);
  next=pagep->chain.next;
  scrappagecontents(fpage,file);
  if(fpage==lpage) break;
  fpage=next;
 }

 return(err);
}


/* inserts pages that have once been deleted */

os_error * uninsertpages(filestr * file)
{
 os_error   * err;
 int          fpage;
 int          lpage;
 int          fsect;
 int          index;
 int          np;


 undoread(file,&index,sizeof(int));
 undoread(file,&np,sizeof(int));
 undoread(file,&fpage,sizeof(int));
 undoread(file,&lpage,sizeof(int));
 undoread(file,&fsect,sizeof(int));

 err=insertpagesub(index,np,fpage,lpage,fsect,file);

 return(err);
}





os_error * doinsert(int page,int dsection,int number,int after,filestr * file)
{
 os_error   * err;
 sectionstr * sectionp;
 int          msection;
 int          fpage;
 int          lpage;
 int          i;
 int          dble;
 int          dpage;
 int          fprev;
 int          lnext;
 int          mpage;
 int          mprevpage;
 pagestr    * pagep;
 int          n;
 int          base;
 int          left;
 int          index;


 err=modfile(file,dsection);
 if(!err)
 {
  err=undostart(file);
  if(!err)
  {
   clearselectionf(file);

   sectionp=(sectionstr*)fob_find(dsection,file);
   msection=sectionp->dual;
   base=getpagebase(sectionp);
   dble=sectionp->data.dble;
   index=sectionp->data.pagenumber.number;

   pagep=(pagestr*)fob_find(page,file);
   index=pagep->data.number-index;

   if(after)
   {
    n=pagep->data.number+1;
    fprev=page;
    lnext=pagep->chain.next;
    index++;
   }
   else
   {
    n=pagep->data.number;
    fprev=pagep->chain.prev;
    lnext=page;
   }

   fpage=lpage=0;

   for(i=0;i<number;i++)
   {
    sectionp=(sectionstr*)fob_find(msection,file);
    mpage=sectionp->chain.child;

    if(dble)
    {
     pagep=(pagestr*)fob_find(mpage,file);
     if(!islhpnb(n,base))
     {
      mpage=pagep->chain.next;
     }
     else
     {
      mprevpage=pagep->chain.next;
     }
    }
    else
    {
     mprevpage=mpage;
    }

    makepage(msection,mpage,dsection,&dpage,n,file,0);
  
    if(!fpage)
    {
     fpage=dpage;
    }

    if(lpage)
    {
     pagep=(pagestr*)fob_find(lpage,file);
     pagep->chain.next=dpage;
     pagep=(pagestr*)fob_find(dpage,file);
     pagep->chain.prev=lpage;
    }

    lpage=dpage;

    n++;
   }

   if(dble && (number & 0x1) && lnext)
   {
    pagep=(pagestr*)fob_find(lnext,file);
    n=pagep->data.number;
    left=islhpnb(n,base);
    canonicalsection(dsection,lnext,!left,file);
   }

   insertpagesub(index,number,fpage,lpage,dsection,file);

   undoend(file);
  }
 }

 return(err);
}




static os_error * deletepagesub(int index,int np,int fsect,filestr * file)
{
 os_error   * err;
 int          fpage;
 int          lpage;
 int          fprev=0;
 int          lnext=0;
 int          olnext;
 pagestr    * pagep;
 sectionstr * sectionp;
 int          n;
 int          dble;
 int          lastpage;
 int          xnp;


 sectionp=(sectionstr*)fob_find(fsect,file);
 dble=sectionp->data.dble;

 fpage=sectionp->chain.child;
 if(index)
 {
  n=index;
  while(1)
  {
   pagep=(pagestr*)fob_find(fpage,file);
   fprev=fpage;
   fpage=pagep->chain.next;
   n--;
   if(!n) break;
  }
 }
 else
 {
  fprev=0;
 }

 lpage=fpage;

 n=np;
 while(1)
 {
  pagep=(pagestr*)fob_find(lpage,file);
  lnext=pagep->chain.next;
  n--;
  if(n) lpage=lnext;
  else  break;
 }

 err=undowritefn(file,UIPAGE,NULL,0);
 undowrite(file,&index,sizeof(int));
 undowrite(file,&np,sizeof(int));
 undowrite(file,&fpage,sizeof(int));
 undowrite(file,&lpage,sizeof(int));
 undowrite(file,&fsect,sizeof(int));

 olnext=lnext;


 if(!lnext && !fprev)
 {
  sectionp=(sectionstr*)fob_find(fsect,file);
  n=sectionp->data.pagenumber.number;

  pagep=(pagestr*)fob_find(lpage,file);
  pagep->data.number=n-1;       /* fix to get number right */
  catpage(lpage,fsect,file);

  pagep=(pagestr*)fob_find(lpage,file);
  lnext=pagep->chain.next;
 }
 else
 if(dble && (np & 0x1) && lnext)
 {
  lastpage=lastpageinsection(fsect,file);
  pagep=(pagestr*)fob_find(lastpage,file);
  xnp=pagep->data.number;
  pagep=(pagestr*)fob_find(lnext,file);
  xnp-=pagep->data.number;
  xnp++;

  if(xnp & 0x1) 
  {
   catpage(lastpage,fsect,file);
  }
 }



/* dprintf(0,"lnext=%d fprev=%d",lnext,fprev); */


 if(fprev)
 {
  fob_mod(fprev,file,(fobjptr)&pagep);
  pagep->chain.next=lnext;
 }
 else
 {
  fob_mod(fsect,file,(fobjptr)&sectionp);
  sectionp->chain.child=lnext;
 }

 if(lnext)
 {
  fob_mod(lnext,file,(fobjptr)&pagep);
  pagep->chain.prev=fprev;
 }

 delinkpages(fpage,lpage,fsect,file);

 file->hdr.np[DOC]-=np;
 sectionp=(sectionstr*)fob_find(fsect,file);
 sectionp->np-=np;

 renumberpages(fprev?fprev:0,fsect,RENSECT,file);

 if(dble && (np & 0x1) && olnext)
 {
  alternatepages(fsect,lnext,file);
 }
 else
 {
  if(lnext) relinkpage(lnext,fsect,file);
 }

 if(fprev) relinkpage(fprev,fsect,file);


 if(lnext)
 {
  reflowpages(lnext,fsect,file);
 }
 else
 {
  reflowpages(fprev,fsect,file);
 }

 renumbersections(file);
 renumberpages(fprev?fprev:lnext,fsect,RENFLOW,file);
 pagereflowsectionplus(lnext,file);

 err=fileresetviews(file,0);

 viewrefreshpageplus(fprev?fprev:lnext,fsect,fprev?0:VPPREV,file);

 return(err);
}




/* tagged to UDPAGE */


os_error * undeletepages(filestr * file)
{
 os_error   * err;
 int          index;
 int          np;
 int          fsect;

 undoread(file,&index,sizeof(int));
 undoread(file,&np,sizeof(int));
 undoread(file,&fsect,sizeof(int));

 err=deletepagesub(index,np,fsect,file);

 return(err);
}



os_error * dodelete(int fpage,int lpage,int fsect,filestr * file)
{
 os_error   * err;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          index;
 int          lnext;
 int          np;
 int          n;
 int          base;
 int          dble;
 int          left;

 err=modfile(file,fsect);
 if(!err)
 {
  err=checkplink(fpage,lpage,file);
  if(!err)
  {
   err=undostart(file);
   if(!err)
   {
    clearselectionf(file);

    sectionp=(sectionstr*)fob_find(fsect,file);
    base=getpagebase(sectionp);
    dble=sectionp->data.dble;
    index=sectionp->data.pagenumber.number;
    pagep=(pagestr*)fob_find(fpage,file);
    np=pagep->data.number;
    index=np-index;
    pagep=(pagestr*)fob_find(lpage,file);
    np=pagep->data.number-np;
    np++;

    lnext=pagep->chain.next;
    if(dble && (np & 0x1) && lnext)
    {
     pagep=(pagestr*)fob_find(lnext,file);
     n=pagep->data.number;
     left=islhpnb(n,base);
     canonicalsection(fsect,lnext,!left,file);
    }

    err=deletepagesub(index,np,fsect,file);
    undoend(file);
   }
  }
 }
 return(err);
}




/*****************************************************************************/

/* int  documentchapters(int file); */

int documentchapters(int fp)
{
 return(((filestr*)stack[fp])->hdr.ns[DOC]);
}



static sectionstr * sectionnp(filestr * file,int n)
{
 int          section;
 sectionstr * sectionp;

 section=file->hdr.section[DOC];

 do
 {
  sectionp=(sectionstr*)fob_find(section,file);
  section=sectionp->chain.next;
 } while(n-->0 && section);

 return(sectionp);
}



static pagestr * pagenp(filestr * file,sectionstr * sectionp,int n)
{
 int       page;
 pagestr * pagep;

 page=sectionp->chain.child;

 do
 {
  pagep=(pagestr*)fob_find(page,file);
  page=pagep->chain.next;
 } while(n-->0 && page);

 return(pagep);
}



/* int  chapterpages(int chapter,int file); */

int  chapterpages(int fp)
{
 return(sectionnp((filestr*)stack[fp+1],stack[fp])->np);
}


/* int  chapterstart(int file);  */

int chapterstart(int fp)
{
 return(prefp((filestr*)stack[fp])->chapterstart);
}


/* int  pagestart(int chapter,int file); */

int pagestart(int fp)
{
 return(sectionnp((filestr*)stack[fp+1],stack[fp])->data.pagenumber.number);
}



/* int  selectionpage(void);     */

int  selectionpage(int fp)
{
 sectionstr * sectionp;
 pagestr    * pagep;

 if(selectn)
 {
  sectionp=(sectionstr*)fob_find(selsectk,selfile);
  pagep=(pagestr*)fob_find(selpagek,selfile);
  return(pagep->data.number-sectionp->data.pagenumber.number);
 }
 else return(-1);

 USE(fp);
}


/* int  selectionchapter(void);  */

int selectionchapter(int fp)
{
 sectionstr * sectionp;

 if(selectn)
 {
  sectionp=(sectionstr*)fob_find(selsectk,selfile);
  return(sectionp->data.number-prefp(selfile)->chapterstart);
 }
 else return(-1);

 USE(fp);
}


/* int  currentpage(int view);   */


int currentpage(int fp)
{
 viewstr    * view;
 filestr    * file;
 sectionstr * sectionp;
 pagestr    * pagep;

 view=(viewstr*)stack[fp];
 file=view->file;

 sectionp=(sectionstr*)fob_find(view->dsection,file);
 pagep=(pagestr*)fob_find(view->dpage,file);
 return(pagep->data.number-sectionp->data.pagenumber.number);
}



/* int  currentchapter(int view); */

int  currentchapter(int fp)
{
 viewstr    * view;
 filestr    * file;
 sectionstr * sectionp;

 view=(viewstr*)stack[fp];
 file=view->file;

 sectionp=(sectionstr*)fob_find(view->dsection,file);
 return(sectionp->data.number-prefp(file)->chapterstart);
}




/* void gotopage(int page,int chapter,int view);*/

void xgotopage(int fp)
{
 sectionstr * sectionp;
 int          section;
 viewstr    * view;
 filestr    * file;

 view=(viewstr*)stack[fp+2];
 file=view->file;

 sectionp=sectionnp(file,stack[fp+1]);
 section=sectionp->key;

 pagenp(file,sectionp,stack[fp]);

//	cprintf("goto page %d chap %d",stack[fp],stack[fp+1]);

 zreport(gotopagek(view,pagenp(file,sectionp,stack[fp])->key,section));
}




/* int  chapterbits(int chapter,int file);  */
/*
     bit     0 start on left
     bit     1 double sided
     bit     2 start numbering
     bit     3 count blanks
     bits 4..7 number format
*/

int  chapterbits(int fp)
{
 sectionstr * sectionp;

 sectionp=sectionnp((filestr*)stack[fp+1],stack[fp]);

 return( (sectionp->data.pagenumber.left & 0x1) |
        ((sectionp->data.dble & 0x1)<<1) |
        ((sectionp->data.pagenumber.start & 0x1)<<2) |
        ((sectionp->data.pagenumber.blanks & 0x1)<<3) |
        ((sectionp->data.pagenumber.format & 0xF)<<4)

       );
}


/* int maxpagewidth(int file); */

int maxpagewidth(int fp)
{
 filestr * file;

 file=(filestr*)stack[fp];
 return(file->hdr.maxpagewidth[0]);
}



/* int maxpageheight(int file); */

int maxpageheight(int fp)
{
 filestr * file;

 file=(filestr*)stack[fp];
 return(file->hdr.maxpageheight[0]);
}


