/*->h.xredraw */


#define PICMARGIN 4000

#define GUIDECOLOUR      WIMPGREY3
#define SELECTCOLOUR     WIMPRED
#define HANDLECOLOUR     WIMPDBLUE
#define SELECTDRAGCOLOUR WIMPGREEN


#define ACTIVECOLOUR WIMPRED
#define PAGEBACKCOL  WIMPWHITE
#define GUIDELINESTYLE 0x33
#define GHOSTCOLOUR  WIMPGREY2
#define WINFILLCOLOUR WIMPGREY2



extern os_error * rsetdotstyle(int style);
extern os_error * rwimp_setcolour(int colour);
extern os_error * rsetgcol(int pal,int action);
extern os_error * rseteorcol(int back,int front);
extern os_error * rseteorcolpal(int back,int front);
extern os_error * rbbc_move(int x,int y,viewredrawstr * v);
extern os_error * rbbc_draw(int x,int y,viewredrawstr * v);
extern os_error * rtbbc_move(int x,int y,transformstr * tr,viewredrawstr * v);
extern os_error * rtbbc_draw(int x,int y,transformstr * tr,viewredrawstr * v);
extern os_error * rtbbc_drawstyle(int x,int y,transformstr * tr,
                                                           viewredrawstr * v);


extern os_error * rrectangleb(boxstr * box,int style,viewredrawstr * v);
extern os_error * rrectangle(coordstr * point,int style,viewredrawstr * v);
extern os_error * rparallel(coordstr * point,int style,viewredrawstr * v);
extern os_error * rcircle(coordstr *point,int style,viewredrawstr * v);
extern os_error * rellipse(coordstr * point,int style,viewredrawstr * v);
extern os_error * startredraw(void);
extern void       redrawswitch(int mask);


extern os_error * rbbc_rectanglefill(boxstr * box,viewredrawstr * v);
extern os_error * rbbc_rectangle(boxstr * box,viewredrawstr * v);




typedef struct pathstyle
{
 int thickness;

 int style;
 int stylescale;

 int startcaps;
 int startwidth;
 int startheight;

 int endcaps;
 int endwidth;
 int endheight;

 int join;

 int windingrule;

 int action;          /* bit 1==fill, bit 0==stroke */

} pathstyle;



extern os_error * rpathline(int * path,pathstyle * style,viewredrawstr * v,
                                                            transformstr * tr);

extern os_error * rpathlines(int * path,pathstyle * style,viewredrawstr * v,
                                                            transformstr * tr);

extern os_error * rsimpleline(int * p,viewredrawstr * v,transformstr * t);
extern os_error * rpathchunk(coordstr * cx,viewredrawstr * v,transformstr * t);
extern os_error * rdrawpath(int * path,int t,int style,int stylescale,
                                                       int join);


extern os_error * rcross(coordstr * point,int style,int n,viewredrawstr * v);


extern void rcreatepathstyle(pathstyle * s,int wimpcolour);


#define DASHSIZE 34

extern int linestyle2draw(int * dash,int style,int scale);

extern os_error * drawboxsize(coordstr * cx,int * path,pathstyle * style);


extern os_error * visiblebox(viewredrawstr * v,transformstr * tr,boxstr * box,int * visible);
