
#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>



#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "sprite.h"
#include "transform.h"


#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "key.h"
#include "wimptext.h"
#include "temp.h"
#include "sp.h"
#include "filetype.h"
#include "bits.h"
#include "err.h"
#include "trans.h"
#include "save.h"
#include "load.h"
#include "xhelp.h"
#include "fsx.h"
#include "bf.h"
#include "csv.h"
#include "alloc.h"
#include "applet.h"
#include "osreg.h"
#include "osthread.h"


#include "colour.h"
#include "deb.h"


#include "xext.h"


#include "str.h"
#include "constants.h"
#include "reslink.h"

#include "dbhi.h"


#include "file.h"
#include "view.h"
#include "object.h"
#include "caret.h"
#include "macros.h"
#include "units.h"
#include "codes.h"


#include "appletman.h"











/*****************************************************************************/
/* code for macros windows */



extern dboxstr appmanbox[2];



#define PANETOPMARGIN  8
#define PANESTEP       32
#define PANEHEIGHT     28
#define PANETEXTSHIFT  0


#define PANELEFTMARGIN 4
#define PANENAME       4

#define PANEMARK       (PANENAME+136)
#define PANESTATUS     (PANEMARK+48)
#define PANEINFO       (PANESTATUS+72)
#define PANETEXT       (PANEINFO+640-PANENAME)


static int         curtot;

static int         selectedappn;
static int         focusn;

static os_error  * appmanextent(void);
static void appmannewselect(int t,int x);


static viewstr   * cview;


static int         panemaxx;
static int         paneminy;
static int         appmanmaxx;
static int         appmanminy;



static dbstackstr * appmanstack;

static dbstackstr ourappmanstack;


/*****************************************************************************/



static os_error * paneredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        ox;
 int        oy;
 int        ylo;
 int        yhi;
 int        n;
 int        y;
 char       temp[64];
 int        v;
 
 err=NULL;

	if(more)
	{
  wimpfontstart(0);

  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
   yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */


   n=(ylo-PANETOPMARGIN)/PANESTEP;
   if(n<0) n=0;
   y=n*PANESTEP+PANETOPMARGIN;

   while(y<=yhi && n<curtot)
   {
    wimp_setcolour(n==selectedappn?WIMPBLACK:WIMPWHITE);

    bbc_rectanglefilli(ox+PANELEFTMARGIN,oy-y,PANETEXT,-PANEHEIGHT);

    if(n==focusn)
    {
     wimp_setcolour(WIMPWHITE);
     wimp_setcolour(0xF0+WIMPBLACK);
     bbc_setstyle(1);
     bbc_rectanglei(ox+PANELEFTMARGIN,oy-y,PANETEXT,-PANEHEIGHT);
    }


    stringat(ox+PANELEFTMARGIN+PANENAME,oy-y-PANETEXTSHIFT,appletname(n),
             n==selectedappn?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
             PANEHEIGHT);

    v=appletversion(n);
    sprintf(temp,"%d.%02d",v/100,v%100);
    stringat(ox+PANELEFTMARGIN+PANEMARK,oy-y-PANETEXTSHIFT,temp,
             n==selectedappn?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
             PANEHEIGHT);

    v=appletstatus(n);
    if(v==0) sprintf(temp,"active");
    else
    if(v==1) sprintf(temp,"inactive");
    else
    if(v==2) sprintf(temp,"delete");

    stringat(ox+PANELEFTMARGIN+PANESTATUS,oy-y-PANETEXTSHIFT,temp,
             n==selectedappn?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
             PANEHEIGHT);

    stringat(ox+PANELEFTMARGIN+PANEINFO,oy-y-PANETEXTSHIFT,appletinfo(n),
             n==selectedappn?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
             PANEHEIGHT);
  
   
    y+=PANESTEP;
    n++;
   }
   wimp_get_rectangle(redrawstr,&more);
  }

  wimpfontend();
	}

 return(err);
 handle=handle;
}


static os_error * paneredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) paneredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}






static void panerefreshline(int handle,int n)
{
 wimp_redrawstr r;
 int more;

 r.box.x0=PANELEFTMARGIN-cvdu.extrax;
 r.box.x1=r.box.x0+PANETEXT+2*cvdu.extrax;
 r.box.y1=-(n*PANESTEP+PANETOPMARGIN)+cvdu.extray;
 r.box.y0=r.box.y1-PANEHEIGHT-2*cvdu.extray;

 r.w=handle;

 wimp_update_wind(&r,&more);
 paneredrawsub(handle,&r,more);
}


static os_error * paneselectn(int handle,int n)
{
 os_error * err;
 int        oldn;

 err=NULL;

 oldn=selectedappn;
 selectedappn=n;
 if(focusn>=0) focusn=selectedappn;
 panerefreshline(handle,oldn);
 panerefreshline(handle,selectedappn);

 setfocus(handle);



 return(err);
}




static os_error * paneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*PANESTEP+PANETOPMARGIN);
 bot=-((n+1)*PANESTEP+PANETOPMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

// wblock.o.y=-(n+1)*(PANESTEP)+(PANESTEP>>1)+((wblock.o.box.y1-wblock.o.box.y0)>>1);


 return(wimp_open_wind(&wblock.o));
}





static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 int        oldfocusn;

 err=NULL;

// cprintf("gain %d",gain);

 if(gain)
 {
  focusn=selectedappn;
  panerefreshline(handle,focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  panerefreshline(handle,oldfocusn);
 }


 return(err);

 USE(userhandle);
}





static os_error * loadapp(char * name,int type,int userhandle,int xvolatile)
{
 char string[MAX_PATH];
 char command[MAX_PATH];
 int  size;
 int  exitcode;


 size=sizeof(string);
 strcpy(command,"HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\");
 regreadstr(command,string,&size);

 sprintf(command,"%s\\Tools\\appletinstall.exe OvationPro \"%s\"",string,name);

 cprintf("load applet %s",command);
 
 runexe(command,&exitcode);

 return(NULL);

 USE(xvolatile);
 USE(userhandle);
 USE(type);
}



static os_error * loadapppost(int userhandle)
{
 os_error         * err;

 err=NULL;
 
 
 return(err);

 USE(userhandle);
}



static os_error *loadapptype(char * name,int type,mousestr * m,int userhandle,int *method)
{
 *method=(type==OAPPLET);
 return(NULL);
 USE(userhandle);
 USE(m);
 USE(name);
}












static os_error * appinstall(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 loadoptstr opts;
 int        xtype=OAPPLET;
 int        copt;
 char       name[FILENAMELEN];

 opts.description="DTP Applet (*.oap)";
 opts.ntypes=1;
 opts.types=&xtype;

 strcpy(name,"");

 err=openloadparent(name,&copt,&opts,1,loadapp,0,handle);

 return(err);

 USE(userhandle);
 USE(handle);
 USE(m);
}









static os_error * appdel(int handle,int userhandle,wimp_mousestr * m)
{
 appletsetstatus(selectedappn,2);
 panerefreshline(appmanbox[1].handle,selectedappn); 
 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}




static os_error * appact(int handle,int userhandle,wimp_mousestr * m)
{
 appletsetstatus(selectedappn,0);
 panerefreshline(appmanbox[1].handle,selectedappn); 
 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}




static os_error * appiact(int handle,int userhandle,wimp_mousestr * m)
{
 appletsetstatus(selectedappn,1);
 panerefreshline(appmanbox[1].handle,selectedappn); 
 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}



static os_error * panegoton(int n,int panehandle)
{
 os_error * err;

 err=NULL;

 if(n<0) n=0;
 if(n>=curtot) n=curtot-1;

  
 if(n!=selectedappn)
 {
  err=paneselectn(panehandle,n);
  paneopenline(panehandle,n);
 }

 return(err);
}



static os_error * panekey2(int panehandle,int mainhandle,int icon,int * key)
{
 int       ch;
 int       n;
 int       next;
 windowstr window;

 ch=*key;

 if(ch==HOME)
 {
  panegoton(0,panehandle);
  *key=-1;
 }
 else
 if(ch==COPY)
 {
  panegoton(curtot-1,panehandle);
  *key=-1;
 }
 if(ch==PAGEUP || ch==PAGEDOWN)
 {
  getw(panehandle,&window);
  next=(window.y1-window.y0)/PANESTEP;
  n=focusn;
  n+=((*key==PAGEDOWN)?next:-next);
  panegoton(n,panehandle);
  *key=-1;
 }
 else
 if(ch==CUP || ch==CDOWN)
 {
  n=focusn;
  n+=((*key==CDOWN)?1:-1);
  panegoton(n,panehandle);
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(mainhandle,panehandle,ch==SHFT_TAB,&next);
//  cprintf("next %d",next);
  setfocusicon(mainhandle,next);
  *key=-1;
 }
 else
 if(ch==ALT_A) // 'A' || ch=='a')
 {
  appletsetstatus(selectedappn,0);
  panerefreshline(appmanbox[1].handle,selectedappn); 
  *key=-1;
 }
 else
 if(ch==ALT_I) // 'I' || ch=='i')
 {
  appletsetstatus(selectedappn,1);
  panerefreshline(appmanbox[1].handle,selectedappn); 
  *key=-1;
 }
 else
 if(ch==ALT_D) // 'D' || ch=='d' || ch==DEL)
 {
  appletsetstatus(selectedappn,2);
  panerefreshline(appmanbox[1].handle,selectedappn);
  *key=-1;
 }
 else
 if(ch==' ')
 {
  next=appletstatus(selectedappn)+1;
  if(next>1) next=0;
  appletsetstatus(selectedappn,next);
  panerefreshline(appmanbox[1].handle,selectedappn); 
  *key=-1;
 }
 else
 if(ch>=' ' && ch<256) // move to next entry that starts with ch
 {
  n=focusn;
  do
  {
   n++;
   if(n>=curtot) n=0;
   if(toupper(*appletname(n))==toupper(ch)) break;
  } while(n!=focusn);

  if(n!=focusn)
  {
   panegoton(n,panehandle);
   *key=-1;
  }
 }

 return(NULL);

 USE(icon);
}



static os_error * panekey(int handle,int userhandle,int icon,int * key)
{
 return(panekey2(handle,appmanbox[0].handle,icon,key));
 USE(userhandle);
}




static os_error * paneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;

 err=NULL;

 if(m->bbits==wimp_BLEFT)
 {
  err=getw(handle,&window);
  if(!err)
  {
   n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;
   if(n<0) n=0;
   if(n>=curtot) n=curtot-1;

   if(n!=selectedappn || n!=focusn)
   {
    paneselectn(handle,n);
   }
  }
 }

 return(err);

 USE(userhandle);
}











static os_error * appmanextent(void)
{
 os_error * err;
 int        sety;

 err=NULL;

 sety=MAX(paneminy,PANETOPMARGIN+curtot*PANESTEP);

          err=extent(appmanbox[1].handle,0,-sety,panemaxx,0);
 if(!err) err=extent(appmanbox[0].handle,0,
                                       -appmanminy,appmanmaxx,sety-paneminy);

 if(!err) err=reopenw(appmanbox[1].handle);
 if(!err) err=reopenw(appmanbox[0].handle);

 return(err);
}






/* close macros window */

static os_error * appmanclose(int code)
{
 os_error    * err;
 int           i;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  appletsavestatus();
 
 }


 if(!err && code!=DBAPPLY) 
 {

  remcaretevent(panecaret,appmanbox[1].handle,0);

  for(i=0;i<2;i++)
  {
   remdataload(appmanbox[i].handle,0,loadapp);
   remdataloadpost(appmanbox[i].handle,0,loadapppost);
   remdataloadtype(appmanbox[i].handle,0,loadapptype);
  }
 }

 return(err);
}






static os_error * apphelp(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=appletrunhelp(selectedappn,handle);
 
 return(err);

 USE(userhandle);
 USE(handle);
 USE(m);
}







static os_error * fieldhelp(int handle,int userhandle,int icon,char ** p)
{
 windowstr   window;
 mousestr    mouse;
 int         x;
 int         i;


 icon=-1;

 getw(handle,&window);
 getpointer(&mouse);

 x=mouse.x-window.bx;

 for(i=0;i<3;i++)
 {
  {
   icon=i;
   break;
  }
 }

 *p=helpfindtagstring(userhandle,icon);

 return(NULL);
}




static dbiconstr appmanicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
    0, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)appdel,0,
    3, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)appact,0,
    7, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)appiact,0,
    8, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)apphelp,0,
    9, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)appinstall,0,
   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};



static dboxstr appmanbox[2]=
{
 0,
 TAPPMAN,
 DBFIX,
 0,
 appmanclose,
 NULL,
 NULL,
 NULL,
 appmanicondefs,
 0,
 0,
 0,NULL,
 0,
 0,


 0,
 TAPPMANP,
 DBPANE,
 0,
 NULL,
 paneicon,
 panekey,
 paneredraw,
 NULL,
 0,
 0,
 0,NULL,
 fieldhelp,
 0,
};








/* click on menu, display macro window */
/* called with zero arg below          */


static os_error * openappmans(dboxstr * parent,dbstackstr * dbstack,viewstr * view)
{
 os_error * err;
 windowstr  window;
 int        i;

 err=NULL;

 if(!appmanbox[0].handle || cview!=view)
 {
  if(appmanbox[0].handle)
  {
   dbclose(appmanbox,DBCANCEL);
  }

  cview=view;
  appmanstack=dbstack;
  selectedappn=focusn=0;

  if(!err)
  {
   curtot=appletnumber();
   err=dodboxspparent(appmanbox,2,parent,dbstack,cview->handle);
   if(!err) 
   {
    wimp_setwindowbackground(appmanbox[1].handle,CCRGB|PALWHITE);
    if(!err) err=setfocus(appmanbox[1].handle);
    if(!err) err=addcaretevent(panecaret,appmanbox[1].handle,0);
    if(!err) err=wimp_setwindowflags(appmanbox[1].handle,WINDOWNOTDIALOGUE,0);


    for(i=0;i<2;i++)
    {
     if(!err) err=adddataload(appmanbox[i].handle,0,loadapp);
     if(!err) err=adddataloadpost(appmanbox[i].handle,0,loadapppost);
     if(!err) err=adddataloadtype(appmanbox[i].handle,0,loadapptype);
    }

    getw(appmanbox[0].handle,&window);
    appmanmaxx=window.x1-window.x0;
    appmanminy=window.y1-window.y0;
   
    getw(appmanbox[1].handle,&window);
    panemaxx=window.x1-window.x0;
    paneminy=window.y1-window.y0;

    err=appmanextent();
   }
  }
 }

 return(err);
}



void openappletbox(int fp)
{
 zreport(openappmans(appmanbox,&ourappmanstack,menuview));
 USE(fp);
}



static os_error * appmanevent(int eventn,int userhandle,void * data,int data1)
{
 if(cview==(viewstr*)data)
 {
  cview=0;
  dbstacksmash(appmanstack);
 }
 return(NULL);

 USE(userhandle);
 USE(data1);
 USE(eventn);
}



os_error * appletmaninit(void)
{
 os_error      * err;
 
 err=addevent(EVENT_VCLOSE,appmanevent,0);

 return(err);
}


