/*->c.grid */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"


#include "err.h"
#include "fsx.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "xmath.h"
#include "osunits.h"
#include "deb.h"

#include "constants.h"
#include "str.h"
#include "object.h"
#include "pref.h"

#include "viewr.h"
#include "view.h"

#include "xredraw.h"


#include "grid.h"










os_error * redrawgrid(viewredrawstr * v)
{
 os_error    * err;
 viewstr     * view;
 int           nxmin;
 int           nymin;
 int           my;
 int           mx;
 int           x;
 int           y;
 gridstr       grid;
 int           subspc;
 int           subspcdiv;
 int           sizex;
 int           sizey;
 int           xorg;
 int           yorg;
 int           n;
 int           ys;
 int           ymax;
 int           yerr;
 int           ystep;
 int           yrem;
 int           xs;
 int           xmax;
 int           xerr;
 int           xs1;
 int           xerr1;
 int           mx1;
 prefdatastr * prefs;
 int           basespacing;
 int           xp;
 int           yp;
 int           xr;
 int           yr;


 sizex=xos2pix(6);
 sizey=yos2pix(6);
  
 sizex=sizey=MAX(sizex,sizey);

 err=NULL;
 view=v->view;
 grid=view->data.grid;
 if(grid.subdiv<=0) grid.subdiv=1;

 if(grid.show)
 {
  xorg=v->xpo+view->data.rulerx;
  yorg=v->ypo+view->data.rulery;

  subspc=grid.spacing;
  subspcdiv=grid.subdiv*grid.spacediv;

  seteorcol(WIMPWHITE,grid.colour);


  nymin=scale((v->ylo-yorg),subspcdiv,subspc);
  my=nymin % grid.subdiv;
  ymax=v->yhi-yorg;
  ystep=subspc/subspcdiv;
  yrem=subspc-ystep*subspcdiv;
  ys=nymin*ystep;
  yerr=yrem*nymin;
  n=yerr/subspcdiv;
  ys+=n;
  yerr-=n*subspcdiv;


  nxmin=scale((v->xlo-xorg),subspcdiv,subspc);
  mx1=nxmin % grid.subdiv;
  xmax=v->xhi-xorg;
  xs1=nxmin*ystep;
  xerr1=yrem*nxmin;
  n=xerr1/subspcdiv;
  xs1+=n;
  xerr1-=n*subspcdiv;

  while(1)
  {
   y=v->oy-osunits(yorg+ys,view);

   mx=mx1;
   xs=xs1;
   xerr=xerr1;

   while(1)
   {
    x=v->ox+osunits(xorg+xs,view);

    if(!mx && !my)  /* big cross */
    { 
     xp=x;yp=y;
     gros2pix(&xp,&yp);

     xr=xp-sizex;
     yr=yp;
     grpix2osr(&xr,&yr);
     bbc_move(xr,yr);

     xr=xp+sizex;
     yr=yp;
     grpix2osr(&xr,&yr);
     bbc_draw(xr,yr);

     xr=xp;
     yr=yp-sizey;
     grpix2osr(&xr,&yr);
     bbc_move(xr,yr);

     xr=xp;
     yr=yp+sizey;
     grpix2osr(&xr,&yr);
     bbc_draw(xr,yr);
    }
    else            /* just a dot */
    {
     bbc_plot(bbc_Point+bbc_DrawAbsFore,x,y);
    }

    if(xs>xmax) break;

    if(++mx>=grid.subdiv) mx=0;
    xs+=ystep;
    xerr+=yrem;
    if(xerr>subspcdiv)
    {
     xs++;
     xerr-=subspcdiv;
    }
   }

   if(ys>ymax) break;

   if(++my>=grid.subdiv) my=0;
   ys+=ystep;
   yerr+=yrem;
   if(yerr>subspcdiv)
   {
    ys++;
    yerr-=subspcdiv;
   }
  } 
 }


 if(grid.baseline)
 {
  prefs=prefp(v->file);
  if(prefs)
  {
   basespacing=prefs->baselinegridspacing;
   if(basespacing)
   {
    yorg=v->ypo+prefs->baselinegridorigin;

    seteorcol(WIMPWHITE,grid.basecolour);

    nymin=((v->ylo-yorg)/basespacing);
    ymax=v->yhi-yorg;
    ystep=basespacing;
    yrem=0;
    ys=nymin*ystep;
    yerr=yrem*nymin;
    n=yerr/1;
    ys+=n;
    yerr-=n*1;

    xs=v->ox+osunits(v->xlo,view);
    x=v->ox+osunits(v->xhi,view);

    while(1)
    {
     y=v->oy-osunits(yorg+ys,view);

     bbc_move(xs,y);
     bbc_draw(x,y);

     if(ys>ymax) break;
     ys+=ystep;
     yerr+=yrem;
     if(yerr>1)
     {
      ys++;
      yerr-=1;
     }
    }
   } 
  }
 }

 return(err);
}




int gridsnapx(int x,viewstr * view,int force)
{
 int factor;
 int divisor;
 int space;

 if(x<0) return(-gridsnapx(-x,view,force));
 else
 {
  if(((view->data.grid.lock & GRIDLOCK) && !view->nosnap) || force)
  {
   x-=view->data.rulerx;
   divisor=view->data.grid.subdiv*view->data.grid.spacediv;
   space=view->data.grid.spacing;
   factor=scale(x,divisor,space);
   x=scale(factor,space,divisor);
   x+=view->data.rulerx;
  }
  return(x);
 }
}



int gridsnapy(int y,viewstr * view,int force)
{
 int           factor;
 int           divisor;
 int           space;
 prefdatastr * prefs;



 if(y<0) return(-gridsnapy(-y,view,force));
 else
 {
  if((view->data.grid.lock && !view->nosnap) || force)
  {                                                                                if((view->data.grid.lock & GRIDBASELOCK) && 
      !(view->data.grid.lock & GRIDLOCK))
   {
    prefs=prefp(view->file);
    if(prefs)
    {
     y-=prefs->baselinegridorigin;
     if(prefs->baselinegridspacing)
     {
      y/=prefs->baselinegridspacing;
      y*=prefs->baselinegridspacing;
     }
     y+=prefs->baselinegridorigin;
    }
   }
   else
   {
    y-=view->data.rulery;
    divisor=view->data.grid.subdiv*view->data.grid.spacediv;
    space=view->data.grid.spacing;
    factor=scale(y,divisor,space);
    y=scale(factor,space,divisor);
    y+=view->data.rulery;
   }
  }
  return(y);
 }
}



