/*->h.line */



#define DSTLINESTYLE   0x300
#define DSTENDCAPS     0x301
#define DSTSTARTCAPS   0x302
#define DSTJOIN        0x303
#define DSTWINDINGRULE 0x304
#define DSTLINE        0x305



/* nb cast to curvestylestr */
/* nb cast to pathstyle from thickness */

typedef struct linedatastr
{
 colourvalue    linecolour;      /* outline colour  */
 colourvalue    fillcolour;      /* fill colour     */

 int            thickness;

 int            style;
 int            stylescale;

 int            startcaps;
 int            startwidth;
 int            startheight;

 int            endcaps;
 int            endwidth;
 int            endheight;

 int            join;

 int            windingrule;

 int            radius;

 fillstr        fill;

} linedatastr;



typedef struct unpackedlinedatastr
{
 linedatastr data;
 int         spread;
 int         lock;

} unpackedlinedatastr;




typedef struct linechangebits
{
 unsigned int   xlinecolour:1;      /* outline colour  */
 unsigned int   xfillcolour:1;      /* fill colour     */

 unsigned int   xthickness:1;

 unsigned int   xstyle:1;
 unsigned int   xstylescale:1;

 unsigned int   xstartcaps:1;
 unsigned int   xstartwidth:1;
 unsigned int   xstartheight:1;

 unsigned int   xendcaps:1;
 unsigned int   xendwidth:1;
 unsigned int   xendheight:1;


 unsigned int   xjoin:1;

 unsigned int   xwindingrule:1;

 unsigned int   xradius:1;

 unsigned int   xfill:1;

 unsigned int   xlock:1;
 unsigned int   xspread:1;

 unsigned int   xtransform:1;

} linechangebits;





typedef struct linestr
{
 int            key;
 int            type;
 chainstr       chain;
 flagstr        flags;

 boxstr         box;
 transformstr   transform;

 curvestr       fcurve;    /* line curve             */
 curvestr       xcurve;    /* overall bounding curve */

 int            master;

 linedatastr    data;

} linestr;



extern linedatastr defltlinedata;


extern os_error * lineinit(void);

extern os_error * lineupdate(unpackedlinedatastr * pd,linechangebits * bits,
                                                   int line,filestr * file);

extern void       unpackline(linestr * linep,unpackedlinedatastr * ld);
extern void       packline(linestr * linep,unpackedlinedatastr * ld);

extern os_error * linechanges(int line,filestr * file,
                              unpackedlinedatastr * pd,linechangebits * bits);

extern os_error * transline(linestr * linep,filestr * file,
                                      transformfn trf,int flags);



