/*->c.tag */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>


#include "os.h"
#include "flex.h"
#include "wimp.h"
#include "werr.h"
#include "transform.h"


#include "err.h"
#include "alloc.h"
#include "xext.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "etc.h"
#include "scrap.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"
#include "deb.h"


#include "constants.h"
#include "str.h"

#include "file.h"
#include "dbmore.h"

#include "tag.h"




typedef struct otagstr
{
 int      key;
 int      type;
 chainstr chain;
 int      size;
 int      spare[2];
 char     stuff[1];

} otagstr;




typedef struct tagstr
{
 int  tag;
 int  size;
 char stuff[1];
} tagstr;



static otagstr * tbase;




static void findtags(otagstr * otag,tagstr ** tagp,int tagkey)
{
 tagstr * tag;
 int      size;

 tag=(tagstr*)otag->stuff;
 size=otag->size;


 while(size>0)
 {
  if(tag->tag==tagkey)
  {
   *tagp=tag;
   break;
  }

  size-=tag->size;
  tag=(tagstr*)(((char*)tag)+tag->size);
 }
}




static os_error * findtag(tagstr ** tagp,int tagkey,filestr * file)
{
 otagstr * otag;

 *tagp=NULL;
 otag=NULL;

 if(file)
 {
  if(file->hdr.tag)
  {
   otag=(otagstr*)fob_find(file->hdr.tag,file);
  }
 }
 else
 {
  otag=tbase;
 }
   
 if(otag)
 {
  findtags(otag,tagp,tagkey);
 }

 return(NULL);
}




static os_error * ensuretag(tagstr ** tagp,int tag,int size,filestr * file)
{
 os_error * err;
 otagstr  * otag;
 int        extra;
 int        offset;
 int        oldsize;


 err=NULL;


 otag=NULL;
 *tagp=NULL;

 if(file)
 {
  if(file->hdr.tag) otag=(otagstr*)fob_find(file->hdr.tag,file);
 }
 else
 {
  otag=tbase;
 }

 if(otag) findtags(otag,tagp,tag);

 if(*tagp)
 {
  extra=((size-((*tagp)->size-2*sizeof(int)))+0x3)&(~0x3);

  if(extra>0)
  {
   offset=((char*)(*tagp))-otag->stuff;
   oldsize=(*tagp)->size;

   if(file)
   {
    err=fob_change(file->hdr.tag,file,
                             sizeof(otagstr)+otag->size+extra,(fobjptr)&otag);
   }
   else
   {
    err=flex_extend((flex_ptr)&tbase,sizeof(otagstr)+otag->size+extra);
    otag=tbase;
   }

   if(!err)
   {
    memmove(otag->stuff+offset+oldsize+extra,otag->stuff+offset+oldsize,
                       otag->size-offset-oldsize);

    otag->size+=extra;
    *tagp=(tagstr*)(otag->stuff+offset);
    (*tagp)->size+=extra;
   }
  }
 }
 else
 {
  extra=size+2*sizeof(int);

  if(otag)
  {
   if(file)
   {
    err=fob_change(file->hdr.tag,file,sizeof(otagstr)+otag->size+extra,(fobjptr)&otag);
   }
   else
   {
    err=flex_extend((flex_ptr)&tbase,sizeof(otagstr)+otag->size+extra);
    otag=tbase;
   }

   if(!err)
   {
    *tagp=(tagstr*)(otag->stuff+otag->size);
    (*tagp)->size=extra;
    (*tagp)->tag=tag;
    otag->size+=extra;
   }
  }
  else
  {
   if(file)
   {
    err=fob_create(sizeof(otagstr)+extra,file,OTAG,(fobjptr)&otag);
   }
   else
   {
    err=flex_alloc((flex_ptr)&tbase,sizeof(otagstr)+extra);
    otag=tbase;
   }

   if(!err)
   {
    *tagp=(tagstr*)(otag->stuff);
    (*tagp)->size=extra;
    (*tagp)->tag=tag;
    otag->size=extra;
    if(file) file->hdr.tag=otag->key;
   }
  }
 }
 return(err);
}






/* int tagwrite(int file,int tag,int value,int index);  return tag */

int tagwrite(int fp)
{
 filestr * file;
 tagstr  * tagp;
 int       tag;
 int       size;

 file=(filestr*)stack[fp];
 tag=stack[fp+1];
 size=sizeof(int)*(stack[fp+3]+1);

 ensuretag(&tagp,tag,size,file);

 *((int*)(tagp->stuff+sizeof(int)*stack[fp+3]))=stack[fp+2];

 return(tag);
}



// issue here is that strings are not being compacted - can't get rid of data


/* int tagwrites(int file,int tag,string & value); */
/*  return tag - write tag[index] */

int tagwrites(int fp)
{
 filestr * file;
 int       tag;
 tagstr  * tagp;
 int       size;


 file=(filestr*)stack[fp];
 tag=stack[fp+1];
 size=(stringlen(stack[fp+2])+1+3)&(~0x3);

 ensuretag(&tagp,tag,size,file);

 memcpy(tagp->stuff,stringptr(stack[fp+2]),stringlen(stack[fp+2])+1);

// cprintf("slen %d p0 %d",stringlen(stack[fp+2]),*stringptr(stack[fp+2]));

 return(tag);
}



/* int tagexists(int file,int tag,int index); return 1 if tag[index] exists */


int tagexists(int fp)
{
 filestr * file;
 tagstr  * tagp;
 int       index;

 file=(filestr*)stack[fp];
 findtag(&tagp,stack[fp+1],file);
 index=stack[fp+2];

 return(tagp && (tagp->size-2*sizeof(int))>=index*sizeof(int));
}



/* int tagread(int file,int tag,int index);         return tag[index] value */


int tagread(int fp)
{
 filestr * file;
 tagstr  * tagp;
 int       index;

 file=(filestr*)stack[fp];
 index=stack[fp+2];

 findtag(&tagp,stack[fp+1],file);

 if(tagp && (tagp->size-2*sizeof(int))>=index*sizeof(int))
 {
  return(*(((int*)tagp->stuff)+index));
 }

 return(-1);
}



/* int tagreads(int file,int tag,string & s);
                                return 1 if tag exists, read string */

int tagreads(int fp)
{
 filestr * file;
 tagstr  * tagp;
 int       len;

 file=(filestr*)stack[fp];

 findtag(&tagp,stack[fp+1],file);

 if(tagp)
 {
  len=strlen(tagp->stuff);
  setstring(stack[fp+2],tagp->stuff);
  findtag(&tagp,stack[fp+1],file);
  strcpy(stringptr(stack[fp+2]),tagp->stuff);

  return(1);
 }

 return(0);
}


static char * tagpath="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\AutoRun\\!Tags.csc";
static char * tagbasepath="<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\AutoRun\\!Tags.csc";



os_error * tagupdate(void)
{
 os_error * err;
 buffer     bf;
 char     * tpath;
 tagstr   * tag;
 int        size;
// char     * w;
// char       temp[256];
 int        t;
 int        t3;
 int        t2;
 int        t1;
 int        csize;
 int        index;

 err=NULL;

// cprintf("tag update tbase %x",tbase);


 if(tbase)
 {
  tpath=multiuser?tagpath:tagbasepath;
  
  err=fs_validatepath(tpath,0);
  if(!err)
  {
   err=bf_open(tpath,'w',DEFBUFFSIZE,&bf);
   if(!err)
   {
    stdfileheader(&bf,fs_leaf(tpath));
    bf_printf(&bf,"void main(void)\r\n{\r\n");

    tag=(tagstr*)tbase->stuff;
    size=tbase->size;


    while(size>0)
    {
     t=tag->tag;
     t3=(t>>24)&0xFF;
     t2=(t>>16)&0xFF;
     t1=(t>>8)&0xFF;

     csize=tag->size-2*sizeof(int);
     index=0;

     while(csize)
     {
      if((t1>=' ' && t1<0x7F) && (t2>=' ' && t2<0x7F) && (t3>=' ' && t3<0x7F))
      { 
       bf_printf(&bf," tagwrite(0,('%c'<<24)|('%c'<<16)|('%c'<<8)|%d,",t3,t2,t1,(t & 0xFF));
      }
      else
      {
       bf_printf(&bf," tagwrite(0,0x%x,",tag->tag);
      }

      bf_printfeol(&bf,"0x%x,%d);",*(int*)(tag->stuff+index*sizeof(int)),index);

      csize-=sizeof(int);
      index++;
     }

     size-=tag->size;
     tag=(tagstr*)(((char*)tag)+tag->size);
    }



#ifdef NEVER

    while(size>0)
    {
     t=tag->tag;
     t3=(t>>24)&0xFF;
     t2=(t>>16)&0xFF;
     t1=(t>>8)&0xFF;

     if((t1>=' ' && t1<0x7F) && (t2>=' ' && t2<0x7F) && (t3>=' ' && t3<0x7F))
     { 
      bf_printf(&bf," tagwrites(0,('%c'<<24)|('%c'<<16)|('%c'<<8)|%d,\"",t3,t2,t1,(t & 0xFF));
     }
     else
     {
      bf_printf(&bf," tagwrites(0,0x%x,\"",tag->tag);
     }

     w=unquoteblock(tag->stuff,tag->size-2*sizeof(int),temp);
     bf_write(&bf,temp,w-temp);

     bf_printfeol(&bf,"\");",tag->tag);
     size-=tag->size;
     tag=(tagstr*)(((char*)tag)+tag->size);
    }

#endif


    bf_printfeoln(&bf,2,"}");
    err=bf_closec(&bf,err,tpath,SCRIPT2);
   }
  }
 }

 return(err);
}