/*->c.pict */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "font.h"
#include "bbc.h"
#include "akbd.h"
#include "transform.h"
#include "xprocess.h"


#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "key.h"
#include "dbhi.h"
#include "avl.h"
#include "bits.h"
#include "deb.h"

#include "constants.h"
#include "str.h"

#include "reslink.h"

#include "object.h"

#include "geometry.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "xredraw.h"
#include "curve.h"
#include "posn.h"
#include "utils.h"

#include "infopal.h"

#include "select.h"
#include "splib.h"
#include "editpath.h"
#include "objectdb.h"
#include "undo.h"
#include "units.h"
#include "frameflow.h"
#include "clip.h"
#include "mpage.h"
#include "fillstub.h"
#include "xcolour.h"
#include "xxcolour.h"
#include "colsep.h"
#include "xrender.h"


#include "border.h"

#include "prstr.h"
#include "xprint.h"

#include "txstr.h"
#include "text.h"
#include "mx.h"
#include "fox.h"


#include "pxstr.h"

#include "pict.h"
#include "impex.h"
#include "dbpicture.h"
#include "pxchoices.h"
#include "pixtool.h"
#include "croptool.h"
#include "xtracex.h"
#include "dbpict.h"
#include "dbpixref.h"
#include "pxconstant.h"
#include "pxds.h"
#include "pxcache.h"
#include "pxref.h"




static os_error * pxfontlist(pictboxstr *pictp,filestr *file,void * data);



#define DEFINSET  MMSIZE
#define DEFOUTSET MMSIZE


pictdatastr defltpictdata=
{
 OURWHITE,

 DEFINSET,    /* inset     */
 0,           /* radius    */
 0,           /* changei   */
 FILLSTR,
};


unpackedpicturedatastr defltpicturedata=
{
 0,           /* lock mode */
 0,           /* fixaspect */
 0,           /* autoscale */
 0,           /* hbits     */
 0,           /* xshift    */
 0,           /* yshift    */
 0x10000,     /* scale     */
 0x10000,     /* aspect    */
 0,           /* angle     */
 0,           /* skew      */
 TR_IDENTITY,

 0,           /* tile       */
 0,           /* spare bits */
 0,           /* tiledx     */
 0,           /* tiledy     */

 0,           /* spare[0]   */
 0,           /* spare[1]   */
 0,           /* spare[2]   */
                          

};



pictprocstr defltpictprocess=
{
 0   /* process str */
};



textflowstr defltpicttextflow=
{
 DEFOUTSET,
 FRFBOTH,
 FROFRAME,
};



int pixfontbits;
int pixjpegbits;
int pixspritebits;



#ifdef NEVER

/* now in c.view */

static void tr_o2d(transformstr * tr)
{
 transformstr temp1;
 transformstr temp2;

 temp1=*tr;
 tr_setscale(&temp2,25,16,25,-16);

 tr_multiply(tr,&temp1,&temp2);
}



static void tr_d2o(transformstr * tr)
{
 transformstr temp1;
 transformstr temp2;

 temp1=*tr;
 tr_setscale(&temp2,16,25,16,-25);

 tr_multiply(tr,&temp1,&temp2);
}

#endif


os_error * pictcentre(int pict,filestr * file,picturedatastr * pdp,
                                                        coordstr * cx)
{
 picturestr     * picturep;
 pictboxstr     * pictp;
 picturedatastr   pd;
 coordstr         c;
 transformstr     tr;
 int              xscale;
 int              yscale;

 pictp=(pictboxstr*)fob_find(pict,file);
 if(!pdp) pd=pictp->pictdata;
 else     pd=*pdp;

 if(pictp->picture)
 {
  picturep=(picturestr*)fob_find(pictp->picture,file);
  if(picturep)
  {
   if(pd.hbits & HBBOTLEFT)
   {
    c.x=(picturep->abox.x1+picturep->abox.x0)/2;
    c.y=-(picturep->abox.y1+picturep->abox.y0)/2;
   }
   else
   {
    c.x=(picturep->abox.x1-picturep->abox.x0)/2;
    c.y=(picturep->abox.y1-picturep->abox.y0)/2;
   }

   yscale=pd.scale;
   xscale=ttmul(yscale,pd.aspect);

   c.x=scale(c.x,25*xscale,16*0x10000);
   c.y=scale(c.y,25*yscale,16*0x10000);

   c.x+=tr_tan(pd.skew,c.y);

   tr_setidentity(&tr);
   tr_setrotationa(&tr,pd.angle);

   tr_transformset(&c,1,&tr);

   cx->x=pd.xshift+c.x;
   cx->y=pd.yshift+c.y;
  }
 }

 return(NULL);
}



os_error * pictcentrepict(int pict,filestr * file,picturedatastr * pdp)
{
 coordstr         cx;
 pictboxstr     * pictp;
 picturedatastr   pd;
 boxbitstr        bits;

 pictp=(pictboxstr*)fob_find(pict,file);

 if(pdp) pd=*pdp;
 else    pd=pictp->pictdata;

 getboxbits(&pictp->fcurve.box,&pictp->transform,&bits);

 pictcentre(pict,file,&pd,&cx);

 pd.xshift+=bits.width/2-cx.x;
 if(pd.hbits & HBBOTLEFT)
 {
  pd.yshift+=-bits.height/2-cx.y;
 }
 else
 {
  pd.yshift+=bits.height/2-cx.y;
 }

 if(pdp) *pdp=pd;
 else
 {
  pictp=(pictboxstr*)fob_find(pict,file);
  pictp->pictdata=pd;
 }

 return(NULL);
}



os_error * pictcheckcentre(int pict,filestr * file,picturedatastr * pdp)
{
 pictboxstr     * pictp;
 int              lockmode;

 if(pdp) lockmode=pdp->lockmode;
 else
 {
  pictp=(pictboxstr*)fob_find(pict,file);
  lockmode=pictp->pictdata.lockmode;
 }

 if(lockmode==1) return(pictcentrepict(pict,file,pdp));
 else            return(NULL);
}




#ifdef NEVER


os_error * xxxxxxxxxxxxxxxxx(int pict,picturedatastr * pdp,filestr * file)
{
 boxbitstr        bits;
 boxbitstr        fbits;
 picturestr     * picturep;
 pictboxstr     * pictp;
 picturedatastr   pd;
 int              w;
 int              h;
 int              angle;
 int              s1;
 int              s2;
 int              wc;
 int              ws;
 int              hc;
 int              hs;
 double           num;
 double           den;
 int              aspect;
 int              q;
 int              w2;
 int              h2;
 int              xscale;
 int              yscale;



 pictp=fob_find(pict,file);
 getboxbits(&pictp->icurve.box,&pictp->transform,&bits);
 getboxbits(&pictp->fcurve.box,&pictp->transform,&fbits);

 if(pdp) pd=*pdp;
 else    pd=pictp->pictdata;

 picturep=fob_find(pictp->picture,file);
 w=picturep->abox.x1-picturep->abox.x0;
 h=picturep->abox.y1-picturep->abox.y0;

 w=w2=scale(w,25,16);
 h=h2=scale(h,25,16);

 angle=pd.angle;
 while(angle> 360*0x10000) angle-=360*0x10000;
 while(angle<-360*0x10000) angle+=360*0x10000;
 if(angle>=0 && angle<=90*0x10000) q=1;
 else
 if(angle>90*0x10000 && angle<=180*0x10000)
 {
  q=2;
  angle=180*0x10000-angle;
 }
 else
 if(angle>180*0x10000 && angle<=270*0x10000)
 {
  q=3;
  angle-=180*0x10000;
 }
 else
 {
  q=4;
  angle=360*0x10000-angle;
 }

 if(pd.fixaspect)
 {
  w=scale(w,pd.aspect,0x10000);
  s1=tr_cos(angle,w)+tr_sin(angle,h);
  s1=scale(0x10000,bits.width,s1);

  s2=tr_sin(angle,w)+tr_cos(angle,h);
  s2=scale(0x10000,bits.height,s2);

  if(s1<s2) pd.scale=s1;
  else      pd.scale=s2;
 }
 else
 {
  wc=tr_cos(angle,w);
  ws=tr_sin(angle,w);
  hc=tr_cos(angle,h);
  hs=tr_sin(angle,h);

  num=((double)bits.height)*((double)hs)-((double)bits.width)*((double)hc);
  den=((double)bits.width)*((double)ws)-((double)bits.height)*((double)wc);

  aspect=(int)((num/den)*(double)0x10000);

  s1=scale(wc,aspect,0x10000)+hs;
  s1=scale(0x10000,bits.width,s1);

  if(s1>=PIXMINSCALE && s1<=PIXMAXSCALE &&
     aspect>=PIXMINSCALE && aspect<=PIXMAXSCALE)
  {
   pd.scale=s1;
   pd.aspect=aspect;
  }
 }


 yscale=pd.scale;
 xscale=ttmul(yscale,pd.aspect);

 w=scale(w2,xscale,0x10000);
 h=scale(h2,yscale,0x10000);

 if(q==1)
 {
  pd.yshift=0;
  pd.xshift=tr_sin(angle,h);
 }
 else
 if(q==2)
 {
  pd.yshift=tr_cos(angle,h);
  pd.xshift=tr_cos(angle,w)+tr_sin(angle,h);
 }
 else
 if(q==3)
 {
  pd.yshift=tr_cos(angle,h)+tr_sin(angle,w);
  pd.xshift=tr_cos(angle,w);
 }
 else
 if(q==4)
 {
  pd.yshift=tr_sin(angle,w);
  pd.xshift=0;
 }


 if(pdp) *pdp=pd;
 else
 {
  pictp=fob_find(pict,file);
  pictp->pictdata=pd;
 }

 return(NULL);
}



#endif





os_error * pictscaletofit(int pict,picturedatastr * pdp,filestr * file)
{
 os_error       * err;
 boxbitstr        bits;
 boxbitstr        fbits;
 picturestr     * picturep;
 pictboxstr     * pictp;
 picturedatastr   pd;
 int              w;
 int              h;
 int              angle;
 int              s1;
 int              s2;
 int              wc;
 int              ws;
 int              hc;
 int              hs;
 double           num;
 double           den;
 int              aspect;
 coordstr         cx;
 int              xscale;
 int              temp;
 int              fw;
 int              fh;


 err=NULL;


 pictp=(pictboxstr*)fob_find(pict,file);
 if(pictp->picture)
 {
  getboxbits(&pictp->icurve.box,&pictp->transform,&bits);
  getboxbits(&pictp->fcurve.box,&pictp->transform,&fbits);

  if(pdp) pd=*pdp;
  else    pd=pictp->pictdata;

  picturep=(picturestr*)fob_find(pictp->picture,file);
  w=picturep->abox.x1-picturep->abox.x0;
  h=picturep->abox.y1-picturep->abox.y0;

/*  dprintf(0,"pix w=%d h=%d",w,h);  */


  if(w>0 && h>0)
  {
   w=scale(w,25,16);
   h=scale(h,25,16);

   angle=pd.angle;
   while(angle> 360*0x10000) angle-=360*0x10000;
   while(angle<0) angle+=360*0x10000;

   if(angle>90*0x10000 && angle<=180*0x10000)
   {
    angle=180*0x10000-angle;
   }
   else
   if(angle>180*0x10000 && angle<=270*0x10000)
   {
    angle-=180*0x10000;
   }
   else
   if(angle>270*0x10000)
   {
    angle=360*0x10000-angle;
   }

   fw=tr_sin(bits.skew,bits.height);
   if(fw<0) fw=-fw;
   fw+=bits.width;
   fh=tr_cos(bits.skew,bits.height);


   if(pd.fixaspect)
   {
    w=scale(w,pd.aspect,0x10000);
    s1=tr_cos(angle,w)+tr_sin(angle,h);
    s1=scale(0x10000,fw,s1);

    s2=tr_sin(angle,w)+tr_cos(angle,h);
    s2=scale(0x10000,fh,s2);

    if(s1<s2) pd.scale=s1;
    else      pd.scale=s2;
   }
   else
   {
    wc=tr_cos(angle,w);
    ws=tr_sin(angle,w);
    hc=tr_cos(angle,h);
    hs=tr_sin(angle,h);

    num=((double)fh)*((double)hs)-((double)fw)*((double)hc);
    den=((double)fw)*((double)ws)-((double)fh)*((double)wc);

    aspect=(int)((num/den)*(double)0x10000);
  
    s1=scale(wc,aspect,0x10000)+hs;
    s1=scale(0x10000,fw,s1);


    if(pd.skew)
    {
     h=scale(h,s1,0x10000);

     xscale=ttmul(s1,aspect);
     w=scale(w,xscale,0x10000);
     temp=tr_tan(pd.skew,h);
     if(temp<0) temp=-temp;

     xscale=scale(xscale,w-temp,w);

     aspect=scale(0x10000,xscale,s1);
    }

    pd.scale=s1;
    pd.aspect=aspect;
   }

  /* dprintf(1,"scale=%x aspect=%x",pd.scale,pd.aspect); */

   if(pd.scale>PIXMAXSCALE  || pd.scale<PIXMINSCALE ||
      pd.aspect>PIXMAXSCALE || pd.aspect<PIXMINSCALE) err=geterror(EPX2);

   pd.scale=CUT(pd.scale,PIXMINSCALE,PIXMAXSCALE);
   pd.aspect=CUT(pd.aspect,PIXMINSCALE,PIXMAXSCALE);


   pictcentre(pict,file,&pd,&cx);

   fw=fbits.width;
   fw+=tr_sin(fbits.skew,fbits.height);
   fh=tr_cos(fbits.skew,fbits.height);

   pd.xshift+=fw/2-cx.x;
   if(pd.hbits & HBBOTLEFT)
   {
    pd.yshift+=-fh/2-cx.y;
   }
   else
   {
    pd.yshift+=fh/2-cx.y;
   }

  /* dprintf(2,"xs=%d ys=%d",pd.xshift,pd.yshift);  */

   if(pdp) *pdp=pd;
   else
   {
    pictp=(pictboxstr*)fob_find(pict,file);
    pictp->pictdata=pd;
   }
  }
 }

 return(err);
}




os_error * pictcalctransform(int pict,filestr * file)
{
 pictboxstr   * pictp;
 pictboxstr     pictd;
 picturestr   * picturep;
 aboxstr        abox;
 transformstr   tr1;
 transformstr   tr2;
 transformstr   tr;
 transformstr   boxtr;
 boxbitstr      bf;
 boxstr         box;
 transformstr   rx;
 coordstr       cx;
 int            xscale;
 int            yscale;

 pictp=(pictboxstr*)fob_find(pict,file);
 pictd=*pictp;

 if(pictd.picture)
 {
  picturep=(picturestr*)fob_find(pictd.picture,file);
  abox=picturep->abox;
  abox2box(&abox,&box);

  if(pictd.pictdata.hbits & HBBOTLEFT)
  {
   tr_setscale(&tr,16,25,16,-25);
  }
  else
  {
   tr_setshift(&tr1,-abox.x0,-abox.y1);
   tr_setscale(&tr2,16,25,16,-25);
   tr_multiply(&tr,&tr1,&tr2);
  }

  yscale=pictd.pictdata.scale;
  xscale=ttmul(yscale,pictd.pictdata.aspect);
  tr_setscale(&tr2,0x10000,xscale,0x10000,yscale);
  tr_multiply(&tr1,&tr,&tr2);



  tr_setidentity(&tr2);
  tr_setskew(&tr2,pictd.pictdata.skew);
  tr=tr1;
  tr_multiply(&tr1,&tr,&tr2);


  getboxbits(&pictd.fcurve.box,&pictd.transform,&bf);

  tr_setidentity(&tr2);
  tr_setrotationa(&tr2,bf.angle+pictd.pictdata.angle);

  tr_multiply(&tr,&tr1,&tr2);


  tr_setidentity(&rx);
  tr_setrotationa(&rx,bf.angle);
  cx.x=pictd.pictdata.xshift;
  cx.y=pictd.pictdata.yshift;
  tr_transformset(&cx,1,&rx);


  if(pictd.pictdata.hbits & HBBOTLEFT)
  {
   tr_setshift(&boxtr,bf.org2x+cx.x,bf.org2y+cx.y);
  }
  else
  {
   tr_setshift(&boxtr,bf.orgx+cx.x,bf.orgy+cx.y);
  }

  tr_multiply(&tr1,&tr,&boxtr);


  pictp=(pictboxstr*)fob_find(pict,file);
  pictp->pictdata.transform=tr1;
 }

 return(NULL);
}





/* work out transform between Draw space and pict box space */

os_error * pictcalctransform2(int pict,filestr * file,transformstr * trx)
{
 pictboxstr   * pictp;
 pictboxstr     pictd;
 picturestr   * picturep;
 aboxstr        abox;
 transformstr   tr1;
 transformstr   tr2;
 transformstr   tr;
 transformstr   boxtr;
 boxstr         box;
 int            xscale;
 int            yscale;

 pictp=(pictboxstr*)fob_find(pict,file);
 pictd=*pictp;

 picturep=(picturestr*)fob_find(pictd.picture,file);
 abox=picturep->abox;
 abox2box(&abox,&box);

 tr_setshift(&tr1,-abox.x0,-abox.y1);
 tr_setscale(&tr2,16,25,16,-25);
 tr_multiply(&tr,&tr1,&tr2);


 yscale=pictd.pictdata.scale;
 xscale=ttmul(yscale,pictd.pictdata.aspect);
 tr_setscale(&tr2,0x10000,xscale,0x10000,yscale);
 tr_multiply(&tr1,&tr,&tr2);



 tr_setidentity(&tr2);
 tr_setskew(&tr2,pictd.pictdata.skew);
 tr=tr1;
 tr_multiply(&tr1,&tr,&tr2);



 tr_setidentity(&tr2);
 tr_setrotationa(&tr2,pictd.pictdata.angle);
 tr_multiply(&tr,&tr1,&tr2);

 tr_setshift(&boxtr,pictd.pictdata.xshift,pictd.pictdata.yshift);
 tr_multiply(trx,&tr,&boxtr);


 return(NULL);
}










 /*  getbordersize(pictp->frame,file,&borderwidth);
   i+=borderwidth; */



#define BCINNER 0x1
#define BCOUTER 0x2
#define BCDEL   0x4



os_error * pxboundingcurves(pictboxstr ** pictpp,filestr * file,int flags)
{
 os_error         * err;
 transformbitstr    b;
 transformstr       tx;
 transformstr       tr;
 transformstr       itr;
 int                pictk;
 curvestr           fcurve;
 curvestr           icurve;
 curvestr           ocurve;
 curvestr           xcurve;
 curvestr           newi;
 curvestr           newo;
 int                i;
 int                o;
 pictboxstr      *  pictp;
 int                borderwidth[4];


 err=NULL;


 if(flags & (BCINNER|BCOUTER))
 {
  pictp=*pictpp;
  pictk=pictp->key;

  nullcurve(&xcurve);

  if(flags & BCINNER)
  {
   if(pictp->textflow.omode==FROUSER && !pictp->masked)
   {
    fcurve=pictp->pcurve;
    tx=pictp->pictdata.transform;
   }
   else
   {
    fcurve=pictp->fcurve;
    tx=pictp->transform;
   }

   tr_getbits(&tx,&b);
   tr_setbits(&tr,&b,TR_XSCALE|TR_YSCALE);

   icurve=pictp->icurve;
   i=pictp->data.i;


   copycurve(&xcurve,file,&fcurve,file);
   transformcurve(&tr,&xcurve,file);

   parallelcurve(file,&xcurve,&newi,-i);
   if(flags & BCDEL) deletecurve(&icurve,file);
   tr_inverse(&tr,&itr);
   transformcurve(&itr,&newi,file);
   err=fob_mod(pictk,file,(fobjptr)&pictp);
   pictp->icurve=newi;
  }

  if((flags & BCOUTER) && !err)
  {
   pictp=(pictboxstr*)fob_find(pictk,file);

   ocurve=pictp->ocurve;
   o=pictp->textflow.o;
   getbordersize(pictp->frame,file,borderwidth,&pictp->fcurve);

   if((flags & BCINNER) && pictp->textflow.omode==FROUSER && pictp->masked)
   {
    /* inner curve exists but is no use to us */
    deletecurve(&xcurve,file);
   }

   if(!(flags & BCINNER) || (pictp->textflow.omode==FROUSER && pictp->masked))
   {
    if(pictp->textflow.omode==FROUSER)
    {
     fcurve=pictp->pcurve;
     tx=pictp->pictdata.transform;
    }
    else
    {
     fcurve=pictp->fcurve;
     tx=pictp->transform;
    }

    tr_getbits(&tx,&b);
    tr_setbits(&tr,&b,TR_XSCALE|TR_YSCALE);

    copycurve(&xcurve,file,&fcurve,file);
    transformcurve(&tr,&xcurve,file);
   }

   pictp=(pictboxstr*)fob_find(pictk,file);

   parallelcurve2(file,&xcurve,&newo,o,
                      (pictp->textflow.omode!=FROUSER)?borderwidth:NULL);

   if(flags & BCDEL) deletecurve(&ocurve,file);
   tr_inverse(&tr,&itr);
   transformcurve(&itr,&newo,file);
   err=fob_mod(pictk,file,(fobjptr)&pictp);
   pictp->ocurve=newo;
  }

  deletecurve(&xcurve,file);
  *pictpp=(pictboxstr*)fob_find(pictk,file);
 }
 return(err);
}



/*****************************************************************************/

os_error * pxrefresh(int pict,int section,int page,filestr * file)
{
 return(viewrefreshobject(pict,section,page,file));
}


/*****************************************************************************/


static void copypicturedata(pictboxstr * pictpd,pictboxstr * pictps)
{
 pictpd->pictdata=pictps->pictdata;
 if(pictps->flags.version>0)
 {
  pictpd->tile=pictps->tile;
  pictpd->tiledx=pictps->tiledx;
  pictpd->tiledy=pictps->tiledy;
  pictpd->sparebits=pictps->sparebits;
  pictpd->spare[0]=pictps->spare[0];
  pictpd->spare[1]=pictps->spare[1];
  pictpd->spare[2]=pictps->spare[2];
 }
 else
 {
  pictpd->tile=pictpd->tiledx=pictpd->tiledy=0;
  pictpd->spare[0]=pictpd->spare[1]=pictpd->spare[2]=0;
  pictpd->sparebits=0;
 }
}



void unpackpicturedata(unpackedpicturedatastr * upd,pictboxstr * pictp)
{
 upd->pd=pictp->pictdata;
 if(pictp->flags.version>0)
 {
  upd->tile=pictp->tile;
  upd->tiledx=pictp->tiledx;
  upd->tiledy=pictp->tiledy;
  upd->spare[0]=pictp->spare[0];
  upd->spare[1]=pictp->spare[1];
  upd->spare[2]=pictp->spare[2];
  upd->sparebits=pictp->sparebits;
 }
 else
 {
  upd->tile=upd->tiledx=upd->tiledy=0;
  upd->spare[0]=upd->spare[1]=upd->spare[2]=0;
  upd->sparebits=0;
 }
}



void packpicturedata(pictboxstr * pictp,unpackedpicturedatastr * upd)
{
 pictp->pictdata=upd->pd;
 pictp->tile=upd->tile;
 pictp->tiledx=upd->tiledx;
 pictp->tiledy=upd->tiledy;
 pictp->spare[0]=pictp->spare[1]=pictp->spare[2]=0;
 pictp->sparebits=0;
 pictp->flags.version=1;
}






static void getpicttextdata(pictboxstr * pictp,textboxstr * textp)
{
 pictp->flags=textp->flags;
 pictp->flags.version=1;
 pictp->box=textp->box;
 pictp->transform=textp->transform;
 pictp->fcurve=textp->fcurve;
 pictp->icurve=textp->icurve;
 pictp->ocurve=textp->ocurve;
 pictp->textflow=textp->textflow;
 pictp->master=textp->master;
 pictp->frame=textp->frame;

 pictp->data.i=textp->data.i;
 pictp->data.colour=textp->data.colour;
 pictp->data.fill=textp->data.fill;
 pictp->data.radius=textp->data.radius;
 pictp->data.changei=textp->data.changei;
}


os_error * pictfromtextlo(pictboxstr * pictp,filestr * file)
{
 int          pict;
 textdatastr  textdata;

 textdata=((textboxstr*)pictp)->data;

 pict=pictp->key;

 fob_change(pict,file,sizeof(pictboxstr),(fobjptr)&pictp);
 pictp->type=OPICTBOX;

 pictp->data=defltpictdata;
 packpicturedata(pictp,&defltpicturedata);

/* pictp->data.i=textdata.i; */
 pictp->data.colour=textdata.colour;
 pictp->data.fill=textdata.fill;
 pictp->data.radius=textdata.radius;

/* pictp->data.changei=textdata.changei; */

 pictp->textflow.changeo=0;

 defltprocess(&pictp->process.process,file);
 pictp->picture=0;
 pictp->ftype=0;

 /* if(!pictp->data.changei) */

 nullcurve(&pictp->pcurve);

 return(NULL);
}



static os_error * pictfromtext(pictboxstr * pictp,filestr * file)
{
 int pict;

 pict=pictp->key;

 pictfromtextlo(pictp,file);

 pictp=(pictboxstr*)fob_find(pict,file);

 pxboundingcurves(&pictp,file,BCDEL|BCINNER|BCOUTER);

 getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

 frameflow((sobjectstr **)&pictp,file);

 return(pixobjectchange(file,pict)); 
}



typedef struct pxsavestr
{
 curvestr        pcurve;
 picturedatastr  pd;
 pictprocstr     process;
 int             picture;
 int             ftype;
 curvestr        icurve;
 curvestr        ocurve;
 int             i;
 unsigned int    masked:1;
 unsigned int    changei:1;
 unsigned int    changeo:1;
 unsigned int    omode:3;
 int             masterdata;
 int             tile;
 int             tiledx;
 int             tiledy;
 int             spare[3];

} pxsavestr;



static os_error * pxsavedata(int pict,filestr * file)
{
 pxsavestr    pxsave;
 pictboxstr * pictp;

 pictp=(pictboxstr*)fob_find(pict,file);

 pxsave.pcurve=pictp->pcurve;
 pxsave.pd=pictp->pictdata;
 pxsave.process=pictp->process;
 pxsave.picture=pictp->picture;
 pxsave.ftype=pictp->ftype;
 pxsave.masked=pictp->masked;
 pxsave.i=pictp->data.i;
 pxsave.changei=pictp->data.changei;
 pxsave.changeo=pictp->textflow.changeo;
 pxsave.omode=pictp->textflow.omode;
 pxsave.icurve=pictp->icurve;
 pxsave.ocurve=pictp->ocurve;
 pxsave.masterdata=pictp->flags.masterdata;

 if(pictp->flags.version>0)
 {
  pxsave.tile=pictp->tile|(pictp->sparebits<<1);
  pxsave.tiledx=pictp->tiledx;
  pxsave.tiledy=pictp->tiledy;
  pxsave.spare[0]=pictp->spare[0];
  pxsave.spare[1]=pictp->spare[1];
  pxsave.spare[2]=pictp->spare[2];
 }
 else
 {
  pxsave.tile=pxsave.tiledx=pxsave.tiledy=0;
  pxsave.spare[0]=pxsave.spare[1]=pxsave.spare[2]=0;
 }

 nullcurve(&pictp->icurve);
 nullcurve(&pictp->ocurve);
 defltprocess(&pictp->process.process,file);

 if(!pxsave.changei) deletecurve(&pxsave.icurve,file);
 if(!pxsave.changeo) deletecurve(&pxsave.ocurve,file);

 return(undowrite(file,&pxsave,sizeof(pxsavestr)));
}


static os_error * pxloaddata(int pict,filestr * file)
{
 os_error   * err;
 pxsavestr    pxsave;
 pictboxstr * pictp;
 int          bits;

 err=undoread(file,&pxsave,sizeof(pxsavestr));

 if(!err)
 {
  pictp=(pictboxstr*)fob_find(pict,file);

  pictp->pcurve=pxsave.pcurve;
  pictp->pictdata=pxsave.pd;
  pictp->process=pxsave.process;
  pictp->picture=pxsave.picture;
  pictp->ftype=pxsave.ftype;
  pictp->masked=pxsave.masked;
  pictp->data.i=pxsave.i;
  pictp->data.changei=pxsave.changei;
  pictp->textflow.changeo=pxsave.changeo;
  pictp->textflow.omode=pxsave.omode;
  pictp->icurve=pxsave.icurve;
  pictp->ocurve=pxsave.ocurve;
  pictp->flags.masterdata=pxsave.masterdata;
  pictp->tile=pxsave.tile & 0x1;
  pictp->sparebits=pxsave.tile>>1;
  pictp->tiledx=pxsave.tiledx;
  pictp->tiledy=pxsave.tiledy;
  pictp->spare[0]=pxsave.spare[0];
  pictp->spare[1]=pxsave.spare[1];
  pictp->spare[2]=pxsave.spare[2];

  bits=0;
  if(!pxsave.changeo) bits|=BCOUTER;
  if(!pxsave.changei) bits|=BCINNER;

/* dprintf(0,"chgo=%d chgi=%d",pxsave.changeo,pxsave.changei); */

  pxboundingcurves(&pictp,file,bits);

  getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

  frameflow((sobjectstr **)&pictp,file);
  vxadd((sobjectstr **)&pictp,file);

  pictcalctransform(pict,file);

  pixchange(pict,file); 
 }

 return(err);
}



static os_error * pxscrapdata(filestr * file)
{
 os_error   * err;
 pxsavestr    pxsave;

 err=undoread(file,&pxsave,sizeof(pxsavestr));

 if(!err)
 {
  if(pxsave.changei) deletecurve(&pxsave.icurve,file);
  if(pxsave.changeo) deletecurve(&pxsave.ocurve,file);
  deletecurve(&pxsave.pcurve,file);
  fob_delete(pxsave.picture,file);
  deleteprocess(pxsave.process.process,file);
 }

 return(err);
}



static os_error * pxscrapcontents(pictboxstr * pictp,filestr * file)
{
 pictboxstr old;

 old=*pictp;

 deletecurve(&old.icurve,file);
 deletecurve(&old.ocurve,file);
 deletecurve(&old.pcurve,file);

 if(old.picture) fob_delete(old.picture,file);

 return(NULL);
}


/*****************************************************************************/

/* called last in undo/redo */

/* tagged to UPXDELS */

static pagesectionstr upxpagesect;

static os_error * unpxdels(filestr * file)
{
 frflflush(file);
 vxflush(file,VRBACK,upxpagesect.page,upxpagesect.section);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 undowritefn(file,UPXDELF,&upxpagesect,sizeof(pagesectionstr));

 return(NULL);
}


/* called first  in undo/redo */

/* tagged to UPXDELF */

static os_error * unpxdelf(filestr * file)
{
 undoread(file,&upxpagesect,sizeof(pagesectionstr));

 vxstart(file);
 frflstart(file);

 undowritefn(file,UPXDELS,NULL,0);

 return(NULL);
}


static os_error * upxdelete(filestr * file)
{
 os_error   * err;
 int          pict;
 pictboxstr * pictp;

 err=undoread(file,&pict,sizeof(int));

 undowritefn(file,UPXRECREATE,&pict,sizeof(int));
 pxsavedata(pict,file);

 pictp=(pictboxstr*)fob_find(pict,file);
 vxadd((sobjectstr **)&pictp,file);

 textfrompictlo((textboxstr*)pictp,file);
 txloaddata(pict,file);

 pixobjectchange(file,pict);

 return(err);
}


static os_error * upxdelscrap(filestr * file)
{
 os_error   * err;
 int          pict;

 err=undoread(file,&pict,sizeof(int));
 txscrapdata(file);

 return(err);
}


static os_error * upxrecreate(filestr * file)
{
 os_error   * err;
 int          pict;
 pictboxstr * pictp;
 int          claim;

 err=undoread(file,&pict,sizeof(int));

 makepictframe(pict,file,selsectk,&claim);

 undowritefn(file,UPXDELETE,&pict,sizeof(int));
 txsavedata(pict,file);

 pictp=(pictboxstr*)fob_find(pict,file);
 vxadd((sobjectstr **)&pictp,file);

 pictfromtextlo(pictp,file);

 pxloaddata(pict,file);

 pixobjectchange(file,pict);

 return(err);
}


static os_error * upxrecscrap(filestr * file)
{
 os_error   * err;
 int          pict;

 err=undoread(file,&pict,sizeof(int));
 pxscrapdata(file);

 return(err);
}


os_error * pxdeletepicture(int pict,filestr * file)
{
 os_error    * err;
 pictboxstr  * pictp;

 pixclear(pict,file);

 upxpagesect.page=selpagek;
 upxpagesect.section=selsectk;

 err=unpxdelf(file);
 if(!err)
 {
  undowritefn(file,UPXRECREATE,&pict,sizeof(int));
  pxsavedata(pict,file);

  pictp=(pictboxstr*)fob_find(pict,file);
  vxadd((sobjectstr **)&pictp,file);
  textfrompict((textboxstr*)pictp,file);

  unpxdels(file);
 }

 return(err);
}


/*****************************************************************************/


/* tagged to UPXCOPY */

static os_error * upxtrash(filestr * file)
{
 os_error   * err;
 int          pict;

 err=undoread(file,&pict,sizeof(int));
 pxscrapdata(file);

 return(err);
}


static os_error * upxcopy(filestr * file)
{
 int pict;

 undoread(file,&pict,sizeof(int));
 undowritefn(file,UPXCOPY,&pict,sizeof(int));

 pxsavedata(pict,file);
 pxloaddata(pict,file);

 return(NULL);
}


os_error * pxdropcopypicture(objectloc * dloc,objectloc * sloc,
                                           int otype,int * copied)
{
 os_error             * err;
 int                    pict;
 pictboxstr           * pictp;
 picturestr           * picturep;
 filestr              * dfile;
 filestr              * sfile;
 int                    message;
 int                    ftype;
 int                    masked;
 int                    picture;
 int                    oldpicture;
 unpackedpicturedatastr upd;
 int                    copypix;
 int                    dprocess;
 int                    sprocess;


 err=NULL;

 cprintf("pxdropcopy 1");

 pict=dloc->object;
 dfile=dloc->file;
 sfile=sloc->file;
 *copied=0;

 if(otype==OPICTBOX) message=0;
 else
 {
  message=OM_PICTBOX;
  makepictframe(dloc->object,dfile,dloc->section,&message);
 }

 if(!message)
 {
  *copied=1;

  upxpagesect.page=dloc->page;
  upxpagesect.section=dloc->section;

  err=unpxdelf(dfile);
  if(!err)
  {
   if(otype==OPICTBOX)
   {
    undowritefn(dfile,UPXCOPY,&pict,sizeof(int));
    pxsavedata(pict,dfile);
   }
   else
   {
    if(otype==OTEXTBOX)
    {
     undowritefn(dfile,UPXDELETE,&pict,sizeof(int));
     txsavedata(pict,dfile);
     pictfromtext((pictboxstr*)fob_find(dloc->object,dfile),dfile);
    }
   }

   /* set up on source object */

   pictp=(pictboxstr*)fob_find(sloc->object,sfile);
   unpackpicturedata(&upd,pictp);
   masked=pictp->masked;
   picture=oldpicture=pictp->picture;
   sprocess=pictp->process.process;

   ftype=0;

   if(picture)
   {
    if(sloc->copymode & LOCCLIP) copypix=getcliphint(dfile,picture);
    else                         copypix=0;

    if(copypix)
    {
     err=fob_copy((fobjptr)&picturep,dfile,copypix,dfile);
					if(!err)
					{
      picture=picturep->key;
      ftype=picturep->ftype;
					}
    }
    else
    {
     err=fob_copy((fobjptr)&picturep,dfile,picture,sfile);
					if(!err)
					{
      picture=picturep->key;
      ftype=picturep->ftype;

      if(sfile!=dfile) // problem of copying a relative path to clipboard
      {
       pxmakereferenceabsolute(picture,sfile,dfile);
      }
     }
    }

    if(!err)
    {
     if(sloc->copymode & LOCCLIP)
     {
      setcliphint(dfile,oldpicture,picture);
     }
    }
   }


    cprintf("pxdropcopy 2");

   if(!err)
   {
    err=copyprocessm(&dprocess,dfile,sprocess,sfile,dloc->copymode);

    /* set up on dest object */

    fob_mod(pict,dfile,(fobjptr)&pictp);
    pictp->picture=picture;
    pictp->flags.masterdata=0;

    packpicturedata(pictp,&upd);
    pictp->ftype=ftype;
    pictp->masked=masked;
    pictp->process.process=dprocess;

    pictp->textflow.changeo=0;
    if(pictp->textflow.omode==FROUSER)
    {
     pictp->textflow.omode=FROFRAME;
     nullcurve(&pictp->pcurve);
    }

    pictp->data.changei=0;

    pxboundingcurves(&pictp,dfile,BCDEL|BCINNER|BCOUTER);

    getframemaxbox((sobjectstr **)&pictp,pictp->frame,dfile,&pictp->transform);

    frameflow((sobjectstr **)&pictp,dfile);

    vxadd((sobjectstr **)&pictp,dfile);

    pictcalctransform(pict,dfile);

    pixchange(pict,dfile); 

     cprintf("pxdropcopy 3");
   }

   unpxdels(dfile);  /* should this be in err clause */
  }
 }
 return(err);
}


/***************************************************************************/

static int pictloadmode;

#define PXNORMAL    0
#define PXREFERENCE 1


static os_error * pictloadtype(char * name,int ftype,posnstr * posn,int * method)
{                 
 os_error   * err;
 int          flags;
 pictboxstr * pictp;

 err=NULL;

 flags=impexdatatrans(ftype,name);
 if((flags & IMPXLOAD) && (flags & IMPXPICT)) *method=1;
 else                                         *method=0;

 cprintf("picttype returns %d",*method);

 pictp=(pictboxstr*)fob_find(posn->object,posn->file);

 if(pictp->type==OPICTBOX)
 {
  if(pictp->master && !pictp->flags.local && 
                           pictp->flags.masterdata)
  {
   *method=0;
   err=geterror(EPX4);
  }

  if((*method)>0) err=modfile(posn->file,posn->section);
 }

 if(!(*method) && !err && (flags & IMPXTEXT)) err=geterror(EPX3);

 return(err);
}



static os_error * pictloadpost(posnstr * posn)
{
 os_error    * err;
 pictboxstr  * pictp;

 err=NULL;

 if(pictloadmode==PXNORMAL)
 {
  pictp=(pictboxstr*)fob_find(posn->object,posn->file);
  err=importloadpost(pictp->ftype,pictp->picture,posn->file);
 }

 return(err);
}



os_error * pictloadsub(int ftype,int object,posnstr * posn)
{
 os_error     * err;
 int            pict;
 filestr      * file;
 pictboxstr   * pictp;
 int            claim;


 file=posn->file;
 pict=posn->object;

 err=NULL;
 if(!err)
 {
  err=undostart(file);
  if(!err)
  {
   pictp=(pictboxstr*)fob_find(pict,file);

   if(pictp->type==OTEXTBOX) makepictframe(pict,file,posn->section,&claim);

   upxpagesect.page=posn->page;
   upxpagesect.section=posn->section;

   err=unpxdelf(file);
   if(!err)
   {
    pictp=(pictboxstr*)fob_find(pict,file);

    if(pictp->type==OTEXTBOX)
    {
     undowritefn(file,UPXDELETE,&pict,sizeof(int));
     txsavedata(pict,file);

     pictfromtext((pictboxstr*)fob_find(pict,file),file);

     pictp=(pictboxstr*)fob_find(pict,file);
    }
    else
    {
     undowritefn(file,UPXCOPY,&pict,sizeof(int));
     pxsavedata(pict,file);
    }

    packpicturedata(pictp,&defltpicturedata);

    pictp->picture=object;
    pictp->ftype=ftype;
    pictp->flags.masterdata=0;

    pictp->textflow.changeo=0;
    if(pictp->textflow.omode==FROUSER)
    {
     pictp->textflow.omode=FROFRAME;
     nullcurve(&pictp->pcurve);
    }

    pxboundingcurves(&pictp,file,BCDEL|BCINNER|BCOUTER);

    getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

    frameflow((sobjectstr **)&pictp,file);

    vxadd((sobjectstr **)&pictp,file);

    if(posn->ctrl) 
    {
     pictp=(pictboxstr*)fob_find(pict,file);
     pictp->pictdata.scale=defimportscale;
     pictcentrepict(pict,file,NULL);
    }
    else
    {
     pictscaletofit(pict,NULL,file);
    }

    pictcalctransform(pict,file);

    pixchange(pict,file); 

    unpxdels(file);
   }
   undoend(file);
  }
 }
 return(err);
}



static os_error * pictrefload(char * name,int ftype,posnstr * posn,
                                                    pxrefstr * ref)
{
 os_error   * err;
 int          object;
 filestr    * file;
 pictboxstr * pictp;
 picturestr * picturep;

 file=posn->file;

 if(ref->reference)
 {
  err=importreferenceload(name,ftype,&object,file);
 }
 else
 {
  err=importload(name,ftype,0,&object,file);
 }

	cprintf("pictrefload err %s",err?err->errmess:"");

 if(!err)
 {
  picturep=(picturestr*)fob_find(object,file);
  ftype=picturep->ftype;
  if(ref->makeproxy) err=importmakeproxy(ftype,object,file,&ref->proxy);
  if(!err)           err=pictloadsub(ftype,object,posn);
 }
 
 if(!err)
 {
  pictp=(pictboxstr*)fob_find(posn->object,file);
  err=importloadpost(ftype,pictp->picture,file);
 }

 return(err);
}


static os_error * pictload(char * name,int ftype,int xvolatile,posnstr * posn)
{
 os_error     * err;
 int            object;
 filestr      * file;
 fstat          fs;
 picturestr   * picturep;

 file=posn->file;

 /* if volatile, then no choice, have to load and can't reference */

// cprintf("pictload");

 if(!xvolatile && posn->shift)
 {
  pictloadmode=PXREFERENCE;
  err=openpiximportbox(name,ftype,posn,pictrefload);
 }
 else
 {
  pictloadmode=PXNORMAL;

  if(!xvolatile)
  {
   fs_stat(name,&fs);
  }
  else fs.length=0;

  if(pxdoreflimit && fs.length>=pxreflimit)
                            err=importreferenceload(name,ftype,&object,file);
  else                      err=importload(name,ftype,xvolatile,&object,file);

  if(!err && object)
  {
   picturep=(picturestr*)fob_find(object,file);
   ftype=picturep->ftype;

   if(!err)
   {
    if(pxdoproxylimit && fs.length>=pxproxylimit)
                            err=importmakeproxy(ftype,object,file,&pxdefproxy);
   }

   err=pictloadsub(ftype,object,posn);
  }
 }

 return(err);
}


/****************************************************************************/


#define XMARGIN 100


static os_error * rendernopicture(viewredrawstr * v,pictboxstr * pictbox)
{
 os_error        * err;
 clipbuff          buff;
 curvestr          fcurve;
 transformstr      tr;
 viewstr         * view;
 filestr         * file;
 int               guidecolour;
 boxstr            xbox;
 boxstr            box;


 err=NULL;


 view=v->view;
 file=v->file;
 fcurve=pictbox->fcurve;
 tr=pictbox->transform;

 guidecolour=(view->data.guides)?(GUIDECOLOUR|OUTLINEWIMPLINE):0;

 if(guidecolour)
 {
  err=clipopen(&buff);
  if(!err)
  {
   xbox.x=fcurve.box.x-XMARGIN;
   xbox.y=fcurve.box.y-XMARGIN;
   xbox.w=fcurve.box.w+2*XMARGIN;
   xbox.h=fcurve.box.h+2*XMARGIN;

   box=xbox;
   box.x+=box.w/2+XMARGIN;

   err=clipvline(&fcurve,&box,file,&buff);
   outlinesections(v,buff.path,guidecolour,NULL,-1,&tr);
   clipreset(&buff);

   box=xbox;
   box.y+=box.h/2+XMARGIN;
   err=cliphline(&fcurve,&box,file,&buff);
   outlinesections(v,buff.path,guidecolour,NULL,-1,&tr);

   clipclose(&buff);
  }
 }

 return(err);
}




static os_error * rendert(aboxstr * dboxp,transformstr * tr,
                          processstr * pr,picturestr * picturep,
                          viewredrawstr * v,int tiledx,int tiledy)
{
 os_error   * err;
 aboxstr      xbox;
 aboxstr      dbox;
 int          x;
 int          xl;
 int          xs;
 int          y;
 int          yl;
 transformstr tr1;
 transformstr tr2;
 int          dx0;
 int          dx1;
 int          dx;
 int          dy;


 err=NULL;

 dbox=*dboxp;
 xbox=picturep->abox;

 dx=(xbox.x1-xbox.x0+tiledx);
 dx=FLOOR(dx,(-(xbox.x1-xbox.x0)/16));
 x=(dbox.x0-xbox.x0)/dx;
 x*=dx;
 x+=xbox.x0;
 if(x>dbox.x0) x-=dx;
 while(((x-dx)+(xbox.x1-xbox.x0))>dbox.x0) x-=dx;
 if(dbox.x0>(x+(xbox.x1-xbox.x0))) x+=dx;
 xs=x;
 xl=dbox.x1;

 dx0=dbox.x0-(x-xbox.x0);
 dx1=dbox.x1-(x-xbox.x0);


 dy=(xbox.y1-xbox.y0+tiledy);
 dy=FLOOR(dy,(-(xbox.y1-xbox.y0)/16));
 y=(dbox.y0-xbox.y0)/dy;
 y*=dy;
 y+=xbox.y0;
 if(y>dbox.y0) y-=dy;
 while(((y-dy)+(xbox.y1-xbox.y0))>dbox.y0) y-=dy;
 if(dbox.y0>(y+(xbox.y1-xbox.y0))) y+=dy;
 yl=dbox.y1;

 dbox.y0-=(y-xbox.y0);
 dbox.y1-=(y-xbox.y0);


 while(y<yl)
 {
  dbox.x0=dx0;
  dbox.x1=dx1;
  x=xs;

  while(x<xl)
  {
   tr_setshift(&tr1,x-xbox.x0,y-xbox.y0);
   tr_multiply(&tr2,&tr1,tr);
   err=render(&dbox,&tr2,pr,picturep,v);
   if(err) break;
   x+=dx;
   dbox.x0-=dx;
   dbox.x1-=dx;
  }

  y+=dy;
  dbox.y0-=dy;
  dbox.y1-=dy;

  if(err) break;
 }
 return(err);
}



/* ensure we don't grab every byte in the machine */

#define PXFUDGE 0x2000


static os_error * renderpicture(viewredrawstr * v,pictboxstr * pictbox)
{
 os_error        * err;
 int               picture;
 picturestr      * picturep;
 processstr        pr;
 transformstr      imagetr;
 transformstr      restr2;
 transformstr      icurvetr;
 transformstr      inv;
 transformstr      drtr;
 coordstr          cx1;
 coordstr          cx2;
 boxstr            maxbox;
 boxstr            imagemaxbox;
 boxstr            framemaxbox;
 int               gx0;
 int               gy0;
 int               gx1;
 int               gy1;
 int               rgx0;
 int               rgy0;
 int               rgx1;
 int               rgy1;
 aboxstr           abox;
 aboxstr           dbox;
 boxstr            box;
 int               cliplevel;
 int               dx;
 int               dy;
 viewstr         * view;
 filestr         * file;
 int               tile;
 int               tiledx;
 int               tiledy;
 void            * cliphandle=NULL;
 int               visible;


 err=NULL;

 picture=pictbox->picture;


 if(picture)
 {
  view=v->view;
  file=v->file;

  pr.isprinter=v->isprinter;
//  pr.vdupal=&cvdu.vdupal;
//  pr.deltax=cvdu.deltax;
//  pr.deltay=cvdu.deltay;
//  pr.lndeltax=cvdu.lndeltax;
//  pr.lndeltay=cvdu.lndeltay;
  pr.xdpi=cvdu.xdpi;
  pr.ydpi=cvdu.ydpi;
  pr.ln2bpp=cvdu.ln2bpp;
  pr.tosprite=0;
  pr.fontbits=pixfontbits;
  pr.jpegbits=pixjpegbits;
  pr.spritebits=pixspritebits;

		pr.prjob=(void*)v->prjob;
  pr.useproxies=v->isprinter?(((prjobstr*)pr.prjob)->prints->printproxies):(!view->data.noproxies);

//		cprintf("use proxies %d",pr.useproxies);

  pr.handle2=view;
  pr.cmyk2rgb=(processcmyk2rgbfn)xcmyk2rgb3232;
  pr.cmyk2bgr=(processcmyk2rgbfn)xcmyk2bgr3232;

  if(pr.isprinter && (printbits & PRB_FLAT))
  {
   pr.scale=((prjobstr*)v->prjob)->scale;
  }
  else
  {
   pr.scale.x=pr.scale.y=0x10000;
  }

//  cprintf("xdpi %d ydpi %d",pr.xdpi,pr.ydpi);


/*
  infofill(&pictbox->data.fill,v,&fillbits,&fillpal);
  if(fillbits) pr.background=-1;
  else         pr.background=findcolourtint(file,&pictbox->data.colour);
*/

  colseparationpict(v,pictbox->key,pictbox->process.process,CSPX_START);

  pr.background=-1;

  setprocess(pictbox->process.process,view,&pr);

  if(pr.mode!=PROCESSNULL)
  {
   picturep=(picturestr*)fob_find(picture,file);

   if(picturep->proxylen)
   {
    //pr.useproxies=v->isprinter?(0):(!view->data.noproxies);
				pr.useproxies=v->isprinter?(((prjobstr*)pr.prjob)->prints->printproxies):(!view->data.noproxies);
   }
   else
   {
    pr.useproxies=0;
   }

   imagetr=pictbox->pictdata.transform;

   if(pictbox->flags.version>0)
   {
    tile=pictbox->tile;
    tiledx=pictbox->tiledx;
    tiledy=pictbox->tiledy;
   }
   else
   {
    tile=tiledx=tiledy=0;
   }


   if(pictbox->textflow.omode==FROUSER && !pictbox->masked) icurvetr=imagetr;
   else                                                     icurvetr=pictbox->transform;


   abox2box(&picturep->abox,&box);

   /* imagemaxbox is the biggest area covered by the picture in our space */
   getmaxbox(&imagemaxbox,&box,&imagetr);

   dx=ourunits(cvdu.extrax,view);  /* margin for error */
   dy=ourunits(cvdu.extray,view);
   imagemaxbox.x-=2*dx;
   imagemaxbox.y-=2*dy;
   imagemaxbox.w+=4*dx;
   imagemaxbox.h+=4*dy;


#ifdef NEVER

  {
   curvestr c;
   c.type=CBOX;
   c.box=box;
   outlinecurve(v,&c,WIMPYELLOW|OUTLINEWIMPLINE,NULL,&imagetr);
  }

#endif

   getmaxbox(&framemaxbox,&pictbox->icurve.box,&icurvetr);

   /* framemaxbox is the biggest area covered by the frame in our space */

   if(tile) maxbox=framemaxbox;
   else
   if(!getminbox2(&maxbox,&imagemaxbox,&framemaxbox)) return(NULL);

   /* maxbox is the largest area of the picture to render */

   /* assert (0) if imagemaxbox fits inside framemaxbox we don't need to clip.
             (1) if it does not fit, then if the frame is a rectangle and 
                 has a simple transform we can clip.
             (2) buffer to a sprite */

   /* in fact image box must lie inside frame icurve to not need clipping */
   /* for angled      boxes this is a tighter constraint than maxboxes    */
   /* to get away with level 1 clip, both picture and box must have       */
   /* simple transforms                                                   */


   /* room here for box fits inside curve text */

   if(pictbox->icurve.type!=CBOX) cliplevel=2;
   else
   {
    if(!tile && boxinbox(&imagemaxbox,&framemaxbox))
    {
     tr_inverse(&icurvetr,&inv);
     tr_multiply(&restr2,&imagetr,&inv);
     getmaxbox(&imagemaxbox,&box,&restr2);
     if(boxinbox(&imagemaxbox,&pictbox->icurve.box)) cliplevel=0;
     else                                            cliplevel=1;
    }
    else cliplevel=1;

    if((icurvetr.b || icurvetr.c) && cliplevel) cliplevel++;
   }

// aim here is that rectangular clip box covers same area as
// Draw style filled area used for frame background.

   render_getdrtr(&drtr,NULL,v);
   cx1.x=maxbox.x;
   cx1.y=maxbox.y;
   cx2.x=maxbox.x+maxbox.w;
   cx2.y=maxbox.y+maxbox.h;
   tr_transformset(&cx1,1,&drtr);
   tr_transformset(&cx2,1,&drtr);

//    cprintf("gx0 %d gy0 %d gx1 %d gy1 %d",gx0*256,gy0*256,gx1*256,gy1*256);
//    cprintf("cx0 %d cy0 %d cx1 %d cy1 %d",cx1.x,cx1.y,cx2.x,cx2.y);

   gx0=cx1.x;
   gx1=cx2.x;
   gy0=cx2.y;
   gy1=cx1.y;

  /* gx0... is biggest area covered by the picture in draw space */

   rgx0=v->redrawstr.g.x0*256;
   rgx1=v->redrawstr.g.x1*256;
   rgy0=v->redrawstr.g.y0*256;
   rgy1=v->redrawstr.g.y1*256;

//   cprintf("gx0 %d gx1 %d gy0 %d gy1 %d",gx0,gx1,gy0,gy1);
//   cprintf("rgx0 %d rgx1 %d rgy0 %d rgy1 %d",rgx0,rgx1,rgy0,rgy1);

   if(
      (gx1<rgx0) || (rgx0>rgx1) ||
      (gy1<rgy0) || (gy0>rgy1)
     )
   {
//				cprintf("no pic redraw");
    return(NULL);
   }

   if(rgx0>gx0) abox.x0=rgx0;
   else         abox.x0=gx0;

   if(rgx1<gx1) abox.x1=rgx1;
   else         abox.x1=gx1;

   if(rgy0>gy0) abox.y0=rgy0;
   else         abox.y0=gy0;

   if(rgy1<gy1) abox.y1=rgy1;
   else         abox.y1=gy1;

   /* abox is biggest area of picture to plot in os space */

   
   if((abox.x0<abox.x1) && (abox.y0<abox.y1))
   {
//    cprintf("cliplevel %d",cliplevel);
    render_gwinrectdr(abox.x0,abox.y0,abox.x1,abox.y1,&visible,v);
    if(visible)
    {
     if(cliplevel>0  || pr.isprinter)
     {
      render_saveclippath(&cliphandle,v);
     }

     if(cliplevel>1 || pr.isprinter) /* now always try to use this code */
     {                               /* for more precision */
      render_setclipcurve(&pictbox->icurve,&icurvetr,v);     
     }
     else
     if(cliplevel==1)
     {
      render_gwindowdr(abox.x0,abox.y0,abox.x1,abox.y1,v);
     }

					if(pr.isprinter)	event(EVENT_PRPXSTART,view,(int)v);
					if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))	event(EVENT_PSSTARTPICT,view,(int)v);



//    getdrtr(&restr2,&imagetr,v);
     tr_multiply(&restr2,&imagetr,&drtr);

     getmaxinvabox(&dbox,&abox,&restr2);

     if(tile) err=rendert(&dbox,&restr2,&pr,picturep,v,tiledx,tiledy);
     else     err=render(&dbox,&restr2,&pr,picturep,v);


     startredraw();

					if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))	event(EVENT_PSENDPICT,view,(int)v);
     if(pr.isprinter)	event(EVENT_PRPXEND,view,(int)v);


     if(cliplevel>1 || pr.isprinter)
     {
      render_clearclipcurve(v);
     }

     if(cliplevel>0 || pr.isprinter)
     {
      render_loadclippath(cliphandle,v);
     }
    }
   }
  }
  colseparationpict(v,pictbox->key,pictbox->process.process,CSPX_END);
 }

 return(err);
}



static os_error * redrawpict(viewredrawstr * v,pictboxstr * pictp)
{
 os_error    * err;
 viewstr     * view;
 filestr     * file;
 int           guidecolour;
 int           doborder;
 int           docontents;
 int           pictk;
 curvestylestr cstyle;
 pictboxstr    pict;


 err=NULL;

 if(pictp->key==v->object) v->ignore=0;

 if(!v->ignore)
 {
  if(!pictp->flags.invisible && boxinredraw(v,&pictp->box))
  {
   pict=*pictp;
   pictk=pict.key;
   file=v->file;
   view=v->view;

   doborder=docontents=1;

   if(v->sobject && v->sshortcuts)
   {
    if(pict.textflow.omode==FROFRAME &&
       !pict.textflow.changeo)
    {
     docontents=pict.textflow.o<0;
     doborder=pict.textflow.o<=0;
    }
    if(doborder || docontents) v->sshortcuts=0;

    if(!docontents || !doborder)
    {
     if(embededobject(pictk,file)) docontents=doborder=1;
   /* if(docontents || doborder) pict=fob_find(pictk,file); */
    }
   }

   if(doborder || docontents)
   {
// draw outline if
// printing, no pics, not hidden, not no outline, not visible

    guidecolour=(view->data.guides || 
     (v->isprinter && !view->data.pictures && !(pict.pictdata.hbits & HBHIDE) && !(printbits & PRB_NOG) && !(pict.pictdata.hbits & HBVISIBLE)))
     ?(GUIDECOLOUR|OUTLINEWIMPLINE|(v->isprinter?OUTLINEUSEPATH:0)):0;

    cstyle.fillcolour=cstyle.linecolour=pict.data.colour;
    cstyle.fill=pict.data.fill;
    rcreatepathstyle(&cstyle.pstyle,0);
    cstyle.pstyle.action=0x2;
    err=renderfill(v,&pict.fcurve,&cstyle,&pict.transform);


    if(!err)
    {
     if(((view->data.pictures && !(pict.pictdata.hbits & HBHIDE)) ||
								 (pict.pictdata.hbits & HBVISIBLE))
                            && pict.picture)  err=renderpicture(v,&pict);
     else                                     err=rendernopicture(v,&pict);

   
     if(!err && doborder)
     {
    /*  pict=fob_find(pictk,file); */
      err=renderborder(pict.frame,&pict.fcurve,&pict.transform,v);
      if(!err)
      {
       err=outlinecurve(v,&pict.fcurve,guidecolour,NULL,&pict.transform);
      }
     }
    }
   }
  }
 }

 return(err);
}







os_error * createpict1(objectloc * loc,curvestr * c,pictdatastr * data,
                       unpackedpicturedatastr * picturedata,
                       textflowstr *  flow,
                       transformstr * tr,int frame,
                       curvestr * ic,curvestr * oc,curvestr * pc)
{
 os_error   * err;
 int          pictk;
 pictboxstr * pictp;
 curvestr     fcurve;
 curvestr     icurve;
 curvestr     ocurve;
 curvestr     pcurve;
 filestr    * file;
 int          bits;


 file=loc->file;

 err=fob_create(sizeof(pictboxstr),file,OPICTBOX,(fobjptr)&pictp);
 if(!err)
 {
  pictk=pictp->key;

  pictp->flags.version=1;
  pictp->data=*data;
  packpicturedata(pictp,picturedata);

  defltprocess(&pictp->process.process,file);
  pictp->textflow=*flow;
  pictp->transform=*tr;
  pictp->frame=frame;

  copycurve(&fcurve,file,c,file);

  bits=0;
  if(ic)
  {
   copycurve(&icurve,file,ic,file);
  }
  else bits|=BCINNER;

  if(oc)
  {
   copycurve(&ocurve,file,oc,file);
  }
  else bits|=BCOUTER;

  if(pc)
  {
   copycurve(&pcurve,file,pc,file);
  }
  else nullcurve(&pcurve);


  fob_mod(pictk,file,(fobjptr)&pictp);
  pictp->fcurve=fcurve;

  if(ic) 
  {
   pictp->icurve=icurve;
   pictp->data.changei=1;
  }
  if(oc)
  {
   pictp->ocurve=ocurve;
   pictp->textflow.changeo=1;
  }

  pictp->pcurve=pcurve;


  setcurveradius(&pictp->fcurve,pictp->data.radius,&pictp->transform);
  pxboundingcurves(&pictp,file,bits);

  getmaxbox(&pictp->box,&pictp->fcurve.box,&pictp->transform);

  insafter(pictk,loc->after,loc->parent,loc->chain,file);

  loc->object=pictk;

  undowritefn(file,UPDELETE,&loc->object,sizeof(int));

  pictp=(pictboxstr*)fob_find(pictk,file);
  frameflow((sobjectstr **)&pictp,file);
  vxadd((sobjectstr **)&pictp,file);
 }
 return(err);
}



static os_error * createpict(objectloc * loc,curvestr * c)
{
 transformstr tr;
 tr_setidentity(&tr);
 return(createpict1(loc,c,&defltpictdata,&defltpicturedata,
                          &defltpicttextflow,&tr,0,NULL,NULL,NULL));

}




os_error * pictdirectload(posnstr * posn,int picture,int * object,int * yshift)
{
 os_error   * err;
 objectloc    loc;
 curvestr     c;
 picturestr * picturep;
 pictboxstr * pictp;
 int          ftype;
 textboxstr * textp;
 int          w2;
 int          h2;
 int          w;
 int          h;
 int          ws;
 int          hs;
 int          fixscale;


 loc.file=posn->file;
 loc.after=0;
 loc.parent=0;
 loc.chain=-1;
 loc.section=posn->section;
 loc.page=posn->page;

 picturep=(picturestr*)fob_find(picture,loc.file);
 ftype=picturep->ftype;

 c.type=CBOX;
 c.box.x=0;
 c.box.y=0;
 c.box.w=scale(picturep->abox.x1-picturep->abox.x0,25,16);
 c.box.h=scale(picturep->abox.y1-picturep->abox.y0,25,16);


 if(posn->buttons & VBCTRL) 
 {
  fixscale=1;
  c.box.w=scale(c.box.w,defimportscale,0x10000);
  c.box.h=scale(c.box.h,defimportscale,0x10000);
 }
 else
 {
  fixscale=0;
 }



 textp=(textboxstr*)fob_find(posn->object,loc.file);
 w2=textp->icurve.box.w/2;
 h2=textp->icurve.box.h/2;

 if(c.box.w>w2 || c.box.h>h2)
 {
  if(c.box.w>w2) w=w2;
  else           w=c.box.w;

  if(c.box.h>h2) h=h2;
  else           h=c.box.h;

  ws=scale(w,0x10000,c.box.w);
  hs=scale(h,0x10000,c.box.h);

  if(ws>hs) ws=hs;
  c.box.h=scale(c.box.h,ws,0x10000);
  c.box.w=scale(c.box.w,ws,0x10000);

  fixscale=0;
 }


 *yshift=scale(picturep->abox.y0,25,16);

 err=createpict(&loc,&c);

 *object=loc.object;

 pictp=(pictboxstr*)fob_find(loc.object,loc.file);
 pictp->ftype=ftype;
 pictp->picture=picture;

 if(fixscale)
 {
  pictp->pictdata.scale=defimportscale;
  pictcentrepict(loc.object,loc.file,NULL);
 }
 else
 {
  pictscaletofit(loc.object,NULL,loc.file);
 }

 return(err);
}



/*****************************************************************************/


static transformstr xtransform;

static int xtrf(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 tr_multiply(r,t,&xtransform);

 return(0);

 USE(c);
 USE(ct);
}



typedef struct pxmovestr
{
 int            pict;
 int            spage;
 int            dpage;
 int            parent;
 int            after;
 transformstr   tr;
 picturedatastr pictdata;
 int            tile;
 int            tiledx;
 int            tiledy;
 int            spare[3];
} pxmovestr;




static os_error * unpictmove(filestr * file)
{
 pxmovestr    old;
 pxmovestr    xnew;
 pictboxstr * pictp;
 int          cbits;

 undoread(file,&xnew,sizeof(pxmovestr));

 old=xnew;
 old.spage=xnew.dpage;
 old.dpage=xnew.spage;

 pictp=(pictboxstr*)fob_find(old.pict,file);

 old.tr=pictp->transform;
 old.pictdata=pictp->pictdata;
 old.tile=pictp->tile|(pictp->sparebits<<1);
 old.tiledx=pictp->tiledx;
 old.tiledy=pictp->tiledy;
 old.spare[0]=pictp->spare[0];
 old.spare[1]=pictp->spare[1];
 old.spare[2]=pictp->spare[2];
 old.after=pictp->chain.prev;
 old.parent=parentof((chainobject*)pictp,file);

 undowritefn(file,UPMOVE,&old,sizeof(pxmovestr));

 pictp=(pictboxstr*)fob_find(xnew.pict,file);

 vxaddn((sobjectstr**)&pictp,file,xnew.spage);
 frameflow((sobjectstr **)&pictp,file);

 pictp->transform=xnew.tr;
 pictp->pictdata=old.pictdata;
 pictp->tile=old.tile & 0x1;
 pictp->tiledx=old.tiledx;
 pictp->tiledy=old.tiledy;
 pictp->sparebits=old.tile>>1;
 pictp->spare[0]=old.spare[0];
 pictp->spare[1]=old.spare[1];
 pictp->spare[2]=old.spare[2];

 unlinkobject(old.pict,0,file);
 insafter(xnew.pict,xnew.after,xnew.parent,0,file);

 pictcalctransform(xnew.pict,file);

 pictp=(pictboxstr*)fob_find(xnew.pict,file);
 setcurveradius(&pictp->fcurve,pictp->data.radius,&pictp->transform);

 cbits=BCDEL;
 if(!pictp->data.changei)     cbits|=BCINNER;
 if(!pictp->textflow.changeo) cbits|=BCOUTER;
 pxboundingcurves(&pictp,file,cbits);

 getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

 frameflow((sobjectstr **)&pictp,file);
 vxaddn((sobjectstr **)&pictp,file,xnew.dpage);

 pixchange(xnew.pict,file);

 return(NULL);
}



static os_error * pictcopym(objectloc * src,objectloc * dest,transformstr * tr)
{
 pictboxstr * pictp;
 filestr    * sfile;
 int          object;
 int          trmode;
 pxmovestr    old;

 sfile=src->file;
 object=src->object;

 pictp=(pictboxstr*)fob_find(object,sfile);
 vxaddn((sobjectstr**)&pictp,sfile,src->page);
 frameflow((sobjectstr **)&pictp,sfile);

 if(dest->copymode & LOCUNDO)
 {
  old.pict=object;
  old.spage=dest->page;
  old.dpage=src->page;
  old.tr=pictp->transform;
  old.pictdata=pictp->pictdata;
  old.tile=pictp->tile|(pictp->sparebits<<1);
  old.tiledx=pictp->tiledx;
  old.tiledy=pictp->tiledy;
  old.spare[0]=pictp->spare[0];
  old.spare[1]=pictp->spare[1];
  old.spare[2]=pictp->spare[2];
  old.after=pictp->chain.prev;
  old.parent=parentof((chainobject*)pictp,sfile);

  undowritefn(sfile,UPMOVE,&old,sizeof(pxmovestr));
 }

 unlinkobject(object,0,sfile);
 dest->object=object;
 insafter(object,dest->after,dest->parent,0,sfile);

 pictp=(pictboxstr*)fob_find(object,sfile);
 xtransform=*tr;

 trmode=TRNOUPDATE|TRNOREFLOWS|TRNOUNDO;

 transpict(pictp,sfile,xtrf,trmode);

 pictp=(pictboxstr*)fob_find(object,sfile);
 vxaddn((sobjectstr**)&pictp,sfile,dest->page);

 return(NULL);
}



static os_error * pictcopyc(objectloc * src,objectloc * dest,transformstr * tr)
{
 os_error    * err;
 int           pictk;
 pictboxstr  * pictp;
 pictboxstr    srcpict;
 pictboxstr    destpict;
 picturestr  * picture;
 int           picturek;
 filestr     * sfile;
 filestr     * dfile;

 err=NULL;


 sfile=src->file;
 dfile=dest->file;

 pictp=(pictboxstr*)fob_find(src->object,sfile);
 srcpict=*pictp;
 destpict=srcpict;

          err=copycurve(&destpict.fcurve,dfile,&srcpict.fcurve,sfile);
 if(!err) err=copycurve(&destpict.icurve,dfile,&srcpict.icurve,sfile);
 if(!err) err=copycurve(&destpict.ocurve,dfile,&srcpict.ocurve,sfile);
 if(!err) err=copycurve(&destpict.pcurve,dfile,&srcpict.pcurve,sfile);
 if(!err) err=copyborderm(&destpict.frame,dfile,
                           srcpict.frame,sfile,dest->copymode); 
 if(!err) err=copyfillm(&destpict.data.fill,dfile,
                        &srcpict.data.fill,sfile,dest->copymode);

 if(!err) err=mapcolour(sfile,dfile,&destpict.data.colour,dest->copymode);

 if(!err) err=copyprocessm(&destpict.process.process,dfile,
                             srcpict.process.process,sfile,dest->copymode);


 if(!err)
 {
  if(srcpict.picture)
  {
   if(src->copymode & LOCCLIP)  picturek=getcliphint(dfile,srcpict.picture);
   else
   if(dest->copymode & LOCCLIP) picturek=getcliphintr(sfile,srcpict.picture);
   else                         picturek=0;

   cprintf("picturek %x",picturek);

   if(picturek)
   {
    err=fob_copy((fobjptr)&picture,dfile,picturek,dfile);
    destpict.picture=picture->key;
   }
   else
   {
    err=fob_copy((fobjptr)&picture,dfile,srcpict.picture,sfile);
    if(!err)
    {
     destpict.picture=picture->key;

     if(sfile!=dfile) // problem of copying a relative path to clipboard
     {
      pxmakereferenceabsolute(destpict.picture,sfile,dfile);
     }
    }
   }

   if(!err)
   {
    if(src->copymode & LOCCLIP)
    {
     setcliphint(dfile,srcpict.picture,destpict.picture);
    }

    if(dest->copymode & LOCCLIP) 
    {
     setcliphint(sfile,destpict.picture,srcpict.picture);
    }
   }
  }
  else
  {
   destpict.picture=0;
  }
 }

 if(!err) err=fob_create(sizeof(pictboxstr),dfile,OPICTBOX,(fobjptr)&pictp);
 if(!err)
 {
  pictk=pictp->key;

  pictp->fcurve=destpict.fcurve;
  pictp->icurve=destpict.icurve;
  pictp->ocurve=destpict.ocurve;
  pictp->pcurve=destpict.pcurve;
  pictp->frame=destpict.frame;
  pictp->data=destpict.data;
  copypicturedata(pictp,&destpict);
  pictp->textflow=destpict.textflow;
  pictp->process=destpict.process;
  pictp->ftype=destpict.ftype;
  pictp->picture=destpict.picture;
  pictp->masked=destpict.masked;


  memset(&pictp->flags,0,sizeof(flagstr));
  pictp->flags.locked=destpict.flags.locked;
  pictp->flags.spread=destpict.flags.spread;
  pictp->flags.version=1;

  if(src->branch && !dest->branch) 
  {
   pictp->master=srcpict.key;
   pictp->flags.masterdata=1;
  }

  if(dest->copymode & LOCOLDMASTER) 
  {
   pictp->master=srcpict.master;
   pictp->flags.masterdata=1;
  }
  else
  if(!src->branch && !dest->branch)
  {
   if(srcpict.master && (dest->copymode & LOCKEEPMASTER))
   { 
    pictp->flags.local=destpict.flags.local;
    mapmaster(src,dest,srcpict.master,&destpict.master);
    pictp=(pictboxstr*)fob_find(pictk,dfile);
    pictp->master=destpict.master;
    pictp->flags.local=destpict.flags.local;
    pictp->flags.masterdata=destpict.flags.masterdata;
   }
  }

  tr_multiply(&pictp->transform,&destpict.transform,tr);

  getframemaxbox((sobjectstr **)&pictp,pictp->frame,dfile,&pictp->transform);

  insafter(pictk,dest->after,dest->parent,dest->chain,dfile);

  dest->object=pictk;

  pictcalctransform(pictk,dfile);

  pictp=(pictboxstr*)fob_find(pictk,dfile);

  if(!(dest->copymode & LOCNOFLOW)) frameflow((sobjectstr **)&pictp,dfile);
  vxadd((sobjectstr **)&pictp,dfile);
 }


 return(err);
}



static os_error * pictcopy(objectloc * src,objectloc * dest,transformstr * tr)
{
 if(dest->copymode & LOCMOVE) return(pictcopym(src,dest,tr));
 else                         return(pictcopyc(src,dest,tr));
}


/*****************************************************************************/


static int findpict(posnstr * posn,pictboxstr * pictp,int * before,int last)
{
 int           pictk;
 int           childk;
 chainobject * childp;

 pictk=pictp->key;

 if(insidebox(posn->x,posn->y,&pictp->box))
 {
  if(insidecurve(posn->x,posn->y,&pictp->fcurve,&pictp->transform,posn->file))
                                                                   last=pictk;
 }

 childk=pictp->chain.child;
 while(childk)
 {
  childp=(chainobject*)fob_find(childk,posn->file);
  childk=childp->chain.next;
  last=objectfind(posn,(objhdrstr*)childp,before,last);
 }
 return(last);
}



static int selectpict(pictboxstr * pictp,posnstr * posn,int type)
{
 int           pictk;
 int           parent;
 filestr     * file;
 int           xtype;

 pictk=pictp->key;
 file=posn->file;

 if(type==SELECTOBJECT || type==SELECT1)
 {
  xtype=type;
  parent=parentof((chainobject*)pictp,file);
  if(parent) type=objectselect((objhdrstr*)fob_find(parent,file),posn,SELECT1);
  if(xtype!=SELECT1) addselection(pictk,file,type);
 }
 else
 if(type==DESELECTOBJECT)
 {
  remselection(pictk,file,type);
 }

 return(type);
}


/*****************************************************************************/


static os_error * pxautoscale(filestr * file,int pict,transformstr * tr)
{
 pictboxstr      * pictp;
 transformbitstr   obits;
 transformbitstr   nbits;
 transformstr      tr1;
 transformstr      tr2;
 transformstr      tr3;

 pictp=(pictboxstr*)fob_find(pict,file);

 tr_getbits(tr,&nbits);
 tr_getbits(&pictp->transform,&obits);

 tr_setscale(&tr1,obits.xscale,nbits.xscale,obits.yscale,nbits.yscale);


 nbits.xshift=pictp->pictdata.xshift;
 nbits.yshift=-pictp->pictdata.yshift;
 nbits.yscale=pictp->pictdata.scale;
 nbits.xscale=ttmul(nbits.yscale,pictp->pictdata.aspect);
 nbits.angle=pictp->pictdata.angle;
 nbits.skewxy=tr_tan(pictp->pictdata.skew,0x10000);
 nbits.skewyx=0;

 tr_setbits(&tr2,&nbits,TR_GENERAL);

 tr_multiply(&tr3,&tr2,&tr1);

 tr_getbits(&tr3,&nbits);

 pictp->pictdata.scale=nbits.yscale;

 if(pictp->pictdata.fixaspect)
 {

 }
 else
 {

  pictp->pictdata.aspect=scale(0x10000,nbits.xscale,nbits.yscale);
 }

 pictp->pictdata.xshift=nbits.xshift;
 pictp->pictdata.yshift=-nbits.yshift;
 pictp->pictdata.angle=nbits.angle;
 pictp->pictdata.skew=scaleatan(nbits.skewxy);

 return(NULL);
}


/*****************************************************************************/

/* writes data that can be changed by a transform */

static os_error * writetransdata(pictboxstr * pictp,filestr * file)
{
 os_error     * err;

          err=undowrite(file,&pictp->transform,sizeof(transformstr));
 if(!err) err=undowrite(file,&pictp->pictdata,sizeof(picturedatastr));
 return(err);
}


/* reads data that can be changed by a transform */

static os_error * readtransdata(pictboxstr * pictp,filestr * file)
{
 os_error     * err;

          err=undoread(file,&pictp->transform,sizeof(transformstr));
 if(!err) err=undoread(file,&pictp->pictdata,sizeof(picturedatastr));
 return(err);
}




/* tagged to UPTRAN */

static os_error * untranspict(filestr * file)
{
 os_error     * err;
 int            pict;
 pictboxstr   * pictp;
 int            cbits;


 err=undoread(file,&pict,sizeof(int));

 pictp=(pictboxstr*)fob_find(pict,file);

 if(pictp)
 {
  frameflow((sobjectstr **)&pictp,file);
  vxadd((sobjectstr **)&pictp,file);

           err=undowritefn(file,UPTRAN,&pict,sizeof(int));
  if(!err) err=writetransdata(pictp,file);
  if(!err) err=readtransdata(pictp,file);

  pictcalctransform(pict,file);

  setcurveradius(&pictp->fcurve,pictp->data.radius,&pictp->transform);

  cbits=BCDEL;
  if(!pictp->data.changei)     cbits|=BCINNER;
  if(!pictp->textflow.changeo) cbits|=BCOUTER;
  pxboundingcurves(&pictp,file,cbits);

  getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

  frameflow((sobjectstr **)&pictp,file);
  vxadd((sobjectstr **)&pictp,file);

  pixchange(pict,file);
 }

 return(err);
}




os_error * transpict(pictboxstr * pictp,filestr * file,
                                      transformfn trf,int flags)
{
 os_error      * err;
 transformstr    r1;
 int             code;
 int             pict;
 int             cbits;
 boxbitstr       b1;
 boxbitstr       b2;
 int             dx;
 int             dy;
 transformstr    tr;
 int             lockmode;
 int             autoscale;


 err=NULL;

 pict=pictp->key;

 lockmode=pictp->pictdata.lockmode;
 autoscale=pictp->pictdata.autoscale;
 autoscale|=(flags & TRADJUST);


 if(!(flags & TRNOREFLOWS)) frameflow((sobjectstr **)&pictp,file);
 if(!(flags & TRNOUPDATE)) vxadd((sobjectstr **)&pictp,file);

 if(!(flags & TRNOUNDO))
 {
           err=undowritefn(file,UPTRAN,&pictp->key,sizeof(int));
  if(!err) err=writetransdata(pictp,file);
 }

 code=trf(&r1,&pictp->transform,&pictp->fcurve,&pictp->transform); 

 if(code & TR_SCALE)
 {
  if(autoscale) pxautoscale(file,pict,&r1);

  if(lockmode==1)
  {
   pictp->transform=r1;
   pictcheckcentre(pict,file,NULL);
   pixchange(pict,file);
  }                                                                               else
  {
   if(autoscale)
   {
    pixchange(pict,file);
   }
   else
   if(code & (SFIXRIGHT|SFIXBOTTOM))
   {
    getboxbits(&pictp->fcurve.box,&pictp->transform,&b1);
    getboxbits(&pictp->fcurve.box,&r1,&b2);
    dx=b1.orgx-b2.orgx;
    dy=b2.orgy-b1.orgy;

    tr_setidentity(&tr);
    tr_setrotationa(&tr,b1.angle);

    tr_delta(&tr,&dx,&dy);

    if(!(code & SFIXRIGHT)) dx=0;
    if(!(code & SFIXBOTTOM)) dy=0;

    pictp->pictdata.xshift+=dx;
    pictp->pictdata.yshift-=dy;

    pixchange(pict,file);
   }

   pictp->transform=r1;
  }
 }
 else
 {
  pictp->transform=r1;
 }

 pictcalctransform(pict,file);

 setcurveradius(&pictp->fcurve,pictp->data.radius,&pictp->transform);

 cbits=BCDEL;
 if(!pictp->data.changei)     cbits|=BCINNER;
 if(!pictp->textflow.changeo) cbits|=BCOUTER;

 pxboundingcurves(&pictp,file,cbits);

 getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

 if(!(flags & TRNOREFLOWD)) frameflow((sobjectstr **)&pictp,file);
 if(!(flags & TRNOUPDATE)) vxadd((sobjectstr **)&pictp,file);

 return(err);
}



/*****************************************************************************/
/* set flow mode for picture box */


static colourvalue pxtranscol={OURTRANS};


static os_error * setflow(filestr * file,int pict,
                          colourvalue * cv,textflowstr * textflow,
                          colourvalue * ocv,textflowstr * oldflow)
{
 os_error          * err;
 int                 changeo;
 pictboxstr        * pictp;
 int                 flags;


 err=NULL;

 fob_mod(pict,file,(fobjptr)&pictp);
 frameflow((sobjectstr **)&pictp,file);

 pictp->textflow=*textflow;
 pictp->data.colour=*cv;


 if(textflow->omode!=oldflow->omode)
 {
  if(textflow->omode==FROUSER)
  {
   err=xtrace(pict,file);
   if(!err)
   {
    pictp=(pictboxstr*)fob_find(pict,file);

    if(pictp->masked) flags=BCOUTER|BCDEL;
    else              flags=BCOUTER|BCINNER|BCDEL;

    err=pxboundingcurves(&pictp,file,flags);
   }
   else
   {
    pictp->textflow=*oldflow;
    pictp->data.colour=*ocv;
   }
  }
  else
  if(textflow->omode==FROFRAME)
  {
   flags=BCOUTER|BCDEL;
   if(oldflow->omode==FROUSER && !pictp->masked) flags=BCOUTER|BCINNER|BCDEL;

   err=pxboundingcurves(&pictp,file,flags);
   deletecurve(&pictp->pcurve,file);
  }
  else
  if(textflow->omode==FRONONE)
  {
   deletecurve(&pictp->ocurve,file);
   pictp=(pictboxstr*)fob_find(pict,file);
   deletecurve(&pictp->pcurve,file);
  }
 }
 else
 {
  changeo=(textflow->changeo!=oldflow->changeo) ||
                                  (textflow->o!=oldflow->o);

  if(changeo && !textflow->changeo)
  {
   err=pxboundingcurves(&pictp,file,BCOUTER|BCDEL);
  }
 }

 if(!err)
 {
  pictp=(pictboxstr*)fob_find(pict,file);
  frameflow((sobjectstr **)&pictp,file);
  if(textflow->omode==FROUSER || oldflow->omode==FROUSER)
  {
   vxadd((sobjectstr **)&pictp,file);
  }
 }

 return(err);
}


/* tagged to UPFLOW */

static os_error * unpictsetflow(filestr * file)
{
 os_error     * err;
 int            pict;
 pictboxstr   * pictp;
 textflowstr    textflow;
 colourvalue    cv;
 textflowstr    oldflow;
 colourvalue    ocv;


 err=undoread(file,&pict,sizeof(int));

 pictp=(pictboxstr*)fob_find(pict,file);

 if(pictp)
 {
  oldflow=pictp->textflow;
  ocv=pictp->data.colour;

           err=undowritefn(file,UPFLOW,&pict,sizeof(int));
  if(!err) err=undowrite(file,&oldflow,sizeof(textflowstr));
  if(!err) err=undowrite(file,&ocv,sizeof(colourvalue));
  if(!err) err=undoread(file,&textflow,sizeof(textflowstr));
  if(!err) err=undoread(file,&cv,sizeof(colourvalue));
  if(!err) err=setflow(file,pict,&cv,&textflow,&ocv,&oldflow);
 }
 return(err);
}


static os_error * pictflowvalues(pictboxstr * pictp,filestr * file,
                                             objectflowstr * flow,int read)
{
 os_error    * err;
 int           pict;
 textflowstr   oldflow;
 colourvalue   ocv;
 colourvalue   cv;

 err=NULL;

 if(read)
 {
  if(pictp->textflow.omode==FROUSER)
  {
   flow->tr=pictp->pictdata.transform;
  }
  else
  {
   flow->tr=pictp->transform;
  }

  flow->flow=pictp->textflow;
 }
 else
 {
  pict=pictp->key;
  oldflow=pictp->textflow;
  ocv=pictp->data.colour;
  if(flow->flow.omode==FROUSER) cv=pxtranscol;
  else                          cv=ocv;

           err=undowritefn(file,UPFLOW,&pict,sizeof(int));
  if(!err) err=undowrite(file,&oldflow,sizeof(textflowstr));
  if(!err) err=undowrite(file,&ocv,sizeof(colourvalue));
  if(!err) err=setflow(file,pict,&cv,&flow->flow,&ocv,&oldflow);
 }

 return(err);
}





static os_error * pictcheckforreflow(pictboxstr * pictp,sobjectstr * fix,
                                         filestr * file,int * end)
{
 os_error   * err;
 sobjectstr * childp;
 int          child;

 err=NULL;


 if(fix->key==pictp->key)
 {
  *end=1;
 }
 else
 {
  /* handle consequences for this object, then apply to children */

  child=pictp->chain.child;
  while(child)
  {
   childp=(sobjectstr*)fob_find(child,file);
   if(childp)
   {
    child=childp->chain.next;
    err=objectsetflow((objhdrstr*)childp,(objhdrstr*)fix,file,end);
    if(err) break;
    if(*end) break;
   }
   else break;
  }
 }
 return(err);
}



/*****************************************************************************/


static os_error *  pictscrap(int object,filestr * file,int flags)
{
 os_error   * err;
 pictboxstr   pbox;
 pictboxstr * pictp;

 pictp=(pictboxstr*)fob_find(object,file);
 pbox=*pictp;

 frameflowdelete((sobjectstr **)&pictp,file);
 vxadd((sobjectstr **)&pictp,file);

 if(flags & DELETEUNLINK) unlinkobject(object,0,file);

          err=deletecurve(&pbox.fcurve,file);
 if(!err) err=deletecurve(&pbox.icurve,file);
 if(!err) err=deletecurve(&pbox.ocurve,file);
 if(!err) err=deleteborder(pbox.frame,file);
 if(!err) err=deletefill(&pbox.data.fill,file);
 if(!err) err=deleteprocess(pbox.process.process,file);
 if(!err) err=fob_delete(pbox.picture,file);

 fob_delete(object,file);

 return(err);
}



static os_error *  updeletesub(int object,filestr * file)
{
 os_error   * err;
 pictboxstr * pictp;
 int          parent;
 int          after;

 err=NULL;

 pictp=(pictboxstr*)fob_find(object,file);
 if(pictp)
 {
  frameflowdelete((sobjectstr **)&pictp,file);
  vxadd((sobjectstr **)&pictp,file);

  parent=pictp->chain.parent;
  after=pictp->chain.prev;

  unlinkobject(object,0,file);

  undowritefn(file,UPRECREATE,&object,sizeof(int));
  undowrite(file,&parent,sizeof(int));
  undowrite(file,&after,sizeof(int));
 }

 return(err);
}





/* tagged to UPRECREATE */

static os_error *  uprecreate(filestr * file)
{
 pictboxstr * pictp;
 int          object;
 int          parent;
 int          after;

 undoread(file,&object,sizeof(int));
 undoread(file,&parent,sizeof(int));
 undoread(file,&after,sizeof(int));

 insafter(object,after,parent,0,file);

 undowritefn(file,UPDELETE,&object,sizeof(int));

 pictp=(pictboxstr*)fob_find(object,file);
 frameflow((sobjectstr **)&pictp,file);
 vxadd((sobjectstr **)&pictp,file);

 return(NULL);
}


/* scrap function for UPRECREATE */

static os_error * uptrash(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(pictscrap(object,file,0));
}



/* tagged to UPDELETE */

static os_error *  updelete(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(updeletesub(object,file));
}



static os_error * pictdelete(pictboxstr * pictp,int dm,filestr * file)
{
 if(dm & DELETESCRAP) return(pictscrap(pictp->key,file,dm));
 else                 return(updeletesub(pictp->key,file));
}


/*****************************************************************************/


static void fillpictdata(unpackedpictdatastr * od,
                         unpackedpictdatastr * pd,pictchangebits * bits)
{

 if(bits->xcolour) od->pictdata.colour=pd->pictdata.colour;
 if(bits->xinset)  od->pictdata.i=pd->pictdata.i;
 if(bits->xradius) od->pictdata.radius=pd->pictdata.radius;
 if(bits->xchangei)od->pictdata.changei=pd->pictdata.changei;
 if(bits->xfill)   od->pictdata.fill=pd->pictdata.fill;
 if(bits->xspread) od->spread=pd->spread;
 if(bits->xlock)   od->lock=pd->lock;
}



os_error * pictchanges(int pict,filestr * file,
                              unpackedpictdatastr * pd,pictchangebits * bits)
{
 pictboxstr  * pictp;

 pictp=(pictboxstr*)fob_find(pict,file);

 bits->xcolour=(cmpcolourval(&pictp->data.colour,&pd->pictdata.colour)!=0);
 bits->xinset=(pictp->data.i!=pd->pictdata.i);
 bits->xradius=(pictp->data.radius!=pd->pictdata.radius);
 bits->xchangei=(pictp->data.changei!=pd->pictdata.changei);
 bits->xfill=(pictp->data.fill.fill!=pd->pictdata.fill.fill);

 bits->xlock=((int)pictp->flags.locked!=pd->lock);
 bits->xspread=((int)pictp->flags.spread!=pd->spread);

 return(NULL);
}



static os_error * pictupdate(int pict,filestr * file,unpackedpictdatastr * pd)
{
 os_error              * err;
 pictboxstr            * pictp;
 unpackedpictdatastr     oldpd;
 int                     cbits;


 err=NULL;

 pictp=(pictboxstr*)fob_find(pict,file);
 oldpd.pictdata=pictp->data;
 oldpd.spread=pictp->flags.spread;
 oldpd.lock=pictp->flags.locked;


 pictp->data=pd->pictdata;
 pictp->flags.spread=pd->spread;
 pictp->flags.locked=pd->lock;


 if(oldpd.pictdata.radius!=pd->pictdata.radius) 
                                      frameflow((sobjectstr **)&pictp,file);
 vxadd((sobjectstr **)&pictp,file);

 setcurveradius(&pictp->fcurve,pd->pictdata.radius,&pictp->transform);

 cbits=BCDEL;

 if(pd->pictdata.i!=oldpd.pictdata.i || 
    pd->pictdata.changei!=oldpd.pictdata.changei ||
    pd->pictdata.radius!=oldpd.pictdata.radius)
 {
  if(!pd->pictdata.changei) cbits|=BCINNER;
 }

 if(pd->pictdata.radius!=oldpd.pictdata.radius)
 {
  if(!pictp->textflow.changeo) cbits|=BCOUTER;
 }

 pxboundingcurves(&pictp,file,cbits);

          err=undowritefn(file,UPUPDATE,&pict,sizeof(int));
 if(!err) err=undowrite(file,&oldpd,sizeof(unpackedpictdatastr));

 return(err);
}



/* tagged to UPUPDATE */

static os_error * unupdatepict(filestr * file)
{
 os_error             * err;
 int                    pict;
 unpackedpictdatastr    pd;

          err=undoread(file,&pict,sizeof(int));
 if(!err) err=undoread(file,&pd,sizeof(unpackedpictdatastr));
 if(!err) err=pictupdate(pict,file,&pd);

 return(err);
}



os_error * pictboxupdate(int pict,filestr * file,
                         unpackedpictdatastr * pd,pictchangebits * bits)
{
 pictboxstr          * pictp;
 unpackedpictdatastr   od;

 pictp=(pictboxstr*)fob_find(pict,file);
 od.pictdata=pictp->data;
 od.lock=pictp->flags.locked;
 od.spread=pictp->flags.spread;

 fillpictdata(&od,pd,bits);

 return(pictupdate(pict,file,&od));
}



static os_error * pictsetfill(pictboxstr * pictp,filestr * file,fillstr * fill)
{
 pictp->data.fill=*fill;
 return(vxadd((sobjectstr **)&pictp,file));
}


static os_error * pictsetprocess(pictboxstr * pictp,int process)
{
 pictp->process.process=process;
 return(NULL);
}


/****************************************************************************/

static os_error * pictupcon(int pict,filestr * file,
                                     unpackedpicturedatastr * pd)
{
 os_error   * err;
 pictboxstr * pictp;

 err=NULL;

 pictp=(pictboxstr*)fob_find(pict,file);
 if(pictp->textflow.omode==FROUSER)
 {
  vxstart(file);
  frflstart(file);

  pictp=(pictboxstr*)fob_find(pict,file);

  frameflow((sobjectstr **)&pictp,file);
  vxadd((sobjectstr **)&pictp,file);

  packpicturedata(pictp,pd);

  pictcalctransform(pict,file);

  frflflush(file);
  vxflush(file,VRBACK,selpagek,selsectk);

  frflvalid(file);

  frflscrap(file);
  vxscrap();
 }
 else
 {
  packpicturedata(pictp,pd);
  pictcalctransform(pict,file);
  err=pxrefresh(pict,selsectk,selpagek,file);
 }

 pixchange(pict,file);

 return(err);
}


static os_error * uconupdate(filestr * file)
{
 os_error               * err;
 int                      pict;
 pictboxstr             * pictp;
 unpackedpicturedatastr   pd;

 err=undoread(file,&pict,sizeof(int));

 pictp=(pictboxstr*)fob_find(pict,file);

 if(pictp)
 {
  unpackpicturedata(&pd,pictp);

           err=undowritefn(file,UCONUPDATE,&pict,sizeof(int));
  if(!err) err=undowrite(file,&pd,sizeof(unpackedpicturedatastr));
  if(!err) err=undoread(file,&pd,sizeof(unpackedpicturedatastr));
  if(!err) err=pictupcon(pict,file,&pd);
 }
 return(err);
}

os_error * pictupdatecontents(int pict,int section,
                                 filestr *  file,unpackedpicturedatastr * pd)
{
 os_error                * err;
 pictboxstr              * pictp;
 unpackedpicturedatastr    opd;

 err=modfile(file,section);
 if(!err)
 {
  pictp=(pictboxstr*)fob_find(pict,file);

  unpackpicturedata(&opd,pictp);

  err=undostart(file);
  if(!err)
  {
            err=undowritefn(file,UCONUPDATE,&pict,sizeof(int));
   if(!err) err=undowrite(file,&opd,sizeof(unpackedpicturedatastr));
   if(!err) err=pictupcon(pict,file,pd);

   undoend(file);
  }
 }

 return(err);
}

/****************************************************************************/


static os_error * masterobject(pictboxstr * pictp,filestr * file,int * master,
                                                          objectbitstr * bits)
{
 *master=pictp->master;

 memset(bits,0,sizeof(objectbitstr));

 bits->local=pictp->flags.local;
 bits->locked=pictp->flags.locked;
 bits->spread=pictp->flags.spread;
 bits->canmakelocal=1;
 bits->localdata=!pictp->flags.masterdata;

 return(NULL);
 USE(file);
}

/***************************************************************************/

/* this is the trivial operation */

/* tagged to UPMXLOCAL */

static os_error *  unpmakelocal(filestr * file)
{
 os_error   * err;
 int          object;
 pictboxstr * pictp=NULL;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undowritefn(file,UPMXMASTER,&object,sizeof(int));
 if(!err) err=fob_mod(object,file,(fobjptr)&pictp);
 if(!err)
 {
  pictp->flags.local=1;
  pixobjectchange(file,object);
 }

 return(err);
}


/* tagged to UPMXMASTER */

static os_error *  unpmakemaster(filestr * file)
{
 os_error   * err;
 int          object;
 pictboxstr * pictp=NULL;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undowritefn(file,UPMXLOCAL,&object,sizeof(int));
 if(!err) err=fob_mod(object,file,(fobjptr)&pictp);
 if(!err)
 {
  pictp->flags.local=0;
  pixobjectchange(file,object);
 }

 return(err);
}



static os_error * makeobjectlocal(pictboxstr * pictp,filestr * file)
{
 int master;
 int object;

 master=pictp->master;

 if(master)
 {
  if(!pictp->flags.local)  
  {
   pictp->flags.local=1;
   object=pictp->key;
   undowritefn(file,UPMXMASTER,&object,sizeof(int));
   pixobjectchange(file,object);
  }
 }

 return(NULL);
}

/***************************************************************************/

typedef struct
{
 int scrap;


} pxmkflags;








static os_error * makemastersub(int pictk,pictboxstr * xnew,filestr * file)
{
 os_error   * err;
 pictboxstr * pictp;
 int          changei;
 int          changeo;
 int          cbits;


 err=fob_mod(pictk,file,(fobjptr)&pictp);

 vxadd((sobjectstr **)&pictp,file);
 frameflow((sobjectstr **)&pictp,file);

 changei=xnew->data.changei;
 changeo=xnew->textflow.changeo;

 pictp->data=xnew->data;
 copypicturedata(pictp,xnew);
 pictp->process=xnew->process;
 pictp->transform=xnew->transform;
 pictp->fcurve=xnew->fcurve;
 pictp->frame=xnew->frame;
 pictp->picture=xnew->picture;

 setcurveradius(&pictp->fcurve,pictp->data.radius,&pictp->transform);

 getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

 if((!changei) || (!changeo))
 {
  cbits=BCDEL;
  if(!changei) cbits|=BCINNER;
  if(!changeo) cbits|=BCOUTER;
  pxboundingcurves(&pictp,file,cbits);
 }

 if(changei) pictp->icurve=xnew->icurve;
 if(changeo) pictp->ocurve=xnew->ocurve;

 vxadd((sobjectstr **)&pictp,file);
 frameflow((sobjectstr **)&pictp,file);

 pictp->flags.local=pictp->flags.local ^ 1;

 pictp->flags.spread=xnew->flags.spread;
 pictp->flags.locked=xnew->flags.locked;
 pictp->flags.masterdata=xnew->flags.masterdata;

 pictcalctransform(pictk,file);

 pixobjectchange(file,pictk);

 return(err);
}



static os_error * pxmkmr(filestr * file,pictboxstr * xnew,pxmkflags * pxflags)
{
 os_error * err;
 int        tile;

          err=undoread(file,&xnew->transform,sizeof(transformstr));
 if(!err) err=undoread(file,&xnew->data,sizeof(pictdatastr));
 if(!err) err=undoread(file,&xnew->pictdata,sizeof(picturedatastr));
 if(!err) err=undoread(file,&xnew->process,sizeof(pictprocstr));
 if(!err) err=undoread(file,&xnew->textflow,sizeof(textflowstr));
 if(!err) err=undoread(file,&xnew->flags,sizeof(flagstr));
 if(!err) err=undoread(file,pxflags,sizeof(pxmkflags));
 if(!err) err=undoread(file,&xnew->frame,sizeof(int));
 if(!err) err=undoread(file,&xnew->picture,sizeof(int));
 if(!err) err=undoread(file,&xnew->fcurve,sizeof(curvestr));

 if(xnew->data.changei && !err) 
          err=undoread(file,&xnew->icurve,sizeof(curvestr));
 else         nullcurve(&xnew->icurve);

 if(xnew->textflow.changeo && !err)
         err=undoread(file,&xnew->ocurve,sizeof(curvestr));
 else        nullcurve(&xnew->ocurve);

 if(!err)
 {
  if(xnew->flags.version>0)
  {
            err=undoread(file,&tile,sizeof(int));
            xnew->tile=tile;
   if(!err) err=undoread(file,&xnew->tiledx,sizeof(int));
   if(!err) err=undoread(file,&xnew->tiledy,sizeof(int));
   if(!err) err=undoread(file,&xnew->spare[0],sizeof(int));
   if(!err) err=undoread(file,&xnew->spare[1],sizeof(int));
   if(!err) err=undoread(file,&xnew->spare[2],sizeof(int));
  }
 }

 return(err);
}




static os_error * pxmkmw(filestr * file,pictboxstr * xnew,pxmkflags * pxflags)  
{
 os_error * err;
 int        tile;

          err=undowrite(file,&xnew->transform,sizeof(transformstr));
 if(!err) err=undowrite(file,&xnew->data,sizeof(pictdatastr));
 if(!err) err=undowrite(file,&xnew->pictdata,sizeof(picturedatastr));
 if(!err) err=undowrite(file,&xnew->process,sizeof(pictprocstr));
 if(!err) err=undowrite(file,&xnew->textflow,sizeof(textflowstr));
 if(!err) err=undowrite(file,&xnew->flags,sizeof(flagstr));
 if(!err) err=undowrite(file,pxflags,sizeof(pxmkflags));
 if(!err) err=undowrite(file,&xnew->frame,sizeof(int));
 if(!err) err=undowrite(file,&xnew->picture,sizeof(int));
 if(!err) err=undowrite(file,&xnew->fcurve,sizeof(curvestr));
 if(!err && xnew->data.changei) 
          err=undowrite(file,&xnew->icurve,sizeof(curvestr));
 if(!err && xnew->textflow.changeo)
          err=undowrite(file,&xnew->ocurve,sizeof(curvestr));

 if(!err)
 {
  if(xnew->flags.version>0)
  {
   tile=xnew->tile;
            err=undowrite(file,&tile,sizeof(int));
   if(!err) err=undowrite(file,&xnew->tiledx,sizeof(int));
   if(!err) err=undowrite(file,&xnew->tiledy,sizeof(int));
   if(!err) err=undowrite(file,&xnew->spare[0],sizeof(int));
   if(!err) err=undowrite(file,&xnew->spare[1],sizeof(int));
   if(!err) err=undowrite(file,&xnew->spare[2],sizeof(int));
  }
 }

 return(err);
}


static os_error * pxmkms(filestr * file)
{
 os_error   * err;
 pictboxstr   xnew;
 pxmkflags    pxflags;

 err=pxmkmr(file,&xnew,&pxflags);

 if(!err)
 {
  err=deletecurve(&xnew.fcurve,file);

  if(!err && xnew.data.changei) err=deletecurve(&xnew.icurve,file);

  if(!err && xnew.textflow.changeo) err=deletecurve(&xnew.ocurve,file);

  if(!err) err=deleteborder(xnew.frame,file);
 /* if(!err) err=deletefill(&new.data.fill,file); */

  if(pxflags.scrap) 
  {

   fob_delete(xnew.picture,file);
  }
 }
 return(err);
}



/* save pix box stuff, about to be turned into text */

os_error * pxmxsave(int pict,filestr * file)
{
 pictboxstr * pictp;
 pictboxstr   old;
 pxmkflags    pxflags;

 pictp=(pictboxstr*)fob_find(pict,file);
 old=*pictp;
 pxflags.scrap=1;
 return(pxmkmw(file,&old,&pxflags));
}


/* reload pix box stuff, turn text into pix */

os_error * pxmxload(int pict,filestr * file)
{
 os_error   * err;
 pxmkflags    pxflags;
 pictboxstr * pictp;
 pictboxstr   xnew;

 pictp=(pictboxstr*)fob_find(pict,file);

 pictfromtextlo(pictp,file);

 err=pxmkmr(file,&xnew,&pxflags);
 if(!err) err=makemastersub(pict,&xnew,file);

 return(err);
}


os_error * pxmxscrap(int pict,filestr * file)
{
 return(pxmkms(file));
 USE(pict);
}



/* given text frame, picture master */

os_error * pxtxmakemaster(int pict,int master,filestr * file)
{
 pictboxstr    xnew;
 pictboxstr  * pictp;
 curvestr      fcurve;
 picturestr  * picturep;

 pictp=(pictboxstr*)fob_find(pict,file);
 pictfromtextlo(pictp,file);

 pictp=(pictboxstr*)fob_find(master,file);

 xnew=*pictp;
 xnew.flags.masterdata=1;

 if(xnew.picture)
 {
  fob_copy((fobjptr)&picturep,file,xnew.picture,file);
  xnew.picture=picturep->key;
 }

 fcurve=xnew.fcurve;

 copycurve(&xnew.fcurve,file,&fcurve,file);

 if(xnew.data.changei) 
 {
  fcurve=xnew.icurve;
  copycurve(&xnew.icurve,file,&fcurve,file);
 }

 if(xnew.textflow.changeo)
 {
  fcurve=xnew.ocurve;
  copycurve(&xnew.ocurve,file,&fcurve,file);
 }

 copyborder(&xnew.frame,xnew.frame,file);
 copyfill(&xnew.data.fill,&xnew.data.fill,file);

 makemastersub(pict,&xnew,file);

 return(NULL);
}





/* tagged to UMAKEMASTER */


static os_error * unmakemasterscrap(filestr * file)
{
 os_error   * err;
 int          pict;
 err=undoread(file,&pict,sizeof(int));
 if(!err) err=pxmkms(file);
 return(err);
}



static os_error * unmakemaster(filestr * file)
{
 os_error   * err;
 pictboxstr   old;
 pictboxstr   xnew;
 int          pictk;
 pxmkflags    pxflags;

          err=undoread(file,&pictk,sizeof(int));

 old=*((pictboxstr*)fob_find(pictk,file));

 if(!err) err=undowritefn(file,UMAKEMASTER,&pictk,sizeof(int));
 if(!err) err=pxmkmr(file,&xnew,&pxflags);
 if(!err) err=pxmkmw(file,&old,&pxflags);

 if(!err) err=makemastersub(pictk,&xnew,file);

 return(err);
}






/**************************************************************************/
/* routines concerned with a doc text frame being made into a master pix  */

/* undo - text goes back to pict */

static os_error * utxpxscrap(filestr * file)
{
 int pict;
 undoread(file,&pict,sizeof(int));
 return(pxmkms(file));
}


static os_error * utxpx(filestr * file)
{
 int          key;
 textboxstr * textp;
 pictboxstr   xnew;
 pxmkflags    pxflags;


 undoread(file,&key,sizeof(int));
 undowritefn(file,UTXPXMK,&key,sizeof(int));

 txmxsave(key,file);

 textp=(textboxstr*)fob_find(key,file);

 pictfromtextlo((pictboxstr*)textp,file);

 pxmkmr(file,&xnew,&pxflags);

 makemastersub(key,&xnew,file);

 return(NULL);
}


/* redo pict goes back to text */

static os_error * utxpxmkscrap(filestr * file)
{
 int pict;
 undoread(file,&pict,sizeof(int));
 return(txmxscrap(pict,file));
}


static os_error * utxpxmk(filestr * file)
{
 os_error   * err;
 int          pict;
 pictboxstr * pictp;
 pictboxstr   old;
 pxmkflags    pxflags;


 undoread(file,&pict,sizeof(int));

 pictp=(pictboxstr*)fob_find(pict,file);

 old=*pictp;
 pxflags.scrap=1;

          err=undowritefn(file,UTXPX,&pict,sizeof(int));
 if(!err) err=pxmkmw(file,&old,&pxflags);
 if(!err) err=txmxload(pict,file);

 return(NULL);
}







/* this is not trivial */

static os_error * makeobjectmaster(pictboxstr * pictp,filestr * file)
{
 os_error   * err;
 int          master;
 pictboxstr   old;
 pictboxstr   xnew;
 int          pict;
 curvestr     fcurve;
 picturestr * picturep;
 pxmkflags    pxflags;


 err=NULL;
 master=pictp->master;

 if(master)
 {
  if(pictp->flags.local)
  {
   /* if this frame has local data, and the master frame has local data */
   /* fault the operation */

   pict=pictp->key;
   old=*pictp;
   pxflags.scrap=0;

   pixclear(pict,file);

   if(txmxdata(master,file))
   {
    pxflags.scrap=1;
             err=undowritefn(file,UTXPX,&pict,sizeof(int));
    if(!err) err=pxmkmw(file,&old,&pxflags);
    if(!err) err=txpxmakemaster(pict,master,file);
   }
   else
   {
    pictp=(pictboxstr*)fob_find(master,file);
    if(pictp->type==OTEXTBOX)
    {                      /* master frame is a text frame */
     getpicttextdata(&xnew,(textboxstr*)pictp);
     xnew.flags.masterdata=0;
     xnew.picture=old.picture;
     xnew.process=old.process;
     copypicturedata(&xnew,&old);
    }
    else
    {
     xnew=*pictp;
     xnew.flags.masterdata=1;

     if(!old.flags.masterdata && xnew.picture)
     {
      fob_copy((fobjptr)&picturep,file,xnew.picture,file);
      xnew.picture=picturep->key;
      pxflags.scrap=1;
     }
     else
     {
      xnew.picture=old.picture;
     }
    }

             err=undowritefn(file,UMAKEMASTER,&pict,sizeof(int));
    if(!err) err=pxmkmw(file,&old,&pxflags);

    fcurve=xnew.fcurve;

    copycurve(&xnew.fcurve,file,&fcurve,file);

    if(xnew.data.changei) 
    {
     fcurve=xnew.icurve;
     copycurve(&xnew.icurve,file,&fcurve,file);
    }

    if(xnew.textflow.changeo)
    {
     fcurve=xnew.ocurve;
     copycurve(&xnew.ocurve,file,&fcurve,file);
    }

    copyborder(&xnew.frame,xnew.frame,file);
    copyfill(&xnew.data.fill,&xnew.data.fill,file);
    copyprocess(xnew.process.process,&xnew.process.process,file);

    makemastersub(pict,&xnew,file);
   }
  }
 }
 return(err);
}




static os_error * forceobjectmaster(int mode,pictboxstr * pictp,filestr * file)
{
 os_error    * err;
 pictboxstr    xnew;
 pictboxstr    old;
 int           pict;
 int           master;
 int           masterdata;
 picturestr  * picturep;


 err=NULL;

 if(mode==FORCEMASTER || mode==FORCEMASTERU || mode==FORCEMASTERR)
 {
  pict=pictp->key;

  master=pictp->master;

  if(mode==FORCEMASTERU) master=findoldmaster(master,file,0);

  if(master)
  {
   old=*pictp;

   vxadd((sobjectstr **)&pictp,file);
   frameflow((sobjectstr **)&pictp,file);

   pictp=(pictboxstr*)fob_find(master,file);
   if(pictp->type==OTEXTBOX && old.flags.masterdata)
   {
    /* make into a text frame and then update */
    pictp=(pictboxstr*)fob_find(pict,file);
    pxscrapcontents(pictp,file);
    pictp=(pictboxstr*)fob_find(pict,file);
    textfrompictlo((textboxstr*)pictp,file);
    objectlocal(pict,file,mode);
   }
   else
   {
    if(pictp->type==OTEXTBOX)
    {
     /* update a picture frame from a text frame */
     getpicttextdata(&xnew,(textboxstr*)pictp);
     masterdata=0;
    }
    else
    { /* update picture from picture */
     xnew=*pictp;
     deletecurve(&old.pcurve,file);
     copycurve(&old.pcurve,file,&xnew.pcurve,file);
     masterdata=1;
    }

    deletecurve(&old.icurve,file);
    deletecurve(&old.ocurve,file);
    deletecurve(&old.fcurve,file);

    copycurve(&old.icurve,file,&xnew.icurve,file);
    copycurve(&old.ocurve,file,&xnew.ocurve,file);
    copycurve(&old.fcurve,file,&xnew.fcurve,file);
 

    if(xnew.frame!=old.frame) /* only useful in zero case */
    {
     deleteborder(old.frame,file);
     copyborder(&old.frame,xnew.frame,file);
    }

    deletefill(&old.data.fill,file);
    copyfill(&xnew.data.fill,&xnew.data.fill,file);

    if(masterdata)
    {
     deleteprocess(old.process.process,file);
     copyprocess(xnew.process.process,&xnew.process.process,file);
    }

    if(xnew.picture!=old.picture && masterdata)
    {
     fob_delete(old.picture,file);
     fob_copy((fobjptr)&picturep,file,xnew.picture,file);
     old.picture=picturep->key;
    }

    err=fob_mod(pict,file,(fobjptr)&pictp);
  
    pictp->data=xnew.data;
    pictp->transform=xnew.transform;
    pictp->box=xnew.box;
    pictp->textflow=xnew.textflow;

    pictp->icurve=old.icurve;
    pictp->ocurve=old.ocurve;
    pictp->fcurve=old.fcurve;
    pictp->frame=old.frame;

    pictp->flags.spread=xnew.flags.spread;
    pictp->flags.locked=xnew.flags.locked;
    pictp->flags.masterdata=masterdata;
  
    vxadd((sobjectstr **)&pictp,file);
    frameflow((sobjectstr **)&pictp,file);

    if(masterdata)
    {
     pictp->picture=old.picture;
     copypicturedata(pictp,&xnew);
     pictp->process=xnew.process;
     pictp->ftype=xnew.ftype;
     pictp->masked=xnew.masked;
     pictp->pcurve=old.pcurve;
    }
    else
    {
     pictcalctransform(pict,file);
    }

   }
  }
 }
 return(err);
}






static os_error * uudm(filestr * file)
{
 mrefstr      mref;
 objectloc    src;
 objectloc    dest;
 transformstr tr;

 undoread(file,&mref,sizeof(mrefstr));
 mpageundelete(&mref,0,&src,&dest,&tr,file);
 pictcopyc(&src,&dest,&tr);
 return(undowritefn(file,UPXRDM,&dest.object,sizeof(int)));
}


static os_error * deletemaster(pictboxstr * pictp,filestr * file)
{
 int     pict;
 mrefstr mref;

 pict=pictp->key;

 mref.master=pictp->master;
 mref.after=pictp->chain.prev;

 pictscrap(pict,file,DELETEUNLINK);

 return(undowritefn(file,UPXUDM,&mref,sizeof(mrefstr)));
}


static os_error * urdm(filestr * file)
{
 int          pict;
 pictboxstr * pictp;

 undoread(file,&pict,sizeof(int));
 pictp=(pictboxstr*)fob_find(pict,file);
 return(deletemaster(pictp,file));
}






static os_error * localobject(pictboxstr * pictp,filestr * file,int makelocal)
{
 if(makelocal==MAKELOCAL)    return(makeobjectlocal(pictp,file));
 else
 if(makelocal==MAKEMASTER)   return(makeobjectmaster(pictp,file));
 else
 if(makelocal==DELETEMASTER) return(deletemaster(pictp,file));
 else                        return(forceobjectmaster(makelocal,pictp,file));
}


/***************************************************************************/


static os_error * ubtrash(filestr * file)
{
 os_error     * err;
 int            object;
 int            border=0;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undoread(file,&border,sizeof(int));

 deleteborder(border,file);

 return(err);
}


#ifdef NEVER

/* boxbitstr    ob;
 boxbitstr    nb;   */

/* getboxbits(&pictp->fcurve.box,&pictp->transform,&ob); */

/* nb=ob; */

/*

  nb.width+=2*(newwidth-oldwidth);
  nb.height+=2*(newwidth-oldwidth);

  if(!bits)
  {
   setboxtrans(&ob,&nb);
   err=transpict(pictp,file,boxtrans,0);
  } 

*/

#endif




static os_error * changeborder(int newborder,int pict,filestr * file,int bits)
{
 os_error   * err;
 int          oldborder;
 int          oldwidth[4];
 int          newwidth[4];
 pictboxstr * pictp;


 err=NULL;

 pictp=(pictboxstr*)fob_find(pict,file);

 oldborder=pictp->frame;


 getbordersize(oldborder,file,oldwidth,&pictp->fcurve);
 getbordersize(newborder,file,newwidth,&pictp->fcurve);


 fob_mod(pict,file,(fobjptr)&pictp);
 pictp->frame=newborder;
 vxadd((sobjectstr **)&pictp,file);

 if(bordercmp(oldwidth,newwidth))
 {
  frameflow((sobjectstr **)&pictp,file);

  if(!pictp->textflow.changeo) pxboundingcurves(&pictp,file,BCDEL|BCOUTER);

  getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

  frameflow((sobjectstr **)&pictp,file);
  vxadd((sobjectstr **)&pictp,file);

  changesize((chainobject*)pictp,file);
 }

 undowritefn(file,UPBORDER,&pict,sizeof(int));
 undowrite(file,&oldborder,sizeof(int));

 return(err);

 USE(bits);
}



static os_error * unborder(filestr * file)
{
 os_error     * err;
 int            object;
 int            newborder=0;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undoread(file,&newborder,sizeof(int));

 err=changeborder(newborder,object,file,1);

 return(err);
}




/* add frame                    */
/* get old width                */
/* stash old frame              */
/* create new frame             */
/* get new width                */
/* sort out changing frame size */
/* add refresh+redraw           */

static os_error * pictnewborder(pictboxstr * pictp,filestr * file,
                                int * message,modifyborderdatastr * borderp)
{
 os_error * err;
 int        newborder;
 int        pict;

 err=NULL;

 pict=pictp->key;

 if(!pictp->master || pictp->flags.local)
 {
  createborder(borderp,file,&newborder,pictp->frame);

  changeborder(newborder,pict,file,0);
 }

 return(err);

 USE(message);
}



static os_error * pictbordertype(pictboxstr * pictp,filestr * file,
                                 int * message,int * border)
{
 *border=pictp->frame;
 *message=0;

 return(NULL);

 USE(file);
}


/**************************************************************************/


static os_error * picteditpath(pictboxstr * pictp,filestr * file,
                                                   int * message,epstr * ep)
{
 os_error      * err;

 err=NULL;

 ep->curve[EP_INNER]=pictp->icurve;
 ep->curve[EP_FRAME]=pictp->fcurve;
 ep->curve[EP_OUTER]=pictp->ocurve;

 if(editpathcanedit(ep->curve))
 {
  *message=0;

  if(pictp->textflow.omode==FROUSER && !pictp->masked)
   ep->tr[EP_INNER]=pictp->pictdata.transform;
  else
   ep->tr[EP_INNER]=pictp->transform;

  if(pictp->textflow.omode==FROUSER)
   ep->tr[EP_OUTER]=pictp->pictdata.transform;
  else
   ep->tr[EP_OUTER]=pictp->transform;

  ep->tr[EP_FRAME]=pictp->transform;

  ep->colour.cv=pictp->data.colour;
  ep->coltype=EPC_CVG;

  pictp->flags.invisible=ep->invisible;

  if(ep->invisible) vxadd((sobjectstr **)&pictp,file);
 }

 return(err);
}



static os_error * pictchangepath(pictboxstr * pictp,filestr * file,
                                                   int * message,epstr * ep)
{
 os_error      * err;
 int             outer;
 int             inner;
 int             flags;
 int             changei;
 int             changef;
 int             changeo;
 int             pict;
 transformbitstr bits;
 transformstr    tr;
 coordstr        old;
 coordstr        xnew;


 err=NULL;

 *message=0;

 pict=pictp->key;


 changei=inner=ep->change[EP_INNER] & 0x1;
 changef=ep->change[EP_FRAME] & 0x1;
 changeo=outer=ep->change[EP_OUTER] & 0x1;

 pictp->data.changei|=inner;
 pictp->textflow.changeo|=outer;

 flags=BCDEL;

 if(changef)
 {
  if(!pictp->data.changei) 
  {
   flags|=BCINNER;
   inner=1;
  }

  if(!pictp->textflow.changeo)
  {
   flags|=BCOUTER;
   outer=1;
  }
 }

 if(changeo) pictp->ocurve=ep->curve[EP_OUTER];

 if(changef) 
 {
  tr_getbits(&pictp->transform,&bits);
  tr_setbits(&tr,&bits,TR_SCALE|TR_SKEW);

  old.x=pictp->fcurve.box.x;
  old.y=pictp->fcurve.box.y;

  pictp->fcurve=ep->curve[EP_FRAME];

  xnew.x=pictp->fcurve.box.x;
  xnew.y=pictp->fcurve.box.y;

  tr_transformset(&old,1,&tr);
  tr_transformset(&xnew,1,&tr);

  pictp->pictdata.xshift-=xnew.x-old.x;
  pictp->pictdata.yshift-=xnew.y-old.y;

  pictcalctransform(pict,file);
 }

 if(changei) pictp->icurve=ep->curve[EP_INNER];

 /* refresh twice, depending on if box is getting bigger or smaller */

 if(!ep->invisible) vxadd((sobjectstr **)&pictp,file);
 if(outer)          frameflow((sobjectstr **)&pictp,file);

 pxboundingcurves(&pictp,file,flags);
 if(flags & BCOUTER) ep->curve[EP_OUTER]=pictp->ocurve;
 if(flags & BCINNER) ep->curve[EP_INNER]=pictp->icurve;

 getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

 pictp->flags.invisible=ep->invisible;

 if(!ep->invisible) vxadd((sobjectstr **)&pictp,file);
 if(outer)          frameflow((sobjectstr **)&pictp,file);

 if(ep->quit) changesize((chainobject*)pictp,file);

 return(err);
}



static os_error * pxfontcache(pictboxstr *pictp,filestr *file,prjobstr *prjob)
{
 if(prjob->nopics) return(NULL);
 else              return(imcache(pictp->picture,file));
}


/*****************************************************************************/


static os_error * pictmessage(pictboxstr * pictp,filestr * file,
                                                   int * message,void * data)

{
 omessagefn fn;
 snapfn     snapbox;

 switch(*message)
 {

  case  OM_FUNCTION:
  case OM_FUNCTION2:
                    fn=((omessagefn)data);
                    return(fn((objhdrstr*)pictp,file,message));
                    break;

  case OM_EDITCHANGE:
                     return(pictchangepath(pictp,file,message,(epstr*)data));
                     break;

  case   OM_EDITPATH:
                     return(picteditpath(pictp,file,message,(epstr*)data));
                     break;

  case  OM_NEWBORDER:
                     return(pictnewborder(pictp,file,message,
                                                 (modifyborderdatastr*)data));
                     break;

  case OM_BORDERTYPE:
                     return(pictbordertype(pictp,file,message,(int*)data));
                     break;

  case  OM_FINDMASTER:
                      if((*((int*)data))==pictp->master)
                      {
                       *((int*)data)=pictp->key;
                       *message=0;
                      }
                      break;


  case     OM_DSSAVE:
  case     OM_DSNAME:
                     return(pxdsmessage(pictp,message,file,(buffer*)data));
                     break;



  case    OM_PRCACHE:
																					cprintf("pict cache font %d",((prjobstr*)data)->nopics);
                     return(pxfontcache(pictp,file,(prjobstr*)data));
                     break;


  case OM_PXLISTFONT:
                      return(pxfontlist(pictp,file,data));
                      break;


   case   OM_SNAPBOX:
                     snapbox=((snapfn)data);
                     snapbox(pictp->key,&pictp->transform,
                                        &pictp->fcurve.box);
                     break;

   case   OM_SETFILL:
                     pictsetfill(pictp,file,(fillstr*)data);
                     break;

   case   OM_GETFILL:
                     *((fillstr*)data)=pictp->data.fill;
                     *message=0;
                     break;

  case OM_SETPROCESS:
                     pictsetprocess(pictp,(int)data);
                     break;

  case OM_GETPROCESS:
                     *((int*)data)=pictp->process.process;
                     *message=0;
                     break;

   case OM_GETCOLOUR:
                     if(*((int*)data)==SELECTION_FILLCOLOUR)
                     {
                      *message=0;
                      *((colourvalue*)data)=pictp->data.colour;
                     }
                     else 
                     {
                      bordergetcolour(pictp->frame,message,data,file);
                     }
                     break;

   case OM_SETCOLOUR:
                     if(*((int*)data)==SELECTION_FILLCOLOUR)
                     {
                      pictp->data.colour=*((colourvalue*)(((int*)data)+1));
                      vxadd((sobjectstr **)&pictp,file);
                     }
                     else 
                     {
                      vxadd((sobjectstr **)&pictp,file);
                      bordersetcolour(pictp->frame,data,file);
                     }
                     break;
 }

 return(NULL);
}



static os_error * picture(pictboxstr * pictp,filestr * file,
                                             viewstr* view,objectdbstr * cont)
{
 switch(cont->type)
 {

  case  ODB_OBJECTNAMEPLURAL:
                             tsprintf(ODBCONLEN,cont->name,"{PX00}");
                             break;
                                                                                  case ODB_OBJECTNAMEPLURALC:
                             tsprintf(ODBCONLEN,cont->name,"{PX01}");
                             break;

  case        ODB_OBJECTNAME:
                             tsprintf(ODBCONLEN,cont->name,"{PX02}");
                             break;
           
  case            ODB_MODIFY:
                             openpictbox(pictp,file,view);
                             break;
 }

 USE(pictp);
 USE(file);

 return(NULL);
}


/*****************************************************************************/

/* tagged to UPSHAPE */

static os_error * ustrash(filestr * file)
{
 os_error     * err;
 int            object;
 curvestr       fcurve;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undoread(file,&fcurve,sizeof(curvestr));

 err=deletecurve(&fcurve,file);

 return(err);
}


static os_error * unshape(filestr * file)
{
 os_error     * err;
 int            object;
 pictboxstr   * pictp;
 curvestr       fcurve;
 curvestr       ocurve;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undoread(file,&fcurve,sizeof(curvestr));

 pictp=(pictboxstr*)fob_find(object,file);
 if(pictp)
 {
  fob_mod(object,file,(fobjptr)&pictp);

  vxadd((sobjectstr **)&pictp,file);
  frameflow((sobjectstr **)&pictp,file);

  ocurve=pictp->fcurve;
  pictp->fcurve=fcurve;

  setcurveradius(&pictp->fcurve,pictp->data.radius,&pictp->transform);
  pxboundingcurves(&pictp,file,BCINNER|BCOUTER|BCDEL);
  getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

  vxadd((sobjectstr **)&pictp,file);
  frameflow((sobjectstr **)&pictp,file);

  deletecurve(&ocurve,file);
 }

 return(err);
}



static os_error * shapeobject(pictboxstr * pictp,int shape,
                                              int data,filestr * file)
{
 int      object;
 curvestr fcurve;

 object=pictp->key;

 vxadd((sobjectstr **)&pictp,file);
 frameflow((sobjectstr **)&pictp,file);

 fcurve=pictp->fcurve;

 undowritefn(file,UPSHAPE,&object,sizeof(int));
 undowrite(file,&fcurve,sizeof(curvestr));

 makecurve(&fcurve,shape,data,file);

 fob_mod(object,file,(fobjptr)&pictp);
 pictp->fcurve=fcurve;

 setcurveradius(&pictp->fcurve,pictp->data.radius,&pictp->transform);
 pxboundingcurves(&pictp,file,BCINNER|BCOUTER|BCDEL);
 getframemaxbox((sobjectstr **)&pictp,pictp->frame,file,&pictp->transform);

 vxadd((sobjectstr **)&pictp,file);
 frameflow((sobjectstr **)&pictp,file);

 return(NULL);
}




static os_error * oreaddata(int action,pictboxstr * pictp,
                                       filestr * file,void * data)

{

 switch(action)
 {
  case SELECTINFO:
                  ((outlineinfostr*)data)->fcurve=pictp->fcurve;
                  ((outlineinfostr*)data)->tr=pictp->transform;
                  ((outlineinfostr*)data)->frame=pictp->frame;
                  break;


  case  OREADFILL:
                  *((colourvalue*)data)=pictp->data.colour;
                  break;

 }

 return(NULL);

 USE(file);
}




/* void pixsetup(int fontbits,int jpegbits,int spritebits,int spare2); */

void pixsetup(int fp)
{
 pixfontbits=stack[fp];
 pixjpegbits=stack[fp+1];
 pixspritebits=stack[fp+2];
}






static os_error * pxdocinit2(int eventn,int user,filestr * file,
                                                            void * data)
{
 int          pict;
 pictboxstr * pictp;

 if((pict=xprototype(OPICTBOX))!=0)
 {
  pictp=(pictboxstr*)fob_find(pict,deffile);

  defltpicttextflow=pictp->textflow;
  defltpicttextflow.changeo=0;

  defltpictdata=pictp->data;

  defltpictdata.fill.fill=FILLSTR;
  defltpictdata.changei=0;
 }

 return(remevent(EVENT_DOCINIT2,(eventfn)pxdocinit2,0));

 USE(eventn);
 USE(data);
 USE(user);
 USE(file);
}



/**************************************************************************/

static int       pxmissing;
static int       pxdeclare;
static int       pxchanged;
static int       pxfontnameindex;
static filestr * pxfontfile;


#define SMAPCHUNK 0x1000


static char * smap;
static int    smaplen;
static int    srootp;




typedef struct smapstr
{
 int          parent;
 int          sibls[2];
 int          balance;
 int          source;

} smapstr;



static int smcmp1(void * key1,void * key2)
{
 return((int)key1-(*((int*)key2)));
}


static int smcmp2(void * key1,void * key2)
{
 return((*((int*)key1))-(*((int*)key2)));
}



static int ssearchmap(int source)
{
 int offset;

 offset=avlfind((void*)source,srootp,smap,smcmp1);

 if(offset>=0)
 {
  return(((smapstr*)(smap+offset))->source);
 }
 else
 {
  return(0);
 }
}



static os_error * saddtomap(int source)
{
 os_error * err;
 smapstr  * s;

 err=flex_chunk((flex_ptr)&smap,smaplen+sizeof(smapstr),SMAPCHUNK);
 if(!err)
 {
  s=(smapstr*)(smap+smaplen);
  s->source=source;
  avlsearch(smaplen,&srootp,smap,smcmp2);
  smaplen+=sizeof(smapstr);
 }

 return(err);
}


static os_error * smapinit(void)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&smap,SMAPCHUNK);
 if(!err)
 {
  smaplen=0;
  srootp=-1;
 }

 return(err);
}



static os_error * smapfinit(void)
{

 return(flex_free((flex_ptr)&smap));
}




#define FMAPCHUNK 0x1000


static char * fmap;
static int    fmaplen;
static int    frootp;




typedef struct fmapstr
{
 int          parent;
 int          sibls[2];
 int          balance;
 int          picture;
 char         name[1];

} fmapstr;





static int fmcmp2(void * key1,void * key2)
{
 return(cstrcmp((char*)(((int*)key1)+1),(char*)(((int*)key2)+1)));
}





static os_error * faddtomap(char * name)
{
 os_error * err;
 int        len;
 fmapstr  * f;

 len=(strlen(name)+1+3) & (~0x3);
 len+=sizeof(fmapstr);

 err=flex_chunk((flex_ptr)&fmap,fmaplen+len,FMAPCHUNK);
 if(!err)
 {
  f=(fmapstr*)(fmap+fmaplen);
  strcpy(f->name,name);
  if(fmaplen==avlsearch(fmaplen,&frootp,fmap,fmcmp2))
  {
   fmaplen+=len;
   pxmissing++;
  }
 }

 return(err);
}


static os_error * fmapinit(void)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&fmap,FMAPCHUNK);
 if(!err)
 {
  fmaplen=0;
  frootp=-1;

 }

 return(err);
}



static os_error * fmapfinit(void)
{

 return(flex_free((flex_ptr)&fmap));
}







/* function called by pictstr when asked for the fonts it needs */

static os_error * pxfontlist(pictboxstr *pictp,filestr *file,void * data)
{
 int picture;

// cprintf("pxfontlist");

 picture=pictp->picture;
 if(!ssearchmap(picture))
 {
//  cprintf("add to map imlist");
  saddtomap(picture);
  return(imlist(picture,file));
 }

 return(NULL);
 USE(data);
}




/* function called by graphics for each font used */

os_error * pxlistfont(char * name,int userfont,void ** handle)
{
//  cprintf("fname %s",name);

 if(findxuserfont(name)<0)
 {
  faddtomap(name);
 }

 return(NULL);

	USE(userfont);
}




typedef struct missfntstr
{
 char * name;
 int    claim;
} missfntstr;



static os_error * scanfontlist(void)
{
 fmapstr  * f;
 fmapstr  * lt;
 int        len;
 missfntstr block;

 f=(fmapstr*)fmap;
 lt=(fmapstr*)((char*)fmap+fmaplen);
 while(f<lt)
 {

  if(findxuserfont(f->name)<0)
  {
   pxmissing++;
   if(pxmissing==1) pxfontnameindex=((char*)f)-fmap;

   if(pxdeclare)
   {
    block.name=f->name;
    block.claim=0;

    event(EVENT_FONTMISSING,pxfontfile,(int)&block);
    pxchanged|=(block.claim!=0);
   }
  }

  len=(strlen(f->name)+1+3) & (~0x3);
  len+=sizeof(fmapstr);

  f=(fmapstr*)((char*)f+len);
 }

 return(NULL);
}





os_error * pictfontload(filestr * file,int * load,int flags)
{
 os_error * err;
 int        message;
 char       string[256];
 fmapstr  * f;

 if(pxfontcheck && !(flags & FL_NOFONTMISSING))
 {
  cprintf("missing font1");

  pxfontnameindex=-1;
  pxfontfile=file;

  err=fmapinit();
  if(!err)
  {
   err=smapinit();
   if(!err)
   {
    pxmissing=0;
    message=OM_PXLISTFONT;
    broadcastmessage(file,&message,NULL);

    smapfinit();
   }

     cprintf("missing font1 %d",pxmissing);

   if(pxmissing)
   {
    checkforfontschange();
    pxmissing=0;
    scanfontlist();

     cprintf("missing font2 %d",pxmissing);

    if(pxmissing)
    {
     pxdeclare=1;
     pxmissing=0;
     pxchanged=0;
     scanfontlist();

	      cprintf("missing font3 %d",pxmissing);

     if(pxmissing)
     {
      checkforfontschange();
      pxmissing=0;
      scanfontlist();

//	       cprintf("missing font4 %d",pxmissing);

      if(pxmissing && pxfontnameindex>=0)
      {
       f=(fmapstr*)(fmap+pxfontnameindex);

       if(pxmissing==1)
       {
        tsprintf(sizeof(string),string,"{FOXGR1}",f->name);
        messagebox(string);
       }
       else
       if(pxmissing>1)
       {
        tsprintf(sizeof(string),string,"{FOXGRN}",pxmissing,f->name);
        messagebox(string);
       }
      }
     }
    }
   }

   fmapfinit();
  }
 }

 return(NULL);

 USE(load);
}



/*****************************************************************************/


static objectstr pictobject=
{
 OPICTBOX,                             /* type        */
 NULL,                                 /* new         */
 (objectcopyfn)pictcopy,               /* copy        */
 (objectredrawfn)redrawpict,           /* redraw      */
 (objectcreatefn)createpict,           /* create      */
 (objectfindfn)findpict,               /* find        */
 (objectselectfn)selectpict,           /* select      */
 (objecttransformfn)transpict,         /* transform   */
 (objectloadtypefn)pictloadtype,       /* load type   */
 (objectloadfn)pictload,               /* load        */
 (objectloadpostfn)pictloadpost,       /* load post   */
 (objectmessagefn)pictmessage,         /* message     */
 (objectdbfn)picture,                  /* object db's */
 (objectflowfn)pictflowvalues,         /* access text flow info */
 (objectdeletefn)pictdelete,           /* delete      */
 NULL,                                 /* text reflow */
 (objectsetflowfn)pictcheckforreflow,  /* object set flow */
 (objectmasterfn)masterobject,         /* master object?  */
 (objectlocalfn)localobject,           /* local object    */
 (objectshapefn)shapeobject,           /* change shape    */
 (objectreadfn)oreaddata,              /* read data       */
 NULL,                                 /* x12 */

};



#define UNDOS 29

static undofnstr undos[UNDOS]=
{
 untranspict,   NULL,                  UPTRAN,        "{UTRANS}",
 unpictsetflow, NULL,                  UPFLOW,        "{UFLOW}",
 unupdatepict,  NULL,                  UPUPDATE,      "{UMODIFY}",
 uprecreate,    uptrash,               UPRECREATE,    NULL,
 updelete,      NULL,                  UPDELETE,      NULL,
 unshape,       ustrash,               UPSHAPE,       NULL,
 unpmakelocal,  NULL,                  UPMXLOCAL,     NULL,
 unpmakemaster, NULL,                  UPMXMASTER,    NULL,
 unmakemaster,  unmakemasterscrap,     UMAKEMASTER,   NULL,
 uconupdate,    NULL,                  UCONUPDATE,    "{UPCON}",
 upxcopy,       upxtrash,              UPXCOPY,       "{UPCOPY}",
 unsavepix,     NULL,                  UPXSAVE,       "{UPSEL}",
 unborder,      ubtrash,               UPBORDER,      NULL,
 unpictmove,    NULL,                  UPMOVE,        "{UTRANS}",
 unpxdels,      NULL,                  UPXDELS,       "{UPCOPY}",
 unpxdelf,      NULL,                  UPXDELF,       "{UPCOPY}",
 upxrecreate,   upxrecscrap,           UPXRECREATE,   NULL,
 upxdelete,     upxdelscrap,           UPXDELETE,     NULL,

 utxpx,         utxpxscrap,            UTXPX,         NULL,
 utxpxmk,       utxpxmkscrap,          UTXPXMK,       NULL,

 uudm,          NULL,                  UPXUDM,        NULL,
 urdm,          NULL,                  UPXRDM,        NULL,

 pxundoproxy,   NULL,                  UPXPROXY,      "{UPPROX}",

 pxundorefchange,NULL,                 UPXCHREF,      "{UPCHREF}",

 pxundoreload,  NULL,                  UPXRELOAD,     "{UPEMBED}",
 pxundoembed,   NULL,                  UPXEMBED,      "{UPEMBED}",

 pxundocollect, NULL,                  UPXCOL,        "{UPCOL}",

};



os_error * pictinit(void)
{
 os_error * err;

 err=undoaddblock(undos,UNDOS);

 if(!err) err=objectregister(&pictobject);
 if(!err) err=dbpxinit();
 if(!err) err=pixtoolinit();
 if(!err) err=croptoolinit();
 if(!err) err=xtraceinit();
 if(!err) err=pxdsinit();
 if(!err) err=pxcacheinit();

 if(!err) err=addevent(EVENT_DOCINIT2,(eventfn)pxdocinit2,0);

 return(err);
}

