/* pxbmp.cpp - BMP handling */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"
#include "sprite.h"
#include "sprx.h"
#include "xprocess.h"


#include "err.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "alloc.h"
#include "colour.h"
#include "etc.h"
#include "poll.h"
#include "xmath.h"
#include "imlib.h"
#include "bmphdr.h"
#include "bmpim.h"
#include "deb.h"



#include "constants.h"
#include "str.h"
#include "reslink.h"

#include "obj.h"
#include "object.h"
#include "dscript.h"

#include "xprint.h"

#include "pxstr.h"
#include "pict.h"
#include "file.h"
#include "view.h"
#include "impex.h"
#include "pixtool.h"
#include "splib.h"
#include "splink.h"
#include "fit.h"
#include "xtrace.h"
#include "pxtags.h"
#include "pxref.h"
#include "pxcache.h"
#include "draw.h"
#include "xrender.h"

#include "pxbmp.h"






/* render picture                */
/* given box in picture space    */
/* given transform to real space */

static os_error * bmprender(aboxstr * abox,transformstr * tr,
                  processstr * pr,picturestr * picturep,viewredrawstr * v)
{
 os_error        * err;
 int               oldmode;
 pxproxyimstr    * proxy;
 void            * data=NULL;


// cprintf("bmprender");

 err=NULL;

 if(!pr->spotplate || pr->knockoutgraphics)
 {
  oldmode=pr->mode;
  if(pr->spotplate && pr->knockoutgraphics) pr->mode=PROCESSWHITE;


  if(pr->useproxies)
  {
   proxy=(pxproxyimstr*)(picturep->data+((picturep->imagelen+0x3)&(~0x3)));
   data=proxy->data;
  }
  else
  {
   if(picturep->imagelen==0)
   {
    err=pxcache2(&picturep,v->file,NULL,NULL);
   }

   if(!err)
   {
    data=picturep->data;
   }
  }

  if(!err)
  {
//   bmppaint(data,tr->e>>8,tr->f>>8,scale(picturep->abox.x1-picturep->abox.x0,tr->a,256*0x10000),scale(picturep->abox.y1-picturep->abox.y0,tr->d,256*0x10000));
   err=render_bmp(data,tr,&picturep->abox,pr,v);
  }

  pr->mode=oldmode;
 }

 return(err);
}




static os_error * bmppxinfo(int object,int ftype,
                                       filestr * file,int * info)
{
 os_error         * err;
 picturestr       * picturep;
 char               string[128];
 int                len;
// int              * buff;
 bmpstr           * bmp;
 int                cx;
 int                cy;
 int                xdpi;
 int                ydpi;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err)
 {
  bmp=(bmpstr*)(picturep->data+2);

  *info++=PT_LENGTH;
  *info++=3*sizeof(int);
  *info++=bmp->hdr.cbsize;

  if(bmp->hdr.cbfix==C_OS2)
  {
   *info++=PT_PIX;
   *info++=4*sizeof(int);
   *info++=cx=bmp->info.os2.cx;
   cy=bmp->info.os2.cy;
   if(cy<0) cy=-cy;
   *info++=cy;

   *info++=PT_RES;
   *info++=4*sizeof(int);
   xdpi=96;
   ydpi=96;
   *info++=xdpi;
   *info++=ydpi;

   *info++=PT_DIM;
   *info++=4*sizeof(int);
   *info++=scale(cx,180*256,xdpi);
   *info++=scale(cy,180*256,ydpi);


   *info++=PT_CLASS;
   *info++=8*sizeof(int);
   *info++=PT_BITMAP;

   *info++=PT_RGB;
   *info++=3;
   *info++=bmp->info.os2.bitcount;
   *info++=0;
   *info++=0;
  }
  else
  {
   *info++=PT_PIX;
   *info++=4*sizeof(int);
   *info++=cx=bmp->info.windows.cx;
   cy=bmp->info.windows.cy;
   if(cy<0) cy=-cy;
   *info++=cy;

   *info++=PT_RES;
   *info++=4*sizeof(int);
   xdpi=scale(bmp->info.windows.xdpm,254,10000);
   ydpi=scale(bmp->info.windows.ydpm,254,10000);
   if(xdpi==0) xdpi=96;
   if(ydpi==0) ydpi=96;
   *info++=xdpi;
   *info++=ydpi;

   *info++=PT_DIM;
   *info++=4*sizeof(int);
   *info++=scale(cx,180*256,xdpi);
   *info++=scale(cy,180*256,ydpi);


   *info++=PT_CLASS;
   *info++=8*sizeof(int);
   *info++=PT_BITMAP;

   *info++=PT_RGB;
   *info++=bmp->info.windows.cplanes;
   *info++=bmp->info.windows.bitcount;
   *info++=0;
   *info++=0;
  }


  sprintf(string,"BMP");

  len=strlen(string)+1;
  len=(len+3)&(~0x3);
  *info++=PT_INFO;
  *info++=2*sizeof(int)+len;
  strcpy((char*)info,string);
  info+=(len/sizeof(int));


  *info++=PT_END;
  *info++=2*sizeof(int);
 }

 return(err);

 USE(ftype);
}











static os_error * bmpimportpost(int ftype,int object,filestr * file)
{
 USE(ftype);
 USE(object);
 USE(file);

 return(NULL);
}


os_error * bmpinitpicture(int object,int ftype,filestr * file)
{
 picturestr * picturep;
 bmpstr     * bmp;
 int          cx;
 int          cy;
 int          xdpi;
 int          ydpi;
 char       * p;

 picturep=(picturestr*)fob_find(object,file);
 bmp=(bmpstr*)(picturep->data+2);

 if(ftype==DIB)
 {
  p=(char*)picturep->data;
  *p++='B';
  *p++='M';

  bmp->hdr.cbsize=picturep->imagelen-2;
  bmp->hdr.offbits=DIBSHIFT+C_WIN;

  if(bmp->hdr.cbfix==C_WIN)
  {
   if(bmp->info.windows.compression==BI_BITFIELDS 
       /* && (bmp->info.windows.bitcount==16 || bmp->info.windows.bitcount==32)*/) bmp->hdr.offbits+=12;
  }

  if(bmp->hdr.cbfix==C_OS2)
  {
   if(bmp->info.windows.bitcount<=8) bmp->hdr.offbits+=4*(1<<bmp->info.windows.bitcount);
  }
  else
  {
   if(bmp->info.windows.bitcount<=8)
   {
    if(bmp->info.windows.ncolourused==0) bmp->hdr.offbits+=4*(1<<bmp->info.windows.bitcount);
    else                                 bmp->hdr.offbits+=4*bmp->info.windows.ncolourused;
   }
   else
   {
    bmp->hdr.offbits+=4*bmp->info.windows.ncolourused;
   }
  }

  ftype=BMP;
 }



 if(bmp->hdr.cbfix==C_OS2)
 {
  cx=bmp->info.os2.cx;
  cy=bmp->info.os2.cy;
  xdpi=96;
  ydpi=96;
 }
 else
 {
  cx=bmp->info.windows.cx;
  cy=bmp->info.windows.cy;
  xdpi=scale(bmp->info.windows.xdpm,254,10000);
  ydpi=scale(bmp->info.windows.ydpm,254,10000);
  if(xdpi==0) xdpi=96;
  if(ydpi==0) ydpi=96;
 }

 if(cy<0) cy=-cy;

 picturep->abox.x0=0;
 picturep->abox.x1=scale(cx,180*256,xdpi);
 picturep->abox.y0=0;
 picturep->abox.y1=scale(cy,180*256,ydpi);
 picturep->ftype=ftype;

	return(NULL);
}




static os_error * bmpimport(char * name,int ftype,int xv,
                                                int * object,filestr * file)
{
 os_error   * err;

 err=dxloadchunk(name,ftype==DIB?DIBSHIFT:0,object,file);
 if(!err)	err=bmpinitpicture(*object,ftype,file);

 return(err);

 USE(xv);
 USE(ftype);
}




static os_error * bmpembed(int ftype,int object,filestr * file)
{
 os_error * err;

 err=dxembedchunk(0,object,file);
 if(!err)
 {
  pxtagsize(object,file,PXPREF1TAG,0);
  pxtagsize(object,file,PXPREF2TAG,0);
 }

 return(err);
 USE(ftype);
}





static os_error * bmpdsexport(int ftype,int object,
                                           filestr * file,buffer * bf)
{
 picturestr * picturep;
 char       * buff;
 int          len;

 picturep=(picturestr*)fob_find(object,file);
 buff=picturep->data;

 len=picturep->imagelen;

 bf_printfeol(bf,"%d",len);

 dxwritedata(NULL,-1,bf);

 dxwritedata(buff,len,bf);

 return(dxwritedata(NULL,-2,bf));

 USE(ftype);
}




static os_error * bmpdsimport(int ftype,int fp,int argc,objectloc * loc)
{              
 os_error          * err;
 filestr           * file;
 dsobjectstr       * ds;
 int                 object;

 file=loc->file;

 err=dxloadblock(0,fp,argc,loc);

 if(argc==DSIMMLAST)
 {
  ds=(dsobjectstr*)(dsstack+fp);
  object=ds->data.integer;

		err=bmpinitpicture(object,ftype,file);
  if(err)
  {
   dxscrapchunk(&object,file);
   ds=(dsobjectstr*)(dsstack+fp);
   ds->data.integer=object;
  }
 }

 return(err);
}





static os_error * bmpexport(char * name,int object,int ftype,int xv,
                                                              filestr * file)
{
 os_error   * err;
 picturestr * picturep;

 err=NULL;

	cprintf("bmpexport dib %d",ftype==DIB);

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err) err=bf_saveblock(name,ftype,ftype==DIB?(picturep->data+DIBSHIFT):picturep->data,ftype==DIB?(picturep->imagelen-DIBSHIFT):picturep->imagelen);

 return(err);

 USE(xv);
}



static os_error * bmpinfo(int object,int ftype,filestr * file,int * len)
{
 os_error   * err;
 picturestr * picturep;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err) *len=picturep->imagelen;

 return(err);

 USE(ftype);
}








static int bmpshift(picturestr * picturep)
{
 return(0);
 USE(picturep);
}



static os_error * bmpproxy(int ftype,int object,filestr * file,
                                                 pxproxystr * proxy)
{
 return(spproxysub(0,object,file,proxy));
 USE(ftype);
}






static impexstr bmpstr=
{
 BMP,
 "bmp",

 IMPXLOAD|IMPXPICT,   /* flags       */
 bmpimport,           /* import      */
 bmpimportpost,       /* import post */
 bmpexport,           /* export      */
 bmprender,           /* render      */
 bmpdsexport,         /* dsexport    */
 bmpdsimport,         /* dsimport    */

 pictintexport,       /* internal export */
 bmpinfo,             /* exportinfo      */

 NULL,                /* cache */

 NULL,                /* rendermem */

 bmpshift,            /* data shift */

 bmppxinfo,           /* info */
 dxrefload,           /* reference load */
 bmpproxy,            /* make proxy */
 dxremoveproxy,       /* remove proxy */

 bmpembed,            /* embed referenced image */
 dxrefreload,         /* reload                 */
 NULL,                /* list fonts             */
 NULL,                /* x3                     */

};






static impexstr dibstr=
{
 DIB,
 "dib",

 IMPXLOAD|IMPXPICT,   /* flags       */
 bmpimport,           /* import      */
 bmpimportpost,       /* import post */
 bmpexport,           /* export      */
 bmprender,           /* render      */
 bmpdsexport,         /* dsexport    */
 bmpdsimport,         /* dsimport    */

 pictintexport,       /* internal export */
 bmpinfo,             /* exportinfo      */

 NULL,                /* cache */

 NULL,                /* rendermem */

 bmpshift,            /* data shift */

 bmppxinfo,           /* info */
 dxrefload,           /* reference load */
 bmpproxy,            /* make proxy */
 dxremoveproxy,       /* remove proxy */

 bmpembed,            /* embed referenced image */
 dxrefreload,         /* reload                 */
 NULL,                /* list fonts             */
 NULL,                /* x3                     */

};






os_error * bmpinit(void)
{
 os_error * err;

          err=impexregister(&bmpstr);
 if(!err) err=impexregister(&dibstr);

 return(err);
}

