/*->c.pract */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"
#include "alloc.h"

#include "wos.h"

#include "filetype.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "save.h"
#include "fsx.h"
#include "bf.h"
#include "units.h"
#include "osprint.h"
#include "deb.h"


#include "str.h"
#include "constants.h"
#include "object.h"

#include "reslink.h"

#include "main.h"
#include "view.h"
#include "viewr.h"
#include "file.h"
#include "geometry.h"

#include "page.h"

#include "txstr.h"
#include "fl.h"



#include "prstr.h"
#include "xprint.h"
#include "dbprint.h"
#include "prjob.h"
#include "prstat.h"
#include "prf.h"
#include "preg.h"

#include "pract.h"




static filestr * prfile;
static viewstr * prview;
static int       prbranch;
static int       printprotocol;

static int       doprintfile;



/* a flag that tells us if we're waiting for printer protocol messages */

int getprintprotocol(void)
{
 return(printprotocol);
}



static void calcposns(printstr * pr,paperstr * ps,filestr * file,
                      int branch,int papern,prmarginstr * prmargins)
{
 int          width;
 int          height;
 int          xshift;
 int          yshift;
 aboxstr      cbox;
 aboxstr      maxbox;
 int          i;
 transformstr tr1;
 transformstr tr2;
 transformstr tr3;
 transformstr r1;
 transformstr r2;
 transformstr r3;
 int          id;
 int          x0;
 int          y0;


 maxbox=ps->mbox;

 for(i=0;i<ps->n;i++)
 {
  if(ps->pset[i].marks)
  {
   praddmarks(&cbox,&ps->pset[i].cbox,ps->pset[i].marks);
   getsumabox(&maxbox,&cbox);
  }

  if(ps->pset[i].page)
  {
   getsumabox(&maxbox,&ps->pset[i].abox);
  }
 }


 if(ps->marks)
 {
  praddmarks(&cbox,&ps->cbox,ps->marks);
  getsumabox(&maxbox,&cbox);
 }


 width=maxbox.x1-maxbox.x0;
 height=maxbox.y1-maxbox.y0;
 xshift=-maxbox.x0;
 yshift=-maxbox.y0;

 for(i=0;i<ps->n;i++)
 {
  ps->pset[i].xpo+=xshift;
  ps->pset[i].ypo+=yshift;

  aboxshift(&ps->pset[i].abox,xshift,yshift);
  aboxshift(&ps->pset[i].cbox,xshift,yshift);
 }

 aboxshift(&ps->cbox,xshift,yshift);

	ps->ebox=maxbox;
 aboxshift(&ps->ebox,xshift,yshift);

 ps->abox.x0=0;
 ps->abox.y0=0;
 ps->abox.y1=height;
 ps->abox.x1=width;

 autoscalecentre(width,height,pr,ps,papern,prmargins);

 for(i=0;i<ps->n;i++)
 {
  ps->pset[i].id=0;
  ps->pset[i].tr=ps->tr;
		tr_setidentity(&ps->pset[i].trs);
 }

 id=1;
 for(i=0;i<ps->n;i++)
 {
  if(ps->pset[i].page && (ps->pset[i].angle || ps->pset[i].scale))
  {
   maxbox=ps->pset[i].abox;

			tr_setidentity(&r3);

   if(ps->pset[i].angle)
   {
    tr_setshift(&tr1,-maxbox.x0,-maxbox.y0);
    tr_setidentity(&tr2);
    tr_setrotationa(&tr2,180*0x10000);
    tr_setshift(&tr3,maxbox.x1,maxbox.y1);

    tr_multiply(&r1,&tr3,&r3); // &ps->tr);
    tr_multiply(&r2,&tr2,&r1);
    tr_multiply(&r3,&tr1,&r2);
    x0=maxbox.x1;
    y0=maxbox.y1;
   }
   else
   {
//    r3=ps->tr;
    x0=maxbox.x0;
    y0=maxbox.y0;
   }

   if(ps->pset[i].scale)
   {
    tr_setshift(&tr1,-x0,-y0);
    tr_setidentity(&tr2);
    tr_setscale(&tr2,0x10000,ps->pset[i].scalex,0x10000,ps->pset[i].scaley);
    tr_setshift(&tr3,x0,y0);

    tr_multiply(&r1,&tr3,&r3); /* input old transform r3 */
    tr_multiply(&r2,&tr2,&r1);
    tr_multiply(&r3,&tr1,&r2);
   }

			cprintf("calc a=%x b=%x c=%x d=%x e=%x f=%x",r3.a,r3.b,r3.c,r3.d,r3.e,r3.f);

   ps->pset[i].trs=r3;
			tr_multiply(&ps->pset[i].tr,&r3,&ps->tr);

   ps->pset[i].id=id++;
  }
 }

 USE(file);
 USE(branch);
}



// repeats calculation in printgraphics()

static os_error * cropcheck(filestr * file,int branch,int * result)
{
 os_error   * err;
 printstr     prints;
 paperstr   * paper;
 int          lpno;
 int          nopages;
 int          pwidth;
 int          first;
 aboxstr      maxbox;
 prmarginstr* savemargin;
 int          xscale;
 int          yscale;
 int          dx;
 int          dy;

 err=NULL;
 *result=1;


 if(printbits & PRB_CROPCHECK)
 {
  prints=((oprintstr*)fob_find(file->hdr.print,file))->pr;
  if(prints.sheet)
  {
   prints.oddevenall=prints.sheetoddeven+(prints.sheetoddevenall<<1);
  }

  if(!prvalidmode(prints.mode)) prints.mode=0;
  prsetfromfile(&prints,file);

  pwidth=prpapern(file,&prints);
  err=salloc((flex_ptr)&paper,sizeof(paperstr)+pwidth*sizeof(psetstr));
  if(!err)
  {
   nopages=prcountpages(&prints,file,branch);
   first=1;
 
   for(lpno=0;lpno<nopages;lpno++)
   {
    if(prints.sheet && first)
    {
     if(prints.oddevenall==PRALL)
     {
      lpno=prints.sheetn*2;
     }
     else
     {
      lpno=prints.sheetn;
     }
    }

    cprintf("nopages %d lpno %d",nopages,lpno);

    memset(paper,0,sizeof(paperstr)+pwidth*sizeof(psetstr));
    paper->n=pwidth;
    prsetlogicalpage(&prints,paper,lpno,nopages,file,branch);
    calcposns(&prints,paper,file,branch,lpno,printerarea());

    if(first) 
    {
     maxbox=paper->abox;
     first=0;
    }
    else
    {
     getsumabox(&maxbox,&paper->abox);
    }

    if(prints.sheet)
    {
     if(prints.oddevenall==PRALL)
     {
      if(lpno & 0x1) break;
     }
     else
     {
      break;
     }
    }
   }


   yscale=prints.scale;
   xscale=ttmul(yscale,prints.aspect);
   dx=(maxbox.x1-maxbox.x0);
   dy=(maxbox.y1-maxbox.y0);
   dx=scale(dx,xscale,0x10000)-MMSIZE;
   dy=scale(dy,yscale,0x10000)-MMSIZE;
   if(prints.sideways) SWOP(dx,dy);

//   prsavemargins(&savemargin); being used to read value...

			savemargin=printerarea();

   if(savemargin && dx>savemargin->paperxsize || dy>savemargin->paperysize)
   {
    confirmparent(NULL,CONYN,result,"{PR0F}");
   }

   cprintf("dx %d margin.paperxsize %d",dx,savemargin->paperxsize);
   cprintf("dy %d margin.paperysize %d",dy,savemargin->paperysize);

   sfree((flex_ptr)&paper);
  }
 }
 return(err);
}



// repeats calculation in cropcheck()

static os_error * printgraphics(viewstr * view,filestr * file,int branch)
{
 os_error   * err;
 printstr     prints;
 paperstr   * paper;
 int          lpno;
 int          nopages;
 int          pwidth;
 int          first;


 err=flex_overhead(flex_getoverhead()+printmemory);
 if(!err)
 {
  prints=((oprintstr*)fob_find(file->hdr.print,file))->pr;
  if(prints.sheet)
  {
   prints.oddevenall=prints.sheetoddeven+(prints.sheetoddevenall<<1);
  }

  if(!prvalidmode(prints.mode)) prints.mode=0;
		prjobapplyhardware(&prints);		// may change prints settings e.g. collate may be done by hardware
  prsetfromfile(&prints,file);

  pwidth=prpapern(file,&prints);
  err=salloc((flex_ptr)&paper,sizeof(paperstr)+pwidth*sizeof(psetstr));
  if(!err)
  {
   err=printjobopen(pwidth);
   if(!err)
   {
    nopages=prcountpages(&prints,file,branch);
    first=1;

    cprintf("nopages %d oddeven %d",nopages,prints.oddevenall);

    for(lpno=0;lpno<nopages;lpno++)
    {
     if(prints.sheet && first)
     {
      if(prints.oddevenall==PRALL)
      {
       lpno=prints.sheetn*2;
      }
      else
      {
       lpno=prints.sheetn;
      }
     }

     cprintf("nopages %d lpno %d",nopages,lpno);


     memset(paper,0,sizeof(paperstr)+pwidth*sizeof(psetstr));
     paper->n=pwidth;
     prsetlogicalpage(&prints,paper,lpno,nopages,file,branch);
     calcposns(&prints,paper,file,branch,lpno,printerarea());

     err=printjobadd(paper);
     if(err) break;

     if(first)
     {
      first=0;
     }

     if(prints.sheet)
     {
      if(prints.oddevenall==PRALL)
      {
       if(lpno & 0x1) break;
      }
      else
      {
       break;
      }
     }

    }

    if(!err) err=printjob(&prints,view,file,branch); // nb may change contents of prints

    printjobclose();
   }

   sfree((flex_ptr)&paper);
  }
  flex_overhead(flex_getoverhead()-printmemory);
 }
 return(err);
}







/*****************************************************************************/

       int    printqueue=0;    /* number of entries in print queue */
static int    printedq;        /* number of last entry printed     */
static int    pqlen;

static char * printbuff=NULL;


static char * pqnext(void)
{
 int    i;
 char * p;

 if(printedq==printqueue)
 {
  flex_free((flex_ptr)&printbuff);
  printqueue=0;
  return(NULL);
 }
 else
 {
  p=printbuff;
  for(i=0;i<printedq;i++) p+=strlen(p)+1;
  printedq++;
  return(p);
 }
}


static void pqzero(int handle)
{
// cprintf("pqz 0");

 if((!inprinter) && (!doprintfile) && (initcomplete))
 {
   cprintf("pqz %d",printqueue);

  if(printqueue) printdoc(pqnext());
  else           remzeroevent(pqzero,0);
 }

 USE(handle);
}


static void pqadd(char * name)
{
 int len;
 int offset;

 cprintf("pqadd %s",name);

 if(!printqueue)
 {
  printedq=0;
  pqlen=0;
  flex_alloc((flex_ptr)&printbuff,0);
  addzeroevent(pqzero,0);
 }

 len=strlen(name)+1;

 flex_extend((flex_ptr)&printbuff,pqlen+len);
 offset=pqlen;
 pqlen+=len;

 memcpy(printbuff+offset,name,len);
 printqueue++;
}



/*****************************************************************************/


/*
static void doprintfileover(filestr * file)
{
 if(doprintfile)
 {
  closedoc(file);
  doprintfile=0;
 }

 USE(file);
}
*/

/* called from messages to do a graphics print */
/* print current 'file' using current 'vdi' */

static os_error * printfile(viewstr * view,filestr * file,int branch) 
{
 os_error  * err;


/* If there is no printer driver
 {
  return(geterror(PR00));
 }
*/

 flowvalidfile(file);
 fob_compactall();


 inprinter=1;

 err=printgraphics(view,file,branch);

 inprinter=0;

 closepstat();


// doprintfileover(file);

 return(err);
}




/* a drag from the filer, has ended on a printer driver          */
/* up to us to load and print the file if we can and then say so */

static os_error * printfileodd(wimp_msgstr * msg,int * ack)
{
 os_error    * err;
 int           type;
 char        * name;


 err=NULL;


 type=msg->data.print.type;
 name=msg->data.print.name;

 if(msg->data.print.printer) osprsetcurrentname(msg->data.print.printer);

 if(type==FTYPE2 || type==STYPE2)
 {
  *ack=1;

  cprintf("print queue %s",name);

  if((!inprinter) && (!doprintfile) && (initcomplete))
  {
   err=printdoc(name);
  }
  else
  {
   pqadd(name);
  }
 }

 return(err);
}





/**************************************************************************/

static int    prsaveref;
static int    prsavetype;
static messfn prsavefn;


void printset(int xprsaveref,int xprsavetype,viewstr * xview,filestr * xfile,
                                                      int xbranch,messfn xfn)
{
 prsaveref=xprsaveref;
 prsavetype=xprsavetype;
 prsavefn=xfn;
 prview=xview;
 prfile=xfile;
 prbranch=xbranch;
}

/*************************************************************************/

os_error * startprint(int direct,viewstr * view,filestr * file,int branch)
{
 os_error  * err;
 oprintstr * op;
 int         result;

/* dprintf(0,"start print"); */

 err=NULL;

 op=(oprintstr*)fob_find(file->hdr.print,file);

/* if(os_swix(PDriver_Info,&rx)) err=geterror(PR00);
 else*/
 {
  cropcheck(file,branch,&result);
  if(result>0)
  {
   err=printfile(view,file,branch);
  }
 }
 return(err);

	USE(direct);
}


/* called if an external file is to be printed */

os_error * printdoc(char * filename)
{
 os_error * err;
 filestr  * file;

 err=NULL;

 if(filename)
 {
  doprintfile=1;

  err=loadanyfile(filename,FLNOVIEW|FLPERMANENT|FLNOLOAD);
  if(!err)
  {
   file=xloadfile;
   if(file)
   {
    err=startprint(1,NULL,file,0);
    closedoc(file);
    cprintf("start print + %d",printqueue);
   }
  }

  doprintfile=0;
 }

 zerofilesquit(NULL);

 return(err);
}


void xprintdoc(int fp)
{
 zreport(startprint(0,menuview,menufile,menuview->branch));
 USE(fp);
}



os_error * printactinit(void)
{
 os_error * err;

 err=addmessage(printfileodd,wimp_MPrintTypeOdd);

 return(err);
}

