/*->c.preg */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "save.h"
#include "fsx.h"
#include "bf.h"



#include "str.h"
#include "constants.h"

#include "file.h"
#include "page.h"
#include "xredraw.h"
#include "xrender.h"
#include "xcolour.h"
#include "curve.h"
#include "geometry.h"



#include "prstr.h"
#include "xprint.h"

#include "preg.h"








int printermarks(filestr * file)
{
 oprintstr  * pr;

 pr=(oprintstr*)fob_find(file->hdr.print,file);

 return(pr->pr.regm?(pr->pr.marks ^ 0xFFFFFFFF):0);
}







void regmsize(int bits,aboxstr * abox)
{
 memset(abox,0,sizeof(aboxstr)); 


 /* top */

 if(bits & 0x1)
 {
  abox->y1=MAX(regvlength/2+reghstandoff,reghstandoff+regradius);
 }

 /* bottom */

 if(bits & 0x2)
 {
  abox->y0=MAX(regvlength/2+reghstandoff,reghstandoff+regradius);
 }

 /* left hand side */

 if(bits & 0x4)
 {
  abox->x0=MAX(regvstandoff+regvlength/2,regvstandoff+regradius);
 }

 /* right hand side */

 if(bits & 0x8)
 {
  abox->x1=MAX(regvstandoff+regvlength/2,regvstandoff+regradius);
 }


 /* left/top */

 if(bits & (0x1<<4)) 
 {
  abox->y1=MAX(abox->y1,cropvlength);
  abox->x0=MAX(abox->x0,regthickness);
 }

 if(bits & (0x4<<4))
 {
  abox->y1=MAX(abox->y1,regthickness);
  abox->x0=MAX(abox->x1,crophlength);
 }


 /* left/bottom */

 if(bits & (0x2<<4))
 {
  abox->y0=MAX(abox->y0,cropvlength);
  abox->x0=MAX(abox->x0,regthickness);
 }

 if(bits & (0x8<<4)) 
 {
  abox->y0=MAX(abox->y0,regthickness);
  abox->x0=MAX(abox->x0,crophlength);
 }


 /* right/top */

 if(bits & (0x1<<8))
 {
  abox->y1=MAX(abox->y1,cropvlength);
  abox->x1=MAX(abox->x1,regthickness);
 }

 if(bits & (0x4<<8)) 
 {
  abox->y1=MAX(abox->y1,regthickness);
  abox->x1=MAX(abox->x1,crophlength);
 }


 /* right/bottom */

 if(bits & (0x2<<8)) 
 {
  abox->y0=MAX(abox->y0,cropvlength);
  abox->x1=MAX(abox->x1,regthickness);
 }

 if(bits & (0x8<<8))
 {
  abox->y0=MAX(abox->y0,regthickness);
  abox->x1=MAX(abox->x1,crophlength);
 }

}



/*

void prdelta(printstr * pr,aboxstr * abox) 
{
 int bits;

 if(pr->regm) bits=pr->marks ^ 0xFFFFFFFF;
 else         bits=0;

 regmsize(bits,abox);
 if(pr->bleed)
 {
  abox->x0=MAX(bleedsize,abox->x0);
  abox->x1=MAX(bleedsize,abox->x1);
  abox->y0=MAX(bleedsize,abox->y0);
  abox->y1=MAX(bleedsize,abox->y1);
 }
}

*/



void praddmarks(aboxstr * r,aboxstr * s,int marks)
{
 aboxstr abox;

 regmsize(marks,&abox);

 r->x0=s->x0-abox.x0;
 r->x1=s->x1+abox.x1;
 r->y0=s->y0-abox.y0;
 r->y1=s->y1+abox.y1;
}




static os_error * regcircle(viewredrawstr * v,int x,int y,int rad)
{
 pathstyle style;
 int       p[35];
 curvestr  c;


 c.type=CELLIPSE;
 c.box.x=x-rad;
 c.box.w=2*rad;
 c.box.y=y-rad;
 c.box.h=c.box.w;

 rcreatepathstyle(&style,0);

 style.thickness=regthickness;

 ellipsepath(p,&c,NULL);

 return(rpathline(p,&style,v,NULL));
}


static os_error * regline(viewredrawstr * v,int x0,int y0,
                                            int x1,int y1)
{
 pathstyle style;
 int       p[10];
 int     * q;

 rcreatepathstyle(&style,0);

 style.thickness=regthickness;

 q=p;

 *q++=DRAWMOVE;
 *q++=x0;
 *q++=y0;
 *q++=DRAWDRAW;
 *q++=x1;
 *q++=y1;
 *q++=DRAWEND;

 return(rpathline(p,&style,v,NULL));
}




#define CROPSIZE   (6*MMSIZE)
#define CROPGAP    (1*MMSIZE)
#define REGRADIUS  (2*MMSIZE)
#define REGGAP     (3*MMSIZE)
#define REGYSHIFT  (REGRADIUS/2+REGGAP)
#define REGXSHIFT  (REGRADIUS/2+REGGAP)
#define REGX       (12*MMSIZE)
#define REGY       (6*MMSIZE)


os_error * pregmarks(viewredrawstr * v,int w,int h,int hand,int bits)
{
 os_error * err;
 int        dble;

 dble=v->view->data.dble;

 err=NULL;


 if(bits) err=render_setgcol(0,0,v);	 /* black */

 /* top */

 if(bits & 0x1)
 {
  regcircle(v,w/2,-reghstandoff,regradius);
  regline(v,w/2-reghlength/2,-reghstandoff,w/2+reghlength/2,-reghstandoff);
  regline(v,w/2,-regvlength/2-reghstandoff,w/2,regvlength/2-reghstandoff);
 }

 /* bottom */


 if(bits & 0x2)
 {
  regcircle(v,w/2,h+reghstandoff,regradius);
  regline(v,w/2-reghlength/2,h+reghstandoff,w/2+reghlength/2,h+reghstandoff);
  regline(v,w/2,h-regvlength/2+reghstandoff,w/2,h+regvlength/2+reghstandoff);
 }

 /* left hand side */

 if((!dble || !hand) && (bits & 0x4))
 {
  regcircle(v,-regvstandoff,h/2,regradius);
  regline(v,-regvstandoff,h/2-reghlength/2,-regvstandoff,h/2+reghlength/2);
  regline(v,-regvstandoff-regvlength/2,h/2,-regvstandoff+regvlength/2,h/2);
 }

 /* right hand side */

 if((!dble || hand) && (bits & 0x8))
 {
  regcircle(v,w+regvstandoff,h/2,regradius);
  regline(v,w+regvstandoff,h/2-reghlength/2,w+regvstandoff,h/2+reghlength/2);
  regline(v,w+regvstandoff-regvlength/2,h/2,w+regvstandoff+regvlength/2,h/2);
 }


 if(!dble || !hand)
 {
  /* left/top */

  if(bits & (0x1<<4)) regline(v,0,-cropvstandoff,0,-cropvlength);
  if(bits & (0x4<<4)) regline(v,-crophstandoff,0,-crophlength,0);

  /* left/bottom */

  if(bits & (0x2<<4)) regline(v,0,h+cropvstandoff,0,h+cropvlength);
  if(bits & (0x8<<4)) regline(v,-crophstandoff,h,-crophlength,h);
 }

 if(!dble || hand)
 {
  /* right/top */

  if(bits & (0x1<<8)) regline(v,w,-cropvstandoff,w,-cropvlength);
  if(bits & (0x4<<8)) regline(v,w+crophstandoff,0,w+crophlength,0);

  /* right/bottom */

  if(bits & (0x2<<8)) regline(v,w,h+cropvstandoff,w,h+cropvlength);
  if(bits & (0x8<<8)) regline(v,w+crophstandoff,h,w+crophlength,h);
 }

 return(err);
}



os_error * predregmarks(viewredrawstr * v,int w,int h,int hand)
{
 return(pregmarks(v,w,h,hand,printermarks(v->file)));
}



