/*->c.prstat */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>
#include <time.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "hourglass.h"
#include "fsx.h"
#include "bf.h"
#include "trans.h"
#include "dbhi.h"


#include "str.h"
#include "constants.h"
#include "object.h"

#include "reslink.h"


#include "view.h"
#include "viewr.h"
#include "file.h"
#include "xxcolour.h"
#include "xcolour.h"
#include "colsep.h"
#include "geometry.h"


#include "prstr.h"
#include "xprint.h"
#include "prjob.h"

#include "prstat.h"



/* handles display of print progress */


int printhg;


static int pstot;
static int pscur; 
static int pspage;
static int psrecord;
static int pscopy;
static int psflag;
static int psplate;
static filestr * psfile;

static int pspause;
static int psmerge;

static int stathandle;




static os_error * statkey(int handle,int userhandle,int icon,int * key) 
{
 if(*key==ESCPRESS) psflag=1;
 else               return(NULL);

 *key=-1;

 return(NULL);

 USE(icon);
 USE(userhandle);
 USE(handle);
}



static os_error * staticon(int handle,int userhandle,wimp_mousestr * m)
{
 switch(m->i)
 {
  case 8: /* pause  */
  case 9: /* cancel */
         psflag=(m->i==9);
         break;
 }

 return(NULL);

 USE(handle);
 USE(userhandle);
}




static os_error * predrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error  * err;
 colourstr * cs;
 int         pal;

 err=NULL;

 while(more)
 {
  redrawslider(redrawstr,7,handle,WIMPGREEN|(WIMPGREY1<<8),pscur,pstot);

  pal=-1;
  if(psplate>=0)
  {
   findcoloursp(psplate,&cs,psfile);
   pal=cs->model.pal;
  }

  redrawblock(redrawstr,handle,11,pal);

  err=wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}


static os_error * predraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=predrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}



static os_error * updatesliders(int icon)
{
 os_error      * err;
 int             more=0;
 wimp_icon       isblock;
 wimp_redrawstr  rblock;

 err=wimp_get_icon_info(stathandle,icon,&isblock);

 rblock.w=stathandle;
 rblock.box=isblock.box;
  
 if(!err) err=wimp_update_wind(&rblock,&more);
 if(!err) err=predrawsub(stathandle,&rblock,more);

 return(err);
}



static os_error * updateslider(void)
{
 os_error      * err;

          err=updatesliders(7);
 if(!err) err=updatesliders(10);

 return(err);
}




/* never used, just to enable zero polls */

static void pszero(int userhandle)
{
 USE(userhandle);
}

static void prpoll(void)
{
 if(printmode==0) poll();
}


static int printpawss(void)
{
 int pausetime=clock();

 bbc_vdu(7);

 writeiconfc(stathandle,8,"{PR05}");

 if(printhg) hourglassoff();

 do 
 {
  psflag=-1;
  while(psflag==-1) prpoll();
 } while(((clock()-pausetime)<1000) && !psflag);

 if(printhg) hourglasson();

 writeiconfc(stathandle,8,"{PR04}");

 return(psflag);
}



int printpaws(void)
{
 if(pspause && printmode==0) return(printpawss());
 return(0);
}



int updatestatpoll(void)
{
 int         i;


 i=5;

 addzeroevent(pszero,0);

 psflag=-1;

 while(i--) 
 {
  prpoll();
  if(psflag!=-1) break;
 }

 remzeroevent(pszero,0);

 if(!psflag) return(printpawss());
 else        return(psflag==1);
}


int updatestat(void)
{
 /* colourstr * cs; */

 if(psmerge) writeiconfc(stathandle,5,"%d",psrecord);
 else        writeiconc(stathandle,5,"-");

 writeiconfc(stathandle,1,"%d",pspage);
 writeiconfc(stathandle,3,"%d",pscopy);

/*
 if(psplate>=0)
 {
  findcoloursp(psplate,&cs,psfile);
  writeiconfc(stathandle,11,"%c",cs->name[0]);
 }
 else
 {
  writeiconc(stathandle,11,"");
 }
*/

 updateslider();

 return(updatestatpoll());
}


int setpspage(int page)
{
 pspage=page;
 return(updatestat());
}


int setpscopy(int copy)
{
 pscopy=copy;
 return(updatestat());
}


int setpsrecord(int record)
{
 psrecord=record;
 return(updatestat());
}



int setpsplate(prjobstr * prjob)
{
 psplate=prjob->doseparations?cscurrentplate(prjob):-1;
 return(updatestat());
}


void pstatinc(int n)
{
 pscur+=n;
}








void closepstat(void)
{
 if(stathandle)
 {
//  closedowncheck(stathandle);

  remkeyevent(statkey,stathandle,0);
  remclickevent(staticon,stathandle,0);
  remredrawevent(predraw,stathandle,0);

  closedown(&stathandle);
 }
}


os_error * openpstat(viewstr * view,filestr * file,printstr * pr)
{
 os_error * err;
 char       string[128];

 psmerge=pr->merge;
 pspause=pr->pause;
 psfile=file;
 psrecord=1;
 psplate=-1;
 pstot=1;
 pscur=0;

 err=tsprintf(sizeof(string),string,"{PR06} %s",fs_leaf(file->name));
 if(!err) err=createwindowtitleparent(TPRINTING,string,&stathandle,view?view->handle:0);
 if(!err)
 {
  addkeyevent(statkey,stathandle,0);
  addclickevent(staticon,stathandle,0);
  addredrawevent(predraw,stathandle,0);

  popup(stathandle,0);

  setfocus(stathandle);

  predraw(stathandle,0);
 }

 return(err);
}


void initpstat(int totpages,int totcopies,int seps)
{
 pstot=totpages*totcopies*seps;
 pscur=0; 
 pspage=1;
 pscopy=1;
 psplate=-1;

 updatestat();
}

