/*->c.dbchars */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"
#include "osunits.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "sp.h"
#include "deb.h"
#include "dbhi.h"


#include "mhi.h"


#include "str.h"
#include "reslink.h"

#include "view.h"
#include "file.h"
#include "dbscale.h"
#include "macros.h"
#include "units.h"


#include "txstr.h"
#include "tx.h"
#include "fox.h"
#include "fx.h"
#include "codes.h"
#include "txchoices.h"
#include "dbstyle.h"
#include "act.h"
#include "styleif.h"
#include "fontmenu.h"
#include "fcache.h"

#include "dbchars.h"



#define NW 32
#define NH 7

#define BACK 4

#define KEYPRESS  15
//#define CHARSELECTION 16
#define CHARSELECTIONTEXT 17
#define GLYPHNAME 20
#define GLYPHCODE 21
#define GLYPHCODEHEX 22


static charclosefn pickclosesub;

static int         xssfont;
static int         xssflags;
static int         xssbold;
static int         xssitalic;

static filestr   * cfile;


extern dboxstr pickcharbox[2];



typedef struct	charselectionstr
{
	char * name;
	int    charset;



}	charselectionstr;


static charselectionstr charselection[]=
{
	"Ovation standard",0,
	"Unicode",0,
	"Western",ANSI_CHARSET,
	"Central Europe",EASTEUROPE_CHARSET,
	"Greek",GREEK_CHARSET,
	"Turkish",TURKISH_CHARSET,
	"Hebrew",HEBREW_CHARSET,
	"Arabic",ARABIC_CHARSET,
	"Baltic",BALTIC_CHARSET,


#ifdef NEVER

0,0x0020,0x007e,"Basic Latin",
1,0x00a0,0x00ff,"Latin-1 Supplement",
2,0x0100,0x017f,"Latin Extended-A",
3,0x0180,0x024f,"Latin Extended-B",
4,0x0250,0x02af,"IPA Extensions",
5,02b0 - 02ff Spacing Modifier Letters 
6,0300 - 036f Combining Diacritical Marks 
7,0370 - 03ff Basic Greek 
8, Reserved  
9,0400 - 04ff Cyrillic 
10,0530 - 058f Armenian 
11,0590 - 05ff Basic Hebrew 
12,Reserved  
13,0600 - 06ff Basic Arabic 
14,Reserved  
15,0900 - 097f Devanagari 
16,0980 - 09ff Bengali 
17,0a00 - 0a7f Gurmukhi 
18,0a80 - 0aff Gujarati 
19,0b00 - 0b7f Oriya 
20,0b80 - 0bff Tamil 
21,0c00 - 0c7f Telugu 
22,0c80 - 0cff Kannada 
23,0d00 - 0d7f Malayalam 
24,0e00 - 0e7f Thai 
25,0e80 - 0eff Lao 
26,10a0 - 10ff Basic Georgian 
27,  Reserved  
28,1100 - 11ff Hangul Jamo 
29,1e00 - 1eff Latin Extended Additional 
30,1f00 - 1fff Greek Extended 
31,2000 - 206f General Punctuation 
32,2070 - 209f Subscripts and Superscripts 
33,20a0 - 20cf Currency Symbols 
34,20d0 - 20ff Combining Diacritical Marks for Symbols 
35,2100 - 214f Letter-like Symbols 
36,2150 - 218f Number Forms 
37,2190 - 21ff Arrows 
38,2200 - 22ff Mathematical Operators 
39,2300 - 23ff Miscellaneous Technical 
40,2400 - 243f Control Pictures 
41,2440 - 245f Optical Character Recognition 
42,2460 - 24ff Enclosed Alphanumerics 
43,2500 - 257f Box Drawing 
44,2580 - 259f Block Elements 
45,25a0 - 25ff Geometric Shapes 
46,2600 - 26ff Miscellaneous Dingbats 
47,2700 - 27bf Dingbats 
48,3000 - 303f Chinese, Japanese, and Korean (CJK) Symbols and Punctuation 
49,3040 - 309f Hiragana 
50,30a0 - 30ff Katakana 
51,3100 - 312f Bopomofo 
52,3130 - 318f Hangul Compatibility Jamo 
53,3190 - 319f CJK Miscellaneous 
54,3200 - 32ff Enclosed CJK Letters and Months 
55,3300 - 33ff CJK Compatibility 
56,ac00 - d7a3 Hangul 
57,d800 - dfff Surrogates  
58,   Reserved  
59,4e00 - 9fff CJK Unified Ideographs 
60,e000 - f8ff Private Use Area 
61,f900 - faff CJK Compatibility Ideographs 
62,fb00 - fb4f Alphabetic Presentation Forms 
63,fb50 - fdff Arabic Presentation Forms-A 
64,fe20 - fe2f Combining Half Marks 
65,fe30 - fe4f CJK Compatibility Forms 
66,fe50 - fe6f Small Form Variants 
67,fe70 - fefe Arabic Presentation Forms-B 
68,ff00 - ffef Halfwidth and Fullwidth Forms 
69,fff0 - fffd Specials 
70,0f00 - 0fcf Tibetan 
71,0700 - 074f Syriac 
72,0780 - 07bf Thaana 
73,0d80 - 0dff Sinhala 
74,1000 - 109f Myanmar 
75,1200 - 12bf Ethiopic 
76,13a0 - 13ff Cherokee 
77,1400 - 14df Canadian Aboriginal Syllabics 
78,1680 - 169f Ogham 
79,16a0 - 16ff Runic 
80,1780 - 17ff Khmer 
81,1800 - 18af Mongolian 
82,2800 - 28ff Braille 
83,a000 - a48c Yi 
84-122   Reserved  


#endif


};



#define S_OVATION 0
#define S_UNICODE 1



static int currentselection=0;

static int charselectionn=sizeof(charselection)/sizeof(charselectionstr);

static int nrows=NH;
static int rowshift=0;

static int xselection;
static int yselection;
static int pickfocusn;


#define CXBACK   PALTRANSPARENT
#define CXFRONT  PALBLACK



static os_error * setpaneextent(void)
{
	os_error * err;
	windowstr  window;
	iconstr    icon;
	int        dy;

 geti(pickcharbox[0].handle,BACK,&icon);

	err=getw(pickcharbox[1].handle,&window);

 dy=(icon.iy1-icon.iy0)/NH;

 extent(pickcharbox[1].handle,0,-(nrows)*dy,icon.ix1-icon.ix0,0);
 reopenw(pickcharbox[1].handle);

	return(err);
}



#ifdef NEVER

static os_error * setuprows(void)
{
	os_error * err;
 int        xssosfont;
	int        nglyph;
	int      * glyphs;
	int        i;
	int        lastrow;
	int        start;
	int        end;
	int        startrow;
	int        endrow;
	int        row;
	int        n;

	err=NULL;

 if(currentselection==S_UNICODE)
	{
  xssosfont=fontosfromuser(xssfont);

  nglyph=fontglyphs(xssosfont,&glyphs);

 	lastrow=-1;
 	n=0;

 	for(i=0;i<nglyph;i++)
 	{
 		start=glyphs[i*2];
 		end=start+glyphs[i*2+1]-1;

//		cprintf("start %d end %d",start,end);

 		startrow=start/32;
 		endrow=end/32;

 		if(startrow>lastrow) row=startrow;
 		else																	row=startrow+1;

 		while(row<=endrow)
 		{
 			n++;
 		 lastrow=row;
 			row++;
 		}
		}

		nrows=n;
	}
	else
	{
		nrows=NH;
	}

	return(err);
}




static int rowcode(int index)
{
	os_error * err;
 int        xssosfont;
	int        nglyph;
	int      * glyphs;
	int        i;
	int        lastrow;
	int        start;
	int        end;
	int        startrow;
	int        endrow;
	int        row;
	int        n;

	err=NULL;

 xssosfont=fontosfromuser(xssfont);
 nglyph=fontglyphs(xssosfont,&glyphs);

	lastrow=-1;
	n=0;

	for(i=0;i<nglyph;i++)
	{
		start=glyphs[i*2];
		end=start+glyphs[i*2+1]-1;

//		cprintf("start %d end %d",start,end);

		startrow=start/32;
		endrow=end/32;

		if(startrow>lastrow) row=startrow;
		else																	row=startrow+1;

		while(row<=endrow)
		{
			if(index==n) return(row*32);
			n++;
		 lastrow=row;
			row++;
		}
	}


	return(0);
}


#endif






static os_error * setuprows(void)
{
	os_error * err;
 int        xssosfont;
	int        nglyph;
	int      * glyphs;
	int        i;
	int        n;

	err=NULL;

 if(currentselection==S_UNICODE)
	{
  xssosfont=fontosfromuser(xssfont);

  err=fontglyphs(xssosfont,&glyphs,&nglyph);

 	n=0;

 	for(i=0;i<nglyph;i++)
 	{
 		n+=glyphs[i*2+1];
		}

// how many glyphs < 32?		- mess about to not display glyphs < 32

		rowshift=0;

 	for(i=0;i<nglyph;i++)
 	{
			if(glyphs[i*2]>31) break;
			if((glyphs[i*2]+glyphs[i*2+1]-1)<32) rowshift+=glyphs[i*2+1];
			else
			{
				rowshift+=32-glyphs[i*2];
				break;
			}
		}


		n-=rowshift;

//		cprintf("ntot %d %x",n,n);

		nrows=(n+(NW-1))/NW;

//		cprintf("ntot %d %x nrows %d",n,n,nrows);

	}
	else
	{
		nrows=NH;
	}

	return(err);
}





static os_error *	makerow(int row,wchar_t ** pp,int * map)
{
	os_error * err;
 int        xssosfont;
	int        nglyph;
	int      * glyphs;
	int        i;
	int        j;
	int        n;
	wchar_t  * p;

	p=*pp;

	j=0;

 xssosfont=fontosfromuser(xssfont);

 err=fontglyphs(xssosfont,&glyphs,&nglyph);
	if(!err && nglyph!=NULL)
	{
 	n=row*NW+rowshift;
 	i=0;

 	while(1)
 	{
 		n-=glyphs[i*2+1];
 		if(n<0) break;
 		i++;
 		if(i>=nglyph) break;
 	}

 	if(i<nglyph)
 	{
 		n=glyphs[i*2+1]+n;		// starting number

 		while(j<NW)
 		{
 			*p++=(wchar_t)(glyphs[i*2]+n);
 			map[j++]=1;
 			n++;
 			if(n>=glyphs[i*2+1])
 			{
 				n=0;
 				i++;
 				if(i>=nglyph) break;
 			}
 		}
 	}
	}

/*
	wchar_t * q=*pp;
 cprintf("%x %x %x %x %x %x %x %x %x",q[0],q[1],q[2],q[3],q[4],q[5],q[6],q[7]);
	q+=8;
 cprintf("%x %x %x %x %x %x %x %x %x",q[0],q[1],q[2],q[3],q[4],q[5],q[6],q[7]);
*/
	while(j<NW)
	{
		map[j++]=0;
	}

	*pp=p;

	return(err);
}



static os_error *	getunicode(int index,int * c16)
{
	os_error * err;
 int        xssosfont;
	int        nglyph;
	int      * glyphs;
	int        i;



	*c16=-1;

 xssosfont=fontosfromuser(xssfont);

 err=fontglyphs(xssosfont,&glyphs,&nglyph);
	if(!err && nglyph!=NULL)
	{
 	i=0;

		index+=rowshift;

 	while(1)
 	{
 		index-=glyphs[i*2+1];
 		if(index<0) break;
 		i++;
 		if(i>=nglyph) break;
 	}

 	if(i<nglyph)
 	{
 		*c16=glyphs[i*2]+(glyphs[i*2+1]+index);
 	}
	}

	return(err);
}




static os_error *	getindex(int * indexp,int c16)
{
	os_error * err;
 int        xssosfont;
	int        nglyph;
	int      * glyphs;
	int        i;
	int        index;


	index=-1;

 xssosfont=fontosfromuser(xssfont);

 err=fontglyphs(xssosfont,&glyphs,&nglyph);
	if(!err && nglyph!=NULL)
	{
 	i=0;

		index=-rowshift;

 	while(1)
 	{
			if(c16>=glyphs[i*2] && c16<(glyphs[i*2]+glyphs[i*2+1]))
			{
				index+=c16-glyphs[i*2];
				break;
			}

 		index+=glyphs[i*2+1];

 		i++;
 		if(i>=nglyph)
   {
				index=-1;
    break;
			}
 	}
	}

	*indexp=index;

	return(err);
}







static os_error * setupselection(void)
{
	int xssosfont;
	int grey;
	int change;

	grey=0;
	change=0;

	if(txunicode && cfile->compatability>=UNICOMPAT)
	{
  xssosfont=fontosfromuser(xssfont);

  if(fontcharset(xssosfont)==SYMBOL_CHARSET)
		{
		 currentselection=S_OVATION;
			change=1;
			grey=1;
		}


	}
	else
	{
		currentselection=S_OVATION;
		change=1;
		grey=1;
	}

//	shadeiconst(pickcharbox[0].handle,CHARSELECTION,grey);
	shadeiconst(pickcharbox[0].handle,CHARSELECTIONTEXT,grey);

	if(change) dbchangevalue(&currentselection,pickcharbox);

	return(NULL);
}



static int pickblank;


static os_error * pickredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error  * err;
 windowstr   window;
 int         dx;
 int         dy;
 int         ox;
 int         oy;
 int         xlo;
 int         xhi;
 int         ylo;
 int         yhi;
 int         x;
 int         y;
 int         ny;
 int         fh;
 wchar_t     string[NW*2+4];
 wchar_t   * p;
 char      * q;
 int         i;
 int         c;
 int         shift;
 int         yshift;
 int         tabs[NW*2+1]; // allow for codes to expand to 2 each
 font_metric metric;
 font_string fs;
 int         dx1;
 int         uni;
 int         flags;
 int         xssosfont;
 int         n;
 int         map[NW];
 int         len=0;



 err=NULL;

	if(more)
	{
  uni=txunicode;
 
  getw(handle,&window);
  dx=(window.x1-window.x0)/NW;
  dy=(window.y1-window.y0)/NH;

// cprintf("xssfont %d",xssfont);

  xssosfont=fontosfromuser(xssfont);

		if(ISW9X)
		{
   err=font_find4(fontosname(xssosfont),fontcharset(xssosfont),0,
                 fontitalic(xssosfont),fontfamily(xssosfont),fontpitch(xssosfont),0,(12*cvdu.ydpi)/72,0,&fh);
		}
		else
		{
   err=font_find4(fontosname(xssosfont),fontcharset(xssosfont),fontweight(xssosfont),
                 fontitalic(xssosfont),fontfamily(xssosfont),fontpitch(xssosfont),0,(12*cvdu.ydpi)/72,0,&fh);
		}

  if(!err)
  {
   font_setcolour(fh,CXBACK,CXFRONT,0);
   font_align(FA_LEFT|FA_BASELINE);
   font_getmetric(&metric);

   yshift=ypix2os(metric.descent)+(dy-ypix2os(metric.height))/2;

//  cprintf("desc %d height %d dy %d",metric.descent,metric.height,dy);

   while(more)
   {
    ox=redrawstr->box.x0-redrawstr->scx;
    oy=redrawstr->box.y1-redrawstr->scy;

//    wimp_setcolour(WIMPWHITE);
//    bbc_rectanglefill(ox+icon.ix0,oy+icon.iy0,icon.ix1-icon.ix0,
//                                              icon.iy1-icon.iy0);

    ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
    ylo=(ylo)/dy;
    if(ylo<0) ylo=0;
    ny=ylo;
    ylo=dy*ylo;

//				cprintf("ny %d",ny);

    yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */
    yhi=(yhi)/dy;
    if(yhi<0) yhi=0;
    if(yhi>(nrows)) yhi=(nrows);
    yhi=dy*(yhi+1);

    xlo=((redrawstr->g.x0-ox)/dx);
    if(xlo<0) xlo=0;
    xlo=dx*xlo;
    xhi=((redrawstr->g.x1-ox)/dx);
    if(xhi>31) xhi=31;
    xhi=(xhi+1)*dx;

    if(xlo<xhi && ylo<yhi)
    {
					if(pickblank)
					{
      wimp_setcolour(WIMPWHITE);
						bbc_rectanglefilli(ox+xlo,oy-ylo,xhi-xlo,-(yhi-ylo));
					}

     wimp_setcolour(WIMPBLACK);

     for(x=xlo;x<=xhi;x+=dx)
     {
      bbc_move(ox+x,oy-ylo);
      bbc_draw(ox+x,oy-yhi);
     }

     for(y=ylo;y<=yhi;y+=dy)
     {
      bbc_move(ox+xlo,oy-y);
      bbc_draw(ox+xhi,oy-y);
     }

     for(y=ylo;y<=yhi;y+=dy)
     {
      if(ny<=nrows && ny>0)
      {
       if(uni)
       {
								if(currentselection==S_UNICODE)
								{
         p=string;
									makerow(ny-1,&p,map);
								}
								else
								{
         p=string;
         shift=0;
         for(i=0;i<NW;i++) 
         {
          c=ny*NW+i;
										if(currentselection==S_OVATION)
										{
           if(fontcharset(xssosfont)==SYMBOL_CHARSET) c=code8symbolinv(c);
           fontgetcode16(c,xssosfont,p,&n);
										}
										else
										{
											*p=(wchar_t)code16wincharset(c,charselection[currentselection].charset);
											n=1;
										}
          map[i]=n;
          p+=n;
         }
								}
        *p=0;
        len=((char*)p)-((char*)string);
       }
       else
       {
        q=(char*)string;
        shift=0;
        for(i=0;i<NW;i++) 
        {
         c=ny*NW+i;
         if(fontcharset(xssosfont)==SYMBOL_CHARSET) c=code8symbolinv(c);
         fontgetcode8(c,xssosfont,q,&n);
         map[i]=n;
         q+=n;
        }
        *q=0;
        len=((char*)q)-((char*)string);
       }


       fs.s=(char*)string;
       fs.term=len;
       fs.x=0;
       fs.y=0;

//      if(uni) font_placement16((font_string16*)&fs,tabs,0);
//      else    font_placement((font_string*)&fs,tabs,0);

       flags=0;
       if(uni) flags|=FPWCS;
       fontplacement(xssosfont,(10*cvdu.xdpi)/72,(10*cvdu.ydpi)/72,&fs,tabs+1,flags,0,0);

							int cdx;
							int ndx;
       int ct;
       int cwidth;
       int j;

 						ndx=xos2pix(ox+(1)*dx)-xos2pix(ox+(0)*dx);
//						 dx1=(ndx-map[0])/2;;

       ct=1;
       tabs[0]=0;
       for(i=0;i<NW;i++)
       {
//								cprintf("tabs[%d] %d",i,tabs[i]);
        cdx=ndx;
 							ndx=xos2pix(ox+(i+2)*dx)-xos2pix(ox+(i+1)*dx);

        if(map[i])
        {
         cwidth=0;
         for(j=0;j<map[i];j++) cwidth+=tabs[ct+j];
         tabs[ct-1]+=(cdx-cwidth)/2;
         tabs[ct+j-1]+=(cdx-cwidth)-(cdx-cwidth)/2;

//  							map[i]=cdx-(cdx-map[i])/2+(ndx-map[i+1])/2;
         ct+=map[i];
        }
        else
        {
         tabs[ct-1]+=cdx;
        }
       }

       dx1=tabs[0];

       if(uni)
       {
								if(currentselection==S_UNICODE)
								{
 								for(i=0;i<NW;i++)
 								{
 									fxfont_paintextsymbol(xssosfont,&string[i],1,font_ABS|font_OSCOORDS,ox+xpix2os(dx1),oy-y+yshift,NULL,tabs+1);
 									dx1+=tabs[i+1];
 								}
								}
								else
								{
 								fxfont_paintextsymbol(xssosfont,string,len/2,font_ABS|font_OSCOORDS,ox+xpix2os(dx1),oy-y+yshift,NULL,tabs+1);
								}
//        font_paintext16(string,len/2,font_ABS|font_OSCOORDS,ox+icon.ix0+xpix2os(dx1),oy-y+yshift,NULL,tabs+1);
							}
       else
       {
        font_paintext((char*)string,len,font_ABS|font_OSCOORDS,ox+xpix2os(dx1),oy-y+yshift,NULL,tabs+1);
							}
      }
      ny++;
     }

					if(xselection<=(xhi/dx) && xselection>=(xlo/dx)	&& yselection>=(ylo/dy) && yselection<=(yhi/dy))
					{
      seteorcol(WIMPWHITE,WIMPBLACK);
						bbc_rectanglefilli(ox+xselection*dx,oy-yselection*dy,dx,-dy);

      if(pickfocusn)
      {
//       wimp_setcolour(WIMPWHITE);
//       wimp_setcolour(0xF0+WIMPBLACK);
       bbc_setstyle(1);
       bbc_rectanglei(ox+xselection*dx,oy-yselection*dy,dx,-dy);
      }
					}
    }

    wimp_get_rectangle(redrawstr,&more);
   }

   font_lose(fh);
  }
	}

 return(err);
}


static os_error * pickredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) pickredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}



static void pickrefreshblock(int handle,int x,int y)
{
 wimp_redrawstr r;
 int            more;
	int            dx;
	int            dy;
	windowstr      window;


 getw(handle,&window);
 dx=(window.x1-window.x0)/NW;
 dy=(window.y1-window.y0)/NH;

 r.box.x0=dx*x-cvdu.extrax;
 r.box.x1=r.box.x0+dx+cvdu.extrax;
 r.box.y1=-dy*y+cvdu.extray;
 r.box.y0=r.box.y1-dy-cvdu.extray;

 r.w=handle;

 wimp_update_wind(&r,&more);

	pickblank=1;
 pickredrawsub(handle,&r,more);
	pickblank=0;
}




static os_error * pickopeny(int handle,int y)
{
 wimp_wstate wblock;
 int         top;
 int         bot;
	int         dy;

 wimp_get_wind_state(handle,&wblock);

 dy=(wblock.o.box.y1-wblock.o.box.y0)/NH;

 top=-(y*dy);
 bot=-((y+1)*dy);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

 return(wimp_open_wind(&wblock.o));
}



static os_error * picksetselection(int x,int y)
{
	int xp;
	int yp;

	xp=xselection;
	yp=yselection;
	xselection=yselection=-1;
 pickrefreshblock(pickcharbox[1].handle,xp,yp);
	xselection=x;
	yselection=y;

 pickrefreshblock(pickcharbox[1].handle,xselection,yselection);

	return(NULL);
}



static int   currpointerx;
static int   currpointery;



static int pickxytocode(int x,int y)
{
	int c16;
	int charset;
	int n;

 if(x>=0 && x<NW && y>=0 && y<nrows)
 {
  n=x+y*NW;

 	if(currentselection==S_UNICODE)
 	{
 		getunicode(n,&n);
 	}
 	else
 	if(currentselection==S_OVATION)
 	{
 		n+=NW;

 		charset=fontcharset(fontosfromuser(xssfont));
   if(charset==SYMBOL_CHARSET) n=code8symbolinv(n);
 	}
 	else
 	{
 		n+=NW;
 	 c16=code16wincharset(n,charselection[currentselection].charset);
 		n=code16inv(c16);
 		if(n<0) n=c16;
 	}
	}
	else
	{
		n=-1;
	}

	return(n);
}



// c16 == unicode
// c			== what you have to type

static void pickcodetodata(int n,int & c,int & c16)
{
	int charset;

 if(n>0)
 {
  charset=fontcharset(fontosfromuser(xssfont));

		if(currentselection==S_UNICODE)			// n is a pure unicode
		{
			c16=n;
			c=code16inv(c16);													// RISC OS code
			if(c>0)	c=code8symbol(c);					//	Win code
		}
		else
		if(currentselection==S_OVATION)		// n is a RISC OS charset number
		{
   c=code8symbol(n);

   if(charset==SYMBOL_CHARSET)
			{

			}
			else
 		if(charset==ANSI_CHARSET)
   {
    c16=code16(n);
   }
   else
   {
    c16=code16wincharset(n,charset);
   }
		}
		else																												// n is either a RISC OS number or a unicode
		{
		 c16=code16(n);
			c=code16inv(c16);
			if(c>0)	c=code8symbol(c);
		}
	}
	else
	{
		c=c16=-1;
	}

}



static int getptrchar(int * xp,int * yp)
{
 windowstr window;
 int       dx;
 int       dy;
 mousestr  mouse;
 int       x;
 int       y;

 getw(pickcharbox[1].handle,&window);


 dx=(window.x1-window.x0)/NW;
 dy=(window.y1-window.y0)/NH;

 getpointer(&mouse);

 x=(mouse.x-window.bx);
 x/=dx;
	if(x<0) x=0;
	if(x>=NW) x=NW-1;

 y=(window.by-mouse.y);
 y/=dy;
	if(y<0) y=0;
	if(y>=nrows) y=nrows-1;

	if(xp) *xp=x;
	if(yp) *yp=y;

 return(pickxytocode(x,y));
}




static os_error * pickkeypress(int c)
{
 char     temp[32];
 char  *  keystring=NULL;
	int      ccode;

 ccode=keypressfromchar(c);
 if(ccode==KEYNONE)
 {
  if(c==127) keystring="Ctrl+backspace";
  else
  if(c==-1)
  {
//     sprintf(temp,"U+0x%x",c16);
			*temp=0;
   keystring=temp;
  }
  else
  if(c<128)
  {
   sprintf(temp,"%c",c);
   keystring=temp;
  }
  else
  if(c<256)
  {
   sprintf(temp,"Alt+0%d",c);
   keystring=temp;
  }
 }
 else
 {
//    sprintf(temp,"%s (0%d)",keystringcanonical(ccode),c);
  sprintf(temp,"%s",keystringcanonical(ccode));
  keystring=temp;
 }

 return(writeicon(pickcharbox[0].handle,KEYPRESS,keystring));
}


static int	pickeditskip;


static os_error * pickwritedata(int icon,int c,int c16)
{
	int charset;

	pickeditskip=1;

 charset=fontcharset(fontosfromuser(xssfont));

 if(charset==SYMBOL_CHARSET)
 {
  if(icon!=GLYPHNAME) writeicon(pickcharbox[0].handle,GLYPHNAME,"");
  if(icon!=GLYPHCODE)
  {
   if(c<0)	writeiconf(pickcharbox[0].handle,GLYPHCODE,"");
   else    writeiconf(pickcharbox[0].handle,GLYPHCODE,"%d",c);
		}
  if(icon!=GLYPHCODEHEX)
  {
   if(c<0)	writeiconf(pickcharbox[0].handle,GLYPHCODEHEX,"");
   else    writeiconf(pickcharbox[0].handle,GLYPHCODEHEX,"#%x",c);
		}
	}
	else
	{
  if(icon!=GLYPHNAME)
  {
   if(c16<0)	writeicon(pickcharbox[0].handle,GLYPHNAME,"");
   else      writeicon(pickcharbox[0].handle,GLYPHNAME,macrofindglyphname(c16));
		}
  if(icon!=GLYPHCODE)
  {
   if(c16<0)	writeiconf(pickcharbox[0].handle,GLYPHCODE,"");
   else      writeiconf(pickcharbox[0].handle,GLYPHCODE,"%d",c16);
		}
  if(icon!=GLYPHCODEHEX)
  {
   if(c16<0)	writeiconf(pickcharbox[0].handle,GLYPHCODEHEX,"#");
   else      writeiconf(pickcharbox[0].handle,GLYPHCODEHEX,"#%x",c16);
		}
	}

	pickeditskip=0;

	return(NULL);
}



static os_error * pointerfn(wimp_w handle,int userhandle,wimp_mousestr * mx)
{
 int      n;
 int      c;
 int      c16=0;
	int      x;
	int      y;


// cprintf("pointerfn");

 n=getptrchar(&x,&y);

 if(x!=currpointerx || y!=currpointery)
 {
  pickcodetodata(n,c,c16);
   
			// c16 == unicode
			// c			== what you have to type

  pickkeypress(c);
		pickwritedata(-1,c,c16);
  picksetselection(x,y);


  currpointerx=x;
		currpointery=y;
 }

 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(mx);
}



static os_error * pickeditupdate(wimp_w handle,int icon,uservalue userhandle)
{
	os_error * err;
	TCHAR      string[256];
	int        value;
	int        c;
	int        charset;
	int        x;
	int        y;
	int        n;
	int        c16;

	err=NULL;

	if(!pickeditskip)
	{
 	cprintf("edit update %d",icon);

		value=-1;

		readicon(handle,icon,string,sizeof(string));

 	if(icon==GLYPHCODE)
 	{
			err=stringtonumber(string,&value);

 	}
 	else
 	if(icon==GLYPHCODEHEX)
 	{
			err=stringtonumber(string,&value);
 	}
 	else
 	if(icon==GLYPHNAME)
 	{
			value=macrofindnearestglyph(string);
	 }

		if(err==NULL && value>=0)
		{
			c=-1;
   charset=fontcharset(fontosfromuser(xssfont));

			if(currentselection==S_UNICODE)
			{
				getindex(&c,value);
//				cprintf("getindex %d c %d",value,c);
			}
			else
			if(currentselection==S_OVATION)		// n is a RISC OS charset number
			{
    if(charset==SYMBOL_CHARSET)
 			{
					c=value;
					c-=NW;
 			}
 			else
	 		if(charset==ANSI_CHARSET)
    {
 				c=code16inv(value);													// unicode -> RISC OS code
					c-=NW;
    }
    else
    {
 				c=code16winindexcharset(value,charset);		// unicode -> Win code
     if(c>0)	c=code8symbolinv(c);   	         //	Win code -> RISC OS code
 				c-=NW;
    }
			}
			else																												
			{
				c=code16winindexcharset(value,charset);		// unicode -> Win code
				c-=NW;
			}


			if(c>=0)
			{
				x=c % NW;
				y=c/NW;

				picksetselection(x,y);


    n=pickxytocode(x,y);
    pickopeny(pickcharbox[1].handle,y);

    pickcodetodata(n,c,c16);
   
	 		// c16 == unicode
	 		// c			== what you have to type
				// c16 should be == value

    pickkeypress(c);

				pickwritedata(icon,c,c16);
			}
		}
		else
		{
			err=NULL;
		}
 }

	return(err);

	USE(userhandle);
}








static os_error * pickpanekey(int handle,int userhandle,int icon,int * key)
{
 int ch;
 int x;
	int y;
	int n;
	int c;
	int c16;
	int next;


 ch=*key;

 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(pickcharbox[0].handle,pickcharbox[1].handle,ch==SHFT_TAB,&next);
  setfocusicon(pickcharbox[0].handle,next);
  *key=-1;
		return(NULL);
 }



	x=xselection;
	y=yselection;


	if(ch==CLEFT)
	{
		x--;
		if(x<0)
		{
			x=NW-1;
			y--;
			if(y<0) y=nrows-1;
		}
	}
	else
	if(ch==CRIGHT)
	{
		x++;
		if(x>=NW)
		{
			x=0;
			y++;
			if(y>=nrows) y=0;
		}
	}
	else
	if(ch==CUP)
	{
		y--;
		if(y<0) y=nrows-1;
	}
	else
	if(ch==CDOWN)
	{
		y++;
		if(y>=nrows) y=0;
 }
 else
 if(ch==HOME)
 {
		x=0;
	}
	else
	if(ch==COPY)
	{
		x=NW-1;
	}
	else
 {
 	return(NULL);
	}


	*key=-1;

	picksetselection(x,y);
 pickopeny(pickcharbox[1].handle,y);
 n=pickxytocode(x,y);
 pickcodetodata(n,c,c16);
 pickkeypress(c);
	pickwritedata(-1,c,c16);


 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}




static os_error * pickkey(int handle,int userhandle,int icon,int * key)
{
 int ch;
 int x;
	int y;
	int n;
	int c;
	int c16;


 ch=*key;


	x=xselection;
	y=yselection;


	if(ch==CDOWN)
	{
		x--;
		if(x<0)
		{
			x=NW-1;
			y--;
			if(y<0) y=nrows-1;
		}
	}
	else
	if(ch==CUP)
	{
		x++;
		if(x>=NW)
		{
			x=0;
			y++;
			if(y>=nrows) y=0;
		}
	}
	else
 {
 	return(NULL);
	}


	*key=-1;

	picksetselection(x,y);
 pickopeny(pickcharbox[1].handle,y);
 n=pickxytocode(x,y);
 pickcodetodata(n,c,c16);
 pickkeypress(c);
	pickwritedata(-1,c,c16);


 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}









static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;


 err=NULL;

// cprintf("gain %d",gain);

 if(gain)
 {
  pickfocusn=1;
 }
 else
 {
  pickfocusn=0;
 }

 pickrefreshblock(handle,xselection,yselection);

 return(err);

 USE(userhandle);
}







static os_error * pickclose(int code)
{
 os_error    * err;
	int           n;
 xstylestr     style;


 err=NULL;

//	cprintf("pickclose %d",code);

 if(code==DBOK || code==DBAPPLY)
 {
		n=pickxytocode(xselection,yselection);

  if(n && pickclosesub)
  {
   memset(&style,0,sizeof(xstylestr));
   style.data.font=xssfont;
   style.data.bold=xssbold;
   style.data.italic=xssitalic;
   style.action.font=1;
   style.action.bold=1;
   style.action.italic=1;
   
   err=pickclosesub(n,&style);
  }
 }

 if(!err && code!=DBAPPLY) 
 {
  remmousemoveevent(pointerfn,pickcharbox[1].handle,0);
  remeditevent(pickeditupdate,pickcharbox[0].handle,0);
  remcaretevent(panecaret,pickcharbox[1].handle,0);
  err=remkeyeventicon(pickcharbox[0].handle,GLYPHNAME);
  err=remkeyeventicon(pickcharbox[0].handle,GLYPHCODE);
  err=remkeyeventicon(pickcharbox[0].handle,GLYPHCODEHEX);

 }

 return(err);
}






static os_error * chsetfont2(int sfont,int sub)
{
 int            italic;
 int            bold;

 if(sub<0) 
 {
  xssfont=fontuserfromstyle(sfont,xssbold,xssitalic);
//  cprintf("xssfont %d bold %d italic %d",xssfont,xssbold,xssitalic);
 
 }
 else      
 {
  xssfont=ifont(sfont)+sub;
  finduserfontstyle(xssfont,&bold,&italic);

  if(bold!=xssbold)
  {
   xssbold=bold;
   dbchangevalue(&xssbold,pickcharbox);
  }

  if(italic!=xssitalic)
  {
   xssitalic=italic;
   dbchangevalue(&xssitalic,pickcharbox);
  }
 }

	setupselection();
	setuprows();
	setpaneextent();
	refreshwindow(pickcharbox[1].handle);

 return(dbchangevalue(&xssfont,pickcharbox));
}



static os_error * chsetfont(int font)
{
 return(chsetfont2(font,-1));
}







static os_error * cstyle(int handle,int userhandle,wimp_mousestr * m)
{
 chsetfont(ufont(xssfont));
 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * chgetfont(int * sfont) 
{
 *sfont=ufont(xssfont);
 return(NULL);
}


static os_error * chgetfont2(int * sfont)
{
 *sfont=xssfont-ifont(ufont(xssfont));
 return(NULL);
}



static char xssfontname[SSNAMELEN];


os_error * charsfont(int pass)
{
 int newfont;

 if(pickcharbox[0].handle)
 {
  if(pass)
  {
   xssfont=newfont=findxuserfontstyle(xssfontname,&xssbold,&xssitalic);
   if(xssfont<0) xssfont=0;

   dbchangevalue(&xssbold,pickcharbox);
   dbchangevalue(&xssitalic,pickcharbox);
   if(newfont<0) chsetfont(ufont(xssfont));
  }
  else
  {
   xzstrncpy(xssfontname,fontidentifieri(xssfont),sizeof(xssfontname));
  }
 }
 return(NULL);
}





static os_error * pickicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
// int        n;
// xstylestr  style;

 err=NULL;

 if(m->bbits==0x4 || m->bbits==0x1)
 {
/*
  n=getptrchar(NULL,NULL);
  if(n && pickclosesub)
  {
   memset(&style,0,sizeof(xstylestr));
   style.data.font=xssfont;
   style.data.bold=xssbold;
   style.data.italic=xssitalic;
   style.action.font=1;
   style.action.bold=1;
   style.action.italic=1;
   
   err=pickclosesub(n,&style);
  }
*/
  if(m->bbits==0x4) dbclose(pickcharbox,DBOK);
		else
  if(m->bbits==0x1) dbclose(pickcharbox,DBAPPLY);
 }

 return(err);

 USE(handle);
 USE(userhandle);
}






void setcharselection(int fp)
{
 int        i;

 i=stack[fp];

 if(i>=0 && i<charselectionn && i!=currentselection)
 {
  currentselection=i;

		setuprows();
  setpaneextent();
  refreshwindow(pickcharbox[1].handle);
  dbchangevalue(&currentselection,pickcharbox);
 }
}



int getcharselection(int fp)
{
 int i;

 i=stack[fp];
 if(i<charselectionn)
 {
  assignstring(stack[fp+1],charselection[i].name);
  return(1);
 }

 return(0);
}



int iscurrentcharselection(int fp)
{
 return(stack[fp]==currentselection);
}




static os_error * pickbaseicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;


 err=NULL;

 if(m->i==11)            err=openfontmenu(chsetfont,chsetfont2,chgetfont,chgetfont2,handle);
//	else
//	if(m->i==CHARSELECTION) err=openmenuparent("charselection_menu",handle);

 return(err);

 USE(handle);
 USE(userhandle);
}



/*
static os_error * xwrselection(int value,char * string)
{
 if(value>=0) strcpy(string,charselection[value].name);
 else         *string=0;
 return(NULL);
}

*/


static os_error * xwrfont(int value,char * string)
{
 if(value>=0) strcpy(string,fontlocalnamei(value));
 else         *string=0;
 return(NULL);
}


static os_error * charscombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

	cprintf("chart combo");

 err=menucombo(pickcharbox,CHARSELECTIONTEXT,"charselection_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);

	return(NULL);
}






static dbiconstr pickicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

   10, &xssfont,    DBTEXT,   0,    0,     -1, -1, -1, -1, NULL, xwrfont,

   12, &xssbold,    DBTOGGLE, 0,    0,      1,  F2, 0, 0,(dbreadfn)cstyle,0,
   13, &xssitalic,  DBTOGGLE, 0,    0,      1,  F3, 0, 0,(dbreadfn)cstyle,0,

// CHARSELECTIONTEXT,	&currentselection,DBTEXT,0,  0,     -1, -1, -1, -1, NULL, xwrselection,
 CHARSELECTIONTEXT,	&currentselection,DBCOMBO,0,  DBCOMBOSTATIC,    -1, -1, -1, -1, NULL, (dbwritefn)charscombo,


    2, NULL,        DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
				1,	NULL,			     DBACTION, 0,   0,      DBOK,RETURN,0,0 ,NULL ,0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr pickcharbox[2]=
{
 0,
 TCHARS,
 DBFIX,
 0,
 pickclose,
 pickbaseicon,
 pickkey,
 NULL,
 pickicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

 0,
 TCHARSP,
 DBPANE,
 DBFITICON,
	NULL,
 pickicon,
 pickpanekey,
 pickredraw,
 NULL,
 0,
 0,
 0,NULL,
 0,
 BACK,

};



os_error * pickchar(charclosefn close,dboxstr * parent,int ifont,int flags,int parenthandle,filestr * file)
{
 os_error * err;
 int        washandle;
 iconstr    icon;
	windowstr  window;
	int        n;
	int        c;
	int        c16;



 if(pickcharbox[0].handle!=parenthandle && pickcharbox[0].handle)
 {
  dbclose(pickcharbox,DBCANCEL);
 }

	cfile=file;
 pickclosesub=close;
 xssfont=ifont;
 xssflags=flags;
 xssbold=(flags & CHARSBOLD)!=0;
 xssitalic=(flags & CHARSITALIC)!=0;

	xselection=yselection=0;

 washandle=pickcharbox[0].handle;

 if(parent) err=dodboxsp(pickcharbox,2,parent,&dbviewstack);
 else       err=dodboxparent(pickcharbox,2,parenthandle);

	if(!err)
	{
		setfocus(pickcharbox[1].handle);
  pickfocusn=1;
               wimp_setwindowbackground(pickcharbox[1].handle,CCRGB|PALWHITE);
  if(!err) err=wimp_setwindowflags(pickcharbox[1].handle,WINDOWNOTDIALOGUE,0);
	}

 if(!washandle)
 {
  addmousemoveevent(pointerfn,pickcharbox[1].handle,0);
  addeditevent(pickeditupdate,pickcharbox[0].handle,0);
  if(!err) err=addcaretevent(panecaret,pickcharbox[1].handle,0);
  if(!err) err=addkeyeventicon(pickcharbox[0].handle,GLYPHNAME);
  if(!err) err=addkeyeventicon(pickcharbox[0].handle,GLYPHCODE);
  if(!err) err=addkeyeventicon(pickcharbox[0].handle,GLYPHCODEHEX);
	}


 if(pickcharbox[0].handle)
 {
  geti(pickcharbox[0].handle,BACK,&icon);
		getw(pickcharbox[0].handle,&window);

  if(!(flags & CHARSNOCHOICE)) icon.iy1=0;
  extent(pickcharbox[0].handle,0,window.y0-window.y1,window.x1-window.x0,icon.iy1);
  reopenwlimit(pickcharbox[0].handle);

		setupselection();
		setuprows();
		setpaneextent();

  n=pickxytocode(xselection,yselection);
  pickcodetodata(n,c,c16);
  pickkeypress(c);
 	pickwritedata(-1,c,c16);

 }


 return(err);
}



void openchars(int fp)
{
 os_error    * err;
 absstylestr   style;
 int           ifont;
 int           ssbold;
 int           ssitalic;
 viewstr     * view;

 err=NULL;

 // overcomplex because this is only called from the window 
 // containing the caret

 if(act.valid)
 {
  view=file1view(act.file,menuview);

  if(actpend==PENDSSHIFT)
  {
   ifont=findxuserfontstyle(ssfontname,&ssbold,&ssitalic);
   err=pickchar(actinschar,NULL,ifont,(ssbold*CHARSBOLD)|
                                      (ssitalic*CHARSITALIC),view->handle,act.file);
  }
  else
  {
            err=getcaretstylex(&act,&style);
   if(!err) err=pickchar(actinschar,NULL,style.style.data.font,
                                        (style.style.data.bold*CHARSBOLD)|
                                        (style.style.data.italic*CHARSITALIC),view->handle,act.file);
  }
 }

 zreport(err);
 USE(fp);
}

