/*->c.textunicode */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"
#include "avl.h"

#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "bf.h"
#include "sp.h"
#include "deb.h"
#include "bits.h"


#include "constants.h"
#include "str.h"
#include "reslink.h"
#include "obj.h"
#include "object.h"
#include "pref.h"

#include "geometry.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "posn.h"

#include "select.h"

#include "editpath.h"
#include "objectdb.h"
#include "undo.h"
#include "units.h"

#include "xcolour.h"
#include "border.h"
#include "xredraw.h"
#include "curve.h"
#include "chain.h"
#include "mpage.h"
#include "fillstub.h"
#include "xprint.h"

#include "pxstr.h"
#include "pict.h"
#include "impex.h"

#include "frameflow.h"
#include "section.h"


#include "txstr.h"
#include "tx.h"
#include "sx.h"
#include "txprivate.h"
#include "fx.h"
#include "vl.h"
#include "vi.h"
#include "fl.h"
#include "fl2.h"
#include "style.h"
#include "ustyle.h"
#include "caret.h"
#include "vec.h"
#include "act.h"
#include "txdd.h"
#include "texttool.h"
#include "codes.h"
#include "hp.h"
#include "blank.h"
#include "link.h"
#include "spell.h"
#include "fmap.h"
#include "fox.h"
#include "mx.h"
#include "dbtext.h"
#include "dbstyle.h"
#include "txchoices.h"
#include "stylemap.h"
#include "styleif.h"
#include "index.h"
#include "txds.h"
#include "textr.h"
#include "bms.h"
#include "tabs.h"
#include "text.h"


#include "textunicode.h"




typedef os_error * (*txssffn)(filestr * file,int c,char * p,int flags);


static os_error * txsourcescan(filestr * file,int text,int code1,int code2,txssffn txc,int flags)
{
 os_error    * err;
 textsrcstr    texs;
 textboxstr  * textp;
 char        * p;
 int           c;
 int           bits;
 int           extent;
 int           u;
 int           header;
 int           footer;


	cprintf("tx source scan");

 err=NULL;

 texs.text=text;

 for(u=0;u<3;u++)
 {
  textp=(textboxstr*)fob_find(text,file);
  header=textp->data.header;
  footer=textp->data.footer;

  if(u==0 || (u==1 && header) || (u==2 && footer))
  {
   texs.u=u;

   if((u==0 && !textp->fchain.prev) || u>0)
   {
    texs.voffset=texs.offset=0;

    err=txlock(&texs,file);
    if(!err)
    {
     extent=texs.sourcep->len;

     while(texs.offset<extent)
     {
      p=txptr(texs.sourcep,texs.offset);
      c=*p;
      bits=codex[c];

      if(c==code1 || c==code2)
      {
							err=txc(file,c,p,flags);
       if(err) break;
      }
      texs.offset+=bits & CODELEN;
     }
     txunlock(&texs,file);
    }
				if(err) break;
   }
  }
 }
 return(err);
}



static	os_error * txcheckunc(char * p,int maxlen)
{
	int    c;
	char * lt;

	lt=p+maxlen;

	while(p<lt && ((c=*p++)!=0))
	{
		if(c==UNC16)	return(geterror(EUNC)); 
	}

	return(NULL);
}





static os_error * txchecktabs(filestr * file,int tab,char * leaderchar)
{
	os_error * err;
 char       leader1[LEADERMAXLEN*3];
 int        leaderlen;
 char       dectab1[DECTABMAXLEN*3];
 int        dectablen;
	int        i;
	int        stype;


	err=NULL;

 gettabruler(file,tab);

 XMEMCPYX(leader1,leaderchar,LEADERLEN);
	leaderlen=LEADERLEN;

	dectablen=0;
 
	for(i=0;i<tabrulern;i++)
	{
  if(tabruler[i].type==TABDATA)
  {
   stype=(tabruler[i].posn>>24);
   if(stype==TSUBLEAD)
   {
				if(leaderlen<(LEADERMAXLEN-3))
				{
     XMEMCPYX(leader1+leaderlen,&tabruler[i],3);
			 	leaderlen+=3;
				}
   }
   else
   if(stype==TSUBDEC)
   {
 			if(dectablen<(DECTABMAXLEN-3))
				{
     XMEMCPYX(dectab1+dectablen,&tabruler[i],3);
     dectablen+=3;
				}
   }
		}
		else
		{
			if(dectablen>3)
   {
    err=geterror(EUNC);
				break;
 		}

			if(leaderlen>3)
   {
   	err=geterror(EUNC);
				break;
			}

   err=txcheckunc(dectab1,dectablen);
			if(err) break;

   err=txcheckunc(leader1,leaderlen);
 		if(err) break;

			leaderlen=0;
			dectablen=0;
		}
	}

	return(err);
}





#define TXCHECK_TABS	0x1
#define TXCHECK_USER 0x2

static os_error * txcheckstyle(filestr * file,datawords * d,int flags)
{
	os_error * err;

	err=NULL;

	if(d->bulletafter2 || d->bulletbefore2) return(geterror(EUNC));
	if(d->bulletornumber && d->bulletdata2) return(geterror(EUNC)); 

	if(flags & TXCHECK_TABS)	err=txchecktabs(file,d->tab,d->leaderchar);

	return(err);
}



static os_error * txchecksn(filestr * file,int sn,int flags)
{
	os_error     * err;
 absstylestr    s;
 int            chain[MAXCHAIN];
 int            nchain;
	int            i;

 err=findabsstyle(file,sn,&s);
	if(!err) err=txcheckstyle(file,&s.style.data,flags);
	if(!err)
	{
		if(flags & TXCHECK_USER)
		{
   findstylechains(file,s.chain,chain,&nchain);
   for(i=0;i<nchain;i++)
   {
				finduserstylex(&s.style,chain[i],file);
    err=txcheckstyle(file,&s.style.data,flags);
				if(err) break;
   }
		}
	}

	return(err);
}





static os_error * txunc(filestr * file,int c,char * p,int flags)
{
	os_error     * err;
	int            sn;

	err=NULL;

	if(c==UNC16) err=geterror(EUNC);
	else
	if(c==SNO)
 {
  sn=p[1]+(p[2]<<8)+(p[3]<<16);
		err=txchecksn(file,sn,flags);
	}

	return(err);
}






os_error * txcheckcopy(vector * s,vector * d,int size,int strip)
{
	os_error * err;
	int        offset;
	int        extent;
	char     * p;
	int        c;
	int        bits;
	int        sn;

	err=NULL;

	if((!strip) && (s->file)->compatability>=UNICOMPAT	&& (d->file)->compatability<UNICOMPAT)
	{
  err=txlock(&s->textsrc,s->file);
  if(!err)
  {
			getstylev(s,1,&sn);
   err=txchecksn(s->file,sn,TXCHECK_TABS|TXCHECK_USER);
			if(!err)
			{
 			offset=s->textsrc.offset;
    extent=offset+size;

    while(offset<extent)
    {
     p=txptr(s->textsrc.sourcep,offset);
     c=*p;
     bits=codex[c];

 				if(c==UNC16 || c==SNO)
 				{
 					if(c==SNO) cprintf("SNO check");
      err=txunc(s->file,c,p,TXCHECK_TABS|TXCHECK_USER);
 					if(err) break;
 				}

     offset+=bits & CODELEN;
    }
 		}
   txunlock(&s->textsrc,s->file);
		}
	}

	return(err);
}







// OM_COMPATABILITY

os_error * txcompatability(filestr * sfile,int text,filestr * dfile,int * message)
{
	os_error * err;

	err=NULL;

	if(sfile->compatability>=UNICOMPAT	&& dfile->compatability<UNICOMPAT)
	{
		err=txsourcescan(sfile,text,UNC16,SNO,txunc,TXCHECK_TABS|TXCHECK_USER);
		if(err) *message=0;
	}

	return(err);
}




static os_error * txcfn(objhdrstr * objhdr,filestr * file,int * message)
{
	os_error * err;
	int        text;

	err=NULL;

	if(objhdr->type==OTEXTBOX)
	{
		text=objhdr->key;

		err=txsourcescan(file,text,UNC16,SNO,txunc,TXCHECK_TABS);	// don't check tabs or user styles
		if(err) *message=0;
	}

	return(err);
}



os_error * txcheckuserstyles(filestr * file)
{
	os_error         * err;
 userstylebasestr * stylebase;
 int                styles;
	int                i;

	err=NULL;

 styles=file->hdr.ustyles;
 stylebase=(userstylebasestr*)fob_find(styles,file);
 if(stylebase)
	{
  for(i=0;i<stylebase->n;i++)
  {
   err=txcheckstyle(file,&stylebase->userstyle[i].style.data,TXCHECK_TABS);
			if(err) break;
		}
	}

	return(err);
}



// EVENT_TESTCOMPATABILITY		-  change of document preferences


os_error * txcompat(int eventn,wimp_w userhandle,filestr * file,int preftest)
{
	os_error         * err;
 prefdatastr      * pref;
	char               string[MAXDECTABCHAR];
	int                message;


	err=NULL;

	pref=((prefteststr*)preftest)->pref;

	if(file->compatability>=UNICOMPAT && ((prefteststr*)preftest)->compatability<UNICOMPAT)
	{
		// transition from unicode to non-unicode, raise error if any unicode used

  // preferences - chapsep, decimal, hyphen

		if(pref->chapterseparator>255)	err=geterror(EUNC);
		if(!err)	   																			err=txcheckunc(pref->hyphenchar,MAXHYPHENCHAR);
		if(!err)
		{
			memcpy(string,pref->decimaltab1,4);
			memcpy(string+4,pref->decimaltab2,8);
			err=txcheckunc(pref->hyphenchar,MAXDECTABCHAR);
		}

		if(!err)	err=txcheckuserstyles(file);

		if(!err)
		{
			message=OM_FUNCTION2;
		 err=broadcastmessage(file,&message,(void*)txcfn);

			cprintf("OM_FUNC error %x",err);

// UNC in text story
// wide char in styles i.e. bullets
// wide char in tab rulers leader, decimal

		}
	}

	return(err);

	USE(eventn);
	USE(userhandle);
}


