/*->c.txdd */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"

#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "timex.h"
#include "dbhi.h"
#include "xmath.h"
//#include "txcb.h"
#include "xprocess.h"
#include "deb.h"

#include "str.h"
#include "reslink.h"
#include "constants.h"

#include "obj.h"
#include "object.h"
#include "chain.h"
#include "posn.h"
#include "units.h"

#include "file.h"

#include "view.h"
#include "viewr.h"
#include "viewo.h"
#include "dbscale.h"
#include "tools.h"


#include "caret.h"
#include "clip.h"

#include "xcolour.h"
#include "undo.h"
#include "geometry.h"
#include "xredraw.h"
#include "curve.h"

#include "select.h"
#include "frameflow.h"
#include "new.h"
#include "transload.h"


#include "pxstr.h"
#include "pict.h"



#include "txstr.h"
#include "codes.h"
#include "tx.h"
#include "txprivate.h"
#include "fox.h"
#include "vec.h"
#include "sx.h"
#include "vl.h"
#include "texttool.h"
#include "fx.h"
#include "style.h"
#include "fl.h"
#include "spell.h"
#include "spchk.h"
#include "txchoices.h"
#include "stylemap.h"
#include "styleif.h"
#include "mx.h"
#include "dbstyle.h"
#include "textimport.h"
#include "find.h"
#include "impex.h"
#include "textunicode.h"

#include "th.h"


#include "act.h"

#include "txdd.h"







static os_error * aselectall(int eventn,int user,filestr * file,int * claim)
{
 os_error * err;

 err=NULL;

 if(act.valid && file==act.file) 
 {
  *claim=1;
  err=selectall(&act);
 }

 return(err);

 USE(eventn);
 USE(user);
}




static os_error * aclearselection(int eventn,int user,
                                             filestr * file,int * claim)
{
 os_error * err;

 err=NULL;

 if(act.valid && zone && file==act.file) 
 {
  *claim=1;
  unsaveact();
  err=unselects(1);
 }

 return(err);

 USE(eventn);
 USE(user);
}



static os_error * adeleteselection(int eventn,int user,
                                             filestr * file,int * claim)
{
 os_error * err;

 err=NULL;

 if(act.valid && zone && file==act.file) 
 {
  *claim=1;
  err=deleteselectedlo();
 }

 return(err);

 USE(eventn);
 USE(user);
}



#ifdef NEVER

static os_error * txtxcbpaste(char * p,int len)
{
 os_error   * err;
 int          type;
 filestr    * sfile;
 textsrcstr   ssrc;
 int          dpage;
 int          dsection;
 int          textk;
 int          c;
 int          clen;
 int          bits;



 err=NULL;

 sfile=clipinfo(&textk,&type,&dpage,&dsection);
 if(type==CLIP_TEXTCONTENTS)
 {
  ssrc.text=textk;
  ssrc.offset=0;
  ssrc.loffset=0;
  ssrc.voffset=0;
  ssrc.s=0;
  ssrc.u=0;
  ssrc.usize=sizeof(textboxstr)+sizeof(texsrc);
  /* columns left blank */

  err=txlock(&ssrc,sfile);
  if(!err)
  {
   while(len>=0)
   {
    c=*txptr(ssrc.sourcep,ssrc.offset);
    bits=codex[c];
    clen=bits & CODELEN;

    if(c>=32) *p++=(char)c;
    if(c==EOT) break;
    ssrc.offset+=clen;
    len--;
   }

   *p=0;

   txunlock(&ssrc,sfile);
  }
 }

 return(err);
}




static curvestr txcbbox=
{
 CBOX,
 0,
 0,
 200*MMSIZE,
 200*MMSIZE,
 0,
 0,

};




static os_error * txtxcbcopy(char * p)
{
 os_error   * err;
 filestr    * dfile;
 textboxstr * textp;
 pagestr    * pagep;
 int          textk;
 int          page;
 int          sect;
 int          size;
 textsrcstr   dsrc;
 int          len;
 boxstr       box;


 err=NULL;


 box=txcbbox.box;
 clipstart(&box,&page,&sect,&dfile);

 size=sizeof(textboxstr)+sizeof(texsrc)+sizeof(texsub);
 if(!err) err=fob_create(size,dfile,OTEXTBOX,(fobjptr)&textp);
 if(!err)
 {
  textk=textp->key;

  textp->fcurve=textp->icurve=txcbbox;
  nullcurve(&textp->ocurve);


  packtextdata(textp,&deflttextdata);

  textp->textflow=deflttextflow;

  textp->chain.parent=page;

  dsrc.text=textk;
  dsrc.offset=SNLEN;
  dsrc.loffset=0;
  dsrc.voffset=0;
  dsrc.s=0;
  dsrc.u=0;
  dsrc.usize=sizeof(textboxstr)+sizeof(texsrc);
  dsrc.columns=textp->data.columns;


  tr_setidentity(&textp->transform);
  textp->transform.e-=box.x;
  textp->transform.f-=box.y;
  settexttransform(textp);

  getmaxbox(&textp->box,&textp->fcurve.box,&textp->transform);

  newtextbuffer(textk,dfile,1);

  pagep=(pagestr*)fob_find(page,dfile);
  pagep->chain.child=textk;

  err=txlock(&dsrc,dfile);
  if(!err)
  {
   len=strlen(p);
   txsourceinsert(p,len,&dsrc,dfile);
   txunlock(&dsrc,dfile);
  }

  if(!err)
  {
   textp=(textboxstr*)fob_find(textk,dfile);

   frflstart(dfile);
   frameflow((sobjectstr **)&textp,dfile);
   frfladd((sobjectstr **)&textp,dfile);
   frflend(dfile);
  }
 }

 clipend(CLIP_TEXTCONTENTS);

 return(err);
}



#endif





static os_error * acopyselections(filestr * sfile)
{
 os_error   * err;
 filestr    * dfile;
 textboxstr * textp;
 pagestr    * pagep;
 int          textk;
 textdatastr  textdata;
 textflowstr  textflow;
 transformstr tr;
 boxstr       box;
 curvestr     sfcurve;
 curvestr     sicurve;
 curvestr     dfcurve;
 curvestr     dicurve;
 int          page;
 int          sect;
 int          texsize;
 int          subsize;
 int          size;
 textsrcstr   dsrc;
 vector       svec;
 int          sn;
 char       * p;

 err=NULL;


 textp=(textboxstr*)fob_find(act.textsrc.text,sfile);
 textdata=textp->data;
 textflow=textp->textflow;
 box=textp->box;
 sicurve=textp->icurve;
 sfcurve=textp->fcurve;
 tr=textp->transform;

 clipstart(&box,&page,&sect,&dfile);

 texsize=sizeof(texsrc);
 subsize=textdata.columns;
 size=sizeof(textboxstr)+sizeof(texsrc)+textdata.columns*sizeof(texsub);

 copycurve(&dfcurve,dfile,&sfcurve,sfile);
 copycurve(&dicurve,dfile,&sicurve,sfile);

          err=mapcolour(sfile,dfile,&textdata.colour,LOCOVERWRITE);
 if(!err) err=mapcolour(sfile,dfile,&textdata.columndata.colour,LOCOVERWRITE);

 if(!err) err=fob_create(size,dfile,OTEXTBOX,(fobjptr)&textp);
 if(!err)
 {
  textk=textp->key;

  textflow.omode=FRONONE;
  textp->fcurve=dfcurve;
  textp->icurve=dicurve;
  nullcurve(&textp->ocurve);

  textp->data=textdata;
  textp->textflow=textflow;

  textp->data.header=textp->data.footer=0;
  textp->data.repeat=0;
  textp->fchain.next=textp->fchain.prev=0;

  textp->chain.parent=page;

  dsrc.text=textk;
  dsrc.offset=SNLEN;
  dsrc.loffset=0;
  dsrc.voffset=0;
  dsrc.s=0;
  dsrc.u=0;
  dsrc.usize=sizeof(textboxstr)+sizeof(texsrc);
  dsrc.columns=textp->data.columns;

  tr.e-=box.x;
  tr.f-=box.y;

  textp->transform=tr;
  settexttransform(textp);

  getmaxbox(&textp->box,&textp->fcurve.box,&textp->transform);

  newtextbuffer(textk,dfile,1);

  pagep=(pagestr*)fob_find(page,dfile);
  pagep->chain.child=textk;

  err=txlock(&dsrc,dfile);
  if(!err)
  {
   svec=*lozon;

   err=txlock(&svec.textsrc,sfile);
   if(!err)
   {
    getstylev(&svec,1,&sn);

    size=hizon->textsrc.offset-lozon->textsrc.offset;
    if(*txptr(svec.textsrc.sourcep,svec.textsrc.offset)==SNO)
    {
     size-=SNLEN;
     svec.textsrc.offset+=SNLEN;
    }

    p=txptr(dsrc.sourcep,0);
    *(p+1)=(char)sn;
    *(p+2)=(char)(sn>>8);
    *(p+3)=(char)(sn>>16);

    txcopyblock(&dsrc,&svec.textsrc,dfile,sfile,size);

    txunlock(&svec.textsrc,sfile);
   }
   txunlock(&dsrc,dfile);
  }

  if(!err)
  {
   txremapsource(dsrc.source,0,size+SNLEN,sfile,dfile,LOCOVERWRITE);

   tr_setidentity(&tr);
   txcopyeobs(sfile,dfile,&tr,textk,page,sect,dsrc.source,0,size+SNLEN,
                                                      LOCOVERWRITE);

   textp=(textboxstr*)fob_find(textk,dfile);

   frflstart(dfile);
   frameflow((sobjectstr **)&textp,dfile);
   frfladd((sobjectstr **)&textp,dfile);
   frflend(dfile);
  }
 }

 clipend(CLIP_TEXTCONTENTS,NULL);

 return(err);
}



static os_error * acopyselection(int eventn,int user,
                                            filestr * file,int * claim)
{
 os_error   * err;

 err=NULL;

 if(act.valid && zone && file==act.file) 
 {
  *claim=1;
  err=acopyselections(file);
 }

 return(err);

 USE(eventn);
 USE(user);
}



static os_error * acancopyselection(int eventn,int user,
                                            filestr * file,int * claim)
{
 if(act.valid && zone && file==act.file) 
 {
  *claim=1;
 }
 return(NULL);

 USE(user);
 USE(eventn);
}


static os_error * acutselection(int eventn,int user,filestr * file,int * claim)
{
 os_error * err;

 err=NULL;

 if(act.valid && zone && file==act.file) 
 {
  *claim=1;
  err=acopyselections(file);
  if(!err)
  {  /* delete stuff */
   err=deleteselectedlo();
  }
 }

 return(err);

 USE(eventn);
 USE(user);
}



/*
static int txtypelist[]=
{
 DRAW,
 SPRITE,
 TEXTFILE,
 DTYPE2,
 0,
 -1,
};
*/


static os_error * apasteselection(int eventn,int user,filestr * file,
                                                              int * claim)
{
 os_error   * err;
 int          cbtype;
 filestr    * sfile;
 vector       dvec;
 textsrcstr   ssrc;
 flowstr      fl;
 int          backflow;
 int          dpage;
 int          dsection;
 int          textk;
 int          size;
 int          extra;
 transformstr tr;
 txmodstr     txmod;
 int          c;
	int          c1;
 int          oldsn;
 int        * ftypes;


 err=NULL;

 clipboardtype(&cbtype,&ftypes);

// cprintf("tx paste sel %d ft %x",type,ftypes[0]);
 
 if(cbtype==CLIP_TEXTCONTENTS)
 {
  err=clipopen(&textk,&dpage,&dsection,&sfile);
  if(!err)
  {
   *claim=1;

   if(act.valid && file==act.file) 
   {
// unicode compatability check
 		 err=checkcompatability(sfile,textk,CHECKC_CHAIN,file);


    if(!err) err=modfile(act.file,act.section);
    if(!err)
    {
     err=undostart(file);
     if(!err)
     {
      size=0;        /* compiler */

      if(txovertype) deleteselectedlo();
      else           unselects(0);

      dvec=act;
      extra=0;

      ssrc.text=textk;
      ssrc.offset=0;
      ssrc.loffset=0;
      ssrc.voffset=0;
      ssrc.s=0;
      ssrc.u=0;
      ssrc.usize=sizeof(textboxstr)+sizeof(texsrc);
     /* columns left blank */

      err=txlock(&ssrc,sfile);
      if(!err)
      {
       err=txlock(&dvec.textsrc,dvec.file);
       if(!err)
       {
        txmodvec(&dvec);

        c=styleprevcode(&dvec);
        if(c!=SNO)
        {
         getstylev(&dvec,0,&oldsn);
         txsourceinsertsn(oldsn,1,&dvec.textsrc,dvec.file);
         extra=SNLEN;
        }

        size=ssrc.sourcep->len-1; /* no EOT */
 
        txcopyblock(&dvec.textsrc,&ssrc,dvec.file,sfile,size);

        txunlock(&dvec.textsrc,dvec.file);
       }
       txunlock(&ssrc,sfile);
      }

      if(!err)
      {
       txremapsource(dvec.textsrc.source,dvec.textsrc.offset,
                                         size,sfile,dvec.file,0);
 
       tr_setidentity(&tr);
       txcopyeobs(sfile,dvec.file,&tr,dvec.textsrc.text,dvec.page,dvec.section,
                                      dvec.textsrc.source,
                                      dvec.textsrc.offset,size,0);

       uninsertfx(UINSERTS);
       txmod.offset=dvec.textsrc.offset;
       txmod.size=size+extra;
       undowritefn(file,txmod.size>=BSSPLIT?UDELETEB:UDELETE,&txmod,
                                                           sizeof(txmodstr));
       undowritefn(file,UINSERTF,NULL,0);

       backflow=1;

       fl.opcode=FLV0|FDATA|FSUB;
       if(backflow) fl.opcode|=FLPREV;

       fl.data.type=FLDELTA;
       fl.data.offset=dvec.textsrc.offset;
       fl.data.delta=size+extra;
       fl.data.length=0;
       fl.roff[0]=dvec.textsrc.offset+size;
       fl.resultv[0]=&dvec;

       flow(&dvec,&fl);

       err=txlock(&dvec.textsrc,dvec.file);
       if(!err)
       {
        setxa(&dvec);
        setactive(&dvec);
        screencaret(&dvec);

        txunlock(&dvec.textsrc,dvec.file);
       }
      }

      undoend(file);
     }
    }
   }
   clipclose(sfile);
  }
 }
 else
 if(cbtype==CLIP_GLOBAL)
 {
  cprintf("text clip global");

		c=0;
  c1=-1;
		while(1)
		{
			if(ftypes[c]==0)
   {
				c=c1;

				cprintf("going out on default");
   	break;
			}

			if(ftypes[c]==HTMLFILE)
			{	
				if(!translatetest2(HTMLFILE,DTYPE2,TRANS_CONTENT))	break;						// and there's a filter
			}

			if(ftypes[c]==RTF)
			{
				if(!translatetest2(RTF,DTYPE2,TRANS_CONTENT))	break;
			}

			if(ftypes[c]==UNICODETEXTFILE && file->compatability>=UNICOMPAT) break;
  	if(ftypes[c]==TEXTFILE)	c1=c;
			c++;
		}

  if(c>=0)
  {
   if(act.valid && file==act.file) 
   {
    viewstr    * view;
//    int          xpo;
//    int          ypo;
//    vlstr      * vline;
//    int          vs;
//    coordstr     cx;
//    vector       s;
    sectionstr * sectionp;
    posnstr      loadposn;


    sectionp=(sectionstr*)fob_find(act.section,file);

    if(caretview && caretview->file==file) view=caretview;
    else
    {
     view=file->view;
     while(view)
     {
      if((int)sectionp->branch==view->branch) break;
      view=view->next;
     }
    }

    if(view)
    {
     *claim=1;

     memset(&loadposn,0,sizeof(posnstr));
     loadposn.view=view;
     loadposn.file=file;
     loadposn.object=act.textsrc.text;
     loadposn.otype=OTEXTBOX;
     loadposn.section=act.section;
     loadposn.page=act.page;

					cprintf("text importglobal %x",ftypes[c]);


     err=importglobal(NULL,&loadposn,ftypes[c],OBCARETLOAD);
    }
   }
  }
 }


 return(err);

 USE(eventn);
 USE(user);
}



static os_error * apastename(int eventn,int user,filestr * file,
                                                              char ** name)
{
 os_error   * err;
 int          cbtype;

 err=NULL;

 clipboardtype(&cbtype,NULL);
 if(cbtype==CLIP_TEXTCONTENTS) *name="{TX03}";

 return(err);

 USE(eventn);
 USE(user);
 USE(file);
}





/****************************************************************************/

typedef struct txdestr
{
 int text;
 int u;
} txdestr;



os_error * txinsrc(vector * v,int source,int sn)
{
 os_error    * err;
 textsrcstr    textsrc2;
 flowstr       flop;
 vector        s;
 filestr     * file;
 int           implen;
 txdestr       txem;
 txmodstr      txmod;
 int           oldsn=0;
 int           cn;
 int           coffset;


 file=v->file;


 textsrc2.source=source;
 textsrc2.offset=0;
 textsrc2.u=0;

 cn=implen=0;

 err=fob_lock((fobjptr)&textsrc2.sourcep,source,file);
 if(!err)
 {
  err=txlock(&v->textsrc,file);
  if(!err)
  {
   if(sn)
   {
    getstylev(v,0,&oldsn);
    if(oldsn==sn) sn=0;
    else
    {
     cn=styleprevcode(v);
    }
   }

   implen=textsrc2.sourcep->len;
   err=txcopyblock(&v->textsrc,&textsrc2,file,file,implen);
   txunlock(&v->textsrc,file);
  }
  fob_unlock((fobjptr)&textsrc2.sourcep,file);
 }


 if(!err)
 { 
  if(!err)
  {
   txem.text=v->textsrc.text;
   txem.u=v->textsrc.u;

   undowritefn(file,UTXDESA,NULL,0);

   txmod.offset=v->textsrc.offset;
   txmod.size=implen;
   undowritefn(file,implen>=BSSPLIT?UDELETEB:UDELETE,&txmod,sizeof(txmodstr));

   coffset=v->textsrc.offset;

   if(sn) 
   {      /* insert a style before */
    s=*v;
    err=txlock(&s.textsrc,file);
    if(!err)
    {
     txundosourceinsertsn(sn,&s.textsrc,file);
     implen+=SNLEN;
   /*  coffset+=SNLEN; */

     if(cn!=SNO && cn!=EOT) /* insert a style after */
     {
      s.textsrc.offset+=implen;
      txundosourceinsertsn(oldsn,&s.textsrc,file);
      implen+=SNLEN;
     }
     txunlock(&s.textsrc,file);
    }
   }

   undowritefn(file,UTXDEFA,&txem,sizeof(txdestr));


   flop.opcode=FDATA|FBOX|FLV0;
   flop.data.type=FLDELTA;
   flop.data.length=0;
   flop.data.delta=implen;
   flop.data.offset=coffset;
   flop.roff[0]=v->textsrc.offset+implen;
   flop.resultv[0]=&s;


   flow(v,&flop);


   if(toolcurrent(file)==TL_SELECT)
   {
    err=txlock(&s.textsrc,file);
    if(!err)
    {
     setxa(&s);
     setactive(&s);
     screencaret(&s);
     txunlock(&s.textsrc,file);
    }
   }
  }
 }

 return(err);
}



/****************************************************************************/

static txdestr   txem;
static vector    txv;


/* tagged to UTXDES */
/* this function is always called last in undo/redo */

static os_error * untxdess(filestr * file,int code)
{
 flowstr    fl;
 int        coffset;
 int        cdelta;
 int        hoffset;

/* dprintf(0,"UTXDES"); */

 txundoend(&coffset,&hoffset,&cdelta,file);

 fl.opcode=FSUB|FLPREV;

 /* problems here if cdelta is zero, but text is changed                */
 /* a delta flow can't really have a length - or else dirty flow anyway */

 movevector(&txv,coffset);

 fl.data.type=cdelta?FLDELTA:FLDIRTY;
 fl.data.offset=coffset;
 fl.data.delta=cdelta;
 fl.data.length=hoffset-coffset;

 flow(&txv,&fl);

 undowritefn(file,code,&txem,sizeof(txdestr));

 return(NULL);
}


static os_error * untxdes(filestr * file) 
{
 return(untxdess(file,UTXDEF));
}

static os_error * untxdesa(filestr * file)
{
 return(untxdess(file,UTXDEFA));
}


/* tagged to UTXDEF */
/* this function is always first in undo/redo */

static os_error * untxdefs(filestr * file,int code)
{
 undoread(file,&txem,sizeof(txdestr));

 setvectorfrombox(&txv,txem.u,txem.text,file);

 txundostart(&txv.textsrc,file);

 return(undowritefn(file,code,NULL,0));
}


static os_error * untxdef(filestr * file)
{
 return(untxdefs(file,UTXDES));
}

static os_error * untxdefa(filestr * file)
{
 if(act.valid && act.file==file) clearactive();
 return(untxdefs(file,UTXDESA));
}



/* the catch here is that almost certainly the active point is not in the */
/* text being deleted                                                     */


os_error * txdelembed(textboxstr * textp,filestr * file,int object)
{
 int        text;
 vector     v1;
 vector     v2;
 int        offset;
 int        u;


 text=textp->key;

 txfindeob(object,text,file,&offset,&u);

 if(offset>=0)
 {
  setvectorfrombox(&v1,u,text,file);
  movevector(&v1,offset);
  v2=v1;
  movevector(&v2,offset+EOBLEN);

  /* think already inside undo loop */

  txem.text=text;
  txem.u=u;

  undowritefn(file,UTXDES,NULL,0);

  deletev(&v1,&v2);

  undowritefn(file,UTXDEF,&txem,sizeof(txdestr));
 }

 return(NULL);
}



os_error * txembedobject(vector * v,int object,int yshift)
{
 os_error   * err;
 char         string[EOBLEN];
 filestr    * file;
 txdestr      txem;


 file=v->file;

 err=undostart(file);
 if(!err)
 {
  if(act.valid && act.file==file) clearactive();

  undowritefn(file,UTXDESA,NULL,0);

  txem.text=v->textsrc.text;
  txem.u=v->textsrc.u;

  memset(string,0,sizeof(string));

  string[0]=EOB;
  string[1]=(char)object;
  string[2]=(char)(object>>8);
  string[3]=(char)(object>>16);
  string[4]=(char)(object>>24);

  err=insertv(v,string,EOBLEN,0,0);

  undowritefn(file,UTXDEFA,&txem,sizeof(txdestr));

  err=txlock(&v->textsrc,file);

  setxa(v);
  setactive(v);
  screencaret(v);

  txunlock(&v->textsrc,file);

  undoend(file);
 }

 return(err);

 USE(yshift);
}


/*****************************************************************************/


static os_error * txstripblock(vector *  d,int size,int * dextra)
{
 os_error * err;
 int        c;
 int        bits;
 int        len;
 int        offset;
 vector     s;

 s=*d;

 err=txlock(&s.textsrc,s.file);
 if(!err)
 {
  offset=s.textsrc.offset;

  while(size)
  {
   c=*txptr(s.textsrc.sourcep,s.textsrc.offset);
   bits=codex[c];
   len=bits & CODELEN;

   if(c<32 && c!=TABSEQ && c!=NL && c!=CR)
   {
    txsourceremove(len,&s.textsrc,s.file);
    *dextra-=len;
   }
   else s.textsrc.offset+=len;

   size-=len;
  }
  txunlock(&s.textsrc,s.file);
 }

 return(err);
}





/**************************************************************************/

static txdestr utxm[2];
static vector  utxv[2];

static int     utxsize;
static int     utxsoffset;
static int     utxdoffset;
static int     utxsame;
static int     utxdelta;
static int     utxloffset;
static int     utxhoffset;


/* tagged to UTXMOVES */
/* this function is always called last in undo/redo */

/* if undo, unlock the single source, do reflows */
/* if redo, do reflows */


static os_error * untxmoves(filestr * file) 
{
 os_error  * err;
 int         forward;
 vector      s;
 flowstr     fl;

 forward=undoforward(file);

 if(!forward)
 {
  txundoend(&utxloffset,&utxhoffset,&utxdelta,file);
 }

 err=undowritefn(file,UTXMOVEF,utxm,2*sizeof(txdestr));

 if(utxsame)
 {
  if(utxv[0].textsrc.offset<utxv[1].textsrc.offset) s=utxv[0];
  else                                              s=utxv[1];

  fl.opcode=FSUB|FLPREV;

  fl.data.type=FLDIRTY;
  fl.data.offset=MIN(utxsoffset,utxdoffset);
  fl.data.delta=utxdelta;
  fl.data.length=MAX(utxsoffset,utxdoffset)-fl.data.offset+utxsize;

  movevector(&s,fl.data.offset);
     
  flow(&s,&fl);
 }
 else
 {
  s=utxv[1];

  fl.opcode=FSUB|FLPREV;

  fl.data.type=FLDELTA;
  fl.data.offset=utxdoffset;
  fl.data.delta=forward?utxsize:-utxsize;
  fl.data.length=0;

  movevector(&s,fl.data.offset);
    
  flow(&s,&fl);


  s=utxv[0];

  fl.opcode=FSUB|FLPREV;

  fl.data.type=FLDELTA;
  fl.data.offset=utxsoffset;
  fl.data.delta=(forward?-utxsize:utxsize)+utxdelta;
  fl.data.length=0;

  movevector(&s,fl.data.offset);

  flow(&s,&fl);
 }

 return(err);
}


/* if undo, do the move, lock the single source */
/* if redo, unlock single source, do the move   */

static os_error * untxmovem(filestr * file)
{
 os_error  * err;
 int         forward;
 textsrcstr  s;
 textsrcstr  d;


 forward=undoforward(file);
 s=utxv[0].textsrc;
 d=utxv[1].textsrc;
 utxsame=(s.source==d.source);


 if(forward)
 {
  txundoend(&utxloffset,&utxhoffset,&utxdelta,file);
 }

 undoread(file,&utxsize,sizeof(int));
 undoread(file,&utxsoffset,sizeof(int));
 undoread(file,&utxdoffset,sizeof(int));

 undowritefn(file,UTXMOVEM,&utxsize,sizeof(int));
 undowrite(file,&utxsoffset,sizeof(int));
 undowrite(file,&utxdoffset,sizeof(int));


 err=txlock(&s,file);
 if(!err)
 {
  err=txlock(&d,file);
  if(!err)
  {
   if(forward)
   {
    s.offset=utxsoffset;
    d.offset=utxdoffset;

    txmoveblock(&d,&s,file,utxsize);                                               }
   else
   {
    s.offset=utxsoffset;
    d.offset=utxdoffset;

    if(utxsame)
    {
     if(utxsoffset<utxdoffset) d.offset-=utxsize;
     else
     if(utxsoffset>utxdoffset) s.offset+=utxsize;
    }

    txmoveblock(&s,&d,file,utxsize);
   }
   txunlock(&d,file);
  }
  txunlock(&s,file);
 }

 if(!forward)
 {
  txundostart(&utxv[0].textsrc,file);
 }

 return(NULL);
}


/* tagged to UTXMOVEF */
/* this function is always first in undo/redo */

/* if redo, lock single source */

static os_error * untxmovef(filestr * file)
{
 undoread(file,utxm,2*sizeof(txdestr));
 undowritefn(file,UTXMOVES,NULL,0);

 setvectorfrombox(&utxv[0],utxm[0].u,utxm[0].text,file);
 setvectorfrombox(&utxv[1],utxm[1].u,utxm[1].text,file);

 if(undoforward(file)) txundostart(&utxv[0].textsrc,file);

 return(NULL);
}


/* have an outer loop to clear marking */

/* this function is always last in undo/redo */

static os_error * untxmoves1(filestr * file) 
{
 return(undowritefn(file,UTXMOVEF1,NULL,0));
}


/* this function is always first in undo/redo */

static os_error * untxmovef1(filestr * file)
{
 undowritefn(file,UTXMOVES1,NULL,0);
 return(clearactive());
}



/* clear selection */
/* copy text area  */
/* delete source + reflow */
/* reflow new      */


static os_error * txmoveselections(vector * s,vector * d,int size)
{
 os_error * err;
 filestr  * sfile;
 filestr  * dfile;
 int        same;
 int        shift;
 int        sextra;
 int        soffset;
 int        dextra;
 int        doffset;
 flowstr    fl;
 vector     s1;
 vector     s2;
 int        c;
 int        astart;
 int        bstart;
 int        dstart;
 int        asn;
 int        asni;
 int        bsn;
 int        bsni;
 int        dsn;


 sfile=s->file;
 dfile=d->file;


// unicode compatability check	not needed source and dest file same



 err=undostart(dfile);
 if(!err)
 {
  same=(d->textsrc.source==s->textsrc.source);
  sextra=dextra=0;
  soffset=s->textsrc.offset;
  doffset=d->textsrc.offset;
  shift=(d->textsrc.offset<soffset);

  undowritefn(sfile,UTXMOVES1,NULL,0);

  clearactive(); /* know only one file involved */

  undowritefn(sfile,UTXMOVES,NULL,0);

  utxm[0].u=s->textsrc.u;
  utxm[0].text=s->textsrc.text;
  utxm[1].u=d->textsrc.u;
  utxm[1].text=d->textsrc.text;

  err=txlock(&d->textsrc,dfile);
  if(!err)
  {
   txmodvec(d);

   c=*txptr(d->textsrc.sourcep,doffset);
   dstart=(c==SNO);
   getstylev(d,0,&dsn);

   s1=*s;
   txlock(&s1.textsrc,sfile);
   c=*txptr(s1.textsrc.sourcep,s1.textsrc.offset+size);
   astart=(c==SNO);
   resetpoint(&s1,s1.textsrc.offset+size);
   getstylev(&s1,0,&asn);
   getstylev(&s1,1,&asni);
   txunlock(&s1.textsrc,sfile);

   s1=*s;
   txlock(&s1.textsrc,sfile);
   c=*txptr(s1.textsrc.sourcep,s1.textsrc.offset);
   bstart=(c==SNO);
   resetpoint(&s1,s1.textsrc.offset);
   getstylev(&s1,0,&bsn);
   getstylev(&s1,1,&bsni);
   txunlock(&s1.textsrc,sfile);

   s1=*s;
   txlock(&s1.textsrc,sfile);
   if(asn!=dsn && !dstart)
   {
    /* insert dsn at end of block */
    s1.textsrc.offset=soffset+size;
    txundosourceinsertsn(dsn,&s1.textsrc,sfile);
    size+=SNLEN;
    dextra+=SNLEN;
    if(same && doffset>s1.textsrc.offset) doffset+=SNLEN;
   }

   if((bsn!=asni || !soffset) && !astart)
   {
    /* insert bsn at end of block */
    s1.textsrc.offset=soffset+size;
    txundosourceinsertsn(bsn,&s1.textsrc,sfile);
    sextra+=SNLEN;
    if(same && doffset>s1.textsrc.offset) doffset+=SNLEN;
   }

   if((bsni!=dsn || !doffset) && !bstart)
   {
    /* insert bsn at start of block */
    s1.textsrc.offset=soffset;
    txundosourceinsertsn(bsn,&s1.textsrc,sfile);

    size+=SNLEN;
    dextra+=SNLEN;
    if(same && doffset>s1.textsrc.offset) doffset+=SNLEN;
   }
   txunlock(&s1.textsrc,sfile);

   d->textsrc.offset=doffset;

   err=txlock(&s->textsrc,sfile);
   if(!err)
   {
    txmodvec(s);

    undowritefn(sfile,UTXMOVEM,&size,sizeof(int));
    undowrite(sfile,&s->textsrc.offset,sizeof(int));
    undowrite(sfile,&d->textsrc.offset,sizeof(int));

    txmoveblock(&d->textsrc,&s->textsrc,dfile,size);
    if(same)
    {
     if(soffset<doffset) doffset-=size;
     else
     if(soffset>doffset) soffset+=size;
    }

    txunlock(&s->textsrc,dfile);
   }
   txunlock(&d->textsrc,sfile);
  }

  undowritefn(sfile,UTXMOVEF,utxm,2*sizeof(txdestr));


  if(!err)
  {
   if(same)
   {
    fl.opcode=FDATA|FSUB|FLV0|FLV1|FLPREV;

    fl.data.type=FLDIRTY;
    fl.data.offset=MIN(soffset,doffset);
    fl.data.delta=sextra+dextra;
    fl.data.length=MAX(soffset,doffset)-fl.data.offset+size;
     
    fl.roff[0]=doffset;
    fl.roff[1]=doffset+size;
    fl.resultv[0]=&s1;
    fl.resultv[1]=&s2;
    
    if(s->textsrc.offset<d->textsrc.offset) flow(s,&fl);
    else                                    flow(d,&fl);

    setupzone(&s1,&s2);
   }
   else
   {
    fl.opcode=FDATA|FSUB|FLPREV;

    fl.data.type=FLDELTA;
    fl.data.offset=soffset;
    fl.data.delta=-size+sextra+dextra;
    fl.data.length=0;
    
    flow(s,&fl);


    fl.opcode=FDATA|FSUB|FLV0|FLV1|FLPREV;

    fl.data.type=FLDELTA;
    fl.data.offset=doffset;
    fl.data.delta=size;
    fl.data.length=0;

    fl.roff[0]=doffset;
    fl.roff[1]=doffset+size;
    fl.resultv[0]=&s1;
    fl.resultv[1]=&s2;
    
    flow(d,&fl);

    setupzone(&s1,&s2);
   }                                                                          
  }

  undowritefn(sfile,UTXMOVEF1,NULL,0);

  undoend(dfile);
 }
 return(err);
}




/*****************************************************************************/

/* (!samefile || (copy && !same)) */
/* same file copies can be undone more efficiently */


static os_error * txcopyselectionss(vector * s,vector * d,int * sizep,
                                             int * dextrap,int strip)
{
 os_error   * err;
 int          c;
 filestr    * sfile;
 filestr    * dfile;
 int          samefile;
 int          same;
 vector       v;
 int          bstart;
 int          dstart;
 int          asn;
 int          bsn;
 int          dsn;
 int          size;
 int          dextra;
 int          oldsoffset;
 transformstr tr;

 sfile=s->file;
 dfile=d->file;
 samefile=(sfile==dfile);
 same=samefile && (s->textsrc.source==d->textsrc.source);

 size=*sizep;
 dextra=0;
 oldsoffset=s->textsrc.offset;

 err=txlock(&s->textsrc,sfile);
 if(!err)
 {
  err=txlock(&d->textsrc,dfile);
  if(!err)
  {
   txmodvec(d);

   asn=bsn=dsn=0;
   dstart=bstart=0;

   if(!strip)
   {
    c=*txptr(d->textsrc.sourcep,d->textsrc.offset);
    dstart=(c==SNO);
    getstylev(d,0,&dsn);

    c=*txptr(s->textsrc.sourcep,s->textsrc.offset);
    bstart=(c==SNO);
    getstylev(s,0,&bsn);

    if(samefile)
    {
     v=*s;
     err=txlock(&v.textsrc,sfile);
     if(!err)
     {
      resetpoint(&v,v.textsrc.offset+size);
      getstylev(&v,0,&asn);
      txunlock(&v.textsrc,sfile);
     }
    }
   }


   if(!strip)
   {
    if((!samefile || dsn!=asn) && !dstart)
    {
     txsourceinsertsn(dsn,1,&d->textsrc,dfile);
     dextra=SNLEN;
     if(same && s->textsrc.offset>d->textsrc.offset) s->textsrc.offset+=dextra;
    }
   }

   txcopyblock(&d->textsrc,&s->textsrc,dfile,sfile,size);

   if(!strip)
   {
    if((!samefile || bsn!=dsn || !d->textsrc.offset) && !bstart)
    {
     txsourceinsertsn(bsn,0,&d->textsrc,dfile);
     size+=SNLEN;
    }
   }

   txunlock(&d->textsrc,dfile);
  }
  txunlock(&s->textsrc,sfile);
 }

 if(!err)
 {
  if(strip)
  {
   txstripblock(d,size,&dextra);
  }
  else
  {
   txremapsource(d->textsrc.source,d->textsrc.offset,
                                       size,sfile,dfile,0);

   tr_setidentity(&tr);
   txcopyeobs(sfile,dfile,&tr,d->textsrc.text,d->page,d->section,
                                  d->textsrc.source,
                                  d->textsrc.offset,size,0);
  }
 }

 *sizep=size;
 *dextrap=dextra;
 s->textsrc.offset=oldsoffset;

 return(NULL);
}









static os_error * txcopyselections(vector * s,vector * d,int size,
                                                         int copy,int strip)
{
 os_error   * err;
 int          dextra;
 txmodstr     txmod;
 flowstr      fl;
 filestr    * sfile;
 filestr    * dfile;


 sfile=s->file;
 dfile=d->file;


// unicode compatability check	already done


 err=undostart(dfile);
 if(!err)
 {
  txcopyselectionss(s,d,&size,&dextra,strip);

  txem.text=d->textsrc.text;
  txem.u=d->textsrc.u;

  undowritefn(dfile,UTXDES,NULL,0);

  txmod.offset=d->textsrc.offset;
  txmod.size=size+dextra;
  undowritefn(dfile,txmod.size>=BSSPLIT?UDELETEB:UDELETE,&txmod,sizeof(txmodstr));

  undowritefn(dfile,UTXDEF,&txem,sizeof(txdestr));


  fl.opcode=FDATA|FSUB|FLPREV;

  fl.data.type=FLDELTA;
  fl.data.offset=d->textsrc.offset;
  fl.data.delta=size+dextra;
  fl.data.length=0;
    
  flow(d,&fl);
 }

 undoend(dfile); /* goes here because we know it's a copy if same file */

 if(!err)
 {
  if(!copy) err=deleteselected();
 }

 return(err);
}




/* copy text chunk within a story */

static int utxs[2];


/* called last in undo/redo */

static os_error * utxcopys(filestr * file)
{
 os_error   * err;
 flowstr      fl;
 vector       s;
 int          coffset;
 int          hoffset;
 int          cdelta;


 undoread(file,utxs,2*sizeof(int));

 txundoend(&coffset,&hoffset,&cdelta,file);

 undowritefn(file,UTXCOPYF,NULL,0);

 s=*lozon;
 err=txlock(&s.textsrc,file);
 if(!err)
 {
  if(coffset<lozon->textsrc.offset) settosot(&s);
  resetpoint(&s,coffset);
  txunlock(&s.textsrc,file);
 }

 fl.opcode=FDATA|FSUB|FLV0|FLV1|FLPREV;

 fl.data.type=FLDELTA;
 fl.data.offset=coffset;
 fl.data.delta=cdelta;
 fl.data.length=0;
     
 fl.roff[0]=lozon->textsrc.offset=utxs[0];
 fl.roff[1]=hizon->textsrc.offset=utxs[1];
 fl.resultv[0]=lozon;
 fl.resultv[1]=hizon;
    
 flow(&s,&fl);

 return(NULL);
}


/* called first in undo/redo */

static os_error * utxcopyf(filestr * file)
{
 utxs[0]=lozon->textsrc.offset;
 utxs[1]=hizon->textsrc.offset;

 undowritefn(file,UTXCOPYS,utxs,2*sizeof(int));

 txundostart(&act.textsrc,file);

 return(NULL);
}



static os_error * txcopyselectionsame(vector * s,vector * d,int size,int strip)
{
 os_error   * err;
 filestr    * file;
 int          loffset;
 int          hoffset;
 flowstr      fl;
 int          dextra;
 txmodstr     txmod;


// unicode compatability check not needed source and dest same file


 file=s->file;

 err=undostart(file);
 if(!err)
 {
  loffset=utxs[0]=lozon->textsrc.offset;
  hoffset=utxs[1]=hizon->textsrc.offset;

  undowritefn(file,UTXCOPYS,utxs,2*sizeof(int));

  txcopyselectionss(s,d,&size,&dextra,strip);

  if(loffset>=d->textsrc.offset)lozon->textsrc.offset=(loffset+=(size+dextra));
  if(hoffset>=d->textsrc.offset)hizon->textsrc.offset=(hoffset+=(size+dextra));

  fl.opcode=FDATA|FSUB|FLV0|FLV1|FLPREV;

  fl.data.type=FLDELTA;
  fl.data.offset=d->textsrc.offset;
  fl.data.delta=(size+dextra);
  fl.data.length=0;
     
  fl.roff[0]=loffset;
  fl.roff[1]=hoffset;
  fl.resultv[0]=lozon;
  fl.resultv[1]=hizon;

    
  flow(d,&fl);


  txmod.offset=fl.data.offset;
  txmod.size=(size+dextra);
  undowritefn(file,txmod.size>=BSSPLIT?UDELETEB:UDELETE,&txmod,
                                                           sizeof(txmodstr));
  undowritefn(file,UTXCOPYF,NULL,0);

  undoend(file);
 }

 return(NULL);
}








os_error * txdragndrop(posnstr * posn,int copy,int strip)
{
 os_error   * err;
 vector       d;
 vector       s;
 int          size;
 int          same;
 int          samefile;


 err=NULL;

 if(posn->valid)
 {
  if(!(posn->view)->data.nodnd)
  {
   findbox(posn,-1);

   err=posn2vector(posn,&d,NULL);

   if(!err && d.valid)
   {
    err=txlock(&d.textsrc,d.file);
    if(!err)
    {
     if(strip)  /* don't want to insert raw text before first style in story */
     {
      vsvec(&d);
     }
     else
     {
      styleprevcode(&d);
     }
     txunlock(&d.textsrc,d.file);
    }

    if(zone)
    {
     s=*lozon;
     size=hizon->textsrc.offset-lozon->textsrc.offset;
    }
    else
    {
     s=act;
     s.textsrc.offset=0;
     size=sourcesize(s.textsrc.source,s.file);
    }

    samefile=(s.file==d.file);
    if(!samefile) copy^=1;
    same=samefile && (d.textsrc.source==s.textsrc.source);

    /* cut drags back into zone, or whole story back into itself */

    if(same)
    {
     if(!zone) return(err);
     if(d.textsrc.offset>lozon->textsrc.offset &&
        d.textsrc.offset<hizon->textsrc.offset) return(err);
    }

				err=txcheckcopy(&s,&d,size,strip);
    if(!err)          err=modfile(d.file,d.section);
    if(!err && !copy) err=modfile(s.file,s.section);
    if(!err)
    {
     if(!samefile || (copy && !same))
     {
      err=txcopyselections(&s,&d,size,copy,strip);
     }
     else /* sfile==dfile && !copy */
     {
      if(!copy)  err=txmoveselections(&s,&d,size);
      else
      {
       /* nasty case of copying selection into active source */
       err=txcopyselectionsame(&s,&d,size,strip);
      }
     }
    }
   }
  }
 }
 else
 {
//  err=txdirectexport();
 }
 return(err);
}







#define UNDOS 11


static undofnstr undos[UNDOS]=
{
 untxdes,       NULL,          UTXDES,       "{UDELETE}",
 untxdef,       NULL,          UTXDEF,       "{UDELETE}",
 untxmoves,     NULL,          UTXMOVES,     NULL,
 untxmovef,     NULL,          UTXMOVEF,     NULL,
 untxdesa,      NULL,          UTXDESA,      "{UDELETE}",
 untxdefa,      NULL,          UTXDEFA,      "{UDELETE}",
 untxmovem,     NULL,          UTXMOVEM,     NULL,
 untxmoves1,    NULL,          UTXMOVES1,    "{UINSERT}",
 untxmovef1,    NULL,          UTXMOVEF1,    "{UINSERT}",
 utxcopys,      NULL,          UTXCOPYS,     "{UINSERT}",
 utxcopyf,      NULL,          UTXCOPYF,     "{UINSERT}",
};





os_error * txddinit(void)
{
 os_error * err;


          err=undoaddblock(undos,UNDOS);
 if(!err) err=addevent(EVENT_SELECTALL,(eventfn)aselectall,0);
 if(!err) err=addevent(EVENT_CLEARSELECTION,(eventfn)aclearselection,0);
 if(!err) err=addevent(EVENT_DELETESELECTION,(eventfn)adeleteselection,0);
 if(!err) err=addevent(EVENT_CANDELETESELECTION,(eventfn)acancopyselection,0);
 if(!err) err=addevent(EVENT_COPYSELECTION,(eventfn)acopyselection,0);
 if(!err) err=addevent(EVENT_CANCOPYSELECTION,(eventfn)acancopyselection,0);
 if(!err) err=addevent(EVENT_CUTSELECTION,(eventfn)acutselection,0);
 if(!err) err=addevent(EVENT_PASTESELECTION,(eventfn)apasteselection,0);
 if(!err) err=addevent(EVENT_PASTENAME,(eventfn)apastename,0);
//  if(!err) err=txcbregister(txtxcbpaste,txtxcbcopy);

 return(err);
}

