/*->c.ustyle */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "font.h"
#include "transform.h"

#include "etc.h"
#include "err.h"
#include "crc.h"
#include "xext.h"
#include "bits.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "key.h"
#include "trans.h"
#include "poll.h"
#include "keylegacy.h"
#include "deb.h"


#include "str.h"
#include "constants.h"

#include "reslink.h"
#include "xredraw.h"
#include "object.h"

#include "xcolour.h"

#include "file.h"
#include "view.h"
#include "undo.h"


#include "txstr.h"
#include "tabs.h"
#include "fmap.h"
#include "fox.h"

#include "style.h"
#include "ustyle.h"




#define USSAVE    0x8000
#define USDELETE  0x8001
#define USUPDATES 0x8002
#define USUPDATEF 0x8003







userstylestr defstyle=
{

 "{STYLE07}",  /* name        */
  1,           /* CTRL_F1 won't fit in 16 bits so we set it in styleinit() */

  1,           /* menu        */
  1,           /* scope       */
  0,           /* no delete   */
  0,           /* not changed */

  0,           /* sparebits0  */

  0,           /* rank        */

  0,           /* sparebits1  */

  0,0,0,       /* spare */


  BODYTEXT,    /* number      */

  /* action bits */

  1, /* bold      */
  1, /* italic    */
  1, /* underline */
  1, /* reverse   */
  1, /* supersub  */
  1, /* strikeout */

  1, /* rulevert  */
  1, /* rulehoriz */

  1, /* font */
  1, /* fcolour */
  1, /* bcolour */
  1, /* size */
  1, /* hscale */
  1, /* track */
  1, /* baseshift */


  1, /* align */
  1, /* before */
  1, /* after */
  1, /* leading */
  1, /* left */
  1, /* right */
  1, /* first */
  1, /* case */
  1, /* drop */
  1, /* bullet */

  1, /* hyphenation */
  1, /* auto kern */
  1, /* word wrap */

  1, /* index */
  1, /* contents */
  1, /* layer    */

  1, /* base line lock */
  1, /* small caps */

  1, /* keeplines */
  1, /* keep para */
  1, /* keep next */

  1, /* language */

  1, /*  tab */

  1, /* rotate */
  1, /* skew   */

  1, /* justification */

  1, /* spare bytes */




  /* data words */

  0,             /* font */
  0,             /* real font number */

  OURBLACK,      /* fcolour */
  OURTRANS,      /* bcolour */
  OURTRANS,      /* colourvalue ulcolour - underline */
  OURTRANS,      /* colourvalue stcolour - strikeout */
  OURBLACK,      /* vrulecolour */
  OURBLACK,      /* hrulecolour */

  0x10000/50,    /* ulthickness 2% */
  0,             /* language */

  0x10000/50,    /* stthickness 2% */
  3,             /* dropno */

  0,             /* rotate */
  0,             /* skew   */


  12000,         /* xpts */
  5,             /* hpmin */

  12000,         /* ypts */
  2,             /* hpbefore */

  0,             /* track */
  2,             /* hpafter */

  0,             /* baseshift */
  0,             /* bulletbefore */

  0,             /* tab leader width */
  0,             /* bulletafter  */

  0,0,0,         /* tab leader char  */
  0,             /* bulletdata   */

  0,             /* height this is a number which comes from font man. */
  1,             /* bulletstart  */

  0,             /* vrule thickness */
  0,             /* justlettermin */

  0,             /* hrule thickness */
  25,            /* justlettermax */

  0,             /* hpzone */
  3,             /* hpconsec */ 

   0,            /* justflushzone */
 125/JUSTWORDSCALE,/* justwordmax   */

  0,             /* ruleaboveshift */
  75/JUSTWORDSCALE,/* justwordmin   */

  0,             /* rulebelowshift */  
  0,             /* bold */
  0,             /* italic */
  0,             /* underline */
  0,             /* reverse */
  0,             /* supersub 0 normal, 1 super, 2 sub             */
  0,             /* strikeout */
  0,             /* rulevert */

  0,             /* before */
  0,             /* rulehoriz */
  0,             /* align 0 left, 1 centre, 2 right, 3 justify */
  1,             /* left  0=from frame, 1=from obstruction              */
  1,             /* right 0=from frame, 1=from obstruction, 2 from left */
  0,             /* bullet */

  0,             /* after */
  0,             /* case */
  0,             /* drop */
  1,             /* ul type */
  1,             /* st type */

  BULLETNOSTYLE, /* bulletstyle  */
  0,             /* layer */
  0,             /* keeplines no */
  0,             /* hyphenation */
  0,             /* auto kern */
  1,             /* word wrap */
  0,             /* index */
  0,             /* contents */
  0,             /* baseline lock */


  0x10000/5,     /* leading 20% */
  0,             /* small caps */
  0,             /* keep lines */
  0,             /* keep para */ 
  0,             /* keep next */
  0,             /* uldouble */
  0,             /* ulword */
  0,             /* ruleabove */
  0,             /* rulebelow */


  0,             /* lead this is a number which comes from font man. */
  0,             /* ruleleft */
  0,             /* ruleright */
  0,             /* hpbreaklast */
  0,             /* hpbreakcaps */
  LEADPC,        /* leadingtype */
  0,             /* bullet or number */


  0,             /* point to tabs */
  1,             /* bullet tab       */
  0,             /* justification        */
  0,             /* justify single words */
  0,             /* after type */
  0,             /* before type */
  0,             /* spare */

  0,             /* left */

  0,             /* right */

  0,             /* first */

		0,													// bulletbefore2;
  0,             // bulletafter2;
  0,             // bulletdata2;
  0,             /* ruleleftshift  */

  0,             /* rulerightshift */

};





void getdefstyle(userstylestr * s)
{
 *s=defstyle;
}








int cmpustylen(const void * s1,const void * s2)
{
 return(((userstylestr*)s1)->style.n-((userstylestr*)s2)->style.n);
}


int cmpustyles(const void * ss1,const void * ss2)
{
 userstylestr * s1=(userstylestr*)ss1;
 userstylestr * s2=(userstylestr*)ss2;
 int            code;

 code=memcmp(&s1->style.action,&s2->style.action,sizeof(actionbits));
 if(code) return(code);
 return(memcmp(&s1->style.data,&s2->style.data,sizeof(datawords)));
}



/* compare fonts, not mfonts */
/* compare colour values     */
/* compare tab rulers        */


int cmpustylesf(const void * ss1,filestr * file1,
                const void * ss2,filestr * file2)
{
 userstylestr  s1=*((userstylestr*)ss1);
 userstylestr  s2=*((userstylestr*)ss2);
 int           code;

 code=memcmp(&s1.style.action,&s2.style.action,sizeof(actionbits));

/*
 dprintf(4,"action"); 

 if(code)
 {
  char * p=(char*)&s1.style.action;
  char * q=(char*)&s2.style.action;
  int    n=0;

  while(*p++==*q++) n++;

  dprintf(4,"diff %d size=%d spare=%d %d",n,sizeof(actionbits),
                      s1.style.action.spare,s2.style.action.spare);
 }
*/

 if(code) return(code);

 s1.style.data.mfont=s2.style.data.mfont;


 code=cmpcolourdataf(&s1.style.data.fcolour,file1,
                     &s2.style.data.fcolour,file2);

/* dprintf(4,"colour1");  */

 if(code) return(code);
 s1.style.data.fcolour.data.tint.key=s2.style.data.fcolour.data.tint.key;


 code=cmpcolourdataf(&s1.style.data.bcolour,file1,
                     &s2.style.data.bcolour,file2);

/* dprintf(4,"colour2");  */

 if(code) return(code);
 s1.style.data.bcolour.data.tint.key=s2.style.data.bcolour.data.tint.key;


 code=cmpcolourdataf(&s1.style.data.ulcolour,file1,
                     &s2.style.data.ulcolour,file2);

/* dprintf(4,"colour3");  */

 if(code) return(code);
 s1.style.data.ulcolour.data.tint.key=s2.style.data.ulcolour.data.tint.key;


 code=cmpcolourdataf(&s1.style.data.stcolour,file1,
                     &s2.style.data.stcolour,file2);
 if(code) return(code);
 s1.style.data.stcolour.data.tint.key=s2.style.data.stcolour.data.tint.key;


 code=cmpcolourdataf(&s1.style.data.vrulecolour,file1,
                     &s2.style.data.vrulecolour,file2);
 if(code) return(code);
 s1.style.data.vrulecolour.data.tint.key=
                                   s2.style.data.vrulecolour.data.tint.key;


 code=cmpcolourdataf(&s1.style.data.hrulecolour,file1,
                     &s2.style.data.hrulecolour,file2);
 if(code) return(code);
 s1.style.data.hrulecolour.data.tint.key=
                                   s2.style.data.hrulecolour.data.tint.key;


 code=cmptabdataf(s1.style.data.tab,file1,s2.style.data.tab,file2);
/* dprintf(4,"tabs");   */

 if(code) return(code);
 s1.style.data.tab=s2.style.data.tab;

/* dprintf(0,"k1=%d bs1=%d k2=%d bs2=%d",
            s1.style.n,s1.style.data.bulletstyle,
            s2.style.n,s2.style.data.bulletstyle); */


 if(s1.style.action.bullet)
 {
  if(s1.style.data.bulletstyle==BULLETSELFSTYLE &&
     (int)s2.style.data.bulletstyle==s2.style.n)
  {
   s1.style.data.bulletstyle=s2.style.data.bulletstyle;
  }
 }
 else
 {
  s1.style.data.bulletstyle=s2.style.data.bulletstyle;
 }

/* dprintf(4,"style");   */

 code=(memcmp(&s1.style.data,&s2.style.data,sizeof(datawords)));

/*

 {
  char * p1=(char*)&s1.style.data;
  char * p2=(char*)&s2.style.data;
  int    n;

  for(n=0;n<sizeof(datawords);n++)
  {
   if(*p1!=*p2) dprintf(0,"diff at %d",n);
   p1++;
   p2++;
  }
 }

 dprintf(0,"code=%d a1=%d a2=%d",code,s1.style.data.ascent,s2.style.data.ascent);

*/

 return(code);
}





static int cmpustylex(const void * ss1,const void * ss2)
{
 userstylestr * s1=(userstylestr*)ss1;
 userstylestr * s2=(userstylestr*)ss2;
 int            code;

           code=strcmp(s1->name,s2->name);
 if(!code) code=s1->key-s2->key;
 if(!code) code=s1->menu-s2->menu;
 if(!code) code=s1->scope-s2->scope;
 if(!code) code=s1->rank-s2->rank;

 return(code);
}


os_error * copystylemap(filestr * file,userstylebasestr ** newstylebase)
{
 os_error          * err;
 userstylebasestr  * userstylebase;
 int                 styles;
 int                 size;
 int                 i;
 int                 n;


 styles=file->hdr.ustyles;

 userstylebase=(userstylebasestr*)fob_find(styles,file);
 size=sizeof(userstylebasestr)+(userstylebase->n-1)*sizeof(userstylestr);

 err=flex_alloc((flex_ptr)newstylebase,size);
 if(!err)
 {
  userstylebase=(userstylebasestr*)fob_find(styles,file);
  XMEMCPYX(*newstylebase,userstylebase,size);

  n=(*newstylebase)->n;

  for(i=0;i<n;i++)
  {
   duptabruler(file,(*newstylebase)->userstyle[i].style.data.tab);
   fmapdup(file,(*newstylebase)->userstyle[i].style.data.mfont);
  }
 }

 return(err);
}




/*
   The user styles have changed.
   We must work out which ones have changed or been deleted
   Sort out style chains
   Find which abs styles have changed, and construct map
   Map all text sources in this file
   Do reflows 
 */


static void clearuserchanges(userstylebasestr * sbase)
{
 int i;

 for(i=0;i<sbase->n;i++)
 {
  sbase->userstyle[i].changed=0;
 }
}


/* this can be called from the user styles having changed  */
/* in which case changesa will be zero                     */
/* or it can be called when we need to substitute fonts on */
/* loading. in that case changesa can be non-zero          */
/* but we want to keep both abs styles that have changed   */
/* fonts, or depend on user styles with changed fonts      */


os_error * stylemapchange(int changesu,int changesa,filestr * file)
{
 os_error         * err;
 int                ustyles;
 userstylebasestr * userstylebase;
 int                message;


 ustyles=file->hdr.ustyles;

 err=NULL;


 if(changesu || changesa)
 {
  updatestylechains(file,&changesu);

  userstylebase=(userstylebasestr*)fob_find(ustyles,file);
  clearuserchanges(userstylebase);

  if(changesu || changesa)
  {
   updateabsstyles(file,&changesa,changesa==0);

   clearchainchanges(file);


   if(changesa)
   {
    message=OM_REMAPSTYLES;
    broadcastmessage(file,&message,NULL);
    clearabschanges(file);
   }
  }
 }

 return(err);
}


static os_error * savestyle(userstylestr * s,filestr * file)
{
 userstylestr temp;
 temp=*s;
 return(undowritefn(file,USSAVE,&temp,sizeof(userstylestr)));
}


/* tagged to USDELETE */

static os_error * undeletestyle(filestr * file)
{
 int                 key;
 int                 ustyles;
 userstylestr      * userstyle;
 userstylestr        temp;
 userstylebasestr  * userstylebase;
 int                 n;


 undoread(file,&key,sizeof(int));


 ustyles=file->hdr.ustyles;

 userstylebase=(userstylebasestr*)fob_find(ustyles,file);

 temp.style.n=key;
 userstyle=(userstylestr*)bsearch(&temp,userstylebase->userstyle,userstylebase->n,
                                            sizeof(userstylestr),cmpustylen);

 n=userstyle-userstylebase->userstyle;
 if(userstyle)
 {
  temp=*userstyle;

  memmove(userstyle,userstyle+1,(userstylebase->n-n-1)*sizeof(userstylestr));
  userstylebase->n--;
  fob_change(ustyles,file,sizeof(userstylebasestr)+
            (userstylebase->n-1)*sizeof(userstylestr),(fobjptr)&userstylebase);
  undowritefn(file,USSAVE,&temp,sizeof(userstylestr));
 }

 return(NULL);
}


/* tagged to USSAVE */


static os_error * unsavestylescrap(filestr * file)
{
 userstylestr        temp;

 undoread(file,&temp,sizeof(userstylestr));
 fmaprem(file,temp.style.data.mfont,1);

/* dprintf(2,"style scrap"); */

 return(remtabruler(file,temp.style.data.tab));
}


static os_error * unsavestyle(filestr * file)
{
 userstylestr        temp;
 userstylestr        temp2;
 userstylebasestr  * userstylebase;
 int                 ustyles;
 userstylestr      * userstyle;
 int                 n;

 undoread(file,&temp,sizeof(userstylestr));

 ustyles=file->hdr.ustyles;

 userstylebase=(userstylebasestr*)fob_find(ustyles,file);

 userstyle=(userstylestr*)bnearest(&temp,userstylebase->userstyle,userstylebase->n,
                                              sizeof(userstylestr),cmpustylen);
 n=userstyle-userstylebase->userstyle;
 if(n<userstylebase->n && userstyle->style.n==temp.style.n)
 {
  temp2=*userstyle;
  temp.changed=(cmpustyles(userstyle,&temp)!=0);
  *userstyle=temp;
  undowritefn(file,USSAVE,&temp2,sizeof(userstylestr));
 }
 else
 {
  fob_change(ustyles,file,sizeof(userstylebasestr)+
               userstylebase->n*sizeof(userstylestr),(fobjptr)&userstylebase);

  memmove(userstylebase->userstyle+n+1,userstylebase->userstyle+n,
                              sizeof(userstylestr)*(userstylebase->n-n));

  temp.changed=1;
  userstylebase->userstyle[n]=temp;
  userstylebase->n++;

  undowritefn(file,USDELETE,&temp.style.n,sizeof(int));
 }

 return(NULL);
}


static int xchanges;

/* tagged to USUPDATES */
/* this function is always called last in undo/redo */

static os_error * unupdatestyles(filestr * file) 
{
/* dprintf(1,"unupdatestyles"); */

 undowritefn(file,USUPDATEF,&xchanges,sizeof(int));

 stylemapchange(xchanges,0,file);
 event(EVENT_USERSTYLECHANGE,file,0);

 return(NULL);
}


/* tagged to USUPDATEF */
/* this function is always first in undo/redo */

static os_error * unupdatestylef(filestr * file)
{
 int                ustyles;
 userstylebasestr * userstylebase;

/* dprintf(1,"unupdatestylef"); */

 undoread(file,&xchanges,sizeof(int));

 undowritefn(file,USUPDATES,NULL,0);

 ustyles=file->hdr.ustyles;
 userstylebase=(userstylebasestr*)fob_find(ustyles,file);

 clearuserchanges(userstylebase);

 return(NULL);
}




/* 

  go through all abs styles, see which depend on style chains that have
  changed.

  if the chain has changed, fill in the style again

*/


os_error * updatestylemap(filestr * file,userstylebasestr ** newstylebase)
{
 os_error         * err;
 userstylebasestr * userstylebase;
 int                ustyles;
 int                oldsize;
 int                newsize;
 int                n;
 userstylestr     * rs;
 userstylestr     * ws;
 userstylestr     * ns;
 int                ri;
 int                wi;
 int                ni;
 int                changes;
 int                key;
 int                changestyle;
 int                mfont;


 err=modfile(file,0);
 if(!err)
 {
  undostart(file);

  undowritefn(file,USUPDATES,NULL,0);

  ustyles=file->hdr.ustyles;

  fob_lock((fobjptr)&userstylebase,ustyles,file);

  clearuserchanges(*newstylebase);
  clearuserchanges(userstylebase);

  newsize=(*newstylebase)->n;
  oldsize=userstylebase->n;
  ri=wi=ni=0;
  changes=0;

  while(ri<oldsize && wi<oldsize && ni<newsize)
  {
   rs=&userstylebase->userstyle[ri];
   ns=&(*newstylebase)->userstyle[ni];

   if(ns->style.n>rs->style.n)
   {
    /* scrapping a style */
    savestyle(rs,file);
    changes++;
    ri++;
   }
   else
   if(ns->style.n==rs->style.n)
   {
    changestyle=cmpustyles(rs,ns);
    if(changestyle || cmpustylex(rs,ns))
    {
     /* scrap old style */
     savestyle(rs,file);
     mfont=ns->style.data.mfont;
     duptabruler(file,ns->style.data.tab);
     fmapdup(file,mfont);
     ws=&userstylebase->userstyle[wi];
     *ws=(*newstylebase)->userstyle[ni];
     if(changestyle) ws->changed=1;
     changes++;
    }
    else
    {
     if(ri!=wi) userstylebase->userstyle[wi]=*rs;
    }

    wi++;
    ri++;
    ni++;
   }
  }  

  /* scrap from r to end of buffer */

  while(ri<oldsize)
  {
   rs=&userstylebase->userstyle[ri];
   savestyle(rs,file);
   ri++;
   changes++;
  }

  n=newsize-ni;
  oldsize=sizeof(userstylebasestr)+(wi+n-1)*sizeof(userstylestr);
  err=fob_change(ustyles,file,oldsize,(fobjptr)&userstylebase);

  while(n--)
  {
   /* add these styles */
   key=(*newstylebase)->userstyle[ni].style.n;
   undowritefn(file,USDELETE,&key,sizeof(int));
   duptabruler(file,(*newstylebase)->userstyle[ni].style.data.tab);
   fmapdup(file,(*newstylebase)->userstyle[ni].style.data.mfont);
   userstylebase->userstyle[wi]=(*newstylebase)->userstyle[ni];
   wi++;
   ni++;
  }

  userstylebase->n=wi;
  
  userstylebase->sequence=(*newstylebase)->sequence;

  fob_unlock((fobjptr)&userstylebase,file);

  undowritefn(file,USUPDATEF,&changes,sizeof(int));
  undoend(file);

  err=stylemapchange(changes,0,file);
  event(EVENT_USERSTYLECHANGE,file,0);
 }
 return(err);
}


os_error * losestylemap(filestr * file,userstylebasestr ** newstylebase)
{
 int i;
 int n;

 n=(*newstylebase)->n;

 for(i=0;i<n;i++)
 {
  remtabruler(file,(*newstylebase)->userstyle[i].style.data.tab);
  fmaprem(file,(*newstylebase)->userstyle[i].style.data.mfont,1);
 }

 flex_free((flex_ptr)newstylebase);

 return(NULL);
}


os_error * deletestyle(filestr * file,userstylebasestr ** userstylebase,int n)
{
 os_error * err;

 err=remtabruler(file,(*userstylebase)->userstyle[n].style.data.tab);
 err=fmaprem(file,(*userstylebase)->userstyle[n].style.data.mfont,1);

 err=flex_midextend((flex_ptr)userstylebase,
      sizeof(userstylebasestr)+(n*sizeof(userstylestr)),-(int)sizeof(userstylestr));
 if(!err) (*userstylebase)->n--;

 return(err);
}


/* generate a new user style */

os_error * createstyle(userstylebasestr ** userstylebase)
{
 os_error     * err;
 int            n;
 userstylestr * userstyle;

 n=(*userstylebase)->n;

 err=flex_extend((flex_ptr)userstylebase,
                            sizeof(userstylebasestr)+(n*sizeof(userstylestr)));
 if(!err)
 {
  (*userstylebase)->n++;
  userstyle=&(*userstylebase)->userstyle[n];
  userstyle->style.n=(*userstylebase)->sequence++;

  if(userstyle->style.n==BODYTEXT) (*userstylebase)->sequence=MINUSINT;

  userstyle->name[0]=0;
 }
 return(err);
}




int finduserstylebase(userstylebasestr  * sbase,int n)
{
 userstylestr        t;
 userstylestr      * r;

 t.style.n=n;

 r=(userstylestr*)bsearch(&t,&sbase->userstyle[0],sbase->n,
                                            sizeof(userstylestr),cmpustylen);
 if(r) return(r-&sbase->userstyle[0]);
 else  return(0);
}




os_error * finduserstylep(userstylestr ** s,int n,filestr * file)
{
 os_error          * err;
 userstylebasestr  * sbase;
 userstylestr      * r;
 userstylestr        t;
 int                 styles;


 err=NULL;

 styles=file->hdr.ustyles;
 sbase=(userstylebasestr*)fob_find(styles,file);

 t.style.n=n;
 r=(userstylestr*)bsearch(&t,&sbase->userstyle[0],sbase->n,
                                          sizeof(userstylestr),cmpustylen);
 *s=r;

 return(err);
}







os_error * finduserstyle(userstylestr * s,int n,filestr * file)
{
 os_error      * err;
 userstylestr      * r;

 err=finduserstylep(&r,n,file);

 if(r) *s=*r;
 else   s->style.n=0;

 return(err);
}




os_error * finduserstylex(xstylestr * s,int n,filestr * file)
{
 os_error      * err;
 userstylestr  * r;

 err=finduserstylep(&r,n,file);

 if(r) *s=r->style;
 else   s->n=0;

 return(err);

}





int finduserstylebynameb(char * name,userstylebasestr * sbase,
                                                        userstylestr * us)
{
 int             i;

 for(i=0;i<sbase->n;i++)
 {
  if(!cstrcmp(sbase->userstyle[i].name,name))
  {
   if(us) *us=sbase->userstyle[i];
   return(i);
  }
 }

 return(-1);
}




int finduserstylebyname(char * name,filestr * file,userstylestr * us)
{
 userstylebasestr  * sbase;
 int                styles;

 styles=file->hdr.ustyles;
 sbase=(userstylebasestr*)fob_find(styles,file);

 return(finduserstylebynameb(name,sbase,us));
}



void nextstylename(char * name,int * n)
{
 int    len;
 char * p;

 len=strlen(name);

 if(isdigit(name[len-1]) && isdigit(name[len-2]))
 {
  if(*n==0) *n=(name[len-2]-'0')*10+(name[len-1]-'0');
  p=name+(len-2);
 }
 else
 {
  if(len>(STYLENAMELEN-3)) len=(STYLENAMELEN-3);
  p=name+len;
 }

 *n=(*n)+1;

 sprintf(p,"%02d",*n);
}



/* turn name into a unique style name */

void newstylenameb(char * name,userstylebasestr * sbase)
{
 int n;

 n=0;

 while(1)
 {
  nextstylename(name,&n);
  if(finduserstylebynameb(name,sbase,NULL)<0) break;
 }
}


/*
void newstylename(char * name,filestr * file)
{
 userstylebasestr  * sbase;
 int                 styles;

 styles=file->hdr.ustyles;
 sbase=fob_find(styles,file);

 newstylenameb(name,sbase);
}
*/


os_error * checkuserstyle(userstylestr * us,filestr * file)
{
 us->style.data.font=fontuserfromstyle2(us->style.data.font,
                                    us->style.data.bold,
                                    us->style.data.italic);

 return(getstylefbbox(&us->style,file));
}



os_error * adduserstyle2(userstylestr * us,filestr * file,int * key,int overwrite,int copyrank)
{
 os_error          * err;
 userstylebasestr  * sbase;
 int                 styles;
 userstylestr        oldstyle;
 userstylestr      * usp;
 int                 mfont;
 int                 usn;


 checkuserstyle(us,file);

 styles=file->hdr.ustyles;

 if(overwrite && finduserstylebyname(us->name,file,&oldstyle)>=0)
 {
//  cprintf("add user remtabruler %d",oldstyle.style.data.tab);

           err=remtabruler(file,oldstyle.style.data.tab);
  if(!err) err=fmaprem(file,oldstyle.style.data.mfont,1);

  fmapadd(file,us->style.data.font,1,&mfont);
  us->style.data.mfont=mfont;

  duptabruler(file,us->style.data.tab);

  us->style.n=oldstyle.style.n;

  usn=ustylekey(us->key,NULL,file);
  if(usn) us->key=oldstyle.key;

  finduserstylep(&usp,oldstyle.style.n,file);

  *usp=*us;

  if(oldstyle.style.n==BODYTEXT) 
  {
   stylesetall(&usp->style);
   usp->nodelete=1;
  }
  else
  {
   usp->nodelete=0;
  }

  usp->rank=oldstyle.rank;

  if(usp->style.data.bulletstyle==BULLETSELFSTYLE) 
  {
   usp->style.data.bulletstyle=oldstyle.style.n;
  }

  if(key) *key=oldstyle.style.n;
 }
 else
 {
  fmapadd(file,us->style.data.font,1,&mfont);
  us->style.data.mfont=mfont;

  sbase=(userstylebasestr*)fob_find(styles,file);

  err=fob_change(styles,file,sizeof(userstylebasestr)+
                             sbase->n*sizeof(userstylestr),(fobjptr)&sbase);

  if(!err)
  {
   us->style.n=sbase->sequence;

   if(us->style.n==BODYTEXT)
   {
    sbase->sequence=MINUSINT;
    us->nodelete=1;
   }
   else
   {
    sbase->sequence++;
    us->nodelete=0;
   }

   if(key) *key=us->style.n;

   if(us->style.data.bulletstyle==BULLETSELFSTYLE) 
   {
    us->style.data.bulletstyle=us->style.n;
   }

   if(copyrank)
   {


   }
   else
   {
    if(sbase->userstyle[0].rank!=0)
    {
     us->rank=sbase->n+1;
    }
   }

   usn=ustylekeys(sbase,us->key,NULL);
   if(usn) us->key=-1;

   sbase->userstyle[sbase->n++]=*us;
   duptabruler(file,us->style.data.tab);
  }
 }

 return(err);
}



os_error * adduserstyle(userstylestr * us,filestr * file,int * key,int overwrite)
{
 return(adduserstyle2(us,file,key,overwrite,0));
}





os_error * makedefstyle(filestr * file,char * name,int * key)
{
 os_error    * err;
 userstylestr  us;
 int           tab;
 int           mfont;

 us=defstyle;
 if(name) xzstrncpy(us.name,name,sizeof(us.name));

 us.style.data.font=defltfont();
 deftabruler(&tab,file);
 us.style.data.tab=tab;
 fmapadd(file,us.style.data.font,1,&mfont);
 us.style.data.mfont=mfont;

 err=adduserstyle2(&us,file,key,0,0);
 remtabruler(file,tab);
 fmaprem(file,mfont,1);

 return(err);
}



/* if needed, make a style with this name - avoid Bodytext problems */

os_error * makeuserstyle(filestr * file,char * name,int * key)
{
 int          n;
 userstylestr style;


 if(!cstrcmp(defstyle.name,name)) *key=BODYTEXT;
 else
 {
  n=finduserstylebyname(name,file,&style);

  if(n>=0) *key=style.style.n;
  else
  {
   return(makedefstyle(file,name,key));
  }
 }

 return(NULL);
}





int ustylekeys(userstylebasestr * stylebase,int ch,int * scope)
{
 int i;

 ch=keylegacyfromcode(ch);
 if(ch>=0)
 {
  for(i=0;i<stylebase->n;i++)
  {
   if(stylebase->userstyle[i].key==ch)
   {
    if(scope) *scope=stylebase->userstyle[i].scope;
    return(stylebase->userstyle[i].style.n);
   }
  }
 }

 return(0);
}


int ustylekey(int key,int * scope,filestr * file)
{
 int                ustyles;
 userstylebasestr * stylebase;

 ustyles=file->hdr.ustyles;
 stylebase=(userstylebasestr*)fob_find(ustyles,file);

 return(ustylekeys(stylebase,key,scope));
}



#define UNDOS 4

static undofnstr undos[UNDOS]=
{
 unsavestyle,    unsavestylescrap, USSAVE,       NULL,
 undeletestyle,  NULL,             USDELETE,     NULL,
 unupdatestyles, NULL,             USUPDATES,   "{USTYLE}",
 unupdatestylef, NULL,             USUPDATEF,   "{USTYLE}",
};




os_error * styleinit(void)
{
 os_error * err;

 err=undoaddblock(undos,UNDOS);


/* dprintf(0,"stylestr=%d action=%d data=%d",sizeof(absstylestr),
                                           sizeof(actionbits),
                                           sizeof(datawords)); */

 trans(defstyle.name,STYLENAMELEN);
 defstyle.key=keylegacyfromcode(CTRL_F1); // because CTRL_F1 won't fit in 16 bits

 return(err);
}

