/*->c.bits */


#include <stdafx.h>



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include "os.h"
#include "flex.h"
#include "alloc.h"

#include "etc.h"
#include "avl.h"
#include "deb.h"
#include "err.h"

#include "bits.h"




int cstrncmp(char * first,char * second,int n)
{
 int f;
 int s;

 while(n--)
 {
  f=toupper(*first++);
  s=toupper(*second++);
  if(f!=s || !f) return(f-s);
 }

 return(0);
}


int cstrcmp(char * first,char * second)
{
 return(cstrncmp(first,second,-1));
}



int xcstrncmp(char * first,char * second,int n)
{
 int f;
 int s;

 while(n--)
 {
  f=toupper(*first++);
  s=toupper(*second++);
  if(f<32 && s<32) return(0);
  if(f!=s) return(f-s);
 }

 return(0);
}



int xstrncmp22(unsigned short * first,unsigned short * second,int n)
{
 int f;
 int s;

 while(n--)
 {
  f=toupper(*first++);
  s=toupper(*second++);
  if(f!=s || !f) return(f-s);
 }

 return(0);
}




int cstrmatch(char * first,char * second,int n)
{
 int f;
 int s;
 int total;

 total=n;
 while(n)
 {
  f=toupper(*first++);
  s=toupper(*second++);
  if(f!=s || !f) break;
  n--;
 }

 return(total-n);
}



int cstrleading(char * first,char * second)
{
 int f;
 int s;

 while(1)
 {
  f=toupper(*first++);
  s=toupper(*second++);
		if(!s) break;
  if(f!=s) return(f-s);
 }

 return(0);
}




/* searches for nearest match in a sorted list                          */
/* pointer is to entry which key should be inserted before              */
/* if key should be added to end of list, pointer is to end of list + 1 */


void *bnearest2(const void *key,void *base,size_t nmemb,size_t size,
                                  int (*compar)(const void *, const void *),int * result)
{
 void * lo;
 void * hi;
 void * p;
 int    ii;
 int    loi;
 int    hii;
 int    cmp;

 ii=0;
 loi=0;
 hii=nmemb-1;


 if(!nmemb)
 {
  if(result) *result=-1;
  return(base);
 }

 lo=base;
 p=lo;                                       /* compiler/play safe */
 cmp=0;
 hi=(void*)(((char*)lo)+(nmemb-1)*size);

 while(hi>=lo)
 {
  p=(char*)((((unsigned int)lo)>>1) & 0x7FFFFFFF);
  p=(((char*)p)+((((unsigned int)hi)>>1) & 0x7FFFFFFF));
  if((((unsigned int)lo) & 0x1) && (((unsigned int)hi) & 0x1))
                                                      p=(((char*)p)+1);

  ii=loi+hii;
  if(ii & 1) p=(void*)(((char*)p)-size/2);
  ii=ii>>1;

  cmp=compar(p,key);

  if(!cmp)
  {
   if(result) *result=0;
   return(p);
  }
  else
  if(cmp<0)
  {
   lo=(void*)((char*)p+size);
   loi=ii+1;
  }
  else
  {
   hi=(void*)((char*)p-size);
   hii=ii-1;
  }
 }

 if(cmp<0) p=(void*)((char*)p+size);

 if(result) *result=cmp;

 return(p);
}


void *bnearest(const void *key,void *base,size_t nmemb,size_t size,
                                  int (*compar)(const void *, const void *))
{
 return(bnearest2(key,base,nmemb,size,compar,NULL));
}



TCHAR * memstring(int size)
{
 static TCHAR string[16];
 int K=size/1024;
 int M=K/1024;

 if(!M && !K) xsprintf(NITEM(string),NULL,string,"%d",size);
 else
 if(!M && K)  xsprintf(NITEM(string),NULL,string,"%dK",K);
 else
 {
  K-=M*1024;
  K=(K*100)/1024;
  if(K) xsprintf(NITEM(string),NULL,string,"%d.%02dM",M,K);
  else  xsprintf(NITEM(string),NULL,string,"%dM",M);
 }
 return(string);
}



char * unquotec(char * input,char * output)
{
 char * r;
 char * w;

 r=input;
 w=output;

 while(*r)
 {
  if(*r=='\"' || *r=='\\') *w++='\\';
  *w++=*r++;
 }

 *w=0;

 return(output);
}




char * unquotechar(int ch,char * w,int flags)
{
 int    t;

 if(ch=='\"' || ch=='\\')
 {
  *w++='\\';
  *w++=(char)ch;
 }
 else
 if((ch>=' ' && ch<0x7F) || (ch>=160) || (ch<160 && ch>0x7F && (flags & 0x1))) *w++=(char)ch;
 else
 if(ch=='\n')
 {
  *w++='\\';
  *w++='n';
 }
 else
 if(ch=='\r')
 {
  *w++='\\';
  *w++='r';
 }
 else
 if(ch=='\t')
 {
  *w++='\\';
  *w++='t';
 }
 else
 {
  *w++='\\';
  *w++='x';
  t=(ch>>4)&0xF;
  *w++=(char)((t<=9)?('0'+t):('a'+t-10));
  t=ch&0xF;
  *w++=(char)((t<=9)?('0'+t):('a'+t-10));
 }

	return(w);
}




char * unquoteblock(char * input,int size,char * output)
{
 char * r;
 char * w;
 int    ch;


 r=input;
 w=output;

 while(size--)
 {
  ch=*r++;
		w=unquotechar(ch,w,UNQUOTE160);
 }

 return(w);
}







char * quotec(char * input,char * output)
{
 char * r;
 char * w;
 int    escape;
 int    c;

 r=input;
 w=output;
 escape=0;


 while((c=*r)!=0)
 {
  if(c=='\\') escape=1;
  else
  {
   if(escape)
   {
    switch(c)
    {
     case 't':
              c='\t';
              break;
     case 'n':
              c='\n';
              break;
     case 'r':
              c='\r';
              break;
     case 'v':
              c='\v';
              break;
     case 'f':
              c='\f';
              break;
    }
    escape=0;
   }
   *w++=(char)c;
  }
  r++;
 }

 *w=0;

 return(output);
}





 /*
  * copies the string pointed to by s2 (including the terminating nul
  * character) into the array pointed to by s1. If copying takes place
  * between objects that overlap, the behaviour is undefined.
  * Returns: the value of s1.
  */


char * xstrcpy(char *s1, const char *s2)
{
 while((*s1++=*s2++)>=32);
 *(s1-1)=0;
 return(s1);
}


void xstripstr(char * p,int len)
{
 while(*p>=32 && len>0) {p++;len--;}
 *p=0;
}


void xstripstr32(char * p)
{
 char * q;

 q=NULL;
 while(*p>=32)
 {
  if(*p==32 && !q) q=p;
  else             q=NULL;
  p++;
 }
 if(q) *q=0;
}


// copy up to n chars, n includes the terminating zero 
// xstrncpy(s,"foot",4) gives s=="foo"
// coded so we don't go past n-1 chars of s2

char * xstrncpy(char *s1,char *s2,int n)
{

 n--;
 while(n-->0)
 {
  if((*s1++=*s2++)<32)
  {
   *(s1-1)=0;
   break;
  }
 }
 *s1=0;

 return(s1);
}




char * xzstrncpy(char *s1,char *s2,int n)
{

 n--;
 while(n-->0)
 {
  if((*s1++=*s2++)==0) break;
 }
 *s1=0;

 return(s1);
}




os_error * xzstrncpye(char *s1,char *s2,int n)
{

 n--;
 while(n-->0)
 {
  if((*s1++=*s2++)==0) return(NULL);
 }
 *s1=0;

	if(*s2) return(geterrorf(EMAXSTRING,"xzstrncpy"));
	return(NULL);
}



os_error * xzstrncpye21(unsigned short *s1,char *s2,int n)
{

 n--;
 while(n-->0)
 {
  if((*s1++=*s2++)==0) return(NULL);
 }
 *s1=0;

	if(*s2) return(geterrorf(EMAXSTRING,"xzstrncpy21"));
	return(NULL);
}



os_error * xzstrncpye22(unsigned short *s1,unsigned short *s2,int n)
{

 n--;
 while(n-->0)
 {
  if((*s1++=*s2++)==0) return(NULL);
 }
 *s1=0;
	if(*s2)	return(geterrorf(EMAXSTRING,"xzstrncpy22"));
	return(NULL);
}




os_error * xzstrncpyu(TCHAR *s1,TCHAR *s2,int n)
{

 n--;
 while(n-->0)
 {
  if((*s1++=*s2++)==0) return(NULL);
 }
 *s1=0;
	if(*s2)	return(geterrorf(EMAXSTRING,"xzstrncpyu"));
	return(NULL);
}







size_t xstrlen2(unsigned short *s)
{
 unsigned short * p;
 p=s;
 while(*s++>0);
 return(s-p-1);
}





int xstrlen(char *s)
{
 char * p;
 p=s;
 while(*s++>=32);
 return(s-p-1);
}


/*

static void xXMEMCPYX(char * d,char * s,int n)
{
 while(n-->0) *d++=*s++;
}

*/


// sequence of strings terminated with a zero length string

int xstrdblecount(char * string)
{
 int    n;
 char * p;

 p=string;
 n=0;

 while(1)
 {
  if(*p==0) break;
  p=p+strlen(p)+1;
  n++;
 }

 return(n);
}



int xstrcount(char * string,int ct)
{
 int count;
 int ch;

 count=0;

 while((ch=*string++)!=0)
 {
  if(ct==ch) count++;
 }

 return(count);
}



char * xstristr(char *haystack,char *needle)
{
	if(!*needle )
	{
		return(haystack);
 }   
	
	for(; *haystack; ++haystack )
	{
		if(toupper(*haystack)==toupper(*needle))
		{
			/*  * Matched starting char -- loop through remaining chars. */
			const char *h, *n;
			for(h=haystack,n=needle;*h && *n;++h,++n)
			{
				if(toupper(*h)!=toupper(*n))
				{
					break;
    }
   }
			if(!*n) /* matched all of 'needle' to null termination */
			{
				return(haystack); /* return the start of the match */
   }
  }
	}
	return(NULL);
}


void xstrislice(char * string,char * search,char * replace)
{
 char * p;
 int    len;
 int    slen;
 int    rlen;

 slen=strlen(search);
 rlen=strlen(replace);
 len=strlen(string);

 p=xstristr(string,search);
 if(p)
 {
  memmove(p+rlen,p+slen,len-((p+slen)-string)+1);
  XMEMCPYX(p,replace,rlen);
 }
}






void xstrslice(char * string,char * search,char * replace)
{
 char * p;
 int    len;
 int    slen;
 int    rlen;

 slen=strlen(search);
 rlen=strlen(replace);
 len=strlen(string);

 p=strstr(string,search);
 if(p)
 {
  memmove(p+rlen,p+slen,len-((p+slen)-string)+1);
  XMEMCPYX(p,replace,rlen);
 }
}

void xstrmap(char * string,int f,int r)
{
 int ch;

 while((ch=*string++)!=0)
 {
  if(ch==f) *(string-1)=(char)r;
 }
}




os_error * stralloc(char * str,char ** alloc)
{
 os_error * err;
 int        len;


 len=strlen(str)+1;

 err=salloc((flex_ptr)alloc,len);
 if(!err)
 {
  XMEMCPYX(*alloc,str,len);
 }

 return(err);
}


size_t ustrlen(TCHAR * p)
{
	return(lstrlen(p));
}


TCHAR * ustrcpy(TCHAR * p1,TCHAR * p2)
{
 return(lstrcpy(p1,p2));
}


TCHAR * ustrcat(TCHAR * p1,const TCHAR * p2)
{
	return(strcat(p1,p2));
}


int ustrcmp(const TCHAR * p1,const TCHAR * p2)
{
	return(strcmp(p1,p2));
}




void stripquotes(char * q,char * p)
{
 while(*p=='\"') p++;
 if(*p==0) return;
 while(*p!='\"' && *p!=0) *q++=*p++;
 *q=0;
}



#define BAR0 0
#define BAR1 1
#define BAR2 2
#define BAR3 3





os_error * gstrans(char * d,int maxlen,char * s,int * len)
{
 int    ch;
 int    barstate;
 char * d0;
	char * dlt;


 d0=d;
	dlt=d+maxlen;
 barstate=BAR0;

 while(1)
 {
  ch=*s++;

  switch(barstate)
  {
   case BAR0:                  /* the state looking for | seqs */
             if(ch=='|') 
             {
              barstate=BAR1;
              continue;
             }
             break;


   case BAR2:                  /* must be a | */
             if(ch!='|') 
             {
              ch+=128;
             }
             else
             {
              barstate=BAR3;
              continue;
             }
             break;

   case BAR3:
   case BAR1:                  /* | something */

             switch(ch)
             {
              case '!':
                       barstate=BAR2;
                       continue;

              case '?':
                       ch=127;
                       break;


               default:
                       if(ch>='@' && ch<='_') ch=ch-'@';
                       break;
             }
             if(barstate==BAR3) ch+=128;
             break;
  }


  *d++=(char)ch;
		if(d>=dlt)
  {
			d=dlt;
   break;
		}
  barstate=BAR0;
  if(ch==0) break;
 }

	*d=0;

 if(len) *len=d-d0;

 return(NULL);
}


/********************************************************************************/



typedef struct xmapstr
{
 int          parent;
 int          sibls[2];
 int          balance;
 int          key;

} xmapstr;





typedef struct xmapbasestr
{
 int len;
 int rootp;
 int size;
 int chunk;
 int (*cmp)(void *,void *);

 
} xmapbasestr;





void * xmapsearch(void * record,void * handle)
{
 int offset;

 offset=avlfind(record,((xmapbasestr*)handle)->rootp,(char*)handle+sizeof(xmapbasestr),((xmapbasestr*)handle)->cmp);
 if(offset>=0)
 {
  return((void*)(((char*)handle)+offset+sizeof(xmapbasestr)+sizeof(xmapstr)-sizeof(int)));
 }
 else
 {
  return(NULL);
 }
}



os_error * xmapadd2(void * record,void ** handle,void ** insert)
{
 os_error    * err;
 xmapbasestr * xbase;
 void        * s;

 xbase=((xmapbasestr*)(*handle));

 err=flex_chunk((flex_ptr)handle,sizeof(xmapbasestr)+xbase->len+xbase->size+sizeof(xmapstr)-sizeof(int),xbase->chunk*(xbase->size+sizeof(xmapstr)-sizeof(int)));
 if(!err)
 {
  xbase=((xmapbasestr*)(*handle));

  s=(void*)((char*)xbase+xbase->len+sizeof(xmapbasestr));
  memcpy(((char*)s)+sizeof(xmapstr)-sizeof(int),record,xbase->size);
  avlsearch(xbase->len,&xbase->rootp,(char*)xbase+sizeof(xmapbasestr),xbase->cmp);
  xbase->len+=xbase->size+sizeof(xmapstr)-sizeof(int);
		if(insert) *insert=(void*)((char*)s+sizeof(xmapstr)-sizeof(int));
 }

 return(err);
}


os_error * xmapadd(void * record,void ** handle)
{
	return(xmapadd2(record,handle,NULL));
}



os_error * xmaprem(void * record,void * handle)
{
 xmapbasestr * xbase;
	int           node;
	int           oldnode;

 xbase=((xmapbasestr*)handle);

	node=((char*)record)-((char*)xbase)-sizeof(xmapbasestr)-sizeof(xmapstr)+sizeof(int);

	avldelete(node,&xbase->rootp,(char*)xbase+sizeof(xmapbasestr),xbase->cmp);


	oldnode=xbase->len-(xbase->size+sizeof(xmapstr)-sizeof(int));

	if(oldnode!=node)
	{
 	avlreloc(node,oldnode,&xbase->rootp,(char*)xbase+sizeof(xmapbasestr));
 
  memcpy((char*)record,((char*)xbase)+xbase->len+sizeof(xmapbasestr)-xbase->size,xbase->size);
	}

	xbase->len-=(xbase->size+sizeof(xmapstr)-sizeof(int));


	return(NULL);
}



void * xmapnext(void * record,void * handle)
{
 xmapbasestr * xbase;
	int           node;
	int           state;
	int           offset;

 xbase=((xmapbasestr*)handle);

	if(record)
	{
 	node=((char*)record)-((char*)handle)-sizeof(xmapbasestr)-sizeof(xmapstr)+sizeof(int);
 	state=AVL_POSTORDER;
	}
	else
	{
 	node=xbase->rootp;
 	state=AVL_PREORDER;
	}


 offset=avlwalk(node,(char*)xbase+sizeof(xmapbasestr),&state);

 if(offset>=0)
 {
  return((void*)(((char*)handle)+offset+sizeof(xmapbasestr)+sizeof(xmapstr)-sizeof(int)));
 }
 else
 {
  return(NULL);
 }
}








int xmapcount(void * handle)
{
 xmapbasestr * xbase;

 xbase=((xmapbasestr*)(handle));

 return(xbase->len/(xbase->size+sizeof(xmapstr)-sizeof(int)));
}



void * xmaprecord(void * handle,int i)
{
 xmapbasestr * xbase;
 int           n;

 xbase=((xmapbasestr*)(handle));

 n=xbase->len/(xbase->size+sizeof(xmapstr)-sizeof(int));
 if(i<0 || i>=n) return(NULL);
 else            return((char*)handle+sizeof(xmapbasestr)+i*(xbase->size+sizeof(xmapstr)-sizeof(int))+sizeof(xmapstr)-sizeof(int));
}



os_error * xmapinit(void ** handle,int size,int chunk,int (*cmp)(void *,void *))
{
 os_error * err;

 err=flex_alloc((flex_ptr)handle,sizeof(xmapbasestr)+chunk*(size+sizeof(xmapstr)-sizeof(int)));
 if(!err)
 {
  ((xmapbasestr*)(*handle))->len=0;
  ((xmapbasestr*)(*handle))->rootp=-1;  
  ((xmapbasestr*)(*handle))->size=size;
  ((xmapbasestr*)(*handle))->chunk=chunk;
  ((xmapbasestr*)(*handle))->cmp=cmp;
 }

 return(err);
}



os_error * xmapfinit(void ** handle)
{

 return(flex_free((flex_ptr)handle));
}


/************************************************************************************/


os_error * xsetadd(int key,void ** handle)
{
 os_error * err;
 void     * p;

 err=NULL;

 p=xmapsearch(&key,*handle);
 if(!p)
 {
  err=xmapadd(&key,handle);
 }

 return(err);
}


// returns 0 if key exists, or non-zero if it does not exist

int xsetsearch(int key,void * handle)
{
 return(xmapsearch(&key,handle)==NULL);
}


int xsetcount(void * handle)
{
 return(xmapcount(handle));
}


int xsetmember(void * handle,int i)
{
 int * p;

 p=(int*)xmaprecord(handle,i);

 return(*p);
}


os_error * xsetfinit(void ** handle)
{
 return(xmapfinit(handle));
}


static int smcmp2(void * key1,void * key2)
{
 return((*((int*)key1))-(*((int*)key2)));
}



os_error * xsetinit(void ** handle,int chunk)
{
 return(xmapinit(handle,sizeof(int),chunk,smcmp2));
}



/************************************************************************************/




typedef struct stringheapstr
{
	int len;
 int chunk;


} stringheapstr;





os_error * stringheapfinit(void ** handle)
{

 return(flex_free((flex_ptr)handle));
}



os_error * stringheapinit(void ** handle,int chunk)
{
 os_error * err;

 err=flex_alloc((flex_ptr)handle,sizeof(stringheapstr)+chunk);
 if(!err)
 {
  ((stringheapstr*)(*handle))->len=sizeof(stringheapstr);
  ((stringheapstr*)(*handle))->chunk=chunk;
 }

 return(err);
}



os_error * stringheapsize(void ** handle,int len,int * offset)
{
	os_error      * err;
	stringheapstr * sh;

 sh=((stringheapstr*)(*handle));
	len++;

 err=flex_chunk((flex_ptr)handle,sh->len+len,sh->chunk);
	if(!err)
	{
		sh=((stringheapstr*)(*handle));

		*offset=sh->len;
		sh->len+=len;
	}

	return(err);
}



int stringheaplength(void * handle)
{
	stringheapstr * sh;

 sh=((stringheapstr*)handle);

 return(sh->len);
}



os_error * stringheapadd(void ** handle,char * string,int * offset)
{
	os_error      * err;
	int             len;
	stringheapstr * sh;

 sh=((stringheapstr*)(*handle));
	len=strlen(string)+1;

 err=flex_chunk((flex_ptr)handle,sh->len+len,sh->chunk);
	if(!err)
	{
		sh=((stringheapstr*)(*handle));

		memcpy((char*)(*handle)+sh->len,string,len);

		*offset=sh->len;
		sh->len+=len;
	}

	return(err);
}


char * stringheapstring(void * handle,int offset)
{
	return((char*)((char*)handle+offset));
}




/*******************************************************************************/




int atoix(char * string,int * len)
{
 char * p;
 int    val;
 int    c;


 p=string;
 val=0;

 while((c=tolower(*p++))!=0)
 {
  if(isdigit(c)) val=val*16+(c-'0');
  else
  if(c>='a' && c<='f') val=val*16+(c-'a'+10);
  else
  {
   p--;
   break;
  }
 }

 if(len) *len=p-string;

 return(val);
}



int getint(char * string,int * len)
{
 char * p;
 int    minus=0;
 int    val=0;
 int    mul=10;
 int    c;

 p=string;
 if(*p=='-') {minus=1;p++;}
 if(*p=='0' && *(p+1)=='x') {mul=16;p+=2;}

 while((c=tolower(*p++))!=0)
 {
  if(isdigit(c)) val=val*mul+(c-'0');
  else
  if(c>='a' && c<='f') val=val*mul+(c-'a'+10);
  else
  {
   p--;
   break;
  }
 }

 if(minus) val=-val;
 if(len) *len=p-string;

 return(val);
}



int isnumberstring(char * p)
{
 int c;
 int hex;

 hex=0;

 if(*p=='-') p++;
 if(*p=='0' && *(p+1)=='x') {p+=2;hex=1;}

 while((c=tolower(*p++))!=0)
 {
  if((!isdigit(c)) && (!hex || (!(c>='a' && c<='f')))) return(0);
 }

 return(1);
}




/*************************************************************************************/



os_error * xsprintf(int maxlen,int * used,char * string,char * format, ...)
{
 va_list    args;
 int        len;

 va_start(args,format);
 VSNPRINTF(string,maxlen,format,args,len);
 va_end(args);

 if(len<0) return(geterrorf(EMAXSTRING,format));

	if(used) *used=len;

 return(NULL);
}




os_error * xsprintf2(int maxlen,int * used,wchar_t * string,wchar_t * format, ...)
{
 va_list    args;
 int        len;

 va_start(args,format);
 VSNWPRINTF(string,maxlen,format,args,len);
 va_end(args);

 if(len<0) return(geterrorf(EMAXSTRING,format));

	if(used) *used=len;

 return(NULL);
}



os_error * xsprintfu(int maxlen,int * used,TCHAR * string,TCHAR * format, ...)
{
 va_list    args;
 int        len;

 va_start(args,format);
 VSNTPRINTF(string,maxlen,format,args,len);
 va_end(args);

 if(len<0) return(geterrorf(EMAXSTRING,format));

	if(used) *used=len;

 return(NULL);
}




/**************************************************************************************/






int xftoa(double f,char * string,int max,int dp)
{
 char * r;
 int    dec;
 int    sign;
 char * p;
 char * lt;
 int    i;
 char * dpptr;


 dpptr=NULL;

 r=_fcvt(f,dp,&dec,&sign);

 p=string;
 lt=string+max;

 if(sign) *p++='-';

 i=0;

 while(i<dec)
 {
  if(p>=lt) break;
  *p++=*r++;
  i++;
 }

 if(p<lt && i==0) *p++='0';
 if(p<lt)
 {
  dpptr=p;
  *p++='.';
 }

 while(dec++<0)
 {
  if(p>=lt) break;  
  *p++='0';
 }


 while(1)
 {
  if(p>=lt) break;
  if((*p++=*r++)==0) break;
 }


 string[max-1]=0;

 if(dpptr && p<lt)
 {
  p-=2;
  while(p>(dpptr+1))
  {
   if(*p=='0')
   {
    *p--=0;
   }
   else
   {
    break;
   }
  }
 }

 return(p>lt);
}



/*

		  byte[] bom = new byte[4]; // Get the byte-order mark, if there is one
    file.Read(bom, 0, 4);
    if ((bom[0] == 0xef && bom[1] == 0xbb && bom[2] == 0xbf) || // utf-8
        (bom[0] == 0xff && bom[1] == 0xfe) || // ucs-2le, ucs-4le, and ucs-16le
        (bom[0] == 0xfe && bom[1] == 0xff) || // utf-16 and ucs-2
        (bom[0] == 0 && bom[1] == 0 && bom[2] == 0xfe && bom[3] == 0xff)) // ucs-4
    {
        enc = System.Text.Encoding.Unicode;



Here's the file "Hello" in various encodings: 

48 65 6C 6C 6F 
This is the traditional ANSI encoding.

48 00 65 00 6C 00 6C 00 6F 00 
This is the Unicode (little-endian) encoding with no BOM.

FF FE 48 00 65 00 6C 00 6C 00 6F 00 
This is the Unicode (little-endian) encoding with BOM. The BOM (FF FE) serves two purposes: First, it tags the file as a Unicode document, and second, the order in which the two bytes appear indicate that the file is little-endian.

00 48 00 65 00 6C 00 6C 00 6F 
This is the Unicode (big-endian) encoding with no BOM. Notepad does not support this encoding.

FE FF 00 48 00 65 00 6C 00 6C 00 6F 
This is the Unicode (big-endian) encoding with BOM. Notice that this BOM is in the opposite order from the little-endian BOM.

EF BB BF 48 65 6C 6C 6F 
This is UTF-8 encoding. The first three bytes are the UTF-8 encoding of the BOM.

2B 2F 76 38 2D 48 65 6C 6C 6F 
This is UTF-7 encoding. The first five bytes are the UTF-7 encoding of the BOM. Notepad doesn't support this encoding.

Notice that the UTF7 BOM encoding is just the ASCII string "+/v8-", which is difficult to distinguish from just a regular file that happens to begin with those five characters (as odd as they may be). 

The encodings that do not have special prefixes and which are still supported by Notepad are the traditional ANSI encoding (i.e., "plain ASCII") and the Unicode (little-endian) encoding with no BOM. When faced with a file that lacks a special prefix, Notepad is forced to guess which of those two encodings the file actually uses. The function that does this work is IsTextUnicode, which studies a chunk of bytes and does some statistical analysis to come up with a guess. 

And as the documentation notes, "Absolute certainty is not guaranteed." Short strings are most likely to be misdetected.




*/





int isunicode(char * buff,int n)
{
	char * p;
	char * end;
 int    even;
	int    odd;
	int    c;
	int    bits;

	bits=0;

	if(n>=2 && buff[0]==0xFF && buff[1]==0xFE) bits=ISUNICODEBOM|ISUNICODEUTF16;
	else
	if(n>=2 && buff[0]==0xFE && buff[1]==0xFF) bits=ISUNICODEREVERSE|ISUNICODEBOM|ISUNICODEUTF16;
	else
	if(n>=2 && buff[0]==0xEF && buff[1]==0xBB && buff[2]==0xBF) bits=ISUNICODEBOM|ISUNICODEUTF8;
	else
	if(n>=4	&& buff[0]==0xFF && buff[1]==0xFE	&& buff[2]==0 && buff[3]==0) bits=ISUNICODEBOM|ISUNICODEUTF32;
	else
	if(n>=4	&& buff[0]==0 && buff[1]==0	&& buff[2]==0xFE && buff[3]==0xFF) bits=ISUNICODEBOM|ISUNICODEUTF32;
	else
	{
 	p=buff;
 	end=buff+n;
 	even=0;
 	odd=0;

 	while(p<end)
 	{
 		c=*p++;
 		if(c==0) even++;

 		if(p>=end) break;

 		c=*p++;
 		if(c==0) odd++;
 	}

  if(odd>2)  bits|=ISUNICODEUTF16;
 	if(even>2) bits|=ISUNICODEREVERSE|ISUNICODEUTF16; 
	}

	return(bits);
}




os_error * wide2char(wchar_t * source,int slen,char * dest,int dlen)
{


	WideCharToMultiByte(CP_ACP, // code page
                     WC_NO_BEST_FIT_CHARS, // performance and mapping flags
                     source,    // wide-character string
                     slen,          // number of chars in string.
                     dest,     // buffer for new string
                     dlen,          // size of buffer
                     NULL,     // default for unmappable chars
                     NULL  // set when default char used
                     );

	return(NULL);
}




os_error * char2wide(char * source,int slen,wchar_t * dest,int dlen)
{



 MultiByteToWideChar(
  CP_ACP,         // code page
  0,         // character-type options
  source, // string to map
  slen,       // number of bytes in string
  dest,  // wide-character buffer
  dlen        // size of buffer
  );

	return(NULL);
}

