/*->c.filetype */


#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"

#include "bits.h"
#include "trans.h"
#include "etc.h"
#include "deb.h"

#include "filetype.h"


static filetypelink  * firstlink;



os_error * addfiletypetable(filetypetag * tags,filetypelink * link)
{
 link->tags=tags;
 link->next=firstlink;
 firstlink=link;

 return(NULL);
}






os_error * getextensionx(int filetype,char * extension,int i,int * hit)
{
 filetypelink  * link;
 filetypetag   * tag;

 link=firstlink;

 *extension=0;
	if(hit) *hit=0;

 while(link)
 {
  tag=link->tags;
  while(tag->filetype!=FTLAST)
  {
   if(tag->filetype==filetype)
   {
    if(tag->extension)
    {
					i--;
					if(i<0)
					{
						if(hit) *hit=1;
      strcpy(extension,tag->extension);
      break;
					}
    }
   }
   else
   if(tag->filetype==FTDEFLT)
   {
    strcpy(extension,tag->extension);
   }
   tag++;
  }

  if(tag->filetype!=FTLAST) break;

  link=link->next;
 }

 return(NULL);
}


os_error * getextension(int filetype,char * extension)
{
 return(getextensionx(filetype,extension,0,NULL));
}





os_error * getdescriptionptr(int filetype,char ** description)
{
 filetypelink  * link;
 filetypetag   * tag;

 link=firstlink;

 *description=NULL;

 while(link)
 {
  tag=link->tags;
  while(tag->filetype!=FTLAST)
  {
   if(tag->filetype==filetype)
   {
    *description=tag->description;
    break;
   }
   else
   if(tag->filetype==FTDEFLT)
   {
    *description=tag->description;
   }
   tag++;
  }

  if(tag->filetype!=FTLAST) break;

  link=link->next;
 }

 return(NULL);
}





os_error * getdescription(int filetype,char * description)
{
 os_error * err;
 char     * p;

 err=getdescriptionptr(filetype,&p);
 if(!err)
 {
  if(p) strcpy(description,p);
  else  * description=0;
 }

 return(err);
}



// possible enhancements
// if the extension is *,XXX strip off the ,XXX
// if the extension is XXX where XXX is a hex number take that as the type



os_error * getfiletypex(int * filetype,int * deftype,char * extension)
{
 filetypelink  * link;
 filetypetag   * tag;

 link=firstlink;

	*filetype=-1;
	if(deftype) *deftype=-1;

 while(link)
 {
  tag=link->tags;
  while(tag->filetype!=FTLAST)
  {
//   cprintf("tagtype=%x %x ",tag->filetype,tag->extension);

   if(tag->extension==NULL)
   {
    if(deftype) *deftype=tag->filetype;
    if(extension==NULL) break;
   }
   else
   if(extension && (!cstrcmp(extension,tag->extension)))
   {
    *filetype=tag->filetype;
    break;
   }

   tag++;
  }

  if(tag->filetype!=FTLAST) break;

  link=link->next;
 }

 return(NULL);
}


os_error * getfiletype(int * filetype,char * extension)
{
	return(getfiletypex(filetype,filetype,extension));
}

