

#define CL_RGB   0
#define CL_CMYK  1
#define CL_GREY  2
#define CL_ALPHA 3

#define PALFROMQUAD(a) ( (((a) & 0xFF)<<24) | (((a) & 0xFF00)<<8) | (((a) & 0xFF0000) >>8) )

typedef struct ipalstr
{
 int word[256];
 int ncolours;
 int palclass;

} ipalstr;




typedef struct imagestr
{
 int               bpp;
 int               xpix;
 int               ypix;
 int               xdpi;
 int               ydpi;
 ipalstr           ipal;
 unsigned int      topdown:1;
 unsigned int      usergbmask:1;
 int               rshift;
 int               gshift;
 int               bshift;
 int               rmask;
 int               gmask;
 int               bmask;

 int               wwidth;  /* width in bytes rounded to words */

 int             * data;

	unsigned char   * iccdata;
	unsigned int      icclen;


} imagestr;


typedef void * ishbm;


typedef struct imagescreenstr
{
 oshdc      hdc;
 ishbm      hbm;
 imagestr * im;
 oshdc      hdcptr;
 
} imagescreenstr;




#define IM 0
#define AL 1



#define FRAMENAMELEN 32


typedef struct framestr
{
 int            offset;             /* offset in file of this image */
 char           name[FRAMENAMELEN];
 int            planes;

 imagestr       im[2];              /* stores raster form of frame */


} framestr;



typedef struct framebasestr
{
 int       framen;

 framestr  frame[1];


} framebasestr;






extern os_error * imnewframebase(framebasestr ** framebase);
extern os_error * imscrapframebase(framebasestr ** framebase);
extern os_error * imaddframe(framebasestr ** framebase,framestr ** frames);
extern os_error * imnew(int xpix,int ypix,int bpp,imagestr * im);
extern os_error * imfind1w(imagestr * image,int y,int ** idata);
extern os_error * imzero(imagestr * image);
extern os_error * imnormalise(imagestr * im,int ** idata,int * buffer);

extern os_error * impaint(framestr * frame,int ox,int oy,int w,int h);
extern os_error * impaintos(framestr * frame,int ox,int oy,int w,int h);
extern os_error * impaintbox(framestr * frame,coordstr * cx,processstr * pr);
extern int        impixelxy(int x,int y,imagestr * im);
extern os_error * impaintim(imagestr * im,int ox,int oy,int w,int h);

extern os_error * imnewscreen(int xpix,int ypix,int bpp,imagestr * im,imagescreenstr * handle);
extern os_error * imsetscreen(imagescreenstr * handle,int set);
extern os_error * imdeletescreen(imagescreenstr * handle);



extern void imgetsppal(imagestr * im,newsprite_header * sph);
extern os_error * imgetspritebits(imagestr * im,newsprite_header * spa,int mask);
