#include <stdafx.h>
#include <stdlib.h>
#include <ctype.h>

#include "dde.h"
#include "objbase.h"


#include "os.h"
#include "wimp.h"
#include "flex.h"

#include "wos.h"
#include "deb.h"
#include "bits.h"
#include "etc.h"
#include "osglue.h"
#include "fsx.h"
#include "poll.h"
#include "alloc.h"
#include "wmf.h"

#include "oscb.h"
#include "oscbx.h"


//typedef void (*zerofn)(int userhandle);    /* external function */




static oscbrenderfn cbrender;
static oscbemptyfn  cbempty;


static int * cbformats;        // cache of formats app supports

static HGLOBAL   cbGlobal;
static void    * cbglobalptr;
static int       cbglobalsize;
static HWND      cbhwnd;

static int       cbflags;



os_error * oscballoc(void ** p,int size)
{

	cprintf("cb alloc %d",size);

 cbGlobal=GlobalAlloc(GMEM_MOVEABLE,size);
 if(cbGlobal)
 {
		cbglobalsize=size;
  *p=cbglobalptr=GlobalLock(cbGlobal);
 }

 return(NULL);
}




int oscbrender(HWND hwnd,UINT format)
{

 cprintf("oscbrender format %d",format);

 if(cbrender)
 {
//  OpenClipboard(NULL);

  cbrender(format);

  if(format==CF_METAFILEPICT)
  {
   cprintf("save metafile");

   HMETAFILE             hmeta;
   METAFILEPICT        * pictp;
   PLACEABLEMETAHEADER * pmetap;

			if(cbGlobal)
   {
    pmetap=(PLACEABLEMETAHEADER*)cbglobalptr;
    if(pmetap->Key==PLACEABLEMAGIC)
    {
     hmeta=SetMetaFileBitsEx(cbglobalsize-PLACEABLESIZE,((BYTE*)cbglobalptr)+PLACEABLESIZE);
    }
    else
    {
     hmeta=SetMetaFileBitsEx(cbglobalsize,(BYTE*)cbglobalptr);
    }

    GlobalUnlock(cbGlobal);
				GlobalDiscard(cbGlobal);

    cbGlobal=GlobalAlloc(GMEM_MOVEABLE,sizeof(METAFILEPICT));
    if(cbGlobal)
    {
     pictp=(METAFILEPICT*)GlobalLock(cbGlobal);
     pictp->mm=MM_ANISOTROPIC;
     pictp->xExt=0;
     pictp->yExt=0;
     pictp->hMF=hmeta;
    
     GlobalUnlock(cbGlobal);    
     SetClipboardData(format,cbGlobal);
    }
			}
  }
  else
		if(format==CF_ENHMETAFILE)
		{
			HENHMETAFILE hmeta;

   cprintf("save enhmetafile");

			if(cbGlobal)
   {
    hmeta=SetEnhMetaFileBits(cbglobalsize,(BYTE*)cbglobalptr);
    GlobalUnlock(cbGlobal);
				GlobalDiscard(cbGlobal);
    SetClipboardData(format,hmeta);
			}
		}
		else
		{
   if(cbGlobal) GlobalUnlock(cbGlobal);

   SetClipboardData(format,cbGlobal);
		}
  cbGlobal=NULL;

//  CloseClipboard();
 }

 return(0); // if you do something

 USE(hwnd);
}




static int cbdefeatdestroy;



int oscbdestroy(HWND hwnd)
{
 os_error * err;

 cprintf("cbdestroy");

	if(cbdefeatdestroy==0)
	{
  if(cbempty) cbempty();

  err=sfree((flex_ptr)&cbformats);

	}

 return(0); // if you do something

 USE(hwnd);
}




int oscbrenderall(HWND hwnd)
{
 int * p;

 cprintf("render all");

 cbdefeatdestroy=1;

	if(cbformats!=NULL)
	{
  OpenClipboard(hwnd);
  EmptyClipboard();

 
  p=cbformats;
  while(1)
  {
   if(!*p) break;
   if(cbrender) oscbrender(hwnd,*p);
   p++;
  }

  CloseClipboard();
	}

 cbdefeatdestroy=0;

 return(0); // if you do something
}





// call this when we claim clipboard, someone clicks on cut/copy

os_error * oscbcopy(int * formats,oscbrenderfn xoscbrender,oscbemptyfn xoscbempty,int flags)
{
 os_error * err;
 int      * p;

 cbrender=xoscbrender;
 cbempty=xoscbempty;

 OpenClipboard(cbhwnd);
 EmptyClipboard();

 p=formats;
 while(1)
 {
  if(!*p) break;
  cprintf("set format %d",*p);

		if(flags & OSCB_IMMEDIATE)
		{
   if(cbrender)
   {
    cbrender(*p);

    if(cbGlobal) GlobalUnlock(cbGlobal);
    SetClipboardData(*p,cbGlobal);
    cbGlobal=NULL;
			}
		}
		else
		{
   SetClipboardData(*p,NULL);
		}
  p++;
 }


 err=schunk((flex_ptr)&cbformats,((p-formats)+1)*sizeof(int),sizeof(int));
 if(!err)
 {
  memcpy(cbformats,formats,((p-formats)+1)*sizeof(int));
 }

 CloseClipboard();

 return(NULL);
}



int oscblocal(void)
{

 return(cbformats!=NULL);
}



// list available formats
// include this program
// include another invocation of this program


#define ACHUNK (16*sizeof(int))

static int * aformats;

os_error * oscbavailable(int ** formats)
{
 os_error * err;
 int        format;
 int        fcount;

 err=NULL;

 if(cbformats)
 {
  fcount=2;
  err=schunk((flex_ptr)&aformats,sizeof(int)*fcount,ACHUNK);
  if(!err)
  {
   aformats[0]=OSCB_LOCAL;
   aformats[1]=0;
  }
 }
 else
 {
  format=0;
  fcount=0;

  if(cbflags & OSCB_OLE)
  {
   IDataObject    * pDataObject;
   IEnumFORMATETC * penumFormatetc;
   FORMATETC        formatetc;
   unsigned long    read;

   if(OleGetClipboard(&pDataObject)==S_OK)
   {
    if(pDataObject->EnumFormatEtc(DATADIR_GET,&penumFormatetc)==S_OK)
    {
     while(1)
     {
      err=schunk((flex_ptr)&aformats,sizeof(int)*fcount,ACHUNK);
      if(err) break;

      if(penumFormatetc->Next(1,&formatetc,&read)==S_OK)
      {
       cprintf("cfformat %d",formatetc.cfFormat);

       aformats[fcount++]=formatetc.cfFormat;
      }
      else
      {
       break;
      }
     }

     penumFormatetc->Release();
    }
        
    pDataObject->Release();
   }
  }
  else
  {
   OpenClipboard(cbhwnd);

   while(1)
   {
    err=schunk((flex_ptr)&aformats,sizeof(int)*fcount,ACHUNK);
    if(err) break;

    format=EnumClipboardFormats(format);
 //   cprintf("enum format %d",format);
    aformats[fcount++]=format;
    if(format==0) break;
   }

   CloseClipboard();
  }
 }

 *formats=aformats;

 return(err);
}



// get clipboard data pointer

os_error * oscbpaste(int format,oscbpastefn paste)
{
 os_error * err;
 HGLOBAL    hGlobal=NULL;
 void     * pGlobal=NULL;
	unsigned int length;
 FORMATETC fmtetc = { CF_TEXT, 0, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
 STGMEDIUM stgmed;
 IDataObject    * pDataObject=NULL;


 err=NULL;

 cprintf("oscbpaste format %d",format); 

 if(cbflags & OSCB_OLE)
 {
  fmtetc.cfFormat=(unsigned short)format;

  if(format==CF_METAFILEPICT) fmtetc.tymed=TYMED_MFPICT;
  else
  if(format==CF_ENHMETAFILE)  fmtetc.tymed=TYMED_ENHMF;
  else                       
  if(format==CF_TEXT)         fmtetc.tymed=TYMED_HGLOBAL;


  if(OleGetClipboard(&pDataObject)==S_OK)
  {
   cprintf("olegetclip");

   if(pDataObject->GetData(&fmtetc,&stgmed)==S_OK)
   {
    hGlobal=stgmed.hGlobal;

    cprintf("get hGlobal");
   }
   else
   {
    hGlobal=NULL;
   }
  }
  else
  {
   pDataObject=NULL;
  }
 }
 else
 {
  OpenClipboard(cbhwnd);
  hGlobal=GetClipboardData(format);
 }

 if(hGlobal!=NULL)
 {
  if(format==CF_METAFILEPICT)
  {
   METAFILEPICT * metap;

   metap=(METAFILEPICT*)GlobalLock(hGlobal);

   length=GetMetaFileBitsEx(metap->hMF,0,NULL);

   cprintf("wmf length %d",length);

   err=salloc((flex_ptr)&pGlobal,length);
   if(!err)
   {
    GetMetaFileBitsEx(metap->hMF,length,(BYTE*)pGlobal);
   }

   GlobalUnlock(metap);
  }
  else
  if(format==CF_ENHMETAFILE)
  {
   length=GetEnhMetaFileBits((HENHMETAFILE)hGlobal,0,NULL);
  
   cprintf("emf length %d",length);

   err=salloc((flex_ptr)&pGlobal,length);
   if(!err)
   {
    GetEnhMetaFileBits((HENHMETAFILE)hGlobal,length,(BYTE*)pGlobal);
   }
  }
  else
  {
   pGlobal=GlobalLock(hGlobal);
 		length=GlobalSize(hGlobal);

 		if(format==CF_TEXT)
 		{
 			char * p;
 			char * lt;
 			p=(char*)pGlobal;
 			lt=p+length;
 			while(p<lt)	if(*p++==0) break;
 			length=p-(char*)pGlobal;
 		}
			else
			if(format==CF_UNICODETEXT)
			{
				short * p;
 			short * lt;
 			p=(short*)pGlobal;
 			lt=p+length;
 			while(p<lt)	if(*p++==0) break;
 			length=(char*)p-(char*)pGlobal;
			}
  }


  paste(pGlobal,length);


  if(format==CF_METAFILEPICT)
  {
   sfree((flex_ptr)&pGlobal);

  }
  else
  if(format==CF_ENHMETAFILE)
  {
   sfree((flex_ptr)&pGlobal);

  }
  else
  {
   GlobalUnlock(hGlobal);
  }
 }

 if(cbflags & OSCB_OLE)
 {
  if(pDataObject)
  {
   if(hGlobal) ReleaseStgMedium(&stgmed);
   pDataObject->Release();
  }
 }
 else
 {
  CloseClipboard();
 }

 return(err);
}



os_error * oscbnametype(char * name,int * type)
{
 *type=RegisterClipboardFormat(name);

 return(NULL);
}



os_error * oscbinit(int flags)
{
 cbhwnd=CreateWindow("Task",TEXT("oscb"),
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, NULL,AppInstance,NULL);

 cbflags=flags;

 return(NULL);
}



os_error * oscbfinit(int flags)
{

	cprintf("oscb finalise");

 DestroyWindow(cbhwnd);
	cbhwnd=0;

	return(NULL);

	USE(flags);
}
